PRO WRITE_DRM_COM_FILE, DET_TYPE, FITS_DIR, FITS_FILE, $
          OD_SEL, OD_DRIVE, OD_LABEL, NAMELIST = NAMELIST

@wgsp_cb.pro

 
   
DET_TYPE = STRUPCASE( STRMID(DET_TYPE, 0, 1) )

OPENW, FL, WGSP_SCRATCH + STRLOWCASE('MAKE_DRM.COM'), /GET_LUN

       IF (OD_SEL NE 0) THEN BEGIN
          PRINTF, FL, '$ MOUNT/SHARE ', OD_DRIVE, ' ', OD_LABEL
       ENDIF

       PRINTF, FL, '$ DEFINE FITS$BFITS ', FITS_DIR
       PRINTF, FL, '$ DEFINE PSCRATCH SYS$LOGIN'
       PRINTF, FL, '$ SET DEFAULT          FITS$BFITS'
       PRINTF, FL, '$ DEFINE FITS$DRM_OUT  FITS$BFITS:' 
       PRINTF, FL, '$ DEFINE FITS$DRM_NML  FITS$BFITS:'
       PRINTF, FL, '$ DEFINE FITS$LOG      FITS$BFITS:'
       PRINTF, FL, '$ DEFINE FITS$DRM_HDR  BDAS$EXE:[DRM.DRM_GEN]'

       IF (DET_TYPE EQ 'L') THEN BEGIN
          PRINTF, FL,'$ RUN BDAS$EXE:[DRM.DRM_GEN]DRM_LAD_GEN'
       ENDIF
       IF (DET_TYPE EQ 'S') THEN BEGIN
          PRINTF, FL,'$ RUN BDAS$EXE:[DRM.DRM_GEN]DRM_SPEC_GEN'
       ENDIF

       PRINTF, FL, FITS_FILE

       IF (N_ELEMENTS(NAMELIST) NE 0) THEN BEGIN
          BREAK_FILE, NAMELIST, NDEV, NDIR, NNAME, NEXT
          NAMELIST = NNAME + NEXT
       ENDIF
       IF (N_ELEMENTS(NAMELIST) EQ 0) THEN NAMELIST = ''
       PRINTF, FL, NAMELIST
 
       IF (OD_SEL NE 0) THEN BEGIN
          PRINTF, FL, '$ DISMOUNT ', OD_DRIVE
       ENDIF

       PRINTF, FL,'$ EXIT'
FREE_LUN, FL



END ; PRO WRITE_DRM_COM_FILE
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
; Widget interface to DRM_GEN
PRO MAKE_DRM_EVENT, EVENT

@wgsp_cb.pro
COMMON DRM_DATA, DATA_DRM_C



TYPE = TAG_NAMES(EVENT, /STRUCTURE)
CASE TYPE OF

 ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 ; The button widget events
 'WIDGET_BUTTON': BEGIN
     WIDGET_CONTROL, EVENT.ID, GET_VALUE = VALUE, GET_UVALUE = UVALUE
                   
     VALUE = STRUPCASE(VALUE(0))
     CASE 1 OF 

          VALUE EQ 'HELP': WM_XDISPLAYFILE, $
                WGSP_SOURCE + STRLOWCASE('DRM.HLP')

          VALUE EQ 'CANCEL': BEGIN
                WIDGET_CONTROL, EVENT.TOP, /DESTROY
                RETURN
                END
      
          VALUE EQ 'DONE': BEGIN
          
                IF (DATA_DRM_C.DETECTOR_SEL AND $
		    DATA_DRM_C.FITS_DIR_SEL AND $
		    DATA_DRM_C.FITS_FILE_SEL) THEN BEGIN

		   IF (DATA_DRM_C.NML_FILE_SEL EQ 0) THEN BEGIN
    
		      WRITE_DRM_COM_FILE, DATA_DRM_C.DETECTOR_VAL, $
        		    DATA_DRM_C.FITS_DIR_VAL, $
        		    DATA_DRM_C.FITS_FILE_VAL, $
        		    DATA_DRM_C.OD_SEL, DATA_DRM_C.OD_DEVICE, $
        		    DATA_DRM_C.OD_LABEL
	
		   ENDIF ELSE BEGIN
 
		      WRITE_DRM_COM_FILE, DATA_DRM_C.DETECTOR_VAL, $
        		    DATA_DRM_C.FITS_DIR_VAL, $
        		    DATA_DRM_C.FITS_FILE_VAL, $
        		    DATA_DRM_C.OD_SEL, DATA_DRM_C.OD_DEVICE, $
        		    DATA_DRM_C.OD_LABEL, $
        		    NAMELIST = DATA_DRM_C.NML_DIR_VAL + $
                                       DATA_DRM_C.NML_FILE_VAL
	
		   ENDELSE

		   PRINT, ' '
		   SPAWN, 'SHOW USERS / BATCH'
		   PRINT, ' '

		   THE_QUE = WIDMENU(['Select CPU', $
                		      'Byrds', $
                		      'Kinks', $
                		      'LedZep', $
                		      'Stones', $
                		      'TheWho', $
                		      'Zappa', $
                		      'AUTOMATIC', $
                		      'DO NOT SUBMIT', $
                		      'CANCEL'], TITLE = 0)
		   CASE THE_QUE OF
        		1: SPAWN, 'SUBMIT/NOTIFY/QUE = BYRDS_BATCH  ' + $
                		  WGSP_SCRATCH + STRLOWCASE('MAKE_DRM.COM')
        		2: SPAWN, 'SUBMIT/NOTIFY/QUE = KINKS_BATCH  ' + $
                		  WGSP_SCRATCH + STRLOWCASE('MAKE_DRM.COM')
        		3: SPAWN, 'SUBMIT/NOTIFY/QUE = LEDZEP_BATCH ' + $
                		  WGSP_SCRATCH + STRLOWCASE('make_drm.com')
        		4: SPAWN, 'SUBMIT/NOTIFY/QUE = STONES_BATCH ' + $
                		  WGSP_SCRATCH + STRLOWCASE('MAKE_DRM.COM')
        		5: SPAWN, 'SUBMIT/NOTIFY/QUE = THEWHO_BATCH ' + $
                		  WGSP_SCRATCH + STRLOWCASE('MAKE_DRM.COM')
        		6: SPAWN, 'SUBMIT/NOTIFY/QUE = ZAPPA_BATCH  ' + $
                		  WGSP_SCRATCH + STRLOWCASE('MAKE_DRM.COM')
        		7: SPAWN, 'SUBMIT/NOTIFY ' + $
                		  WGSP_SCRATCH + STRLOWCASE('MAKE_DRM.COM')
        		8: INFORM, 'Command file ' + $
                		  WGSP_SCRATCH + $
                                  'make_drm.com created.  Ready.'
        		ELSE: 
		   ENDCASE

		ENDIF ELSE BEGIN

		   IF (NOT DATA_DRM_C.DETECTOR_SEL) THEN BEGIN
		      JUNK = WIDMENU(['Please Select a Detector Type', 'Ok'], $
		             TITLE = 0)
		   ENDIF
		   IF (NOT DATA_DRM_C.FITS_DIR_SEL) OR $
		      (NOT DATA_DRM_C.FITS_FILE_SEL) THEN BEGIN
		      JUNK = WIDMENU(['Please Supply Full File Path', 'Ok'], $
                             TITLE = 0)
		   ENDIF

                GOTO, TRY_AGAIN 
		ENDELSE

                WIDGET_CONTROL, EVENT.TOP, /DESTROY
                RETURN
                END

          VALUE EQ 'BROWSE...': BEGIN
                IF (UVALUE EQ 'FITS') THEN BEGIN
                   FITS_FILE = PICKFILE(FILTER = '*.fits', /NOCONFIRM)
                   IF (FITS_FILE NE '') THEN BEGIN
                      WIDGET_CONTROL, DATA_DRM_C.FITS_TEXT_ID, $
                             SET_VALUE = FITS_FILE
                      BREAK_FILE, FITS_FILE, FDEV, FDIR, FNAME, FEXT

                      IF (FDEV NE '' AND FDIR NE '') THEN BEGIN
                         DATA_DRM_C.FITS_DIR_VAL  = FDEV + FDIR
                         DATA_DRM_C.FITS_DIR_SEL  = 1
                      ENDIF

                      IF (FNAME NE '') THEN BEGIN
                         IF (STRLEN(FNAME + FEXT) GT 60) THEN BEGIN
                            ERROR = WIDMENU(['ERROR: DRM_GEN filenames limited to 60 characters.', $
                                             'OK'], TITLE = 0)
                            RETURN
                         ENDIF

                         DATA_DRM_C.FITS_FILE_VAL = FNAME + FEXT
                         DATA_DRM_C.FITS_FILE_SEL = 1
                      ENDIF
                   ENDIF
                ENDIF

                IF (UVALUE EQ 'NAMELIST') THEN BEGIN
                   NML_FILE = PICKFILE(FILTER = '*.nml', /NOCONFIRM)
                   IF (NML_FILE NE '') THEN BEGIN
                      WIDGET_CONTROL, DATA_DRM_C.NML_TEXT_ID, $
                             SET_VALUE = NML_FILE
                      BREAK_FILE, NML_FILE, NDEV, NDIR, NNAME, NEXT

                      IF (NDEV NE '' AND NDIR NE '') THEN BEGIN
                         DATA_DRM_C.NML_DIR_VAL  = NDEV + NDIR
                         DATA_DRM_C.NML_DIR_SEL  = 1
                      ENDIF

                      IF (NNAME NE '') THEN BEGIN
                         IF (STRLEN(NNAME + NEXT) GT 60) THEN BEGIN
                            ERROR = WIDMENU(['ERROR: DRM_GEN filenames limited to 60 characters.', $
                                             'OK'], TITLE = 0)
                            RETURN
                         ENDIF

                         DATA_DRM_C.NML_FILE_VAL = NNAME + NEXT
                         DATA_DRM_C.NML_FILE_SEL = 1
                      ENDIF
                   ENDIF
                ENDIF
                END
 
     ENDCASE ; for VALUE
     END

 ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 ; The radio button widget events
 '': BEGIN
     WIDGET_CONTROL, EVENT.ID, GET_VALUE = VALUE, GET_UVALUE = UVALUE

     CASE UVALUE OF 
  
          'DET_TYPES': BEGIN
               CASE EVENT.VALUE OF
                0: BEGIN
                   DATA_DRM_C.DETECTOR_SEL = 1
                   DATA_DRM_C.DETECTOR_VAL = 'L'
                   END
                1: BEGIN
                   DATA_DRM_C.DETECTOR_SEL = 1
                   DATA_DRM_C.DETECTOR_VAL = 'S'
                   END
               ENDCASE
               END
          'OD_SEL': BEGIN
               CASE EVENT.VALUE OF
                0: BEGIN
                   DATA_DRM_C.OD_SEL = 1
                   WIDGET_CONTROL, DATA_DRM_C.OD_DEVICE_LABEL_ID, SENSITIVE = 1
                   WIDGET_CONTROL, DATA_DRM_C.OD_LABEL_LABEL_ID, SENSITIVE = 1
                   WIDGET_CONTROL, DATA_DRM_C.OD_DEVICE_TEXT_ID, SENSITIVE = 1
                   WIDGET_CONTROL, DATA_DRM_C.OD_LABEL_TEXT_ID, SENSITIVE = 1
                   END
                1: BEGIN
                   DATA_DRM_C.OD_SEL = 0
                   WIDGET_CONTROL, DATA_DRM_C.OD_DEVICE_LABEL_ID, SENSITIVE = 0
                   WIDGET_CONTROL, DATA_DRM_C.OD_LABEL_LABEL_ID, SENSITIVE = 0
                   WIDGET_CONTROL, DATA_DRM_C.OD_DEVICE_TEXT_ID, SENSITIVE = 0
                   WIDGET_CONTROL, DATA_DRM_C.OD_LABEL_TEXT_ID, SENSITIVE = 0
                   END
               ENDCASE
               END

     ENDCASE ; for UVALUE
     END

 ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 ; The text widget events
 'WIDGET_TEXT_CH': BEGIN
     WIDGET_CONTROL, EVENT.ID, GET_VALUE = VALUE, GET_UVALUE = UVALUE

     CASE UVALUE OF 
                
          'FITS_FILE': BEGIN
                       BREAK_FILE, VALUE(0), FDEV, FDIR, FNAME, FEXT
                       IF (FDEV NE '' AND FDIR NE '') THEN BEGIN
                          DATA_DRM_C.FITS_DIR_VAL  = FDEV + FDIR
                          DATA_DRM_C.FITS_DIR_SEL  = 1
                       ENDIF

                       IF (FNAME NE '') THEN BEGIN
                          IF (STRLEN(FNAME + FEXT) GT 60) THEN BEGIN
                             ERROR = WIDMENU(['ERROR: DRM_GEN filenames limited to 60 characters.', $
                                              'OK'], TITLE = 0)
                             RETURN
                          ENDIF

                          DATA_DRM_C.FITS_FILE_VAL = FNAME + FEXT
                          DATA_DRM_C.FITS_FILE_SEL = 1
                       ENDIF
                       END
               
          'NML_FILE': BEGIN
                      BREAK_FILE, VALUE(0), NDEV, NDIR, NNAME, NEXT
                      IF (NDEV NE '' AND NDIR NE '') THEN BEGIN
                         DATA_DRM_C.NML_DIR_VAL  = NDEV + NDIR
                         DATA_DRM_C.NML_DIR_SEL  = 1
                      ENDIF

                      IF (NNAME NE '') THEN BEGIN
                         IF (STRLEN(NNAME + NEXT) GT 60) THEN BEGIN
                            ERROR = WIDMENU(['ERROR: DRM_GEN filenames limited to 60 characters.', $
                                             'OK'], TITLE = 0)
                            RETURN
                         ENDIF

                         DATA_DRM_C.NML_FILE_VAL = NNAME + NEXT
                         DATA_DRM_C.NML_FILE_SEL = 1
                      ENDIF
                      END

          'OD_DEVICE': BEGIN
                       DATA_DRM_C.OD_DEVICE = VALUE(0)
                       END

          'OD_LABEL': BEGIN
                      DATA_DRM_C.OD_LABEL = VALUE(0)
                      END

     ENDCASE
     END

ENDCASE ; for TYPE

TRY_AGAIN:



END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
PRO MAKE_DRM


COMMON DRM_DATA, DATA_DRM_C

DATA_DRM_C = {DETECTOR_SEL: 1, DETECTOR_VAL: 'L', $
        FITS_DIR_SEL: 0, FITS_DIR_VAL: '', $
        FITS_FILE_SEL: 0, FITS_FILE_VAL: '', $
        NML_DIR_SEL: 0, NML_DIR_VAL: '', $
        NML_FILE_SEL: 0, NML_FILE_VAL: '', $
        OD_SEL: 0, OD_DEVICE: '', OD_LABEL: '', $
        OD_DEVICE_LABEL_ID: 0L, OD_LABEL_LABEL_ID: 0L, $
        OD_DEVICE_TEXT_ID: 0L, OD_LABEL_TEXT_ID: 0L, $
        FITS_TEXT_ID: 0L, NML_TEXT_ID: 0L}


; Parent
MTITLE = 'W_DRM_GEN'
BASE   = WIDGET_BASE(TITLE = MTITLE, /COLUMN, MAP = 0)

DBUTTON = WIDGET_BUTTON(BASE, VALUE = 'DONE')
BUTTON = WIDGET_BUTTON(BASE, VALUE = 'Help')
BUTTON = WIDGET_BUTTON(BASE, VALUE = 'CANCEL')

ROW_BASE  = WIDGET_BASE(BASE, /ROW)
LABEL     = WIDGET_LABEL(ROW_BASE, VALUE = 'Detector Type')
DET_TYPES = ['LAD', 'SD']
BUTTONS   = CW_BGROUP(ROW_BASE, DET_TYPES, /EXCLUSIVE, $
                      /ROW, /NO_RELEASE, UVALUE = 'DET_TYPES')
WIDGET_CONTROL, BUTTONS, SET_VALUE = 0

ROW_BASE  = WIDGET_BASE(BASE, /ROW)
LABEL     = WIDGET_LABEL(ROW_BASE, VALUE = 'Use Data on Optical Disk')
DET_TYPES = ['Yes', 'No']
BUTTONS   = CW_BGROUP(ROW_BASE, DET_TYPES, /EXCLUSIVE, $
                      /ROW, /NO_RELEASE, UVALUE = 'OD_SEL')
WIDGET_CONTROL, BUTTONS, SET_VALUE = 1

ROW_BASE = WIDGET_BASE(BASE, /ROW)
DATA_DRM_C.OD_DEVICE_LABEL_ID = WIDGET_LABEL(ROW_BASE, $
                                      VALUE = 'Optical Disk Device')
DATA_DRM_C.OD_DEVICE_TEXT_ID  = WIDGET_TEXT(ROW_BASE, VALUE = ' ', $
                                      YSIZE = 1, /EDIT, UVALUE = 'OD_DEVICE')
WIDGET_CONTROL, DATA_DRM_C.OD_DEVICE_LABEL_ID, SENSITIVE = 0
WIDGET_CONTROL, DATA_DRM_C.OD_DEVICE_TEXT_ID, SENSITIVE = 0

ROW_BASE = WIDGET_BASE(BASE, /ROW)
DATA_DRM_C.OD_LABEL_LABEL_ID = WIDGET_LABEL(ROW_BASE, $
                                      VALUE = 'Optical Disk Label')
DATA_DRM_C.OD_LABEL_TEXT_ID  = WIDGET_TEXT(ROW_BASE, VALUE = ' ', $
                                      YSIZE = 1, /EDIT, UVALUE = 'OD_LABEL')
WIDGET_CONTROL, DATA_DRM_C.OD_LABEL_LABEL_ID, SENSITIVE = 0
WIDGET_CONTROL, DATA_DRM_C.OD_LABEL_TEXT_ID, SENSITIVE = 0

ROW_BASE = WIDGET_BASE(BASE, /ROW)
LABEL    = WIDGET_LABEL(ROW_BASE, VALUE = 'FITS Filename')
DATA_DRM_C.FITS_TEXT_ID = WIDGET_TEXT(ROW_BASE, VALUE = ' ', YSIZE = 1, /EDIT, $
                           UVALUE = 'FITS_FILE')
BUTTON   = WIDGET_BUTTON(ROW_BASE, VALUE = 'Browse...', UVALUE = 'FITS')

ROW_BASE = WIDGET_BASE(BASE, /ROW)
LABEL    = WIDGET_LABEL(ROW_BASE, VALUE = 'Namelist Filename')
DATA_DRM_C.NML_TEXT_ID = WIDGET_TEXT(ROW_BASE, VALUE = ' ', YSIZE = 1, /EDIT, $
                          UVALUE = 'NML_FILE')
BUTTON   = WIDGET_BUTTON(ROW_BASE, VALUE = 'Browse...', UVALUE = 'NAMELIST')


; Realize the BASE widget and the children
WIDGET_CONTROL, BASE, /REALIZE, SHOW = 1 

; Place the widget in center of screen
DEVICE, GET_SCREEN_SIZE = CURRENT_SCREEN
WIDGET_CONTROL, BASE, TLB_GET_SIZE = MENU_SIZE
MENU_CENTER = [(CURRENT_SCREEN(0) / 2.0) - (MENU_SIZE(0) / 2.0), $ 
               (CURRENT_SCREEN(1) / 2.0) - (MENU_SIZE(1) / 2.0)] 
WIDGET_CONTROL, BASE, $
                TLB_SET_XOFFSET = MENU_CENTER(0), $
                TLB_SET_YOFFSET = MENU_CENTER(1)
WIDGET_CONTROL, BASE, MAP = 1

; Register with XMANAGER
XMANAGER, 'MAKE_DRM', BASE, /MODAL



END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
