; Sets up plot region to plot a spectrum with residuals plotted
;  below, with shared x-axes.  The spectrum plot occupies the
;  upper 80% of the plot box; the residuals occupy the remaining
;  20%.
;
; Calling procedure:
;  RESIDUAL_PLOTTER, /SPECTRUM
;  PLOT, SPECTRUM_DATA
;  RESIDUAL_PLOTTER, /RESIDUALS
;  PLOT, RESIDUAL_DATA
;
; mallozzi@gibson.msfc.nasa.gov, Oct, 1995

PRO RESIDUAL_PLOTTER, SPECTRUM = SPECTRUM, RESIDUALS = RESIDUALS


IF (N_ELEMENTS(SPECTRUM) NE 0) THEN BEGIN
   ERASE
   !P.NOERASE  = 1
   !P.POSITION = [0.093755, 0.249224, 0.971880, 0.964849]
   !X.TICKNAME = REPLICATE(' ', 30)
ENDIF

IF (N_ELEMENTS(RESIDUALS) NE 0) THEN BEGIN
   RESET_PLOT
   !P.POSITION = [0.093755, 0.0703175, 0.971880, 0.249224]
   !P.NOERASE  = 1
   !Y.MINOR    = 2
ENDIF



END
