; WINGSPAN MFIT WIDGET AND EVENT PROCESSING PROCEDURES
; Used under the main widget
; R.S. Mallozzi, UAH/NASA, Dec, 1994
 
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
; This is the event handler 
PRO MFIT_BASE_EVENT, EVENT

@wgsp_cb.pro
COMMON MFIT_BUTTON_IDS, MFIT_BID


!X.TICKS = 0 & !Y.TICKS = 0
TYPE = TAG_NAMES(EVENT, /STRUCTURE)
CASE TYPE OF

 ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 ; The radio button widget events
; '': BEGIN
;      WIDGET_CONTROL, EVENT.ID, GET_UVALUE = UVALUE
;      CASE UVALUE OF 
;       'RESID_BUTTONS': BEGIN
;        CASE EVENT.VALUE OF
;         0: BEGIN
;             ACTION = 'YES'
;             MFIT_INFORM, 'Plotting Residuals.  Ready.'
;             WGSP_PLOT_RESIDUALS = 1
;            END
;         1: BEGIN
;             ACTION = 'NO'
;             MFIT_INFORM, 'Not Plotting Residuals.  Ready.'
;             WGSP_PLOT_RESIDUALS = 0
;            END
;        ENDCASE
;        END
;      ENDCASE
;     END ; RADIO_BUTTON events


 ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 ; The button widget events
 'WIDGET_BUTTON': BEGIN
    WIDGET_CONTROL, EVENT.ID, GET_VALUE = VALUE, GET_UVALUE = UVALUE
    MFIT_PLOT_OPTION = -1
               
    VALUE = STRUPCASE(VALUE)
    MFIT_INFORM, ''
    CASE 1 OF 
         VALUE EQ 'EXIT': BEGIN                 
               WIDGET_CONTROL, WIDS.MFIT_BASE, /DESTROY
               WIDS.MFIT_BASE = 0L
               ; Reset TIME_RANGE, HIST_RANGE if user changed with ZOOM
               IF (HAVE_ZOOMED_HIST EQ 1) THEN BEGIN
                  TIME_RANGE = TIME_RANGE_SAVE
                  HIST_RANGE = HIST_RANGE_SAVE
               ENDIF
               ; Reset XBEG, etc. if user changed with ZOOM
               IF (HAVE_ZOOMED_DATA(1) EQ 1) THEN BEGIN
                  XBEG(*,1) = XBEG_SAVE(*,1)
                  XEND(*,1) = XEND_SAVE(*,1)
                  YBEG(*,1) = YBEG_SAVE(*,1)
                  YEND(*,1) = YEND_SAVE(*,1)
                  HAVE_XAXIS_LIMITS(*,1) = HAVE_XAXIS_LIMITS_SAVE(*,1)
                  HAVE_YAXIS_LIMITS(*,1) = HAVE_YAXIS_LIMITS_SAVE(*,1)
               ENDIF
               IF (HAVE_ZOOMED_DATA(2) EQ 1) THEN BEGIN
                  XBEG(*,2) = XBEG_SAVE(*,2)
                  XEND(*,2) = XEND_SAVE(*,2)
                  YBEG(*,2) = YBEG_SAVE(*,2)
                  YEND(*,2) = YEND_SAVE(*,2)
                  HAVE_XAXIS_LIMITS(*,2) = HAVE_XAXIS_LIMITS_SAVE(*,2)
                  HAVE_YAXIS_LIMITS(*,2) = HAVE_YAXIS_LIMITS_SAVE(*,2)
               ENDIF
               IF (HAVE_ZOOMED_DATA(3) EQ 1) THEN BEGIN
                  XBEG(*,3) = XBEG_SAVE(*,3)
                  XEND(*,3) = XEND_SAVE(*,3)
                  YBEG(*,3) = YBEG_SAVE(*,3)
                  YEND(*,3) = YEND_SAVE(*,3)
                  HAVE_XAXIS_LIMITS(*,3) = HAVE_XAXIS_LIMITS_SAVE(*,3)
                  HAVE_YAXIS_LIMITS(*,3) = HAVE_YAXIS_LIMITS_SAVE(*,3)
               ENDIF
               IF (HAVE_ZOOMED_DATA(4) EQ 1) THEN BEGIN
                  XBEG(*,4) = XBEG_SAVE(*,4)
                  XEND(*,4) = XEND_SAVE(*,4)
                  YBEG(*,4) = YBEG_SAVE(*,4)
                  YEND(*,4) = YEND_SAVE(*,4)
                  HAVE_XAXIS_LIMITS(*,4) = HAVE_XAXIS_LIMITS_SAVE(*,4)
                  HAVE_YAXIS_LIMITS(*,4) = HAVE_YAXIS_LIMITS_SAVE(*,4)
               ENDIF
               IF (HAVE_ZOOMED_DATA(5) EQ 1) THEN BEGIN
                  XBEG(*,5) = XBEG_SAVE(*,5)
                  XEND(*,5) = XEND_SAVE(*,5)
                  YBEG(*,5) = YBEG_SAVE(*,5)
                  YEND(*,5) = YEND_SAVE(*,5)
                  HAVE_XAXIS_LIMITS(*,5) = HAVE_XAXIS_LIMITS_SAVE(*,5)
                  HAVE_YAXIS_LIMITS(*,5) = HAVE_YAXIS_LIMITS_SAVE(*,5)
               ENDIF
               RETURN
               END
         VALUE EQ 'FIT ONE SPECTRUM': BEGIN           
               MFIT_INFORM, 'Click on spectrum to fit.  ' + $
                            'Select left margin to EXIT.'
               END
         VALUE EQ 'FIT SUMMED SELECTIONS': BEGIN          
               MFIT_INFORM, 'Fitting summed selections.'
               END
         VALUE EQ 'ADD SELECTION AND FIT': BEGIN          
               MFIT_INFORM, 'Adding summed selections to previous data.'
               END
         VALUE EQ 'BATCH FIT SELECTIONS': BEGIN                 
               MFIT_INFORM, 'Batch fitting selections.'
               WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
               END
         VALUE EQ 'CREATE SYNTHETIC BURST': BEGIN                 
               MFIT_INFORM, 'Creating synthetic burst.'
               END
         VALUE EQ 'DISPLAY DRM': BEGIN                 
               MFIT_INFORM, 'Detector response contours.  Ready.', /NO_STATUS
               END

         ; MFIT commands
         ; MFIT_OPTION = 6 is the MFIT COMMANDS button - doesn't generate events
         VALUE EQ 'OBTAIN A 1D CHI-SQUARE PLOT': BEGIN        
               END
         VALUE EQ 'OBTAIN A 2D CHI-SQUARE MAP': BEGIN                 
               END
         VALUE EQ 'READ FIT TEMPLATE': BEGIN
               END
         VALUE EQ 'WRITE FIT TEMPLATE': BEGIN
               END
         VALUE EQ 'EDIT FIT TEMPLATE': BEGIN
               END
         VALUE EQ 'WRITE ASCII FIT INFORMATION': BEGIN
               END
         VALUE EQ 'SEARCH FOR GAUSSIAN LINE': BEGIN
               MFIT_INFORM, 'Searching for Gaussian line in spectrum.'
               END
         VALUE EQ 'WRITE BINARY BATCH OUTPUT FILE': BEGIN
               END
         VALUE EQ 'CLOSE BINARY BATCH OUTPUT FILE': BEGIN
               MFIT_INFORM, 'Closed binary output file.'
               END
         VALUE EQ 'WRITE SESSION': BEGIN
               MFIT_INFORM, ''
               END

         ; Plot options
         ; MFIT_PLOT_OPTION = 0 not yet used
         VALUE EQ 'COUNT RATE': BEGIN          
               IF (HAVE_ZOOMED_DATA(1) EQ 1) THEN BEGIN
                  XBEG(*,1) = XBEG_SAVE(*,1)
                  XEND(*,1) = XEND_SAVE(*,1)
                  YBEG(*,1) = YBEG_SAVE(*,1)
                  YEND(*,1) = YEND_SAVE(*,1)
                  HAVE_XAXIS_LIMITS(*,1) = HAVE_XAXIS_LIMITS_SAVE(*,1)
                  HAVE_YAXIS_LIMITS(*,1) = HAVE_YAXIS_LIMITS_SAVE(*,1)
               ENDIF 
               MFIT_PLOT_OPTION = 1       
               END
         VALUE EQ 'PHOTON FLUX': BEGIN          
               IF (HAVE_ZOOMED_DATA(2) EQ 1) THEN BEGIN
                  XBEG(*,2) = XBEG_SAVE(*,2)
                  XEND(*,2) = XEND_SAVE(*,2)
                  YBEG(*,2) = YBEG_SAVE(*,2)
                  YEND(*,2) = YEND_SAVE(*,2)
                  HAVE_XAXIS_LIMITS(*,2) = HAVE_XAXIS_LIMITS_SAVE(*,2)
                  HAVE_YAXIS_LIMITS(*,2) = HAVE_YAXIS_LIMITS_SAVE(*,2)
               ENDIF
               MFIT_PLOT_OPTION = 2
               END
         VALUE EQ 'COUNT RATE RESIDUALS': BEGIN          
               IF (HAVE_ZOOMED_DATA(3) EQ 1) THEN BEGIN
                  XBEG(*,3) = XBEG_SAVE(*,3)
                  XEND(*,3) = XEND_SAVE(*,3)
                  YBEG(*,3) = YBEG_SAVE(*,3)
                  YEND(*,3) = YEND_SAVE(*,3)
                  HAVE_XAXIS_LIMITS(*,3) = HAVE_XAXIS_LIMITS_SAVE(*,3)
                  HAVE_YAXIS_LIMITS(*,3) = HAVE_YAXIS_LIMITS_SAVE(*,3)
               ENDIF
               MFIT_PLOT_OPTION = 3
               END
         VALUE EQ 'PHOTON FLUX RESIDUALS': BEGIN          
               IF (HAVE_ZOOMED_DATA(4) EQ 1) THEN BEGIN
                  XBEG(*,4) = XBEG_SAVE(*,4)
                  XEND(*,4) = XEND_SAVE(*,4)
                  YBEG(*,4) = YBEG_SAVE(*,4)
                  YEND(*,4) = YEND_SAVE(*,4)
                  HAVE_XAXIS_LIMITS(*,4) = HAVE_XAXIS_LIMITS_SAVE(*,4)
                  HAVE_YAXIS_LIMITS(*,4) = HAVE_YAXIS_LIMITS_SAVE(*,4)
               ENDIF
               MFIT_PLOT_OPTION = 4
               END
         VALUE EQ 'NU_F_NU = D(EFLUX) / D(LOG(E))': BEGIN
               IF (HAVE_ZOOMED_DATA(5) EQ 1) THEN BEGIN
                  XBEG(*,5) = XBEG_SAVE(*,5)
                  XEND(*,5) = XEND_SAVE(*,5)
                  YBEG(*,5) = YBEG_SAVE(*,5)
                  YEND(*,5) = YEND_SAVE(*,5)
                  HAVE_XAXIS_LIMITS(*,5) = HAVE_XAXIS_LIMITS_SAVE(*,5)
                  HAVE_YAXIS_LIMITS(*,5) = HAVE_YAXIS_LIMITS_SAVE(*,5)
               ENDIF
               MFIT_PLOT_OPTION = 5
               END
         VALUE EQ 'SIGMA RESIDUALS': BEGIN          
               MFIT_PLOT_OPTION = 6
               END
         VALUE EQ 'ADJUST PLOT PARAMETERS': BEGIN                     
               END

         ; 'DISPLAY FIT PARAMETERS'
         VALUE EQ 'PARAMETER TIME HISTORY': 
         VALUE EQ 'ONE PARAMETER VS. ANOTHER':
         VALUE EQ 'PARAMETER HISTOGRAM': 
         VALUE EQ 'SIGMA RESIDUALS MAP': 
         VALUE EQ 'MODEL NU-F-NU CONTOURS': 
         VALUE EQ 'WRITE FIT PARAMETERS TO FILE': 

         VALUE EQ 'CREATE HARDCOPY': BEGIN                 
               ; Change the log scale tick marks, if necessary
               IF (!X.TYPE EQ 1) THEN BEGIN                 
                  IF (CHECK_DECADE(10.0^!X.CRANGE)) THEN !X.TICKS = 5
               ENDIF
               IF (!Y.TYPE EQ 1) THEN BEGIN                 
                  IF (CHECK_DECADE(10.0^!Y.CRANGE)) THEN !Y.TICKS = 5
               ENDIF

               CASE WGSP_LAST_PLOT OF
                    'COUNT RATE'                : MFIT_PLOT_OPTION = 1
                    'PHOTON FLUX'               : MFIT_PLOT_OPTION = 2
                    'COUNT RESIDUALS'           : MFIT_PLOT_OPTION = 3
                    'PHOTON RESIDUALS'          : MFIT_PLOT_OPTION = 4
                    'NUFNU'                     : MFIT_PLOT_OPTION = 5
                    'SIGMA RESIDUALS'           : MFIT_PLOT_OPTION = 6
                    'CHI1D'                     : MFIT_PLOT_OPTION = 7
                    'CHI2D'                     : MFIT_PLOT_OPTION = 8
                    'FIT GAUSS'                 : MFIT_PLOT_OPTION = 9
                    'DISPLAY DRM'               : MFIT_PLOT_OPTION = 10
                    'PARAMETER TIME HISTORY'    : MFIT_PLOT_OPTION = 11
                    'ONE PARAMETER VS. ANOTHER' : MFIT_PLOT_OPTION = 11
                    'PARAMETER HISTOGRAM'       : MFIT_PLOT_OPTION = 11
                    'SIGMA RESIDUALS MAP'       : MFIT_PLOT_OPTION = 12
                    'MODEL NU-F-NU CONTOURS'    : MFIT_PLOT_OPTION = 13
                    'HISTORY'                   : MFIT_PLOT_OPTION = 14       
               ENDCASE
               END

         VALUE EQ 'ZOOM':                  
         VALUE EQ 'RE-FIT LAST SPECTRUM':           

         VALUE EQ 'FULL SCREEN': BEGIN          
               ; Change the log scale tick marks, if necessary
               IF (N_ELEMENTS(XLOG) EQ 0) THEN BEGIN
                  XLOG = READ_MENU(1) 
                  YLOG = READ_MENU(2) 
               ENDIF

               IF (XLOG EQ 'LOG') THEN BEGIN                 
                  IF (CHECK_DECADE(10.0^!X.CRANGE)) THEN !X.TICKS = 5
               ENDIF
               IF (YLOG EQ 'LOG') THEN BEGIN                 
                  IF (CHECK_DECADE(10.0^!Y.CRANGE)) THEN !Y.TICKS = 5
               ENDIF

               WIDGET_CONTROL, WIDS.MFIT_BASE, MAP = 0
               CASE WGSP_LAST_PLOT OF
                    'COUNT RATE'                : MFIT_PLOT_OPTION = 1
                    'PHOTON FLUX'               : MFIT_PLOT_OPTION = 2
                    'COUNT RESIDUALS'           : MFIT_PLOT_OPTION = 3
                    'PHOTON RESIDUALS'          : MFIT_PLOT_OPTION = 4
                    'NUFNU'                     : MFIT_PLOT_OPTION = 5
                    'SIGMA RESIDUALS'           : MFIT_PLOT_OPTION = 6
                    'CHI1D'                     : MFIT_PLOT_OPTION = 7
                    'CHI2D'                     : MFIT_PLOT_OPTION = 8
                    'FIT GAUSS'                 : MFIT_PLOT_OPTION = 9
                    'DISPLAY DRM'               : MFIT_PLOT_OPTION = 10
                    'PARAMETER TIME HISTORY'    : MFIT_PLOT_OPTION = 11
                    'ONE PARAMETER VS. ANOTHER' : MFIT_PLOT_OPTION = 11
                    'PARAMETER HISTOGRAM'       : MFIT_PLOT_OPTION = 11
                    'SIGMA RESIDUALS MAP'       : MFIT_PLOT_OPTION = 12
                    'MODEL NU-F-NU CONTOURS'    : MFIT_PLOT_OPTION = 13
                    'HISTORY'                   : MFIT_PLOT_OPTION = 14       
               ENDCASE
               BUTTON_COMMAND = 'PLOT'
               EXPAND_PLOT, BUTTON_COMMAND, MFIT_PLOT_OPTION
               MFIT_INFORM, 'Ready.'
               END

         ; CV selector and plot options
         VALUE EQ 'PLOTTING': BEGIN
               CV_SELECT_PLOTTING 
               RETURN
               END
         VALUE EQ 'FILES': BEGIN
               CV_SELECT_FILES 
               RETURN
               END               
         VALUE EQ 'MISCELLANEOUS': BEGIN
               CV_SELECT_MISC 
               RETURN
               END               
         VALUE EQ 'PLOT LABELS / OPTIONS': BEGIN
               W_LABEL 
               MFIT_INFORM, 'Ready.'
               RETURN
               END               

         ; Else do nothing
         ELSE:          
    ENDCASE ; for VALUE

    ; Binary batch file buttons
    IF (HAVE_MODEL) THEN BEGIN
       TURN_ON, MFIT_BID.WRITE_BATCH
       TURN_ON, MFIT_BID.CLOSE_BATCH
    ENDIF

    ; Process the button events
    BUTTON_COMMAND = VALUE(0)
    IF (VALUE NE 'FULL SCREEN') THEN $
       W_MFIT_SELECT, BUTTON_COMMAND, MFIT_PLOT_OPTION

    IF (VALUE EQ 'CREATE HARDCOPY') THEN $
       MFIT_INFORM, 'Ready.'

    END ; WIDGET_BUTTON events

ENDCASE ; for TYPE

WIDGET_CONTROL, WIDS.MFIT_BASE, MAP = 1, SHOW = 1



END ; PRO MFIT_BASE_EVENT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO W_MFIT

@wgsp_cb.pro
COMMON MFIT_BUTTON_IDS, MFIT_BID


DEVICE, RETAIN = CV_IDL_RETAIN

IF XREGISTERED('W_MFIT') THEN BEGIN
 ; Because of COMMON BLOCKS, only one instance of the WINGSPAN widget
 ; is allowed
 INFORM, 'W_MFIT already running.'
 RETURN
ENDIF

; Structure definition for the MFIT button IDs.
; One structure element for each button, including buttons on pull-down menus.
; Buttons that do not need to be accessed externally are omitted.
MFIT_BID = {FIT_ONE: 0L, $
            REFIT: 0L, $
            FIT_SUMMED: 0L, $
            BATCH_FIT: 0L, $
            FIT_SUM_MULTI: 0L, $
            SYNTHETIC: 0L, $
            DRM: 0L, $
            MFIT: 0L, $
            CHI1D: 0L, $
            CHI2D: 0L, $
            READ_TEMPL: 0L, $
            WRITE_TEMPL: 0L, $
            EDIT_TEMPL: 0L, $
            WRITE_ASCII: 0L, $
            FIT_GAUSS_LINE: 0L, $
            WRITE_SESSION: 0L, $
            PLOT: 0L, $
            ZOOM: 0L, $
            DISPLAY_FIT_PARAMS: 0L, $
            WRITE_FIT_PARAMS: 0L, $
            WRITE_BATCH: 0L, $
            CLOSE_BATCH: 0L}

; Parent
IF (N_ELEMENTS(MFIT_VERSION_TAG) EQ 0) THEN BEGIN
   MTITLE = STRUPCASE(STRTRIM(MFIT_SUPER_VER, 2))
ENDIF ELSE BEGIN
   MTITLE = STRUPCASE(STRTRIM(MFIT_SUPER_VER, 2)) + $
           '; ' + STRTRIM(MFIT_VERSION_TAG, 2)
ENDELSE
WIDS.MFIT_BASE = WIDGET_BASE(TITLE = MTITLE, /COLUMN)
            
 ; Status  
 WIDS.MM_STATUS = WIDGET_TEXT(WIDS.MFIT_BASE, VALUE = ' ', YSIZE = 1)
 WIDS.MM_DATA = WIDGET_TEXT(WIDS.MFIT_BASE, VALUE = ' ', YSIZE = 1)

 BASE1 = WIDGET_BASE(WIDS.MFIT_BASE, /ROW, /FRAME)

  ; Selection buttons 
  BOX_BASE = WIDGET_BASE(BASE1, /COLUMN)

  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ; The widget buttons

  BUTTON = WIDGET_BUTTON(BOX_BASE, VALUE = 'EXIT')
  
  BUTTON = WIDGET_BUTTON(BOX_BASE, VALUE = 'Preferences', MENU = 1)
  BUTTON_LABELS = ['Plotting', $
                   'Files', $
                   'Miscellaneous', $
                   'Plot Labels / Options', $
                   'Adjust Plot Parameters']
  FOR I=0, N_ELEMENTS(BUTTON_LABELS)-1 DO BEGIN
      PD_BUTTON = WIDGET_BUTTON(BUTTON, VALUE = BUTTON_LABELS(I))
  ENDFOR


  BUTTON = WIDGET_BUTTON(BOX_BASE, VALUE = 'Fitting', MENU = 1)
  BUTTON_LABELS = ['Fit One Spectrum', $
                   'Re-Fit Last Spectrum', $
                   'Fit Summed Selections', $
                   'Batch Fit Selections', $
                   'Add Selection and Fit']
  MFIT_BID.FIT_ONE       = WIDGET_BUTTON(BUTTON, VALUE = BUTTON_LABELS(0))
  MFIT_BID.REFIT         = WIDGET_BUTTON(BUTTON, VALUE = BUTTON_LABELS(1))
  MFIT_BID.FIT_SUMMED    = WIDGET_BUTTON(BUTTON, VALUE = BUTTON_LABELS(2))
  MFIT_BID.BATCH_FIT     = WIDGET_BUTTON(BUTTON, VALUE = BUTTON_LABELS(3))
  MFIT_BID.FIT_SUM_MULTI = WIDGET_BUTTON(BUTTON, VALUE = BUTTON_LABELS(4))

  MFIT_BID.SYNTHETIC = WIDGET_BUTTON(BOX_BASE, VALUE = 'Create Synthetic Burst')
  MFIT_BID.DRM = WIDGET_BUTTON(BOX_BASE, VALUE = 'Display DRM')

  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ; MFIT buttons
 
  ; Pull-down menu for MFIT commands
  MFIT_BID.MFIT  = WIDGET_BUTTON(BOX_BASE, VALUE = 'MFIT Commands', MENU = 1)
  MFIT_LABELS = ['Obtain A 1d Chi-Square Plot', $
                 'Obtain A 2d Chi-Square Map', $
                 'Read Fit Template', $
                 'Write Fit Template', $
                 'Edit Fit Template',$
                 'Write ASCII Fit Information', $
                 'Search for Gaussian Line', $
                 'Write Binary Batch Output File', $
                 'Close Binary Batch Output File', $
                 'Write Session']
  MFIT_BID.CHI1D          = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(0))
  MFIT_BID.CHI2D          = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(1))
  MFIT_BID.READ_TEMPL     = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(2))
  MFIT_BID.WRITE_TEMPL    = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(3))
  MFIT_BID.EDIT_TEMPL     = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(4))
  MFIT_BID.WRITE_ASCII    = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(5))
  MFIT_BID.FIT_GAUSS_LINE = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(6))
  MFIT_BID.WRITE_BATCH    = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(7))
  MFIT_BID.CLOSE_BATCH    = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(8))
  MFIT_BID.WRITE_SESSION  = WIDGET_BUTTON(MFIT_BID.MFIT, VALUE = MFIT_LABELS(9))

  ; Pull-down menu for plot options
  MFIT_BID.PLOT = WIDGET_BUTTON(BOX_BASE, VALUE = 'Plot', MENU = 1)
  PLOT_LABELS = ['Count Rate', $
                 'Photon Flux', $
                 'Count Rate Residuals', $
                 'Photon Flux Residuals', $
                 'Nu_F_nu = d(EFLUX) / d(LOG(E))', $
                 'Sigma Residuals']
  FOR I=0, N_ELEMENTS(PLOT_LABELS) - 1 DO BEGIN
      PD_BUTTON = WIDGET_BUTTON(MFIT_BID.PLOT, VALUE = PLOT_LABELS(I))
  ENDFOR

  BUTTON = WIDGET_BUTTON(BOX_BASE, VALUE = 'Full Screen')

  MFIT_BID.ZOOM = WIDGET_BUTTON(BOX_BASE, VALUE = 'Zoom')

  BUTTON = WIDGET_BUTTON(BOX_BASE, VALUE = 'Create Hardcopy')

  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  ; Pull-down menu for Display Fit Parameters
  MFIT_BID.DISPLAY_FIT_PARAMS = WIDGET_BUTTON(BOX_BASE, $
                                       VALUE = 'Fit Parameters', MENU = 1)
  FP_LABELS = ['Parameter Time History', $
               'One Parameter vs. Another', $
               'Parameter Histogram', $
               'Sigma Residuals Map', $
               'Model Nu-F-Nu Contours']
  FOR I=0, N_ELEMENTS(FP_LABELS) - 1 DO BEGIN
      BUTTON = WIDGET_BUTTON(MFIT_BID.DISPLAY_FIT_PARAMS, VALUE = FP_LABELS(I))
  ENDFOR

  MFIT_BID.WRITE_FIT_PARAMS = WIDGET_BUTTON(MFIT_BID.DISPLAY_FIT_PARAMS, $
                           VALUE = 'Write Fit Parameters To File')

;  Someday we will plot the residuals below the spectrum
;  BASE_RESID    = WIDGET_BASE(BOX_BASE, /ROW)
;  LIST_RESID    = WIDGET_LABEL(BASE_RESID, VALUE = 'Plot Residuals')
;  BUTTON_LABELS = ['Yes', 'No']
;  RESID_BUTTONS = CW_BGROUP(BASE_RESID, BUTTON_LABELS, $
;                     /ROW, /EXCLUSIVE, /NO_RELEASE, UVALUE = 'RESID_BUTTONS')
;  WIDGET_CONTROL, RESID_BUTTONS, SET_VALUE = 0 ; Yes

  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  ; The draw widget
  MFIT_DRAW = WIDGET_DRAW(BASE1, $
                     XSIZE = CURRENT_SCREEN(0)*0.65*WGSP_SCALE, $
                     YSIZE = CURRENT_SCREEN(1)*0.50, /FRAME)

; Realize the BASE widget and the children
WIDGET_CONTROL, WIDS.MFIT_BASE, /REALIZE, SHOW = 1 

; Get the draw widget window number
;  MFIT_WINDOW goes into COMMON
WIDGET_CONTROL, MFIT_DRAW, GET_VALUE = MFIT_WINDOW

; Plot the data  
WSET, MFIT_WINDOW
WW_UPDATE, 'HISTORY'

; Assume parameters to start
RUN_MODE               = 'B' ; Batch
HAVE_MODEL             = LONG(0)
HAVE_DRM               = LONG(0)
HAVE_ZOOMED_HIST       = 0      
HAVE_ZOOMED_DATA       = INTARR(MAX_PLOT_TYPE)
HAVE_ZOOMED_PARAM      = 0
XBEG_SAVE              = FLTARR(MAX_DET, MAX_PLOT_TYPE)
XEND_SAVE              = FLTARR(MAX_DET, MAX_PLOT_TYPE)
YBEG_SAVE              = FLTARR(MAX_DET, MAX_PLOT_TYPE)
YEND_SAVE              = FLTARR(MAX_DET, MAX_PLOT_TYPE)
HAVE_XAXIS_LIMITS_SAVE = FLTARR(MAX_DET, MAX_PLOT_TYPE)
HAVE_YAXIS_LIMITS_SAVE = FLTARR(MAX_DET, MAX_PLOT_TYPE)
WGSP_LAST_PLOT         = 'HISTORY' ; First plot in the MFIT widget
;WGSP_PLOT_RESIDUALS    = 1         ; Yes   

; Button control to start
TURN_OFF, MFIT_BID.REFIT
TURN_OFF, MFIT_BID.DRM
TURN_OFF, MFIT_BID.CHI1D
TURN_OFF, MFIT_BID.CHI2D
TURN_ON,  MFIT_BID.READ_TEMPL
TURN_OFF, MFIT_BID.WRITE_TEMPL
TURN_ON,  MFIT_BID.EDIT_TEMPL
TURN_OFF, MFIT_BID.WRITE_ASCII
TURN_ON,  MFIT_BID.FIT_GAUSS_LINE
TURN_OFF, MFIT_BID.WRITE_SESSION
TURN_OFF, MFIT_BID.PLOT
TURN_OFF, MFIT_BID.DISPLAY_FIT_PARAMS
TURN_OFF, MFIT_BID.WRITE_FIT_PARAMS
TURN_OFF, MFIT_BID.WRITE_BATCH
TURN_OFF, MFIT_BID.CLOSE_BATCH
IF (NUM_DET LT 2L) THEN TURN_OFF, MFIT_BID.FIT_SUM_MULTI

BREAK_FILE, CURRENT_VALUES(6), FDEV, FDIR, FNAME, FEXT, FVER
WIDGET_CONTROL, WIDS.MM_DATA, SET_VALUE = 'CURRENT DATA FILE:  ' + FNAME + FEXT
MFIT_INFORM, 'Ready.'

; Register with XMANAGER
XMANAGER, 'MFIT_BASE', WIDS.MFIT_BASE, /MODAL



END
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 


; BEGIN W_MFIT_PROCS 

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO INIT_MFIT, THE_PAGE_POS, BUTTON_COMMAND, MFIT_PLOT_OPTION, MAKE_HC = MAKE_HC

@wgsp_cb.pro
COMMON BATCHFIT_C, BATCH_TIMES, PARAM_HIST, PARAM_UNCER_HIST, RESID_CONTOURS, $
                   NUFNU_CONTOURS, PARAM_STORE, NUM_STORE, HAVE_APLOT, $
                   BATCH_SELECT, ENERGY_SCALE, RATE_SCALE, T_IND 


MULTI_SAVE = !P.MULTI

IF KEYWORD_SET(MAKE_HC) THEN BEGIN
   HC_OPTION = 1
   REQ_ACTION = 'P ' 
   ; Skip down if we are only making a hardcopy
   GOTO, HARDCOPY_ONLY
ENDIF

XLOG = READ_MENU(1) 
YLOG = READ_MENU(2) 
YLOG_VAL = LONG(YLOG EQ 'LOG')


; Commands for MFIT
CASE BUTTON_COMMAND OF
     'EXIT'                           : REQ_ACTION = 'Q '
     'FIT ONE SPECTRUM'               : REQ_ACTION = 'FO'
     'FIT SUMMED SELECTIONS'          : REQ_ACTION = 'FS'
     'BATCH FIT SELECTIONS'           : REQ_ACTION = 'BF'
     'ADD SELECTION AND FIT'          : REQ_ACTION = 'FA'
     'CREATE SYNTHETIC BURST'         : REQ_ACTION = 'S '
     'OBTAIN A 1D CHI-SQUARE PLOT'    : REQ_ACTION = '1 '
     'OBTAIN A 2D CHI-SQUARE MAP'     : REQ_ACTION = '2 '
     'WRITE FIT TEMPLATE'             : REQ_ACTION = 'WT'
     'READ FIT TEMPLATE'              : REQ_ACTION = 'RT'
     'EDIT FIT TEMPLATE'              : REQ_ACTION = 'ET'
     'WRITE ASCII FIT INFORMATION'    : REQ_ACTION = 'WA'
     'SEARCH FOR GAUSSIAN LINE'       : REQ_ACTION = 'FG'
     'WRITE BINARY BATCH OUTPUT FILE' : REQ_ACTION = 'WB'
     'CLOSE BINARY BATCH OUTPUT FILE' : REQ_ACTION = 'CB'
     'PLOT'                           : REQ_ACTION = 'P '
     'ADJUST PLOT PARAMETERS'         : REQ_ACTION = 'A '
     'DISPLAY FIT PARAMETERS'         : REQ_ACTION = 'DP'
     'WRITE FIT PARAMETERS TO FILE'   : REQ_ACTION = 'WP'
     'RE-FIT LAST SPECTRUM'           : REQ_ACTION = 'FO'
     'WRITE SESSION'                  : REQ_ACTION = 'WS'
     ELSE                             : REQ_ACTION = 'XX'
ENDCASE

;IF THEN BEGIN ; Add current data into prev. detector:
;    REQ_ACTION = 'F '
    ; This code initiates MFIT, so hide the MFIT widget for certain options
;    WIDGET_CONTROL, WIDS.MFIT_BASE, MAP = 0
;ENDIF

; Set up the labels for hardcopy
N_ANNOTES = 0

ANNOTE, STRTRIM(COMMENT_DATA, 2), THE_PAGE_POS

FOR I = 1, NUM_DET DO BEGIN
   TEMP_FILE_NAME = STRLOWCASE( STRING(DATA_FILE_NAME(NUM_DET - I)) )
   BREAK_FILE, TEMP_FILE_NAME, TDEV, TDIR, TNAME, TEXT, TVER
   A_NOTE = 'FITS File: ' + TNAME + TEXT
   ANNOTE, A_NOTE, THE_PAGE_POS
ENDFOR

IF (NUM_DET EQ 1) THEN BEGIN
   LOOKUP_FILE = STRLOWCASE( LOOKUP_FILE )
   BREAK_FILE, LOOKUP_FILE, LDEV, LDIR, LNAME, LEXT, LVER
   A_NOTE = 'Lookup File: ' + LNAME + LEXT
   ANNOTE, A_NOTE, THE_PAGE_POS
ENDIF

IF (NUM_DET LE 2) THEN BEGIN
   DRM_LABEL = STRLOWCASE( DRM_LABEL )
   BREAK_FILE, DRM_LABEL, DDEV, DDIR, DNAME, DEXT, DVER
   A_NOTE = 'DRM File: ' + DNAME + DEXT
   ANNOTE, A_NOTE, THE_PAGE_POS
ENDIF

IF (NUM_DET LE 3) THEN BEGIN
   A_NOTE = 'Calib. Name: ' + STRTRIM(CTOE_LABEL, 2)
   ANNOTE, A_NOTE, THE_PAGE_POS
ENDIF

; If the DRM has changed, then the data must have also changed:
IF (NEW_DRM AND (NOT NEW_DATA)) THEN BEGIN
   PRINT, '* * * ERROR: INIT_MFIT: DRM is new, so the DATA must also be new'
   HELP, NEW_DRM, NEW_DATA
ENDIF

; Previous fit is meaningless if the data has changed:
IF (NEW_DRM OR NEW_DATA) THEN BEGIN

   ; Input arguments
   NUM_LIST       = LONG(0)
   MODEL_CHISQ    = -879.0
   HAVE_MODEL     = LONG(0)
   HAVE_FIT       = LONG(0)
   HAVE_1D_CHI    = LONG(0)
   HAVE_2D_CHI    = LONG(0)
   HAVE_GAUSS_CHI = LONG(0)
   COMMENT_FIT    = STRARR (3)
   COMMENT_FIT(0) = STRING (REPLICATE (32B, 80))
   COMMENT_FIT(1) = STRING (REPLICATE (32B, 80))
   COMMENT_FIT(2) = STRING (REPLICATE (32B, 80))
   TIME_TAG       = STRING(REPLICATE(32B, 18))
   IF (NEW_DRM) THEN BEGIN
      HAVE_YAXIS_LIMITS(CDET, *) = LONARR(MAX_PLOT_TYPE)
      HAVE_XAXIS_LIMITS(CDET, *) = LONARR(MAX_PLOT_TYPE)
   ENDIF

   ; Set up the net count rates = observed - background, and the corresponding
   ;  sigmas:
   T_CHAN_BEG   = CHAN_OFFSET
   T_CHAN_END   = T_CHAN_BEG + NUM_CHAN - LONG(1)
   USE_ALL_DET  = LONARR(MAX_DET) + LONG(1)
   CNT_RATE_SIG = FLTARR(MAX_CHAN, MAX_DET)
   STATUS = CALL_EXTERNAL('MFIT_SHARE', 'MGET_DATA_CR_VARI', $
                          NUM_DET, CHAN_OFFSET, CHAN_WIDTH, BACK_CSIG, $
                          LIVE_TIME, USE_ALL_DET, T_CHAN_BEG, T_CHAN_END, $
                          OBS_CRATE, CNT_RATE_SIG)
   NET_CRATE    = OBS_CRATE - BACK_CRATE
   CNT_RATE_SIG = SQRT(CNT_RATE_SIG)

ENDIF ; New data

; Get control variables
GET_CONTROL 

IF (REQ_ACTION EQ 'FO') OR $
   (REQ_ACTION EQ 'FS') OR $
   (REQ_ACTION EQ 'FA') OR $
   (REQ_ACTION EQ 'BF') THEN BEGIN
    
    REQ_ACTION = 'F '
    ; This code initiates MFIT, so hide the MFIT widget for certain options
    IF (WIDS.MFIT_BASE NE 0) THEN $
       WIDGET_CONTROL, WIDS.MFIT_BASE, MAP = 0
ENDIF

; Adjust plot parameters
IF ((REQ_ACTION EQ 'A ') AND (REQ_ACTION NE 'RS')) OR $
   (NOT HAVE_XAXIS_LIMITS(CDET,1)) THEN BEGIN            

   PLOT_SELECTIONS = ['Count Rate', $
                      'Photon Flux', $
                      'Count Residuals', $
                      'Photon Residuals', $
                      'Nu F_nu', $
;                      'Sigma Residuals', $ ; Not implemented
                      'CANCEL']
   IF HAVE_MODEL THEN BEGIN
      WANT_PLOT = WIDMENU(['Select plot type for adjustment', $
                           PLOT_SELECTIONS], TITLE = 0)
      IF (WANT_PLOT EQ N_ELEMENTS(PLOT_SELECTIONS)) THEN RETURN
      PLOT_TYPE = WANT_PLOT
   ENDIF ELSE PLOT_TYPE = 1  ; Handle count rate on first pass

   IF NOT HAVE_XAXIS_LIMITS(CDET, 1) THEN BEGIN
    
      M_SELECT_ENERGY, NUM_CHAN, NUM_DET, CHAN_OFFSET, $
                     CHAN_ENERGY, CHAN_WIDTH, OBS_CRATE, $
                     BACK_CRATE, LIVE_TIME, $
                     DET_NAMES, CNT_RATE_SIG, USED_REBIN, REBIN_CHAN, $
                     FIRST_CHAN_PLOT, LAST_CHAN_PLOT, XBEG, XEND, $
                     HAVE_XAXIS_LIMITS, CDET, /SILENT

      YLOG_VAL = LONG(YLOG EQ 'LOG')

      M_SELECT_CNTS, NUM_CHAN, NUM_DET, OBS_CRATE, BACK_CRATE, LIVE_TIME, $
                     DET_NAMES, $
                     CHAN_OFFSET, FIRST_CHAN_PLOT, LAST_CHAN_PLOT, $
                     CNT_RATE_SIG, YLOG_VAL, YBEG, YEND, $
                     HAVE_YAXIS_LIMITS

   ENDIF ELSE BEGIN
     
         YLOG_VAL = LONG(YLOG EQ 'LOG')

         IF HAVE_MODEL THEN BEGIN

         ; Always ask if the energy axis should be adjusted
         PRINT, ' '
         PRINT, FORMAT = $
               '($, "Change plot CHANNEL RANGE or ENERGY axis limits (Y/N)? ")'
         RESPONSE = GET_KBRD(1)
         PRINT, RESPONSE
         RESPONSE = STRUPCASE(RESPONSE)
         CASE RESPONSE OF
              'Y' : BEGIN
                    PRINT, ' '
                    PRINT, ' '
                    PRINT, '* * * MAKE CHANGES TO CHANNEL RANGE OR ENERGY AXIS LIMITS * * *'
                    M_SELECT_ENERGY, $
                       NUM_CHAN, NUM_DET, CHAN_OFFSET, $
                       CHAN_ENERGY, CHAN_WIDTH, OBS_CRATE, $
                       BACK_CRATE, LIVE_TIME, $
                       DET_NAMES, CNT_RATE_SIG, USED_REBIN, REBIN_CHAN, $
                       FIRST_CHAN_PLOT, LAST_CHAN_PLOT, XBEG, XEND, $
                       HAVE_XAXIS_LIMITS, CDET, /ADJUST
                    END
              ELSE:
         ENDCASE

         ; Now handle each of the individual plot choices
         CASE STRUPCASE(PLOT_SELECTIONS(WANT_PLOT-1)) OF

              'COUNT RATE': BEGIN
                 PRINT, ' '
                 PRINT, ' '
                 PRINT, '* * * MAKE CHANGES TO COUNT RATE AXIS LIMITS * * *'
                 M_SELECT_CNTS, $
                   NUM_CHAN, NUM_DET, OBS_CRATE, BACK_CRATE, $
                   LIVE_TIME, DET_NAMES, $
                   CHAN_OFFSET, FIRST_CHAN_PLOT, LAST_CHAN_PLOT, $
                   CNT_RATE_SIG, YLOG_VAL, YBEG, YEND, $
                   HAVE_YAXIS_LIMITS, /ADJUST
                 END

              'PHOTON FLUX': BEGIN
                 PRINT, ' '
                 PRINT, ' '
                 PRINT, '* * * MAKE CHANGES TO PHOTON FLUX AXIS LIMITS * * *'
                 M_SELECT_PHOTS, $
                   NUM_CHAN, NUM_DET, LIVE_TIME, DET_NAMES,  $
                   CHAN_OFFSET, PHOT_OBS_RATE, PHOT_OBS_SIG, $
                   FIRST_CHAN_PLOT, LAST_CHAN_PLOT, YLOG_VAL, $
                   YBEG, YEND, HAVE_YAXIS_LIMITS, /ADJUST
                 END
              'COUNT RESIDUALS': BEGIN
                 PRINT, ' '
                 PRINT, ' '
                 PRINT, '* * * MAKE CHANGES TO COUNT RATE RESIDUAL AXIS LIMITS * * *'
                 M_SELECT_RESID, NUM_DET, DET_NAMES, CNT_RESID, CNT_RATE_SIG, $
                   LIVE_TIME, CHAN_OFFSET, FIRST_CHAN_PLOT, $
                   LAST_CHAN_PLOT, PLOT_TYPE, $
                   YBEG, YEND, HAVE_YAXIS_LIMITS, /ADJUST
                 END
              'PHOTON RESIDUALS': BEGIN
                 PRINT, ' '
                 PRINT, ' '
                 PRINT, '* * * MAKE CHANGES TO PHOTON RATE RESIDUAL AXIS LIMITS * * *'
                 M_SELECT_RESID, NUM_DET, DET_NAMES, PHOT_RESID, $
                   PHOT_OBS_SIG,  LIVE_TIME, CHAN_OFFSET, FIRST_CHAN_PLOT, $
                   LAST_CHAN_PLOT, PLOT_TYPE, $
                   YBEG, YEND, HAVE_YAXIS_LIMITS, /ADJUST
                 END
              'NU F_NU': BEGIN
                 PRINT, ' '
                 PRINT, ' '
                 PRINT, '* * * MAKE CHANGES TO NU F_NU AXIS LIMITS * * *'
                 M_SELECT_NUFNU, $
                   NUM_CHAN, NUM_DET, LIVE_TIME, DET_NAMES,  $
                   CHAN_OFFSET, NU_F_NU_DATA, NU_F_NU_SIG, $
                   FIRST_CHAN_PLOT, LAST_CHAN_PLOT, YLOG_VAL, $
                   YBEG, YEND, HAVE_YAXIS_LIMITS, /ADJUST
                 END
              ELSE: 
         ENDCASE

         ENDIF ; HAVE_MODEL

   ENDELSE
ENDIF

HC_OPTION = 0
HARDCOPY_ONLY:

IF REQ_ACTION EQ 'P ' THEN BEGIN
   IF HAVE_MODEL THEN BEGIN
       ; The plot options:
       ; OPTION = ['Count Rate', 
       ;           'Photon Flux', $
       ;           'Count Rate Residuals', $
       ;           'Photon Flux Residuals', $
       ;           'nu_F_nu = d(Eflux)/d(log E)', $
       ;           'Sigma Residuals'] 
      OPTION = MFIT_PLOT_OPTION - 1

      ; Add the fit notes
      ; Reset number of notes: earlier ones don't change
      N_ANNOTES = 5

      A_NOTE = STRTRIM(MFIT_VERSION_TAG, 2) + $
                      ' Called By: ' + STRTRIM(CALLING_PROG, 2)
      ANNOTE, A_NOTE, THE_PAGE_POS

      A_NOTE = 'Fit at: ' + STRTRIM(TIME_TAG, 2)
      ANNOTE, A_NOTE, THE_PAGE_POS

      ANNOTE, '  ', THE_PAGE_POS

      NUM_COMM = 3
      FOR QQ = 0, NUM_COMM - 1 DO BEGIN
          TEMP_STR = COMMENT_FIT(QQ)
          ANNOTE, STRTRIM(TEMP_STR, 2), THE_PAGE_POS, /LEFT_ALIGN
      ENDFOR
   ENDIF ELSE OPTION = -1

   YLOG_VAL = LONG(YLOG EQ 'LOG')

   ; Plotting residuals?
;   IF (WGSP_PLOT_RESIDUALS EQ 1) THEN BEGIN
;      IF (OPTION EQ 0) OR (OPTION EQ 1) OR (OPTION EQ 4) THEN BEGIN
;         NOREASE_SAVE   = !P.NOERASE
;         XTICKNAME_SAVE = !X.TICKNAME
;         POSITION_SAVE = THE_PAGE_POS
;         XAXIS_LABEL_SAVE = XAXIS_LABEL
;         !P.NOERASE = 1
;         ERASE
;         XAXIS_LABEL = ''
;         !X.TICKNAME = REPLICATE(' ', 30)
;         THE_PAGE_POS = [0.093755, 0.249224, 0.971880, 0.964849]
;      ENDIF
;   ENDIF

   IF (OPTION EQ 0) OR (OPTION EQ -1) THEN BEGIN
      ; Count Spectrum
      WGSP_LAST_PLOT = 'COUNT RATE'
      IF HC_OPTION EQ 0 THEN $
         MFIT_INFORM, 'Count Rate.  Ready.', /NO_STATUS $
      ELSE $
         MFIT_INFORM, 'Creating Hardcopy: Count Rate.'
      
      PLOT_TYPE = LONG(1)                       

      PLOT_MODEL = LONG(0)
      IF HAVE_MODEL THEN PLOT_MODEL = LONG(1)
      IF CV_PLOT_ONLY_DATA THEN PLOT_MODEL = LONG(0)

      IF (CV_MULTI_DET_PLOT_MODE EQ 'S') OR $
         (CV_MULTI_DET_PLOT_MODE EQ 'C') THEN BEGIN
         FOR LDET = 0, NUM_DET - 1 DO BEGIN
             IF USE_DET(LDET) THEN BEGIN
                IF (N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1) THEN BEGIN
                   MULTI_FLAG = 0
                ENDIF ELSE BEGIN
                   MULTI_FLAG = 1
                   IF LDET EQ 0 THEN $
                      CASE N_ELEMENTS(WHERE(USE_DET)) OF
                           2: !P.MULTI = [0, 2, 1]
                           3: !P.MULTI = [0, 2, 2]
                           4: !P.MULTI = [0, 2, 2]
                           ELSE: MULTI_FLAG = 0
                      ENDCASE
                ENDELSE
                MODEL_PLOTTER, THE_PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
             ENDIF
         ENDFOR
      ENDIF ELSE BEGIN
         MULTI_MODEL_PLOT, THE_PAGE_POS, HC_OPTION
      ENDELSE
   ENDIF

   IF OPTION EQ 1 THEN BEGIN
      ; Photon Spectrum
      WGSP_LAST_PLOT = 'PHOTON FLUX'
      IF HC_OPTION EQ 0 THEN $
         MFIT_INFORM, 'Photon Flux.  Ready. ', /NO_STATUS $
      ELSE $
         MFIT_INFORM, 'Creating Hardcopy: Photon Flux.'

      PLOT_TYPE = LONG(2)                       

      FLAG = LONG(0)
      FOR LDET = 0, NUM_DET - 1 DO BEGIN
          IF USE_DET(LDET) AND (NOT HAVE_YAXIS_LIMITS(LDET, PLOT_TYPE)) THEN $
             FLAG = LONG(-1)
      ENDFOR
      IF FLAG THEN $
          M_SELECT_PHOTS, $
                  NUM_CHAN, NUM_DET, LIVE_TIME, DET_NAMES, CHAN_OFFSET, $
                  PHOT_OBS_RATE, PHOT_OBS_SIG, $
                  FIRST_CHAN_PLOT, LAST_CHAN_PLOT, YLOG_VAL, YBEG, YEND, $
                  HAVE_YAXIS_LIMITS

      PLOT_MODEL = LONG(1)
      IF CV_PLOT_ONLY_DATA THEN PLOT_MODEL = LONG(0)

      IF CV_MULTI_DET_PLOT_MODE EQ 'S' THEN BEGIN
         FOR LDET = 0, NUM_DET - 1 DO BEGIN
             IF USE_DET(LDET) THEN BEGIN
                IF (N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1) THEN BEGIN
                   MULTI_FLAG = 0
                ENDIF ELSE BEGIN
                   MULTI_FLAG = 1
                   IF LDET EQ 0 THEN $
                      CASE N_ELEMENTS(WHERE(USE_DET)) OF
                           2: !P.MULTI = [0, 2, 1]
                           3: !P.MULTI = [0, 2, 2]
                           4: !P.MULTI = [0, 2, 2]
                           ELSE: MULTI_FLAG = 0
                      ENDCASE
                ENDELSE
                MODEL_PLOTTER, THE_PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
             ENDIF
         ENDFOR
      ENDIF ELSE BEGIN
         MULTI_MODEL_PLOT, THE_PAGE_POS, HC_OPTION
      ENDELSE

   ENDIF

   IF OPTION EQ 2 THEN BEGIN
      ; Count residuals
      WGSP_LAST_PLOT = 'COUNT RESIDUALS'
      IF HC_OPTION EQ 0 THEN $
         MFIT_INFORM, 'Count Rate Residuals.  Ready.', /NO_STATUS $
      ELSE $
         MFIT_INFORM, 'Creating Hardcopy: Count Rate Residuals.' 

      PLOT_TYPE  = LONG(3)                       
      PLOT_MODEL = LONG(0)

      FOR LDET = 0, NUM_DET - 1 DO BEGIN
          IF USE_DET(LDET) THEN BEGIN
             IF NOT HAVE_YAXIS_LIMITS(LDET, PLOT_TYPE) THEN $
                M_SELECT_RESID, NUM_DET, DET_NAMES, CNT_RESID, CNT_RATE_SIG, $
                                LIVE_TIME, CHAN_OFFSET, FIRST_CHAN_PLOT, $
                                LAST_CHAN_PLOT, PLOT_TYPE, $
                                YBEG, YEND, HAVE_YAXIS_LIMITS

             IF (N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1) THEN BEGIN
                MULTI_FLAG = 0
             ENDIF ELSE BEGIN
                MULTI_FLAG = 1
                IF LDET EQ 0 THEN $
                   CASE N_ELEMENTS(WHERE(USE_DET)) OF
                        2: !P.MULTI = [0, 2, 1]
                        3: !P.MULTI = [0, 2, 2]
                        4: !P.MULTI = [0, 2, 2]
                        ELSE: MULTI_FLAG = 0
                   ENDCASE
             ENDELSE
             MODEL_PLOTTER, THE_PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
          ENDIF
      ENDFOR
   ENDIF


   IF OPTION EQ 3 THEN BEGIN
      ; Photon residuals
      WGSP_LAST_PLOT = 'PHOTON RESIDUALS'
      IF HC_OPTION EQ 0 THEN $
         MFIT_INFORM, 'Photon Flux Residuals.  Ready.', /NO_STATUS $
      ELSE $
         MFIT_INFORM, 'Creating Hardcopy: Photon Flux Residuals.'

         PLOT_TYPE  = LONG(4)                       
         PLOT_MODEL = LONG(0)

         FOR LDET = 0, NUM_DET - 1 DO BEGIN
             IF USE_DET(LDET) THEN BEGIN
                IF NOT HAVE_YAXIS_LIMITS(LDET, PLOT_TYPE) THEN $
                   M_SELECT_RESID, NUM_DET, DET_NAMES, PHOT_RESID, $
                            PHOT_OBS_SIG,  $
                            LIVE_TIME, CHAN_OFFSET, FIRST_CHAN_PLOT, $
                            LAST_CHAN_PLOT, PLOT_TYPE, $
                            YBEG, YEND, HAVE_YAXIS_LIMITS

                IF (N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1) THEN BEGIN
                   MULTI_FLAG = 0
                ENDIF ELSE BEGIN
                   MULTI_FLAG = 1
                   IF LDET EQ 0 THEN $
                      CASE N_ELEMENTS(WHERE(USE_DET)) OF
                           2: !P.MULTI = [0, 2, 1]
                           3: !P.MULTI = [0, 2, 2]
                           4: !P.MULTI = [0, 2, 2]
                           ELSE: MULTI_FLAG = 0
                      ENDCASE
                ENDELSE
                MODEL_PLOTTER, THE_PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
             ENDIF
         ENDFOR
   ENDIF

   IF OPTION EQ 4 THEN BEGIN
      ; Nu-f-nu plot
      WGSP_LAST_PLOT = 'NUFNU'
      IF HC_OPTION EQ 0 THEN $
         MFIT_INFORM, 'Nu F_nu = d(Eflux)/d(log E).  Ready.', /NO_STATUS $
      ELSE $
         MFIT_INFORM, 'Creating Hardcopy: Nu F_nu.' 

      PLOT_TYPE = LONG(5)                       

      FLAG = LONG(0)
      FOR LDET = 0, NUM_DET - 1 DO BEGIN
          IF USE_DET(LDET) AND (NOT HAVE_YAXIS_LIMITS(LDET, PLOT_TYPE)) THEN $
             FLAG = LONG(-1)
      ENDFOR

      IF FLAG THEN $
         M_SELECT_NUFNU, $
                     NUM_CHAN, NUM_DET, LIVE_TIME, DET_NAMES,  $
                     CHAN_OFFSET, NU_F_NU_DATA, NU_F_NU_SIG, $
                     FIRST_CHAN_PLOT, LAST_CHAN_PLOT, YLOG_VAL, YBEG, YEND, $
                     HAVE_YAXIS_LIMITS

      PLOT_MODEL = LONG(1)
      IF CV_PLOT_ONLY_DATA THEN PLOT_MODEL = LONG(0)

      IF CV_MULTI_DET_PLOT_MODE EQ 'S' THEN BEGIN
          FOR LDET = 0, NUM_DET - 1 DO BEGIN
              IF USE_DET(LDET) THEN BEGIN
                 IF (N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1) THEN BEGIN
                    MULTI_FLAG = 0
                 ENDIF ELSE BEGIN
                    MULTI_FLAG = 1
                    IF LDET EQ 0 THEN $
                       CASE N_ELEMENTS(WHERE(USE_DET)) OF
                            2: !P.MULTI = [0, 2, 1]
                            3: !P.MULTI = [0, 2, 2]
                            4: !P.MULTI = [0, 2, 2]
                            ELSE: MULTI_FLAG = 0
                       ENDCASE
                 ENDELSE
                 MODEL_PLOTTER, THE_PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
              ENDIF
          ENDFOR
      ENDIF ELSE BEGIN
          MULTI_MODEL_PLOT, THE_PAGE_POS, HC_OPTION
      ENDELSE
   ENDIF

   IF OPTION EQ 5 THEN BEGIN                  
      ; Sigma Residuals
      WGSP_LAST_PLOT = 'SIGMA RESIDUALS'
      IF HC_OPTION EQ 0 THEN $
         MFIT_INFORM, 'Sigma Residuals.  Ready.', /NO_STATUS $
      ELSE $
         MFIT_INFORM, 'Creating Hardcopy: Sigma Residuals.' 

      PLOT_TYPE = LONG(6)                       
      PLOT_MODEL = LONG(1)

      FOR LDET = 0, NUM_DET - 1 DO BEGIN
          IF USE_DET(LDET) THEN BEGIN
             IF (N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1) THEN BEGIN
                MULTI_FLAG = 0
             ENDIF ELSE BEGIN
                MULTI_FLAG = 1
                IF LDET EQ 0 THEN $
                   CASE N_ELEMENTS(WHERE(USE_DET)) OF
                        2: !P.MULTI = [0, 2, 1]
                        3: !P.MULTI = [0, 2, 2]
                        4: !P.MULTI = [0, 2, 2]
                        ELSE: MULTI_FLAG = 0
                   ENDCASE
             ENDELSE
             SIGMA_PLOT, THE_PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
             ; Set the axis ranges - special case for sigma residuals
             IF (!X.TYPE EQ 1) THEN BEGIN
                XBEG(LDET, 6) = 10.0^!X.CRANGE(0)
                XEND(LDET, 6) = 10.0^!X.CRANGE(1)
             ENDIF ELSE BEGIN
                XBEG(LDET, 6) = !X.CRANGE(0)
                XEND(LDET, 6) = !X.CRANGE(1)
             ENDELSE
             IF (!Y.TYPE EQ 1) THEN BEGIN
                YBEG(LDET, 6) = 10.0^!Y.CRANGE(0)
                YEND(LDET, 6) = 10.0^!Y.CRANGE(1)
             ENDIF ELSE BEGIN
                YBEG(LDET, 6) = !Y.CRANGE(0)
                YEND(LDET, 6) = !Y.CRANGE(1)
             ENDELSE
          ENDIF
      ENDFOR
   ENDIF

   ; Plotting residuals?
;   IF (WGSP_PLOT_RESIDUALS EQ 1) THEN BEGIN
;      IF (OPTION EQ 0) OR (OPTION EQ 1) OR (OPTION EQ 4) THEN BEGIN
;         TITLE_SAVE = CURRENT_VALUES(8)
;         CURRENT_VALUES(8) = ''
;         YMINOR_SAVE = !Y.MINOR
;         !Y.MINOR = 2
;         XAXIS_LABEL = XAXIS_LABEL_SAVE
;         THE_PAGE_POS = [0.093755, 0.0703175, 0.971880, 0.249224]
;; LOOP FOR NOW
;         FOR LDET = 0, NUM_DET - 1 DO BEGIN
;; FOR NOW
;             MULTI_FLAG = 0
;             SIGMA_PLOT, THE_PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
;         ENDFOR
;         !P.POSITION = POSITION_SAVE 
;         !P.NOERASE  = NOREASE_SAVE
;         !X.TICKNAME = XTICKNAME_SAVE
;         !Y.MINOR    = YMINOR_SAVE
;         CURRENT_VALUES(8) = TITLE_SAVE
;      ENDIF
;   ENDIF



ENDIF ; REQ_ACTION EQ 'P ' 

; Handle subsequent requests for chi-square plots:
IF (REQ_ACTION EQ '1 ') AND HAVE_1D_CHI THEN BEGIN
   IF WIDMENU(['Chi 1D Plot:', 'Replot', 'Recalculate'], TITLE = 0) THEN BEGIN
      WGSP_LAST_PLOT = 'CHI1D'
      CHI_1D_PLOT, THE_PAGE_POS, 0
      PRINT, ' '
      RETURN
   ENDIF
ENDIF

IF (REQ_ACTION EQ '2 ') AND HAVE_2D_CHI THEN BEGIN
   IF WIDMENU(['Chi 2D Plot:', 'Replot', 'Recalculate'], TITLE = 0) THEN BEGIN
      WGSP_LAST_PLOT = 'CHI2D'
      CHI_2D_PLOT, THE_PAGE_POS, 0
      PRINT, ' '
      RETURN
   ENDIF
ENDIF



IF REQ_ACTION EQ 'F ' OR $
   REQ_ACTION EQ 'FG' OR $    
   REQ_ACTION EQ '1 ' OR $
   REQ_ACTION EQ '2 ' OR $
   REQ_ACTION EQ 'S ' OR $
   REQ_ACTION EQ 'RT' OR $
   REQ_ACTION EQ 'WT' OR $ 
   REQ_ACTION EQ 'ET' OR $
   REQ_ACTION EQ 'RS' OR $     ; disabled (read synthetic)
   REQ_ACTION EQ 'WA' OR $
   REQ_ACTION EQ 'WS' OR $    
   REQ_ACTION EQ 'WB' OR $
   REQ_ACTION EQ 'CB' THEN BEGIN

   MPASS_ADD = LONARR(100)
   MPASS_ADD(0)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', FIRST_MODEL_PLOT)
   MPASS_ADD(1)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', LAST_MODEL_PLOT)
   MPASS_ADD(2)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', FIRST_EXTRAP_PLOT)
   MPASS_ADD(3)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', LAST_EXTRAP_PLOT)
   MPASS_ADD(4)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', TERM_USED)
   MPASS_ADD(5)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NUM_TERMS_AVAIL)
   MPASS_ADD(6)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NUM_CHI)
   MPASS_ADD(7)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', MODEL_CHISQ)
   MPASS_ADD(8)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', X_BEST_VALUE)
   MPASS_ADD(9)  = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', Y_BEST_VALUE)
   MPASS_ADD(10) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', X_PARAM_VALS)
   MPASS_ADD(11) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', Y_PARAM_VALS)
   MPASS_ADD(12) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', CHI_1D_VALS)
   MPASS_ADD(13) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', CHI_2D_VALS)
   MPASS_ADD(14) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NUM_LIST)
   MPASS_ADD(15) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', PARAM_LIST)
   MPASS_ADD(16) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', PARAM_UNCER_LIST)
   MPASS_ADD(17) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', DOF)
   MPASS_ADD(18) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NUM_VARY)
   MPASS_ADD(19) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', FIT_ERR)
   MPASS_ADD(20) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', GAUSS_VWIDTH)
   MPASS_ADD(21) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NEW_DRM)
   MPASS_ADD(22) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NEW_DATA)
   MPASS_ADD(23) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', HAVE_MODEL)
   MPASS_ADD(24) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', HAVE_FIT)
   MPASS_ADD(25) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', HAVE_1D_CHI)
   MPASS_ADD(26) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', HAVE_2D_CHI)
   MPASS_ADD(27) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', HAVE_GAUSS_CHI)
   MPASS_ADD(28) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NUM_CHAN )    
   MPASS_ADD(29) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NUM_DET )   
   MPASS_ADD(30) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', CHAN_OFFSET)   
   MPASS_ADD(31) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', CHAN_ENERGY) 
   MPASS_ADD(32) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', CHAN_WIDTH)  
   MPASS_ADD(33) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', OBS_CRATE) 
   MPASS_ADD(34) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', BACK_CRATE) 
   MPASS_ADD(35) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', BACK_CSIG) 
   MPASS_ADD(36) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', LIVE_TIME)  
   MPASS_ADD(37) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NUM_EBINS) 
   MPASS_ADD(38) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', PHOT_ENERGY) 
   MPASS_ADD(39) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', PHOT_WIDTH) 
   MPASS_ADD(40) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', DRM_DIM1) 
   MPASS_ADD(41) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', DRM_DIM2) 
   MPASS_ADD(42) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', DRM_DIM3) 
   MPASS_ADD(43) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', DRM) 
   MPASS_ADD(44) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', RES_FRAC_AT511) 
   MPASS_ADD(45) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', RES_EXP) 
   MPASS_ADD(46) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', FIRST_CHAN_PLOT) 
   MPASS_ADD(47) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', LAST_CHAN_PLOT) 
   MPASS_ADD(48) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', USED_REBIN) 
   MPASS_ADD(49) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', REBIN_CHAN) 
   MPASS_ADD(50) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', XBEG) 
   MPASS_ADD(51) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', XEND) 
   MPASS_ADD(52) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', YBEG) 
   MPASS_ADD(53) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', YEND) 
   MPASS_ADD(54) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', HAVE_XAXIS_LIMITS) 
   MPASS_ADD(55) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', HAVE_YAXIS_LIMITS)
   MPASS_ADD(56) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', FIRST_CHAN_FIT) 
   MPASS_ADD(57) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', LAST_CHAN_FIT) 
   MPASS_ADD(58) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', USE_DET) 
   MPASS_ADD(59) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', MODEL_CNT_RATE) 
   MPASS_ADD(60) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', PHOT_OBS_RATE) 
   MPASS_ADD(61) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', PHOT_OBS_SIG)       
   MPASS_ADD(62) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', CNT_RESID)    
   MPASS_ADD(63) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', PHOT_RESID)
   MPASS_ADD(64) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NU_F_NU_DATA) 
   MPASS_ADD(65) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NU_F_NU_SIG) 
   MPASS_ADD(66) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', NU_F_NU_MODEL) 
   MPASS_ADD(67) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', MODEL_ENERGY) 
   MPASS_ADD(68) = CALL_EXTERNAL('MFIT_SHARE', 'M_LOC', MODEL_PHOT_RATE) 

   ; Convert the IDL string arrays into FORTRAN character arrays:
   PASS_DET_NAMES        = IDL_TO_FOR(DET_NAMES, MAX_DET, 12)
   PASS_DATA_FILE_NAME   = IDL_TO_FOR(DATA_FILE_NAME, MAX_DET, 70)

   PASS_COMMENT_FIT      = IDL_TO_FOR(COMMENT_FIT, 3, 80)
   PASS_PARAM_LABEL_LIST = IDL_TO_FOR(PARAM_LABEL_LIST, MAX_PARAM, 57)

   ; Before calling MFIT, the UNIX signal SIGALRM must be blocked because
   ;  IDL widgets use this signal for all timing events, which interferes
   ;  with system calls during CALL_EXTERNAL (e.g I/O)
   IF (STRUPCASE(!VERSION.OS) NE 'VMS') THEN BEGIN
      STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BLOCK_SIGALRM')
   ENDIF

   STATUS = CALL_EXTERNAL('MFIT_SHARE','MFIT_IDL_INTERFACE', $
                MPASS_ADD, $
                PASS_DET_NAMES, $
                TOPLABEL, $
                PASS_DATA_FILE_NAME,$
                COMMENT_DATA, $
                CALLING_PROG, $
                DRM_LABEL, $
                CTOE_LABEL, $
                MFIT_FUNCINFO_FILENAME, $
                MFIT_CONTROL_FILENAME, $
                MFIT_SUPER_VER, $
                PASS_COMMENT_FIT, $ 
                MFIT_VERSION_TAG, $
                TIME_TAG, $
                X_CHI_LABEL, $ 
                Y_CHI_LABEL, $
                PASS_PARAM_LABEL_LIST, $ 
                REQ_ACTION, $
                RUN_MODE)

   ; MFIT is done; restore the default state of SIGALRM handling
   IF (STRUPCASE(!VERSION.OS) NE 'VMS') THEN BEGIN
      STATUS = CALL_EXTERNAL('MFIT_SHARE', 'CATCH_SIGALRM')
   ENDIF

   ; Convert the FORTRAN character arrays back into IDL string arrays:
   DET_NAMES        = FOR_TO_IDL(PASS_DET_NAMES, MAX_DET, 12)
   DATA_FILE_NAME   = FOR_TO_IDL(PASS_DATA_FILE_NAME, MAX_DET, 70)
   COMMENT_FIT      = FOR_TO_IDL(PASS_COMMENT_FIT, 3, 80)
   PARAM_LABEL_LIST = FOR_TO_IDL(PASS_PARAM_LABEL_LIST, MAX_PARAM, 57)

   N_ANNOTES = 5         ;Reset number of notes: earlier ones don't change

   A_NOTE = STRTRIM(MFIT_VERSION_TAG, 2) + $
                        ' Called By: ' + STRTRIM(CALLING_PROG, 2)
   ANNOTE, A_NOTE, THE_PAGE_POS

   A_NOTE = 'Fit at: ' + STRTRIM(TIME_TAG, 2)
   ANNOTE, A_NOTE, THE_PAGE_POS

   ANNOTE, '  ', THE_PAGE_POS

   NUM_COMM = 3
   FOR QQ = 0, NUM_COMM - 1 DO BEGIN
       TEMP_STR = COMMENT_FIT(QQ)
       ANNOTE, STRTRIM(TEMP_STR, 2), THE_PAGE_POS, /LEFT_ALIGN
   ENDFOR

   IF REQ_ACTION EQ '1 ' THEN BEGIN
      WGSP_LAST_PLOT = 'CHI1D'
      CHI_1D_PLOT, THE_PAGE_POS, 0
      PRINT, ' '
   ENDIF

   IF REQ_ACTION EQ '2 ' THEN BEGIN
      WGSP_LAST_PLOT = 'CHI2D'
      CHI_2D_PLOT, THE_PAGE_POS, 0
      PRINT, ' '
   ENDIF

   IF REQ_ACTION EQ 'FG' THEN BEGIN
      IF NOT HAVE_GAUSS_CHI THEN $
         MFIT_INFORM, 'MFIT_SUPER ERROR: GAUSS chi-square info not available.' $
      ELSE BEGIN
         WGSP_LAST_PLOT = 'FIT GAUSS'
         FIT_GAUSS_PLOT, THE_PAGE_POS, 0
         PRINT, ' '
      ENDELSE
   ENDIF

   IF RUN_MODE EQ 'B' THEN BEGIN
      RETURN
   ENDIF

ENDIF

; Get control variables
GET_CONTROL                      

!P.MULTI = MULTI_SAVE



END ; INIT_MFIT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO W_MFIT_SELECT, BUTTON_COMMAND, MFIT_PLOT_OPTION
; Called from W_MFIT; this PRO processes the selected event

@wgsp_cb.pro
; Some things need to be stored between calls, so that the 'Display Fit
;  Parameters' functions work
COMMON BATCHFIT_C, BATCH_TIMES, PARAM_HIST, PARAM_UNCER_HIST, RESID_CONTOURS, $
                   NUFNU_CONTOURS, PARAM_STORE, NUM_STORE, HAVE_APLOT, $
                   BATCH_SELECT, ENERGY_SCALE, RATE_SCALE, T_IND 
COMMON MFIT_BUTTON_IDS, MFIT_BID


THE_PP    = [0.1, 0.28, 0.86, 0.86]
DATA_TITL = READ_MENU(8)  

CASE 1 OF 
     ; Display fit parameters
     BUTTON_COMMAND EQ 'PARAMETER TIME HISTORY': BEGIN
            PARAM_OPTION = 1
            BUTTON_COMMAND = 'DISPLAY FIT PARAMETERS'
            END
     BUTTON_COMMAND EQ 'ONE PARAMETER VS. ANOTHER': BEGIN
            PARAM_OPTION = 2
            BUTTON_COMMAND = 'DISPLAY FIT PARAMETERS'
            END
     BUTTON_COMMAND EQ 'PARAMETER HISTOGRAM': BEGIN
            PARAM_OPTION = 3
            BUTTON_COMMAND = 'DISPLAY FIT PARAMETERS'
            END
     BUTTON_COMMAND EQ 'SIGMA RESIDUALS MAP': BEGIN
            PARAM_OPTION = 4
            BUTTON_COMMAND = 'DISPLAY FIT PARAMETERS'
            END
     BUTTON_COMMAND EQ 'MODEL NU-F-NU CONTOURS': BEGIN
            PARAM_OPTION = 5
            BUTTON_COMMAND = 'DISPLAY FIT PARAMETERS'
            END

     ; Plot
     BUTTON_COMMAND EQ 'COUNT RATE': BUTTON_COMMAND = 'PLOT'
     BUTTON_COMMAND EQ 'PHOTON FLUX': BUTTON_COMMAND = 'PLOT'
     BUTTON_COMMAND EQ 'COUNT RATE RESIDUALS': BUTTON_COMMAND = 'PLOT'
     BUTTON_COMMAND EQ 'PHOTON FLUX RESIDUALS': BUTTON_COMMAND = 'PLOT'
     BUTTON_COMMAND EQ 'NU_F_NU = D(EFLUX) / D(LOG(E))': BUTTON_COMMAND = 'PLOT'
     BUTTON_COMMAND EQ 'SIGMA RESIDUALS': BUTTON_COMMAND = 'PLOT'

     ; Else do nothing
     ELSE:
ENDCASE

BATCH_SELECT = 0

; MFIT_WINDOW in COMMON
WSET, MFIT_WINDOW

CASE STRUPCASE(BUTTON_COMMAND) OF

     'FIT ONE SPECTRUM': BEGIN
        ; If FIT PARAMETERS have been zoomed, 
        ;  axis ranges must be reset for HISTORY
        IF (HAVE_ZOOMED_PARAM EQ 1) THEN BEGIN
           TIME_RANGE = INIT_TIME_RANGE
           HIST_RANGE = INIT_HIST_RANGE  
        ENDIF
        WGSP_LAST_PLOT = 'HISTORY'
        WW_UPDATE, 'HISTORY'
SELECT_AGAIN:
        STATUS = TRACK_ONE(X, Y)
        ; Bail out: EXIT
        IF STATUS EQ 1 THEN GOTO, DONE       
        ; Allow user to reset the plot
        IF STATUS EQ 2 THEN BEGIN        
           WW_UPDATE, 'HISTORY'
           GOTO, SELECT_AGAIN
        ENDIF
        ; Numerical entry
        IF STATUS EQ 3 THEN BEGIN        
           WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
NUM_AGAIN:
           READ, 'Enter any time value in the desired interval: ', X
           IF (X LT !X.CRANGE(0)) OR (X GT !X.CRANGE(1)) THEN BEGIN
              PRINT, ' '
              PRINT, 'Select a value in the plotted range.'
              PRINT, ' '
              GOTO, NUM_AGAIN
           ENDIF
           X_TEMP = NEAREST_EDGE(COMBINED_TIMES, [X, X])
           OPLOT, [X_TEMP(0), X_TEMP(0)], !Y.CRANGE, LINESTYLE = 1, THICK = 2
           OPLOT, [X_TEMP(1), X_TEMP(1)], !Y.CRANGE, LINESTYLE = 1, THICK = 2
           ANS = 'Y'
           READ, 'Do you want to fit this spectrum (<CR> = Y)? ', ANS
           ANS = STRUPCASE(ANS)
           IF (ANS NE 'Y') AND (ANS NE 'YES') AND (ANS NE '') THEN BEGIN
              WW_UPDATE, 'HISTORY'
              GOTO, NUM_AGAIN
           ENDIF ELSE BEGIN
              WW_UPDATE, 'HISTORY'
           ENDELSE
        ENDIF

        T_IND = SEARCH(COMBINED_TIMES(0, *), X)

        RUN_MODE = STRING(FORMAT='(A1)', 'I') ; Interactive mode
        IF NOT HAVE_DRM THEN MFIT_INFORM, 'Searching for DRM file.'
        END

     'RE-FIT LAST SPECTRUM': BEGIN
         RUN_MODE = STRING(FORMAT='(A1)', 'I')  ; Put in interactive mode
         NEW_DATA = LONG(0)                     ; Passing in old data to MFIT
         INIT_MFIT, THE_PP, BUTTON_COMMAND
         GOTO, DONE
         END

     'READ FIT TEMPLATE': BEGIN
         RUN_MODE = STRING(FORMAT='(A1)', 'I')  ; Put in interactive mode
         COUNT_SPAN, COMBINED_TIMES, TIME_SPAN, T_IND
         SPEC_TITLE = CREATE_LABEL(COMBINED_TIMES, TIME_SPAN(0, *), ' s')
         DATA_COMM = SPEC_TITLE + ' of ' + DATA_TITL 
         NEW_DATA = LONG(1)                     ; Passing in new data to MFIT
         WIDGET_CONTROL, WIDS.MFIT_BASE, MAP = 0
         WRITE_SPEC, T_IND, DATA_TITL, DATA_COMM, THE_PP, IO_ERR, BUTTON_COMMAND
         WIDGET_CONTROL, WIDS.MFIT_BASE, MAP = 1
         GOTO, DONE
         END

     'WRITE FIT TEMPLATE': BEGIN
         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
         INIT_MFIT, THE_PP, BUTTON_COMMAND
         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 1
         GOTO, DONE
         END

     'EDIT FIT TEMPLATE': BEGIN
         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
         INIT_MFIT, THE_PP, BUTTON_COMMAND
         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 1
         GOTO, DONE
         END

     'WRITE ASCII FIT INFORMATION': BEGIN
         RUN_MODE = STRING(FORMAT='(A1)', 'I')  ; Put in interactive mode
         NEW_DATA = LONG(0)                     ; Passing in old data to MFIT
         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
         IF (STRCOMPRESS(CV_ASCII_OUT_FILE, /REMOVE_ALL) EQ '?') THEN BEGIN
            MFIT_INFORM, 'Data written to file.  Ready.'
         ENDIF ELSE BEGIN
            IF (STRCOMPRESS(CV_ASCII_OUT_FILE, /REMOVE_ALL) EQ '') THEN BEGIN
               BREAK_FILE, CURRENT_VALUES(6), FDEV, FDIR, FNAME
               FILE_OUT = FNAME + '.MFIT_ASCII'
            ENDIF ELSE BEGIN
               IF (STRPOS(CV_ASCII_OUT_FILE, '.MFIT_ASCII') EQ -1) OR $
                  (STRPOS(CV_ASCII_OUT_FILE, '.mfit_ascii') EQ -1) THEN BEGIN
                  FILE_OUT = CV_ASCII_OUT_FILE + '.MFIT_BATCH' 
               ENDIF ELSE FILE_OUT = CV_ASCII_OUT_FILE 
            ENDELSE
            IF (FILE_OUT EQ CV_ASCII_OUT_FILE) THEN CURRENT_DIR = '' ELSE $
               CD, CURRENT = CURRENT_DIR
            FILE_OUT = STRLOWCASE(STRCOMPRESS(FILE_OUT, /REMOVE_ALL))
            MFIT_INFORM, 'Data written to file ' + $
                         STRLOWCASE(CURRENT_DIR) + $
                         STRLOWCASE(FILE_OUT) + '.  Ready.'
         ENDELSE
         INIT_MFIT, THE_PP, BUTTON_COMMAND
         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 1
         RETURN
         END

     'FIT SUMMED SELECTIONS': BEGIN
        ; Interactive mode
        RUN_MODE = STRING(FORMAT='(A1)', 'I') 
        COUNT_SPAN, COMBINED_TIMES, TIME_SPAN, T_IND
        SPEC_TITLE = CREATE_LABEL(COMBINED_TIMES, TIME_SPAN(0, *), ' s')
        DATA_COMM = SPEC_TITLE + ' of ' + DATA_TITL 
        NEW_DATA = LONG(1)                     ; Passing in new data to MFIT
        THE_FIT_ERR = 1

        WRITE_SPEC, T_IND, DATA_TITL, DATA_COMM, THE_PP, IO_ERR, BUTTON_COMMAND
          
        IF IO_ERR EQ -1 THEN GOTO, DONE     ; No background chosen: bail
        GOTO, DONE
        END

     'ADD SELECTION AND FIT': BEGIN
        CHOICES = ['Choose a detector to add into:', DET_NAMES(0: NUM_DET - 2)]
        THE_DET = WIDMENU(CHOICES, TITLE = 0) - 1
        RUN_MODE = STRING(FORMAT='(A1)', 'I') ; Interactive mode: Important! 
;        DATA_TITL = READ_MENU(8)  
        COUNT_SPAN, COMBINED_TIMES, TIME_SPAN, T_IND
        SPEC_TITLE = CREATE_LABEL(COMBINED_TIMES, TIME_SPAN(0, *), ' s')
        DATA_COMM = SPEC_TITLE + ' of ' + DATA_TITL 
;        PASS_COMMAND = STRING(FORMAT='(A2)', 'FA')       ; Fit regardless
        NEW_DATA = LONG(1)                     ; Passing in new data to MFIT
        THE_FIT_ERR = 1
        SUM_SPEC, T_IND, DATA_TITL, DATA_COMM, THE_PP, IO_ERR, THE_DET
        IF IO_ERR LT 0 THEN GOTO, DONE     ; Handle IO errors

         ; Need to replace current data set completely:
         CDET = CDET - 1L
         NUM_DET = NUM_DET - 1L

         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
         INIT_MFIT, THE_PP, BUTTON_COMMAND
         WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 1

        ; Turn off the appropriate buttons!
        TURN_OFF, MFIT_BID.FIT_SUM_MULTI
        TURN_OFF, MFIT_BID.FIT_SUMMED
        TURN_OFF, MFIT_BID.FIT_ONE
        TURN_OFF, MFIT_BID.BATCH_FIT

        GOTO, DONE
        END

     'BATCH FIT SELECTIONS': BEGIN
        ; Batch mode
        RUN_MODE = STRING(FORMAT='(A1)', 'B') 
        COUNT_SPAN, COMBINED_TIMES, TIME_SPAN, T_IND
        BATCH_TIMES = COMBINED_TIMES(*, T_IND) ; Store times for later
        BATCH_SELECT = 1
        HAVE_APLOT = 0           ; Initialize: we don't have a plot to overlay
        END

     'DISPLAY FIT PARAMETERS': BEGIN
        RESET_LIST = 0
        ; Must check that model is still valid
        IF PARAM_STORE(0) NE PARAM_LABEL_LIST(0) THEN BEGIN
           PARAM_TEMP = PARAM_LABEL_LIST
           NUM_TEMP = NUM_LIST
           PARAM_LABEL_LIST = PARAM_STORE
           NUM_LIST = NUM_STORE
           RESET_LIST = 1
        ENDIF
        B_LABEL = STRTRIM(TOPLABEL, 2)
        ; PARAM_OPTION set before CASE
        CASE PARAM_OPTION OF
             1: WGSP_LAST_PLOT = 'PARAMETER TIME HISTORY'
             2: WGSP_LAST_PLOT = 'ONE PARAMETER VS. ANOTHER'
             3: WGSP_LAST_PLOT = 'PARAMETER HISTOGRAM'
             4: WGSP_LAST_PLOT = 'SIGMA RESIDUALS MAP'
             5: WGSP_LAST_PLOT = 'MODEL NU-F-NU CONTOURS'
        ENDCASE
        PLOT_PARAMS, BATCH_TIMES, $
                     PARAM_HIST, PARAM_UNCER_HIST, B_LABEL, $
                     ENERGY_SCALE, RATE_SCALE, ENERGY_RANGE, RATE_RANGE, $
                     RESID_CONTOURS, NUFNU_CONTOURS, HAVE_APLOT, PARAM_OPTION

        IF RESET_LIST THEN BEGIN
           PARAM_LABEL_LIST = PARAM_TEMP
           NUM_LIST = NUM_TEMP
           RESET_LIST = 0
        ENDIF
        GOTO, DONE
        END

     'WRITE FIT PARAMETERS TO FILE': BEGIN 
        LOOK_SAVE = READ_MENU(7)
        PARAM_NAME = LOOK_SAVE
        BREAK_FILE, PARAM_NAME, PDEV, PDIR, PNAME, PEXT, PVER
        PARAM_NAME = STRLOWCASE( PDEV + PDIR + PNAME + '.bat')
        MESSAGE = 'Writing batch fit parameters to file ' + PARAM_NAME
        MFIT_INFORM, MESSAGE 

        OPENW, FLUN, PARAM_NAME, /GET_LUN
            WM_DISPLAY_PARAMETERS, FLUN, /WRITE_ONLY
            PRINTF, FLUN
            PRINTF, FLUN, NUM_LIST + 6, ' columns are labeled:'
            TEMP = STRING(PARAM_LABEL_LIST)
            PARAM_L_LIST = STRARR(NUM_LIST + 5)
            PARAM_L_LIST(0: NUM_LIST - 1) = TEMP(0: NUM_LIST - 1)
            COLON_POS = STRPOS (PARAM_L_LIST(0), ':')
            MODEL_NAME = STRMID(PARAM_L_LIST(0),0, COLON_POS+1)
            PARAM_L_LIST(NUM_LIST) = model_name + ' Photon Flux (ph/s-cm^2)'
            PARAM_L_LIST(NUM_LIST+1) = model_name + ' Photon Fluence (ph/cm^2)'
            PARAM_L_LIST(NUM_LIST+2) = model_name + ' Energy Flux (erg/s-cm^2)'
            PARAM_L_LIST(NUM_LIST+3) = model_name + ' Energy Fluence (erg/cm^2)'
            PARAM_L_LIST(NUM_LIST+4) = model_name + ' Reduced Chi-squares'
            FOR I = 0, NUM_LIST + 4 DO BEGIN
                PRINTF, FLUN, PARAM_L_LIST(I)
            ENDFOR
            PRINTF, FLUN, 'Reduced Chi-squares (Chi-squares in Uncertanties):',$
               FIX(DOF), ' Degrees of Freedom'
            IF (CV_RATE_MODE EQ 'R') THEN BEGIN     ; Don't divide by bin width 
               PRINTF, FLUN, 'Burst Time History (Counts/s)'
            ENDIF ELSE BEGIN
               PRINTF, FLUN, 'Burst Time History (Counts/s-keV)'
            ENDELSE
            PRINTF, FLUN

            COUNT_SPAN, COMBINED_TIMES, TIME_SPAN, T_IND
            NUM_T = FIX(N_ELEMENTS(T_IND))
            PRINTF, FLUN, NUM_T, ' time bins processed; start and stop times:'
            PRINTF, FLUN, COMBINED_TIMES(*, T_IND)
            PRINTF, FLUN
            PRINTF, FLUN, 'Batch Fit Parameters: ', FIX(NUM_LIST + 6), ' X', $
                           NUM_T
            PRINTF, FLUN, PARAM_HIST
            PRINTF, FLUN
            PRINTF, FLUN, 'Batch Fit Uncertanties: ', FIX(NUM_LIST + 6), ' X',$
                           NUM_T
            PRINTF, FLUN, PARAM_UNCER_HIST
        FREE_LUN, FLUN
        GOTO, DONE
        END
       
     'CREATE SYNTHETIC BURST': BEGIN
        WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
        CREATE_SYNTH, DATA_TITL, THE_PP
        WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 1
        GOTO, DONE
        END

     'PLOT': BEGIN
        INIT_MFIT, THE_PP, BUTTON_COMMAND, MFIT_PLOT_OPTION
        GOTO, DONE
        END

     'DISPLAY DRM': BEGIN
        WGSP_LAST_PLOT = 'DISPLAY DRM'
        PX0 = 55 / 510.0   &  PY0 = 70 / 660.0
        PX1 = 439 / 510.0  &  PY1 = 600 / 660.0
        DISPLAY_DRM, [PX0, PY0, PX1, PY1], 0
        GOTO, DONE
        END

     'CREATE HARDCOPY': BEGIN
        CASE MFIT_PLOT_OPTION OF
             ; Option 0 is currently not used
             ; Options 1-6 are for Count Rate, Photon Flux, etc. Handled 
             ;  under ELSE:

             7:  BEGIN
                  MFIT_INFORM, 'Creating hardcopy: 1d chi-square plot.'
                  CHI_1D_PLOT, THE_PP, 1
                 END
             8:  BEGIN
                  MFIT_INFORM, 'Creating hardcopy: 2d chi-square map.'
                  CHI_2D_PLOT, THE_PP, 1
                 END
             9:  BEGIN
                  MFIT_INFORM, 'Creating hardcopy: Gaussian line fit.'
                  FIT_GAUSS_PLOT, THE_PP, 1
                 END
             10: BEGIN
                  MFIT_INFORM, 'Creating hardcopy: DRM contours.'
                  DISPLAY_DRM, THE_PP, 1
                 END
             11: BEGIN
                  MFIT_INFORM, 'Creating hardcopy: fit parameters.'
                  HARD_COPY, ENERGY_RANGE, RATE_RANGE, ENERGY_SCALE, $
                            RATE_SCALE, THE_PP, 'BATCH'
                 END
             12: BEGIN
                  MFIT_INFORM, 'Creating hardcopy: sigma contours.'
                  PLOT_PARAMS, BATCH_TIMES, $
                     PARAM_HIST, PARAM_UNCER_HIST, STRTRIM(TOPLABEL, 2), $
                     ENERGY_SCALE, RATE_SCALE, ENERGY_RANGE, RATE_RANGE, $
                     RESID_CONTOURS, NUFNU_CONTOURS, HAVE_APLOT, 4, /MAKE_HC
                  END
             13: BEGIN 
                  MFIT_INFORM, 'Creating hardcopy: nu F_nu coutours.'
                  PLOT_PARAMS, BATCH_TIMES, $
                     PARAM_HIST, PARAM_UNCER_HIST, STRTRIM(TOPLABEL, 2), $
                     ENERGY_SCALE, RATE_SCALE, ENERGY_RANGE, RATE_RANGE, $
                     RESID_CONTOURS, NUFNU_CONTOURS, HAVE_APLOT, 5, /MAKE_HC
                 END
             14: BEGIN
                 MFIT_INFORM, 'Creating Hardcopy: Burst History.'
                 WW_CONSTRUCT_LOOKUP, 'HISTORY', BUTTON_COMMAND
                 GOTO, DONE
                 END
             ELSE: INIT_MFIT, THE_PP, BUTTON_COMMAND, MFIT_PLOT_OPTION, /MAKE_HC
        ENDCASE
        GOTO, DONE
        END

     'SEARCH FOR GAUSSIAN LINE': BEGIN
        INIT_MFIT, THE_PP, BUTTON_COMMAND
        GOTO, DONE
        END

     'WRITE BINARY BATCH OUTPUT FILE': BEGIN
        IF (STRCOMPRESS(CV_BATCH_OUT_FILE, /REMOVE_ALL) EQ '?') THEN BEGIN
           WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
           MFIT_INFORM, 'Data written to file.  Ready.'
        ENDIF ELSE BEGIN
           IF (STRCOMPRESS(CV_BATCH_OUT_FILE, /REMOVE_ALL) EQ '') THEN BEGIN
              BREAK_FILE, CURRENT_VALUES(6), FDEV, FDIR, FNAME
              FILE_OUT = FDEV + FDIR + FNAME + '.MFIT_BATCH'
           ENDIF ELSE FILE_OUT = CV_BATCH_OUT_FILE + '.MFIT_BATCH'
           FILE_OUT = STRLOWCASE(STRCOMPRESS(FILE_OUT, /REMOVE_ALL))
           MFIT_INFORM, 'Data written to file ' + FILE_OUT + '.  Ready.'
        ENDELSE
        INIT_MFIT, THE_PP, BUTTON_COMMAND
        WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 1
        RETURN
        END

     'CLOSE BINARY BATCH OUTPUT FILE': BEGIN
        INIT_MFIT, THE_PP, BUTTON_COMMAND
        ; Selecting this button changes RUN_MODE to 'I', so turn on
        ; BATCH buttons manually
        TURN_ON, MFIT_BID.WRITE_BATCH
        TURN_ON, MFIT_BID.CLOSE_BATCH
        GOTO, DONE
        END

     'ZOOM': BEGIN
        THE_PP = [0.1, 0.28, 0.86, 0.86]
        CASE 1 OF
             (WGSP_LAST_PLOT EQ 'PARAMETER TIME HISTORY') OR $
             (WGSP_LAST_PLOT EQ 'ONE PARAMETER VS. ANOTHER') OR $
             (WGSP_LAST_PLOT EQ 'PARAMETER HISTOGRAM') OR $
             (WGSP_LAST_PLOT EQ 'SIGMA REDISDUALS MAP') OR $
             (WGSP_LAST_PLOT EQ 'MODEL NU-F-NU CONTOURS'): BEGIN
                ; Shrink the plot box since we might have axis titles on
                ;  both sides of plot
;                TEMP_PP = [0.13, 0.10, 0.87, 0.90]
                TEMP_PP = [0.17, 0.10, 0.83, 0.90]
                HAVE_ZOOMED_PARAM = 1
                ENERGY_RANGE_SAVE = ENERGY_RANGE
                RATE_RANGE_SAVE   = RATE_RANGE
                HIST_RANGE_SAVE   = HIST_RANGE
                BAIL_OUT = -1
                IF (!X.TYPE EQ 1) THEN XR = 10.0^!X.CRANGE ELSE XR = !X.CRANGE
                IF (!Y.TYPE EQ 1) THEN YR = 10.0^!Y.CRANGE ELSE YR = !Y.CRANGE
                WHILE BAIL_OUT NE 1 DO BEGIN
RESET_PARAM:
                      XR_LAST = XR
                      YR_LAST = YR
                      PLOT_PS_PH, !X.TYPE, !Y.TYPE, TEMP_PP
                      MFIT_INFORM, 'Select range to ZOOM.' + $  
                                   '  Left margin to EXIT,' + $ 
                                   ' right margin to RESET,' + $
                                   ' lower margin for NUMERICAL ENTRY'
                      ZOOM, XR, YR, BAIL_OUT
                      IF (BAIL_OUT EQ 1) THEN BEGIN
                         XR = XR_LAST
                         YR = YR_LAST
                      ENDIF
                      ; Handle accidental double clicks
                      Z_ERR = 1.0E-10
                      IF (ABS( XR(1) - XR(0) ) LE Z_ERR) OR $
                         (ABS( YR(1) - YR(0) ) LE Z_ERR) THEN BEGIN
                         MFIT_INFORM, 'ZOOM Error.  Resetting.'
                         ENERGY_RANGE = ENERGY_RANGE_SAVE
                         RATE_RANGE   = RATE_RANGE_SAVE
                         HIST_RANGE   = HIST_RANGE_SAVE
                         GOTO, RESET_PARAM
                      ENDIF
                      ; Handle the different cases:
                      IF PH_TITLE THEN BEGIN  ; Zoom the overplot
                         ENERGY_RANGE = XR
                         HIST_RANGE   = YR
                      ENDIF ELSE BEGIN        ; Zoom the main plot
                         ENERGY_RANGE = XR
                         RATE_RANGE   = YR
                      ENDELSE
                      IF (BAIL_OUT EQ 2) THEN BEGIN ; RESET
                         ENERGY_RANGE = ENERGY_RANGE_SAVE
                         RATE_RANGE   = RATE_RANGE_SAVE
                         HIST_RANGE   = HIST_RANGE_SAVE
                         BAIL_OUT     = -1
                      ENDIF 
                ENDWHILE
                END

             WGSP_LAST_PLOT EQ 'HISTORY': BEGIN
                IF (HAVE_ZOOMED_HIST EQ 0) THEN BEGIN
                   TIME_RANGE_SAVE  = TIME_RANGE
                   HIST_RANGE_SAVE  = HIST_RANGE
                   HAVE_ZOOMED_HIST = 1
                ENDIF
                XR = TIME_RANGE
                YR = HIST_RANGE
                BAIL_OUT = -1
                WHILE BAIL_OUT NE 1 DO BEGIN
RESET_HISTORY:
                      XR_LAST = XR
                      YR_LAST = YR
                      WW_UPDATE, 'HISTORY', XRANGE = XR, YRANGE = YR
                      MFIT_INFORM, 'Select range to ZOOM.' + $  
                                   '  Left margin to EXIT,' + $ 
                                   ' right margin to RESET,' + $
                                   ' lower margin for NUMERICAL ENTRY'
                      ZOOM, XR, YR, BAIL_OUT
                      IF (BAIL_OUT EQ 1) THEN BEGIN
                         XR = XR_LAST
                         YR = YR_LAST
                      ENDIF
                      ; Handle accidental double clicks
                      Z_ERR = 1.0E-10
                      IF (ABS( XR(1) - XR(0) ) LE Z_ERR) OR $
                         (ABS( YR(1) - YR(0) ) LE Z_ERR) THEN BEGIN
                         MFIT_INFORM, 'ZOOM Error.  Resetting.'
                         XR = TIME_RANGE_SAVE
                         YR = HIST_RANGE_SAVE
                         GOTO, RESET_HISTORY
                      ENDIF
                      IF (BAIL_OUT EQ 2) THEN BEGIN ; RESET
                         XR = TIME_RANGE_SAVE
                         YR = HIST_RANGE_SAVE
                         BAIL_OUT = -1
                         GOTO, RESET_HISTORY
                      ENDIF
                ENDWHILE
                ; Temporarily set TIME_RANGE, HIST_RANGE in case user wants
                ;  hardcopy of zoomed plot
                TIME_RANGE = XR
                HIST_RANGE = YR
                END

             (WGSP_LAST_PLOT EQ 'COUNT RATE') OR $
             (WGSP_LAST_PLOT EQ 'PHOTON FLUX') OR $
             (WGSP_LAST_PLOT EQ 'NUFNU') OR $
             (WGSP_LAST_PLOT EQ 'COUNT RESIDUALS') OR $
             (WGSP_LAST_PLOT EQ 'SIGMA RESIDUALS') OR $
             (WGSP_LAST_PLOT EQ 'PHOTON RESIDUALS'): BEGIN 

                ; Reset the log scale tick marks, if necessary
                !X.TICKS = 0 & !Y.TICKS = 0

                CASE WGSP_LAST_PLOT OF
                     'COUNT RATE'       : PLOT_INDEX = 1
                     'PHOTON FLUX'      : PLOT_INDEX = 2
                     'COUNT RESIDUALS'  : PLOT_INDEX = 3
                     'PHOTON RESIDUALS' : PLOT_INDEX = 4
                     'NUFNU'            : PLOT_INDEX = 5
                     'SIGMA RESIDUALS'  : PLOT_INDEX = 6
                ENDCASE

                ; Save the appropriate axis ranges
                XBEG_SAVE(*, PLOT_INDEX) = XBEG(*, PLOT_INDEX)
                XEND_SAVE(*, PLOT_INDEX) = XEND(*, PLOT_INDEX)
                YBEG_SAVE(*, PLOT_INDEX) = YBEG(*, PLOT_INDEX)
                YEND_SAVE(*, PLOT_INDEX) = YEND(*, PLOT_INDEX)
                HAVE_XAXIS_LIMITS_SAVE(*, PLOT_INDEX) = $
                     HAVE_XAXIS_LIMITS(*, PLOT_INDEX)
                HAVE_YAXIS_LIMITS_SAVE(*, PLOT_INDEX) = $
                     HAVE_YAXIS_LIMITS(*, PLOT_INDEX)

                ; Mark the plot as ZOOMED
                HAVE_ZOOMED_DATA(PLOT_INDEX) = 1

                FOR LDET=0, NUM_DET-1 DO BEGIN
                    ; No USE_DET loop here
                    XR = [XBEG(LDET, PLOT_INDEX), XEND(LDET, PLOT_INDEX)]
                    YR = [YBEG(LDET, PLOT_INDEX), YEND(LDET, PLOT_INDEX)]
                ENDFOR
                BAIL_OUT = -1
                WHILE (BAIL_OUT NE 1) DO BEGIN
RESET_PLOT:          
                      XR_LAST = XR
                      YR_LAST = YR
                      INIT_MFIT, THE_PP, 'PLOT', PLOT_INDEX
                      MFIT_INFORM, 'Select range to ZOOM.' + $  
                                   '  Left margin to EXIT,' + $ 
                                   ' right margin to RESET,' + $
                                   ' lower margin for NUMERICAL ENTRY'
                      ZOOM, XR, YR, BAIL_OUT

                      ; Change the log scale tick marks, if necessary
                      IF (XLOG EQ 'LOG') THEN BEGIN                 
                         IF (CHECK_DECADE(XR)) THEN !X.TICKS = 5
                      ENDIF
                      IF (YLOG EQ 'LOG') THEN BEGIN                 
                         IF (CHECK_DECADE(YR)) THEN !Y.TICKS = 5
                      ENDIF

                      ; Handle accidental double clicks (for EXACT ranges)
                      Z_ERR = 1.0E-10
                      IF (ABS( XR(1) - XR(0) ) LE Z_ERR) OR $
                         (ABS( YR(1) - YR(0) ) LE Z_ERR) THEN BEGIN
                         MFIT_INFORM, 'ZOOM Error.  Resetting.'
                         XBEG(*, PLOT_INDEX) = XBEG_SAVE(*, PLOT_INDEX) 
                         XEND(*, PLOT_INDEX) = XEND_SAVE(*, PLOT_INDEX) 
                         YBEG(*, PLOT_INDEX) = YBEG_SAVE(*, PLOT_INDEX) 
                         YEND(*, PLOT_INDEX) = YEND_SAVE(*, PLOT_INDEX) 
                         HAVE_XAXIS_LIMITS(*, PLOT_INDEX) = $
                              HAVE_XAXIS_LIMITS_SAVE(*, PLOT_INDEX)
                         HAVE_YAXIS_LIMITS(*, PLOT_INDEX) = $
                              HAVE_YAXIS_LIMITS_SAVE(*, PLOT_INDEX)
                         !X.TICKS = 0 & !Y.TICKS = 0
                         GOTO, RESET_PLOT
                      ENDIF
                      IF (BAIL_OUT EQ 1) THEN BEGIN
                         XR = XR_LAST
                         YR = YR_LAST
                      ENDIF
                      IF (BAIL_OUT EQ 2) THEN BEGIN ; RESET
                         XBEG(*, PLOT_INDEX) = XBEG_SAVE(*, PLOT_INDEX) 
                         XEND(*, PLOT_INDEX) = XEND_SAVE(*, PLOT_INDEX) 
                         YBEG(*, PLOT_INDEX) = YBEG_SAVE(*, PLOT_INDEX) 
                         YEND(*, PLOT_INDEX) = YEND_SAVE(*, PLOT_INDEX) 

                         FOR LDET=0, NUM_DET-1 DO BEGIN
                           ; No USE_DET loop here
                           XR = [XBEG(LDET, PLOT_INDEX), XEND(LDET, PLOT_INDEX)]
                           YR = [YBEG(LDET, PLOT_INDEX), YEND(LDET, PLOT_INDEX)]
                         ENDFOR

                         HAVE_XAXIS_LIMITS(*, PLOT_INDEX) = $
                              HAVE_XAXIS_LIMITS_SAVE(*, PLOT_INDEX)
                         HAVE_YAXIS_LIMITS(*, PLOT_INDEX) = $
                              HAVE_YAXIS_LIMITS_SAVE(*, PLOT_INDEX)
                         BAIL_OUT = -1
                         !X.TICKS = 0 & !Y.TICKS = 0
                         GOTO, RESET_PLOT
                      ENDIF

                      ; Temporarily set XBEG, etc. in case user wants
                      ;  hardcopy of zoomed plot
                      ; Must set ranges for ALL selected detectors 
                      ;  (multi-detector case)
                       FOR LDET=0, NUM_DET-1 DO BEGIN
;                           IF USE_DET(LDET) THEN BEGIN
                              XBEG(LDET, PLOT_INDEX) = XR(0)                  
                              XEND(LDET, PLOT_INDEX) = XR(1)                  
                              YBEG(LDET, PLOT_INDEX) = YR(0)
                              YEND(LDET, PLOT_INDEX) = YR(1)
;                           ENDIF
                       ENDFOR
                ENDWHILE
                MFIT_INFORM, 'Ready.'
                END
             ELSE: BEGIN
                MFIT_INFORM, 'No ZOOM option for this selection.  Ready.'
                RETURN
                END 
        ENDCASE ; WGSP_LAST_PLOT

        GOTO, DONE
        END ; ZOOM

     'WRITE SESSION': BEGIN
        INIT_MFIT, THE_PP, BUTTON_COMMAND
        GOTO, DONE
        END

     ELSE: BEGIN
        WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 0
        INIT_MFIT, THE_PP, BUTTON_COMMAND
        WIDGET_CONTROL, WIDS.MFIT_BASE, SHOW = 1
        GOTO, DONE
        END

ENDCASE ; for BUTTON_COMMAND

OLD_PHOT_FLUENCE   = 0
OLD_PHOT_FLU_ERR   = 0
OLD_ENERGY_FLUENCE = 0
OLD_EN_FLU_ERR     = 0

FOR I = 0, N_ELEMENTS(T_IND) - 1 DO BEGIN
    TEMP_SPAN = TRANSPOSE(COMBINED_TIMES(*,T_IND(I)))
    TEMP_SPAN(0,1) = TOTAL(TEMP_SPAN) / 2.0  ; Shorten a bit....
    SPEC_TITLE = CREATE_LABEL(COMBINED_TIMES, TEMP_SPAN, ' s')
    DATA_COMM = SPEC_TITLE + ' of ' + DATA_TITL 

    NEW_DATA = LONG(1)                     ; Passing in new data to MFIT
    IF BUTTON_COMMAND EQ 'RE-FIT LAST SPECTRUM' THEN BEGIN
       NEW_DATA = LONG(0)                  ; Passing in old data to MFIT
    ENDIF

    THE_FIT_ERR = 1
    WHILE THE_FIT_ERR EQ 1 DO BEGIN
          WRITE_SPEC, T_IND(I), DATA_TITL, DATA_COMM, THE_PP, $
                      IO_ERR, BUTTON_COMMAND

          IF IO_ERR EQ -1 THEN GOTO, DONE     ; No background chosen: bail

          IF NUM_LIST EQ 0 THEN BEGIN         ; No model selected on Batch
             IF HAVE_DRM EQ 0 THEN BEGIN
                MFIT_INFORM, 'Ready.'
             ENDIF ELSE BEGIN
                MFIT_INFORM, 'No model selected for batch fitting.'
             ENDELSE
             RETURN
          ENDIF

          THE_FIT_ERR = FIT_ERR
          IF (BUTTON_COMMAND EQ 'BATCH FIT SELECTIONS') AND $
             (FIT_ERR GE 1) THEN BEGIN
             THE_FIT_ERR = 1
             Y_NO = WIDMENU(['MFIT failed to converge. Continue with MFIT?', $
                             'Yes', 'No'], TITLE = 0)
             IF Y_NO EQ 1 THEN NEW_DATA = LONG(0)   ; Restart fit with current
                                                    ;parameters
             IF Y_NO EQ 2 THEN THE_FIT_ERR = 0      ; Aborting this fit
          ENDIF ELSE $             ; Interactive case handled w/in MFIT, so:
             IF (BUTTON_COMMAND NE 'BATCH FIT SELECTIONS') THEN $
                THE_FIT_ERR = 0 ; abort all other cases!
    ENDWHILE

    IF BUTTON_COMMAND EQ 'BATCH FIT SELECTIONS' THEN BEGIN  ; Batch fitting:

       IF I EQ 0 THEN BEGIN
          ; Create arrays to hold the results of Batch fits for later display.
          NMCHAN = NUM_CHAN(CDET) - 1
          NUM_T = N_ELEMENTS(T_IND)
          PARAM_HIST = FLTARR(NUM_LIST + 6, NUM_T)
          PARAM_UNCER_HIST = FLTARR(NUM_LIST + 6, NUM_T)
          RESID_CONTOURS = FLTARR(NMCHAN, NUM_T)
          NUFNU_CONTOURS = FLTARR(MAX_PLOT, NUM_T)
          PARAM_STORE = PARAM_LABEL_LIST
          NUM_STORE = NUM_LIST
       ENDIF

       ; Update the result arrays:
       PARAM_HIST(0: NUM_LIST - 1, I) = PARAM_LIST(0: NUM_LIST - 1)
       PARAM_UNCER_HIST(0: NUM_LIST - 1, I) = PARAM_UNCER_LIST(0 : NUM_LIST - 1)

       ; keep chi^2 and time history at top of 
       ;  PARAM_HIST list: NUM_LIST+4,5 resp.
       ;  flux/fluence variables num_list thru num_list+3

       ; Calculate LIVE_TIME
       INDEX = WHERE(LIVE_TIME, COUNT)
       TIME = LIVE_TIME(INDEX(0))

       ; Start over using PHOT_OBS_RATE instead of MODEL_PHOT_RATE
       ;  Figure index limits for energy range
       ; RANGE = range of indices for valid energies
       RANGE = WHERE( THRESHOLDS(1,*) GT ENERGY_SPAN(0,0) AND $
		      THRESHOLDS(0,*) LT ENERGY_SPAN(0,1) )

       ; DE is energy bin width
       DE = (THRESHOLDS(1,*) - THRESHOLDS(0, *))

       ; E_CEN is energy bin center
       E_CEN = THRESHOLDS(0,*) + DE/2

       ; Take out neg. #s from PHOT_OBS_RATE 
       PHOT_RATE = PHOT_OBS_RATE > 0

       ; Get energy channel index that ignores all zero rates and ignore rates
       ;  for which the error is 100%
       ; Add bottom channel to renorm NZERO
       NZERO = WHERE( PHOT_RATE(RANGE) AND $
                      PHOT_RATE(RANGE) - PHOT_OBS_SIG(RANGE) GT 0 ) + RANGE(0) 

       ; Photon Flux
       PHOT_FLUX = TOTAL(PHOT_RATE(NZERO) * DE(NZERO))
       ; Quadrature sum phot_err
       P_ERR = 0
       TOP = N_ELEMENTS(NZERO) - 1
       FOR NN=NZERO(0), NZERO(TOP) DO BEGIN
           P_ERR = (PHOT_OBS_SIG(NN) * DE(NN))^2 + P_ERR
       ENDFOR

       ; PHOT_OBS_RATE errors are independent if model is correct, so weight
       ;  independent propagation with chisq: the "correctness" measure of the 
       ;  model
       ; Error = quadrature addition * chi^2
       PHOT_ERR = SQRT(P_ERR) * MODEL_CHISQ / DOF

       ; NO   ; average quadrature plus linear sum for compromise error
       ; phot_err=(sqrt(p_err)+total(phot_obs_sig(nzero)*de(nzero)))/2

       ; PHOTON FLUENCE (the new part - accumulate later)
       P_FLU = PHOT_FLUX * TIME
       P_FLU_ERR = PHOT_ERR * TIME

       ; Energy Flux
       ENERGY_FLUX = TOTAL( PHOT_RATE(NZERO) * DE(NZERO) * E_CEN(NZERO) ) $
		     * 1.602e-9

       ; Energy flux error (like phot_err)
       EFLX_ERR = 0
       FOR MM=NZERO(0), NZERO(TOP) DO BEGIN
	   EFLX_ERR = (PHOT_OBS_SIG(MM) * DE(MM) * E_CEN(MM))^2 + EFLX_ERR
       ENDFOR

       ; error = quadrature addition x chi^2
       EN_FLX_ERR = SQRT(EFLX_ERR) * 1.602e-9 * MODEL_CHISQ / DOF

       ; NO    ; average quadrature plus linear sum for compromise error
       ; en_flx_err = (sqrt(eflx_err) + total(phot_obs_sig(nzero) * de(nzero) $
       ;		* e_cen(nzero)))/2 * 1.602e-9

       ; ENERGY FLUENCE (the new part - accumulate later)
       EN_FLU = ENERGY_FLUX * TIME
       EN_FLU_ERR = EN_FLX_ERR * TIME
	
       ; Accumulate fluences
       IF ( I EQ 0) THEN BEGIN
          OLD_PHOT_FLUENCE = 0
          OLD_PHOT_FLU_ERR = 0
          OLD_ENERGY_FLUENCE = 0
          OLD_EN_FLU_ERR     = 0
       ENDIF ELSE BEGIN
          OLD_PHOT_FLUENCE = PARAM_HIST(NUM_LIST+1, I-1)
          OLD_PHOT_FLU_ERR = PARAM_UNCER_HIST(NUM_LIST+1, I-1)
          OLD_ENERGY_FLUENCE = PARAM_HIST(NUM_LIST+3, I-1)
          OLD_EN_FLU_ERR     = PARAM_UNCER_HIST(NUM_LIST+3, I-1)
       ENDELSE

       PHOT_FLUENCE = P_FLU + OLD_PHOT_FLUENCE
       PHOT_FLU_ERR = SQRT(OLD_PHOT_FLU_ERR^2 + P_FLU_ERR^2)
       ENERGY_FLUENCE = EN_FLU + OLD_ENERGY_FLUENCE
       ENERGY_FLU_ERR = SQRT(EN_FLU_ERR^2 + OLD_EN_FLU_ERR^2)

       OLD_PHOT_FLUENCE = PHOT_FLUENCE
       OLD_PHOT_FLU_ERR = PHOT_FLU_ERR
       OLD_ENERGY_FLUENCE = ENERGY_FLUENCE
       OLD_EN_FLU_ERR     = ENERGY_FLU_ERR

       ; Assign arrays
       PARAM_HIST(NUM_LIST, I) = PHOT_FLUX
       PARAM_HIST(NUM_LIST+1, I) = PHOT_FLUENCE
       PARAM_HIST(NUM_LIST+2, I) = ENERGY_FLUX
       PARAM_HIST(NUM_LIST+3, I) = ENERGY_FLUENCE
       PARAM_UNCER_HIST(NUM_LIST, I) = PHOT_ERR
       PARAM_UNCER_HIST(NUM_LIST+1, I) = PHOT_FLU_ERR
       PARAM_UNCER_HIST(NUM_LIST+2, I) = EN_FLX_ERR
       PARAM_UNCER_HIST(NUM_LIST+3, I) = ENERGY_FLU_ERR
       PARAM_HIST(NUM_LIST+4, I) = MODEL_CHISQ / DOF
       PARAM_UNCER_HIST(NUM_LIST+4, I) = MODEL_CHISQ 
       PARAM_HIST(NUM_LIST + 5, I) = HISTORY(T_IND(I))
       PARAM_UNCER_HIST(NUM_LIST + 5, I) = HISTORY_ERR(T_IND(I))

       TEMP_RESID = PHOT_RESID(*, CDET)
       TEMP_SIGMA = PHOT_OBS_SIG(*, CDET)
       NIND = WHERE(TEMP_SIGMA GT 0.0)
       IF NIND(0) EQ -1 THEN BEGIN          ; Trap negative models
          TEMP_SIGMA(*) = 1.0  
          NIND = WHERE(TEMP_SIGMA EQ 1.0)
          ENDIF
       RESID_CONTOURS(NIND, I) = TEMP_RESID(NIND) / TEMP_SIGMA(NIND)
       NUFNU_CONTOURS(*, I) = NU_F_NU_MODEL(*, CDET)

    ENDIF
ENDFOR

DONE:

; Button control
IF (RUN_MODE EQ 'I') THEN BEGIN

   IF (HAVE_MODEL) THEN BEGIN
      TURN_ON, MFIT_BID.FIT_ONE
      TURN_ON, MFIT_BID.REFIT
      TURN_ON, MFIT_BID.FIT_SUMMED
      TURN_ON, MFIT_BID.BATCH_FIT
      IF (NUM_DET GT 1L) THEN $
         TURN_ON, MFIT_BID.FIT_SUM_MULTI
      TURN_ON, MFIT_BID.SYNTHETIC
      TURN_ON, MFIT_BID.DRM
      TURN_ON, MFIT_BID.MFIT
      TURN_ON, MFIT_BID.CHI1D
      TURN_ON, MFIT_BID.CHI2D
      TURN_ON, MFIT_BID.READ_TEMPL
      TURN_ON, MFIT_BID.WRITE_TEMPL
      TURN_ON, MFIT_BID.EDIT_TEMPL
      TURN_ON, MFIT_BID.WRITE_ASCII
      TURN_ON, MFIT_BID.FIT_GAUSS_LINE
      TURN_ON, MFIT_BID.WRITE_SESSION
      TURN_ON, MFIT_BID.PLOT
      TURN_ON, MFIT_BID.ZOOM
      TURN_ON, MFIT_BID.DISPLAY_FIT_PARAMS
      TURN_ON, MFIT_BID.WRITE_FIT_PARAMS
      TURN_ON, MFIT_BID.WRITE_BATCH
      TURN_ON, MFIT_BID.CLOSE_BATCH
      TURN_OFF, MFIT_BID.DISPLAY_FIT_PARAMS
      TURN_OFF, MFIT_BID.WRITE_FIT_PARAMS
   ENDIF ELSE BEGIN
      TURN_ON, MFIT_BID.FIT_ONE
      TURN_ON, MFIT_BID.FIT_SUMMED
      TURN_ON, MFIT_BID.BATCH_FIT
      TURN_ON, MFIT_BID.SYNTHETIC
      TURN_OFF, MFIT_BID.DRM
      TURN_OFF, MFIT_BID.MFIT
      TURN_OFF, MFIT_BID.CHI1D
      TURN_OFF, MFIT_BID.CHI2D
      TURN_OFF, MFIT_BID.READ_TEMPL
      TURN_OFF, MFIT_BID.WRITE_TEMPL
      TURN_OFF, MFIT_BID.EDIT_TEMPL
      TURN_OFF, MFIT_BID.WRITE_ASCII
      TURN_OFF, MFIT_BID.FIT_GAUSS_LINE
      TURN_OFF, MFIT_BID.WRITE_SESSION
      TURN_OFF, MFIT_BID.PLOT
      TURN_OFF, MFIT_BID.ZOOM
      TURN_OFF, MFIT_BID.DISPLAY_FIT_PARAMS
      TURN_OFF, MFIT_BID.WRITE_FIT_PARAMS
      TURN_OFF, MFIT_BID.WRITE_BATCH
      TURN_OFF, MFIT_BID.CLOSE_BATCH
      TURN_OFF, MFIT_BID.DISPLAY_FIT_PARAMS
      TURN_OFF, MFIT_BID.WRITE_FIT_PARAMS
   ENDELSE

ENDIF ELSE BEGIN ; batch

   IF BATCH_SELECT THEN BEGIN
      TURN_ON, MFIT_BID.FIT_ONE
      TURN_ON, MFIT_BID.FIT_SUMMED
      TURN_ON, MFIT_BID.BATCH_FIT
      TURN_ON, MFIT_BID.SYNTHETIC
      TURN_ON, MFIT_BID.DRM
      TURN_OFF, MFIT_BID.MFIT
      TURN_OFF, MFIT_BID.PLOT
      TURN_ON, MFIT_BID.WRITE_BATCH
      TURN_ON, MFIT_BID.CLOSE_BATCH
      TURN_ON, MFIT_BID.DISPLAY_FIT_PARAMS
      TURN_ON, MFIT_BID.WRITE_FIT_PARAMS
   ENDIF

ENDELSE

; ZOOM button control
IF (WGSP_LAST_PLOT EQ 'HISTORY') OR $
   (WGSP_LAST_PLOT EQ 'PARAMETER TIME HISTORY') OR $
   (WGSP_LAST_PLOT EQ 'ONE PARAMETER VS. ANOTHER') OR $
   (WGSP_LAST_PLOT EQ 'PARAMETER HISTOGRAM') OR $
   (WGSP_LAST_PLOT EQ 'COUNT RATE') OR $
   (WGSP_LAST_PLOT EQ 'PHOTON FLUX') OR $
   (WGSP_LAST_PLOT EQ 'NUFNU') OR $
   (WGSP_LAST_PLOT EQ 'COUNT RESIDUALS') OR $
   (WGSP_LAST_PLOT EQ 'SIGMA RESIDUALS') OR $
   (WGSP_LAST_PLOT EQ 'PHOTON RESIDUALS') THEN $
   TURN_ON, MFIT_BID.ZOOM $
ELSE TURN_OFF, MFIT_BID.ZOOM

GET_CONTROL
MFIT_INFORM, 'Ready.'



END ; W_MFIT_SELECT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO DISPLAY_DRM, THE_PP, HC_OPTION

@wgsp_cb.pro


NCH      = NUM_CHAN(CDET)
NEB      = NUM_EBINS(CDET)
CH_WIDTH = CH_OUT(1: NCH - 1) - CH_OUT(0: NCH - 2)
EB_WIDTH = E_IN(1: NEB - 1) - E_IN(0: NEB - 2)
RESP     = DRM(0: NEB - 2, 0: NCH - 2, CDET)

FOR I = 0, NEB - 2 DO RESP(I, *) = RESP(I, *) / CH_WIDTH

RESP     = RESP + 0.01
LN_RESP  = ALOG(RESP)
CH_E     = CH_OUT(0: NCH - 2) + 0.5 * CH_WIDTH
EB_E     = E_IN(0: NEB - 2) + 0.5 * EB_WIDTH
XR       = [MIN(EB_E), MAX(EB_E)]
YR       = [MIN(CH_E), MAX(CH_E)]
LN_CH_E  = ALOG10(CH_E)
LN_EB_E  = ALOG10(EB_E)
FNAME    = STRTRIM(DET_NAMES(CDET), 2)

PLOTTING = 0
PP = THE_PP

IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0
   Y0 = 185 / 660.0
   X1 = 439 / 510.0
   Y1 = 567 / 660.0
   PP = [X0, Y0, X1, Y1]
ENDIF 


CONTOUR, LN_RESP, LN_EB_E, LN_CH_E, NLEVELS=10, XSTYLE = 5, $
         YSTYLE = 5, TITLE = FNAME + ' DRM Contour Map', $
         POSITION = PP

PLOT, XR, YR, XTYPE = 1, YSTYLE = 1, /NOERASE, /NODATA, $
         XTITLE = "Photon Energy (keV)", $
         YTITLE = "Channel Energy (keV)", $
         YTYPE = 1, XSTYLE = 1, POSITION = PP


IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PP, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF


END ; PRO DISPLAY_DRM
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO INIT_VARS

@wgsp_cb.pro


; Output arguments: do not change!
NUM_LIST = LONG(0)
PARAM_LIST = FLTARR(MAX_PARAM)
PARAM_UNCER_LIST = FLTARR(MAX_PARAM)
DOF = LONG(0)
FIT_ERR = LONG(0)
PARAM_LABEL_LIST = STRARR (MAX_PARAM)
FOR I=0, MAX_PARAM - 1 DO BEGIN
    PARAM_LABEL_LIST (I) = STRING (REPLICATE (32B, 57))
ENDFOR

;Internal Variables:
MFIT_VERSION_TAG = STRING(REPLICATE(32B, 12))

PHOT_OBS_RATE   = FLTARR(MAX_CHAN, MAX_DET)
PHOT_OBS_SIG    = FLTARR(MAX_CHAN, MAX_DET)
PHOT_RESID      = FLTARR(MAX_CHAN, MAX_DET)
CNT_RESID       = FLTARR(MAX_CHAN, MAX_DET)
NU_F_NU_DATA    = FLTARR(MAX_CHAN, MAX_DET)
NU_F_NU_SIG     = FLTARR(MAX_CHAN, MAX_DET)
NU_F_NU_MODEL   = FLTARR(MAX_PLOT, MAX_DET)
MODEL_CNT_RATE  = FLTARR(MAX_CHAN, MAX_TERMS, MAX_DET)
MODEL_PHOT_RATE = FLTARR(MAX_PLOT, MAX_TERMS, MAX_DET)
MODEL_ENERGY    = FLTARR(MAX_PLOT, MAX_DET)

NUM_TERMS_AVAIL = LONG(MAX_TERMS)
TERM_USED       = LONARR(MAX_TERMS)
USE_DET         = LONARR(MAX_DET)

XBEG = FLTARR(MAX_DET, MAX_PLOT_TYPE) 
XEND = FLTARR(MAX_DET, MAX_PLOT_TYPE)
YBEG = FLTARR(MAX_DET, MAX_PLOT_TYPE)
YEND = FLTARR(MAX_DET, MAX_PLOT_TYPE)
HAVE_XAXIS_LIMITS = LONARR(MAX_DET, MAX_PLOT_TYPE)
HAVE_YAXIS_LIMITS = LONARR(MAX_DET, MAX_PLOT_TYPE)
XLOG = READ_MENU(1) 
YLOG = READ_MENU(2) 
                                                   
XAXIS_LABEL = 'Energy (keV)'              

CASE (STRUPCASE(STRTRIM(CV_RATE_MODE, 2))) OF
     'E': BEGIN
          YAXIS_LABEL = ['NOT USED YET', $
                  'Count Rate (counts s!U-1!N keV!U-1!N det!U-1!N)', $
                  'Flux (photons s!U-1!N keV!U-1!N cm!U-2!N)', $
                  'Residuals (counts s!U-1!N keV!U-1!N det!U-1!N)', $
                  'Residuals (photons s!U-1!N keV!U-1!N cm!U2!N)', $
                  '!7m!XF!D!7m!N!X (keV s!U-1!N cm!U-2!N!X)']           ; nuFnu
          END
     'R': BEGIN
          YAXIS_LABEL = ['NOT USED YET', $
                  'Count Rate (counts s!U-1!N det!U-1!N)', $
                  'Flux (photons s!U-1!N cm!U-2!N)', $
                  'Residuals (counts s!U-1!N keV!U-1!N det!U-1!N)', $
                  'Residuals (photons s!U-1!N keV!U-1!N cm!U2!N)', $
                  '!7m!XF!D!7m!N!X (keV s!U-1!N cm!U-2!N!X)']           ; nuFnu
          END
     ELSE: PRINT, 'ERROR: W_MFIT: CV_RATE_MODE = ', STRTRIM(CV_RATE_MODE, 2)
ENDCASE

NUM_VARY = LONG(0)
NUM_CHI  = LONG(0)
X_CHI_LABEL  = STRING(REPLICATE(32B, 57))
Y_CHI_LABEL  = STRING(REPLICATE(32B, 57))
X_BEST_VALUE = 0.0
Y_BEST_VALUE = 0.0
X_PARAM_VALS = FLTARR(MAX_CHI_1D)
Y_PARAM_VALS = FLTARR(MAX_CHI_2D)
CHI_1D_VALS  = FLTARR(MAX_CHI_1D)
CHI_2D_VALS  = FLTARR(MAX_CHI_2D, MAX_CHI_2D)
GAUSS_VWIDTH = LONG(0)

FIRST_CHAN_PLOT   = LONARR(MAX_DET)
LAST_CHAN_PLOT    = LONARR(MAX_DET)         ;  Let MFIT figure it out.
FIRST_CHAN_FIT    = LONARR(MAX_DET)
LAST_CHAN_FIT     = LONARR(MAX_DET)         ;  Let MFIT figure it out.
FIRST_MODEL_PLOT  = LONARR(MAX_DET)
LAST_MODEL_PLOT   = LONARR(MAX_DET)
FIRST_EXTRAP_PLOT = LONARR(MAX_DET)
LAST_EXTRAP_PLOT  = LONARR(MAX_DET)

SIG_LEVELS = FLTARR(10, 3)
SIG_LEVELS(0:29) = $
    [ 1.00,  2.30,  3.53,  4.72,  5.89,  7.04,  8.18,  9.30, 10.42, 11.54, $
      4.00,  6.18,  8.02,  9.72, 11.31, 12.85, 14.34, 15.79, 17.21, 18.61, $
      9.00, 11.83, 14.16, 16.25, 18.20, 20.06, 21.85, 23.57, 25.26, 26.90]

NINE_LEVELS = FLTARR(10, 3)
NINE_LEVELS(0:29) = $
    [ 2.70,  4.60,  6.25,  7.78,  9.24, 10.64, 12.02, 13.36, 14.68, 15.99, $
      6.63,  9.21, 11.34, 13.28, 15.09, 16.81, 18.48, 20.09, 21.67, 23.21, $
     10.83, 13.82, 16.27, 18.47, 20.52, 22.46, 24.32, 26.12, 27.88, 29.59]



END; PRO INIT_VARS
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
FUNCTION GET_NOTE, SSTRING        ; Returns the number of the note containing
                                  ;  the given string.
COMMON ANNOTATION_C, NOTES, N_NOTES, N_ANNOTES, ANNOTES, ANN_X, ANN_Y

FOR JJ = 0, N_NOTES - 1 DO BEGIN
  KK = STRPOS(NOTES(JJ), SSTRING)
  IF KK NE -1 THEN RETURN, JJ
  ENDFOR

RETURN, 3

END; FUNCTION GET_NOTE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO READ_DRM, FILENAME, IO_STATUS, FITS = FITS

@wgsp_cb.pro


NCHAN = NUM_CHAN(NUM_DET - 1)

IF NUM_DET GT 1 THEN BEGIN
   DIM1_SAVE = DRM_DIM1 
   DIM2_SAVE = DRM_DIM2 
   DIM3_SAVE = DRM_DIM3 
   ENDIF

IF KEYWORD_SET(FITS) THEN BEGIN
   IO_OK = 1        ; Set named variable first: want to check if filetype valid.
   READ_COMPRESSED, FILENAME, NEB, E_IN, NUMCH, CH_OUT, MAT_TYPE, $
                    RESP_MATRIX, SCAT_MATRIX, IO_ERR = IO_OK
   IF IO_OK EQ -1 THEN BEGIN
      MFIT_INFORM, 'DRM Read Error: FITS filetype is wrong; use DRM FITS file.'
      IO_STATUS = -99
      RETURN
   ENDIF      

   NUM_EBINS(NUM_DET - 1) = LONG(NEB)
   IF NUMCH NE NCHAN THEN BEGIN
      MFIT_INFORM, 'DRM Read Error: Number of channels is wrong: ' + $
                    STRTRIM(NUMCH, 2)
      IO_STATUS = -99
      RETURN
   ENDIF      

   ; RP: Make sure only valid detectors are included:
   DRM_DIM1 = LONG(MAX(NUM_EBINS(0: NUM_DET - 1)) - 1)
   DRM_DIM2 = LONG(MAX(NUM_CHAN(0: NUM_DET - 1)) - 1)
   DRM_DIM3 = LONG(NUM_DET - 1)
ENDIF ELSE BEGIN
   MFIT_INFORM, 'DRM Read Error: DRM filetype is wrong; use FITS file.'
   IO_STATUS = -99
   RETURN
ENDELSE

IO_STATUS = 0

IF MAT_TYPE EQ 2 THEN BEGIN
   USE_SCAT = WIDMENU(['Include Earth Scattering Matrix?', 'Yes', 'No'], $
                       TITLE = 0)
   IF USE_SCAT THEN RESP_MATRIX = RESP_MATRIX + SCAT_MATRIX
ENDIF

;IF DRM_DIM3 GT 0 THEN BEGIN       ; Store old matrices as well:
IF NUM_DET GT 1 THEN BEGIN       ; Store old matrices as well:
   TEMP_DIM1 = MAX([DRM_DIM1, DIM1_SAVE])
   TEMP_DIM2 = MAX([DRM_DIM2, DIM2_SAVE])
   TEMP_DRM = FLTARR(TEMP_DIM1 + 1, TEMP_DIM2 + 1, DRM_DIM3 + 1)
   TEMP_DRM(0: DIM1_SAVE, 0: DIM2_SAVE, 0: DIM3_SAVE) = DRM
   TEMP_DRM(0: NEB - 1, 0: NCHAN - 1, DRM_DIM3) = RESP_MATRIX
   DRM = TEMP_DRM
ENDIF ELSE BEGIN                       
   ; Store the first matrix:
   DRM = RESP_MATRIX
ENDELSE

CHAN_ENERGY(0: NCHAN - 1, NUM_DET - 1) = $
               (CH_OUT(1:NCHAN) + CH_OUT(0:NCHAN - 1)) / 2.
CHAN_WIDTH(0: NCHAN - 1, NUM_DET - 1) = (CH_OUT(1:NCHAN) - CH_OUT(0:NCHAN - 1))
C_IND = WHERE((CHAN_WIDTH(*, NUM_DET - 1) LE 0.0), COUNT)
IF COUNT NE 0 THEN CHAN_WIDTH(C_IND, NUM_DET - 1) = 0.01

PHOT_ENERGY(0:(NEB - 1), NUM_DET - 1) = (E_IN(0:NEB-1) + E_IN(1:NEB)) / 2.0
PHOT_WIDTH(0:(NEB - 1), NUM_DET - 1) = E_IN(1: NEB) - E_IN(0: NEB - 1)



END; PRO READ_DRM
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO SUM_DRM, FILENAME, PREV_LIVE, CUR_LIVE, SUM_DET, IO_STATUS

@wgsp_cb.pro


NCHAN = NUM_CHAN(SUM_DET)


   IO_OK = 1        ; Set named variable first: want to check if filetype valid.
   READ_COMPRESSED, FILENAME, NEB, E_IN, NUMCH, CH_OUT, MAT_TYPE, $
                    RESP_MATRIX, SCAT_MATRIX, IO_ERR = IO_OK
   IF IO_OK EQ -1 THEN BEGIN
      MFIT_INFORM, 'DRM Read Error: FITS filetype is wrong; use DRM FITS file.'
      IO_STATUS = -99
      RETURN
   ENDIF      

   NUM_EBINS(SUM_DET) = LONG(NEB)
   IF NUMCH NE NCHAN THEN BEGIN
      MFIT_INFORM, 'DRM Read Error: Number of channels is wrong: ' + $
                    STRTRIM(NUMCH, 2)
      IO_STATUS = -99
      RETURN
   ENDIF      

IO_STATUS = 0

IF MAT_TYPE EQ 2 THEN BEGIN
   USE_SCAT = WIDMENU(['Include Earth Scattering Matrix?', 'Yes', 'No'], $
                       TITLE = 0)
   IF USE_SCAT THEN RESP_MATRIX = RESP_MATRIX + SCAT_MATRIX
ENDIF

   TEMP_DRM = DRM(0: NEB - 1, 0: NCHAN - 1, SUM_DET)
   ; Livetime weight the DRMs for the old and new data:
   TOT_LIVE = (PREV_LIVE + CUR_LIVE)
   DRM(0: NEB - 1, 0: NCHAN - 1, SUM_DET) = (TEMP_DRM * PREV_LIVE + $
               RESP_MATRIX * CUR_LIVE) / TOT_LIVE

OLD_THRESH = FLTARR(2, NCHAN)
NEW_THRESH = FLTARR(2, NCHAN)
OLD_THRESH(0, *) = CHAN_ENERGY(0: NCHAN - 1, SUM_DET) - $
                   CHAN_WIDTH(0: NCHAN - 1, SUM_DET) / 2.
OLD_THRESH(1, *) = CHAN_ENERGY(0: NCHAN - 1, SUM_DET) + $
                   CHAN_WIDTH(0: NCHAN - 1, SUM_DET) / 2.
NEW_THRESH(0, *) = (OLD_THRESH(0, *) * PREV_LIVE + CH_OUT(0:NCHAN - 1) * $
                   CUR_LIVE) / TOT_LIVE
NEW_THRESH(1, *) = (OLD_THRESH(1, *) * PREV_LIVE + CH_OUT(1: NCHAN) * $
                   CUR_LIVE) / TOT_LIVE
CHAN_ENERGY(0: NCHAN - 1, SUM_DET) = (NEW_THRESH(1, *) + NEW_THRESH(0, *)) / 2.
CHAN_WIDTH(0: NCHAN - 1, SUM_DET) = (NEW_THRESH(1, *) - NEW_THRESH(0, *)) 
C_IND = WHERE((CHAN_WIDTH(*, SUM_DET) LE 0.0), COUNT)
IF COUNT NE 0 THEN CHAN_WIDTH(C_IND, SUM_DET) = 0.01

PHOT_ENERGY(0:(NEB - 1), SUM_DET) = (E_IN(0:NEB-1) + E_IN(1:NEB)) / 2.0
PHOT_WIDTH(0:(NEB - 1), SUM_DET) = E_IN(1: NEB) - E_IN(0: NEB - 1)



END; PRO SUM_DRM
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO ANNOTE, THE_NOTE, PGE_POS, LEFT_ALIGN = LA

COMMON ANNOTATION_C, NOTES, N_NOTES, N_ANNOTES, ANNOTES, ANN_X, ANN_Y

COMMON CURRENT_MENU, CURRENT_VALUES, ANNOTATE_BH, ANNOTATE_BS, $
                     AUTO_READ, JOINT_FIT, ANNOTATE_SIZE, $
                     GLOBAL_CHARSIZE, GLOBAL_TICKLEN, $
                     GLOBAL_LINETHICK, GLOBAL_CHARTHICK


DEL_Y_PAGE = PGE_POS(3) - PGE_POS(1)
Y_PAGE = PGE_POS(1)  

ANNOTES(N_ANNOTES) = THE_NOTE

IF KEYWORD_SET(LA) THEN $              ;Fit comments are left aligned
   ANN_X(N_ANNOTES) = PGE_POS(0) $
ELSE $
   ANN_X(N_ANNOTES) = PGE_POS(2)

ANN_Y(N_ANNOTES) = Y_PAGE - (N_ANNOTES + 3) * 0.03 * DEL_Y_PAGE
N_ANNOTES = N_ANNOTES + 1



END; PRO ANNOTE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; Turns on the button whose widget id is WID
PRO TURN_ON, WID

; Handle undefined button
STATUS = WIDGET_INFO(WID, /VALID_ID)
IF (STATUS NE 0) THEN BEGIN 
   WIDGET_CONTROL, WID, SENSITIVE = 1
ENDIF 


END

; Turns off the button whose widget id is WID
PRO TURN_OFF, WID

; Handle undefined button
STATUS = WIDGET_INFO(WID, /VALID_ID)
IF (STATUS NE 0) THEN BEGIN 
   WIDGET_CONTROL, WID, SENSITIVE = 0
ENDIF 


END
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
