; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
PRO MODEL_PLOTTER, PAGE_POS, LDET, HC_OPTION, MULTI_FLAG

@wgsp_cb.pro


; Maximum of eight detectors for simultaneous fit
;  Vector-drawn fonts corresponding to PSYM 1, 8, 6, 4, 5, 7, 2:
PLOT_SYM_V = ['!13+!X', '!20B!X', '!9B!X', '!9V!X', '!4D!X', '!9X!X', '!4*!X']
PLOT_SYM = [3, 8, 6, 4, 5, 7, 2]

NCHAN = NUM_CHAN(LDET) - 1
OFF_CHAN = CHAN_OFFSET(LDET)

TOP = LAST_CHAN_PLOT(LDET) - OFF_CHAN
BOT = FIRST_CHAN_PLOT(LDET) - OFF_CHAN
STOP_IND = USED_REBIN(LDET)
PIND = REBIN_CHAN(0: STOP_IND, LDET)
PIND = PIND(WHERE(PIND GE BOT))
PIND = PIND(WHERE(PIND LE TOP))
PIND = [PIND, TOP + 1] - BOT

; Plot count model as a histogram if the control variable is set.
IF HAVE_MODEL AND (CV_SPEC_STYLE GE (N_ELEMENTS(PIND) - 1)) AND $
                  (PLOT_TYPE EQ 1) THEN BEGIN
   PLOT_COUNT_HIST, PAGE_POS, LDET, HC_OPTION, MULTI_FLAG
   RETURN
ENDIF

XR = [XBEG(LDET, PLOT_TYPE), XEND(LDET, PLOT_TYPE)]
YR = [YBEG(LDET, PLOT_TYPE), YEND(LDET, PLOT_TYPE)]

XLOG = READ_MENU(1) 
YLOG = READ_MENU(2) 
F_TITLE = STRTRIM(TOPLABEL, 0)
X_F_TITLE = XAXIS_LABEL
Y_F_TITLE = YAXIS_LABEL(PLOT_TYPE)

; Scale the plot position according to the chararacter size
X0 = 0.11  &  X0 = X0 + (0.075 * (GLOBAL_CHARSIZE-1))
X1 = 0.96  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
Y0 = 0.11  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
Y1 = 0.96  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
;X0 = PAGE_POS(0)  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
;Y0 = PAGE_POS(1)  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
;X1 = PAGE_POS(2)  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
;Y1 = PAGE_POS(3)  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))

DE = CHAN_WIDTH(0: NCHAN, LDET)
CH_EDGES = FLTARR(2, NCHAN + 1)
CH_EDGES(0, *) = CHAN_ENERGY(0: NCHAN, LDET) - DE / 2.
CH_EDGES(1, *) = CHAN_ENERGY(0: NCHAN, LDET) + DE / 2.

   IF PLOT_TYPE EQ 1 THEN BEGIN
      NIND = WHERE(NET_CRATE(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         NET_CRATE(NIND, LDET) = 1.0E-14
      COMBINE, NET_CRATE(BOT:TOP, LDET) * DE(BOT:TOP), $
               CNT_RATE_SIG(BOT:TOP, LDET) * DE(BOT:TOP), $
               CH_EDGES(*, BOT:TOP), PIND, $
               Y_F_DATA, DY_F_DATA, X_F_DATA

      IF PLOT_MODEL THEN BEGIN
         XLO = FIRST_CHAN_FIT(LDET) - OFF_CHAN
         XHI = LAST_CHAN_FIT(LDET) - OFF_CHAN
         MIND = INDGEN(N_ELEMENTS(MODEL_CNT_RATE(*, 0, LDET)))
         IF CV_PLOT_MODEL_EXTRAP THEN $
            MIND = MIND(FIRST_CHAN_PLOT(LDET) - OFF_CHAN: $
                      LAST_CHAN_PLOT(LDET) - OFF_CHAN)    $
         ELSE $
            MIND = MIND(XLO: XHI)
         MX_DATA = CHAN_ENERGY(*, LDET)
         T_IND = WHERE(TERM_USED EQ 1)
         NUM_TERMS = N_ELEMENTS(T_IND)
         MY_DATA = MODEL_CNT_RATE(*, T_IND, LDET)
         IF NUM_TERMS EQ 2 THEN NUM_TERMS = 1
         ENDIF
      ENDIF 
   IF PLOT_TYPE EQ 2 THEN BEGIN
      NIND = WHERE(PHOT_OBS_RATE(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         PHOT_OBS_RATE(NIND, LDET) = 1.0E-14
      COMBINE, PHOT_OBS_RATE(BOT:TOP, LDET) * DE(BOT:TOP), $
               PHOT_OBS_SIG(BOT:TOP, LDET) * DE(BOT:TOP), $
               CH_EDGES(*, BOT:TOP), PIND, $
               Y_F_DATA, DY_F_DATA, X_F_DATA

      IF PLOT_MODEL THEN BEGIN
         MIND = INDGEN(N_ELEMENTS(MODEL_PHOT_RATE(*, 0, LDET)))
         IF CV_PLOT_MODEL_EXTRAP THEN $
            MIND = MIND(FIRST_EXTRAP_PLOT(LDET): $
                        LAST_EXTRAP_PLOT(LDET)) $
         ELSE $
            MIND = MIND(FIRST_MODEL_PLOT(LDET): $
                        LAST_MODEL_PLOT(LDET))
         XLO = FIRST_MODEL_PLOT(LDET)
         XHI = LAST_MODEL_PLOT(LDET)
         MX_DATA = MODEL_ENERGY(*, LDET)
         T_IND = WHERE(TERM_USED EQ 1)
         NUM_TERMS = N_ELEMENTS(T_IND)
         MY_DATA = MODEL_PHOT_RATE(*, T_IND, LDET)
         IF NUM_TERMS EQ 2 THEN NUM_TERMS = 1
         ENDIF
      ENDIF
   IF PLOT_TYPE EQ 3 THEN BEGIN
      YLOG = 'LINEAR'
      NIND = WHERE(CNT_RESID(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         CNT_RESID(NIND, LDET) = 1.0E-14
      COMBINE, CNT_RESID(BOT:TOP, LDET) * DE(BOT:TOP), $
               CNT_RATE_SIG(BOT:TOP, LDET) * DE(BOT:TOP), $
               CH_EDGES(*, BOT:TOP), PIND, $
               Y_F_DATA, DY_F_DATA, X_F_DATA

      MIND = WHERE(CHAN_ENERGY(*, LDET))
      XLO = FIRST_CHAN_FIT(LDET) - OFF_CHAN
      XHI = LAST_CHAN_FIT(LDET) - OFF_CHAN
      MX_DATA = CHAN_ENERGY(*, LDET)
      MY_DATA = FLTARR(N_ELEMENTS(MX_DATA))
      MY_DATA(*) = 0.0
      NUM_TERMS = 1
      PLOT_MODEL = 1
      ENDIF
   IF PLOT_TYPE EQ 4 THEN BEGIN
      YLOG = 'LINEAR'
      NIND = WHERE(PHOT_RESID(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         PHOT_RESID(NIND, LDET) = 1.0E-14
      COMBINE, PHOT_RESID(BOT:TOP, LDET) * DE(BOT:TOP), $
               PHOT_OBS_SIG(BOT:TOP, LDET) * DE(BOT:TOP), $
               CH_EDGES(*, BOT:TOP), PIND, $
               Y_F_DATA, DY_F_DATA, X_F_DATA

      MIND = WHERE(MODEL_ENERGY(*, LDET))
      XLO = FIRST_MODEL_PLOT(LDET)
      XHI = LAST_MODEL_PLOT(LDET)
      MX_DATA = MODEL_ENERGY(*, LDET)
      MY_DATA = FLTARR(N_ELEMENTS(MX_DATA))
      MY_DATA(*) = 0.0
      NUM_TERMS = 1
      PLOT_MODEL = 1
      ENDIF
   IF PLOT_TYPE EQ 5 THEN BEGIN
      D_LOG_E = (ALOG(CH_EDGES(1, *)) - ALOG(CH_EDGES(0, *)))
      NIND = WHERE(NU_F_NU_DATA(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         NU_F_NU_DATA(NIND, LDET) = 1.0E-14
      COMBINE, NU_F_NU_DATA(BOT:TOP, LDET) * D_LOG_E(BOT:TOP), $
               NU_F_NU_SIG(BOT:TOP, LDET) * D_LOG_E(BOT:TOP), $
               ALOG(CH_EDGES(*, BOT:TOP)), PIND, $
               Y_F_DATA, DY_F_DATA, X_F_DATA
      X_F_DATA = EXP(X_F_DATA)

      IF PLOT_MODEL THEN BEGIN
         MIND = INDGEN(N_ELEMENTS(NU_F_NU_MODEL(*, LDET)))
         IF CV_PLOT_MODEL_EXTRAP THEN $
            MIND = MIND(FIRST_EXTRAP_PLOT(LDET): LAST_EXTRAP_PLOT(LDET)) $
         ELSE $
            MIND = MIND(FIRST_MODEL_PLOT(LDET): LAST_MODEL_PLOT(LDET))
         XLO = FIRST_MODEL_PLOT(LDET)
         XHI = LAST_MODEL_PLOT(LDET)
         MX_DATA = MODEL_ENERGY(*, LDET)
         MY_DATA = NU_F_NU_MODEL(*, LDET)
         NUM_TERMS = 1
         ENDIF
      ENDIF

PLOTTING = 0
IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0    &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 185 / 660.0   &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 439 / 510.0   &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 567 / 660.0   &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
ENDIF 

; Change the log scale tick marks, if necessary
IF (XLOG EQ 'LOG') THEN BEGIN                 
   IF (CHECK_DECADE(XR)) THEN !X.TICKS = 5
ENDIF
IF (YLOG EQ 'LOG') THEN BEGIN           
   IF (CHECK_DECADE(YR)) THEN !Y.TICKS = 5
ENDIF

IF MULTI_FLAG EQ 0 THEN $
   PLOT, XR, YR, $                 
         TITLE = F_TITLE, XTITLE = X_F_TITLE, POSITION = [X0, Y0, X1, Y1],$
         YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
         XSTYLE = 1, YSTYLE = 1, /NODATA
IF MULTI_FLAG EQ 1 THEN $
   PLOT, XR, YR, $                 
         TITLE = F_TITLE, XTITLE = X_F_TITLE,$
         YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
         XSTYLE = 1, YSTYLE = 1, /NODATA

   PLOT_POINTS, X_F_DATA, Y_F_DATA, DY_F_DATA
   IF (PLOT_TYPE EQ 1) OR $
      (PLOT_TYPE EQ 2) OR $
      (PLOT_TYPE EQ 5) THEN BEGIN

      IF (CV_MULTI_DET_PLOT_MODE EQ 'S') OR $
         ((CV_MULTI_DET_PLOT_MODE EQ 'C') AND (PLOT_TYPE EQ 1)) THEN GOTO, SKIP

      ; Get the mid point of data and oplot a different symbol for each det.
      XMID = ( ( X_F_DATA(1, *) - X_F_DATA(0, *) ) / 2.0 ) + X_F_DATA(0, *)
      ; Need upper limits?
      YMID = FLTARR(N_ELEMENTS(Y_F_DATA)) 
      FOR I=0, N_ELEMENTS(Y_F_DATA)-1 DO BEGIN
          IF Y_F_DATA(I) LT DY_F_DATA(I) THEN BEGIN
             YMID(I) = 2 * DY_F_DATA(I)
          ENDIF ELSE BEGIN
             YMID(I) = Y_F_DATA(I)
          ENDELSE
      ENDFOR
      ; Make a plot symbol
      PI = ACOS(-1.0)
      A  = FINDGEN(16)*(PI*2/16.0)
      USERSYM, COS(A)*0.5, SIN(A)*0.5, /FILL
      OPLOT, XMID, YMID, PSYM = PLOT_SYM(LDET MOD 7)
   ENDIF

SKIP:

   IF PLOT_MODEL THEN BEGIN
      IF NOT CV_PLOT_EACH_TERM THEN NUM_TERMS = 1
      FOR LL = 0, (NUM_TERMS - 1) DO BEGIN
         LINE_NUM = MIN([2,2 * LL + 1])
         IF CV_ABS_MODEL THEN BEGIN
            OPLOT, MX_DATA(MIND), ABS(MY_DATA(MIND, LL)), $
                      LINESTYLE = LINE_NUM 
            ENDIF $
         ELSE BEGIN
            TEMP_MY = MY_DATA(MIND, LL)
            NEG_IND = WHERE(TEMP_MY, NEG_NUM)
            IF NEG_NUM NE 0 THEN $
               TEMP_MX = MX_DATA(MIND)
               OPLOT, TEMP_MX(NEG_IND), TEMP_MY(NEG_IND), LINESTYLE = LINE_NUM 
            ENDELSE
         ENDFOR
      Y_TEMP = MY_DATA(XLO:XHI, 0)
      Y_IND = WHERE(Y_TEMP)
      X_TEMP = MX_DATA(XLO:XHI)
      IF Y_IND(0) EQ -1 THEN Y_IND = WHERE(X_TEMP)
      OPLOT, X_TEMP(Y_IND), Y_TEMP(Y_IND), LINESTYLE = 0 
      ENDIF     ; Plot model.

DET_TITLE = STRTRIM(DET_NAMES(LDET), 2)
X_WIN = !X.WINDOW
Y_WIN = !Y.WINDOW
IF (PLOT_TYPE EQ 1) OR $
   (PLOT_TYPE EQ 2) OR $
   (PLOT_TYPE EQ 5) AND $
   (NUM_DET GT 1) THEN BEGIN
   PLABEL = PLOT_SYM_V(LDET MOD 7) + ' ' + DET_TITLE
ENDIF ELSE BEGIN
   PLABEL = DET_TITLE
ENDELSE

IF (CV_MULTI_DET_PLOT_MODE EQ 'S') OR $
   ((CV_MULTI_DET_PLOT_MODE EQ 'C') AND (PLOT_TYPE EQ 1)) THEN $
   PLABEL = DET_TITLE

IF (ANNOTATE_SIZE GT 0.0) THEN BEGIN
   IF (PLOT_TYPE NE 5) THEN BEGIN
      XYOUTS, X_WIN(1) -  0.04, Y_WIN(1) - 0.04*(ANNOTATE_SIZE/1.5), $
           PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
   ENDIF ELSE BEGIN
      ; Left side of plot for nuF_nu
      XYOUTS, X_WIN(0) +  0.2, Y_WIN(1) - 0.04*(ANNOTATE_SIZE/1.5), $
           PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
   ENDELSE
ENDIF

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PAGE_POS, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF

YLOG = READ_MENU(2) 
!X.TICKS = 0 & !Y.TICKS = 0


END; PRO MODEL_PLOTTER
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
PRO MULTI_MODEL_PLOT, PAGE_POS, HC_OPTION

@wgsp_cb.pro


; Maximum of four detectors for simultaneous fit
;  Vector-drawn fonts corresponding to PSYM 1, 8, 6, 4, 5, 7, 2:
PLOT_SYM_V = ['!13+!X', '!20B!X', '!9B!X', '!9V!X', '!4D!X', '!9X!X', '!4*!X']
PLOT_SYM = [3, 8, 6, 4, 5, 7, 2]
;PLOT_SYM_V = ['!13+!X', '!20B!X', '!9B!X', '!9V!X']
;PLOT_SYM = [3, 8, 6, 4]
MULTI_SAVE = !P.MULTI

; Scale the plot position according to the chararacter size
X0 = 0.11  &  X0 = X0 + (0.075 * (GLOBAL_CHARSIZE-1))
X1 = 0.96  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
Y0 = 0.11  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
Y1 = 0.96  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
;X0 = PAGE_POS(0)  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
;Y0 = PAGE_POS(1)  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
;X1 = PAGE_POS(2)  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
;Y1 = PAGE_POS(3)  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))

XLOG = READ_MENU(1) 
YLOG = READ_MENU(2) 
F_TITLE = STRTRIM(TOPLABEL, 0)
X_F_TITLE = XAXIS_LABEL
Y_F_TITLE = YAXIS_LABEL(PLOT_TYPE)

XR = [MIN(XBEG(0: NUM_DET - 1, PLOT_TYPE)), $
      MAX(XEND(0: NUM_DET - 1, PLOT_TYPE))]
YR = [MIN(YBEG(0: NUM_DET - 1, PLOT_TYPE)), $
      MAX(YEND(0: NUM_DET - 1, PLOT_TYPE))]

PLOTTING = 0

IF (N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1) THEN BEGIN
   PLOTTING = 1
ENDIF 

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0    &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 185 / 660.0   &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 439 / 510.0   &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 567 / 660.0   &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
ENDIF 

; Change the log scale tick marks, if necessary
IF (XLOG EQ 'LOG') THEN BEGIN
   IF (CHECK_DECADE(XR)) THEN !X.TICKS = 5
ENDIF
IF (YLOG EQ 'LOG') THEN BEGIN                 
   IF (CHECK_DECADE(YR)) THEN !Y.TICKS = 5
ENDIF

IF ((N_ELEMENTS(HC_OPTION) NE 0) AND (HC_OPTION EQ 1)) OR $
   ((CV_MULTI_DET_PLOT_MODE EQ 'T') OR $
    (CV_MULTI_DET_PLOT_MODE EQ 'C')) THEN BEGIN
   MULTI_FLAG = 0
   PLOT, XR, YR, $                 
         TITLE = F_TITLE, XTITLE = X_F_TITLE, POSITION = [X0, Y0, X1, Y1],$
         YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
         XSTYLE = 1, YSTYLE = 1, /NODATA
ENDIF ELSE BEGIN
   MULTI_FLAG = 1
   CASE NUM_DET OF
        2: !P.MULTI = [0, 2, 1]
        3: !P.MULTI = [0, 2, 2]
        4: !P.MULTI = [0, 2, 2]
        ELSE: MULTI_FLAG = 0
   ENDCASE

   IF MULTI_FLAG EQ 0 THEN $
      PLOT, XR, YR, $                 
            TITLE = F_TITLE, XTITLE = X_F_TITLE, POSITION = [X0, Y0, X1, Y1],$
            YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
            XSTYLE = 1, YSTYLE = 1, /NODATA
ENDELSE


FOR LDET = 0, NUM_DET - 1 DO BEGIN
   IF MULTI_FLAG EQ 1 THEN $
      PLOT, XR, YR, $                 
            TITLE = F_TITLE, XTITLE = X_F_TITLE, $
            YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
            XSTYLE = 1, YSTYLE = 1, /NODATA

   NCHAN = NUM_CHAN(LDET) - 1
   OFF_CHAN = CHAN_OFFSET(LDET)

   TOP = LAST_CHAN_PLOT(LDET) - OFF_CHAN
   BOT = FIRST_CHAN_PLOT(LDET) - OFF_CHAN
   STOP_IND = USED_REBIN(LDET)
   PIND = REBIN_CHAN(0: STOP_IND, LDET)
   PIND = PIND(WHERE(PIND GE BOT))
   PIND = PIND(WHERE(PIND LE TOP))
   PIND = [PIND, TOP + 1] - BOT

   PLOT_HIST = 0
   ; Plot count model as a histogram if the control variable is set.
   IF HAVE_MODEL AND (CV_SPEC_STYLE GE (N_ELEMENTS(PIND) - 1)) AND $
                  (PLOT_TYPE EQ 1) THEN BEGIN
      PLOT_HIST = 1
   ENDIF

   DE = CHAN_WIDTH(0: NCHAN, LDET)
   CH_EDGES = FLTARR(2, NCHAN + 1)
   CH_EDGES(0, *) = CHAN_ENERGY(0: NCHAN, LDET) - DE / 2.
   CH_EDGES(1, *) = CHAN_ENERGY(0: NCHAN, LDET) + DE / 2.

   IF PLOT_TYPE EQ 1 THEN BEGIN
      NIND = WHERE(NET_CRATE(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         NET_CRATE(NIND, LDET) = 1.0E-14
      TOP_CNT = LAST_CHAN_PLOT(LDET) - OFF_CHAN
      BOT_CNT = FIRST_CHAN_PLOT(LDET) - OFF_CHAN
      CIND = REBIN_CHAN(0: STOP_IND, LDET)
      CIND = CIND(WHERE(CIND GE BOT_CNT))
      CIND = CIND(WHERE(CIND LE TOP_CNT))
      CIND = [CIND, TOP_CNT + 1] - BOT_CNT

      COMBINE, NET_CRATE(BOT_CNT:TOP_CNT, LDET) * DE(BOT_CNT:TOP_CNT), $
         CNT_RATE_SIG(BOT_CNT:TOP_CNT, LDET) * DE(BOT_CNT:TOP_CNT), $
         CH_EDGES(*, BOT_CNT:TOP_CNT), CIND, $
         Y_F_DATA, DY_F_DATA, X_F_DATA

      IF PLOT_MODEL THEN BEGIN
         XLO = FIRST_CHAN_FIT(LDET) - OFF_CHAN
         XHI = LAST_CHAN_FIT(LDET) - OFF_CHAN
         QIND = REBIN_CHAN(0: STOP_IND, LDET)
         QIND = QIND(WHERE(QIND GE XLO))
         QIND = QIND(WHERE(QIND LE XHI))
         QIND = [QIND, XHI + 1] - XLO
         MIND = INDGEN(N_ELEMENTS(MODEL_CNT_RATE(*, 0, LDET)))

         IF CV_PLOT_MODEL_EXTRAP THEN $
            MIND = MIND(FIRST_CHAN_PLOT(LDET) - OFF_CHAN: $
                      LAST_CHAN_PLOT(LDET) - OFF_CHAN)    $
         ELSE $
            MIND = MIND(XLO: XHI)

         T_IND = WHERE(TERM_USED EQ 1)
         NUM_TERMS = N_ELEMENTS(T_IND)

         IF PLOT_HIST THEN BEGIN
            MY_DATA = MODEL_CNT_RATE(*, T_IND, LDET)
            FOR LL = 0, (NUM_TERMS - 1) DO BEGIN
               IF NIND(0) NE -1 THEN $
                  MODEL_CNT_RATE(NIND, T_IND(LL), LDET) = 1.0E-14
               COMBINE, MODEL_CNT_RATE(BOT:TOP, T_IND(LL), LDET) * DE(BOT:TOP),$
                        0.0 * DE(BOT:TOP), $
                        CH_EDGES(*, BOT:TOP), PIND, $
                        DUMMY_MY, MDY_DATA, MX_DATA
               MY_IND = N_ELEMENTS(DUMMY_MY) - 1
               MY_DATA(0:MY_IND, LL) = DUMMY_MY
               MY_DATA(MY_IND + 1: *, LL) = 0.0
               ENDFOR

            IF (XLO EQ BOT) AND (XHI EQ TOP) THEN BEGIN
               X_TEMP = MX_DATA
               Y_TEMP = MY_DATA(*, 0)
               ENDIF $
            ELSE BEGIN
               COMBINE, MODEL_CNT_RATE(XLO:XHI, 0, LDET) * DE(XLO:XHI), $
                        0.0 * DE(XLO:XHI), $
                        CH_EDGES(*, XLO:XHI), QIND, $
                        Y_TEMP, MDY_DATA, X_TEMP
               ENDELSE
            ENDIF $
         ELSE BEGIN
            MX_DATA = CHAN_ENERGY(*, LDET)
            MY_DATA = MODEL_CNT_RATE(*, T_IND, LDET)
            ENDELSE
         IF NUM_TERMS EQ 2 THEN NUM_TERMS = 1
         ENDIF
      ENDIF 
   IF PLOT_TYPE EQ 2 THEN BEGIN
      NIND = WHERE(PHOT_OBS_RATE(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         PHOT_OBS_RATE(NIND, LDET) = 1.0E-14
      COMBINE, PHOT_OBS_RATE(BOT:TOP, LDET) * DE(BOT:TOP), $
               PHOT_OBS_SIG(BOT:TOP, LDET) * DE(BOT:TOP), $
               CH_EDGES(*, BOT:TOP), PIND, $
               Y_F_DATA, DY_F_DATA, X_F_DATA

      IF PLOT_MODEL THEN BEGIN
         MIND = INDGEN(N_ELEMENTS(MODEL_PHOT_RATE(*, 0, LDET)))
         IF CV_PLOT_MODEL_EXTRAP THEN BEGIN
            MIND = MIND(FIRST_EXTRAP_PLOT(LDET): $
                        LAST_EXTRAP_PLOT(LDET)) 
            ENDIF $
         ELSE BEGIN
            IF USE_DET(LDET) THEN $
            MIND = MIND(FIRST_MODEL_PLOT(LDET): $
                        LAST_MODEL_PLOT(LDET))
            ENDELSE
         XLO = FIRST_MODEL_PLOT(LDET)
         XHI = LAST_MODEL_PLOT(LDET)
         MX_DATA = MODEL_ENERGY(*, LDET)
         T_IND = WHERE(TERM_USED EQ 1)
         NUM_TERMS = N_ELEMENTS(T_IND)
         MY_DATA = MODEL_PHOT_RATE(*, T_IND, LDET)
         IF NUM_TERMS EQ 2 THEN NUM_TERMS = 1
         ENDIF
      ENDIF
   IF PLOT_TYPE EQ 5 THEN BEGIN
      D_LOG_E = (ALOG(CH_EDGES(1, *)) - ALOG(CH_EDGES(0, *)))
      NIND = WHERE(NU_F_NU_DATA(*, LDET) LT -1.0E14)
      IF NIND(0) NE -1 THEN $
         NU_F_NU_DATA(NIND, LDET) = 1.0E-14
      COMBINE, NU_F_NU_DATA(BOT:TOP, LDET) * D_LOG_E(BOT:TOP), $
               NU_F_NU_SIG(BOT:TOP, LDET) * D_LOG_E(BOT:TOP), $
               ALOG(CH_EDGES(*, BOT:TOP)), PIND, $
               Y_F_DATA, DY_F_DATA, X_F_DATA
      X_F_DATA = EXP(X_F_DATA)

      IF PLOT_MODEL THEN BEGIN
         MIND = INDGEN(N_ELEMENTS(NU_F_NU_MODEL(*, LDET)))
         IF CV_PLOT_MODEL_EXTRAP THEN BEGIN
            MIND = MIND(FIRST_EXTRAP_PLOT(LDET): $
                        LAST_EXTRAP_PLOT(LDET)) 
            ENDIF $
         ELSE BEGIN
            IF USE_DET(LDET) THEN $
            MIND = MIND(FIRST_MODEL_PLOT(LDET): $
                        LAST_MODEL_PLOT(LDET))
            ENDELSE
         XLO = FIRST_MODEL_PLOT(LDET)
         XHI = LAST_MODEL_PLOT(LDET)
         MX_DATA = MODEL_ENERGY(*, LDET)
         MY_DATA = NU_F_NU_MODEL(*, LDET)
         NUM_TERMS = 1
         ENDIF
      ENDIF

   PLOT_POINTS, X_F_DATA, Y_F_DATA, DY_F_DATA
   IF (PLOT_TYPE EQ 1) OR $
      (PLOT_TYPE EQ 2) OR $
      (PLOT_TYPE EQ 5) THEN BEGIN

      IF (CV_MULTI_DET_PLOT_MODE EQ 'S') OR $
         ((CV_MULTI_DET_PLOT_MODE EQ 'C') AND (PLOT_TYPE EQ 1)) THEN GOTO, SKIP

      ; Get the mid point of data and oplot a different symbol for each det.
      XMID = ( ( X_F_DATA(1, *) - X_F_DATA(0, *) ) / 2.0 ) + X_F_DATA(0, *)
      ; Need upper limits?
      YMID = FLTARR(N_ELEMENTS(Y_F_DATA)) 
      FOR I=0, N_ELEMENTS(Y_F_DATA)-1 DO BEGIN
          IF Y_F_DATA(I) LT DY_F_DATA(I) THEN BEGIN
             YMID(I) = 2 * DY_F_DATA(I)
          ENDIF ELSE BEGIN
             YMID(I) = Y_F_DATA(I)
          ENDELSE
      ENDFOR
      ; Make a plot symbol
      PI = ACOS(-1.0)
      A  = FINDGEN(16)*(PI*2/16.0)
      USERSYM, COS(A)*0.5, SIN(A)*0.5, /FILL
      OPLOT, XMID, YMID, PSYM = PLOT_SYM(LDET MOD 7)
   ENDIF

SKIP:

   IF PLOT_MODEL THEN BEGIN
      IF NOT CV_PLOT_EACH_TERM THEN NUM_TERMS = 1
      FOR LL = 0, (NUM_TERMS - 1) DO BEGIN
         LINE_NUM = MIN([2,2 * LL + 1])
         IF CV_ABS_MODEL THEN BEGIN
            IF PLOT_HIST THEN BEGIN
               SAVE_STYLE = !P.LINESTYLE
               !P.LINESTYLE = LINE_NUM
               NEW_HIST, MX_DATA, ABS(MY_DATA(*, LL)), !P.COLOR
               !P.LINESTYLE = SAVE_STYLE
               ENDIF $
            ELSE BEGIN
               OPLOT, MX_DATA(MIND), ABS(MY_DATA(MIND, LL)), $
                      LINESTYLE = LINE_NUM 
               ENDELSE
            ENDIF $
         ELSE BEGIN
            TEMP_MY = MY_DATA(MIND, LL)
            NEG_IND = WHERE(TEMP_MY, NEG_NUM)
            IF NEG_NUM NE 0 THEN $
               IF PLOT_HIST THEN BEGIN
                  TEMP_MX = MX_DATA
                  SAVE_STYLE = !P.LINESTYLE
                  !P.LINESTYLE = LINE_NUM
                  NEW_HIST, TEMP_MX(*, NEG_IND), TEMP_MY(NEG_IND), !P.COLOR
                  !P.LINESTYLE = SAVE_STYLE
                  ENDIF $
               ELSE BEGIN
                  TEMP_MX = MX_DATA(MIND)
                  OPLOT, TEMP_MX(NEG_IND), TEMP_MY(NEG_IND), $
                         LINESTYLE = LINE_NUM 
                  ENDELSE
            ENDELSE
         ENDFOR
      IF USE_DET(LDET) THEN BEGIN        ; Don't plot model if det not selected
         IF PLOT_HIST THEN BEGIN
            Y_IND = WHERE(Y_TEMP)
            IF Y_IND(0) EQ -1 THEN Y_IND = WHERE(X_TEMP)
            SAVE_STYLE = !P.LINESTYLE
            !P.LINESTYLE = 0
            NEW_HIST, X_TEMP(*, Y_IND), Y_TEMP(Y_IND), !P.COLOR
            !P.LINESTYLE = SAVE_STYLE
            ENDIF $
         ELSE BEGIN
            Y_TEMP = MY_DATA(XLO:XHI, 0)
            Y_IND = WHERE(Y_TEMP)
            X_TEMP = MX_DATA(XLO:XHI)
            IF Y_IND(0) EQ -1 THEN Y_IND = WHERE(X_TEMP)
            OPLOT, X_TEMP(Y_IND), Y_TEMP(Y_IND), LINESTYLE = 0 
            ENDELSE
         ENDIF
      ENDIF     ; Plot model.

   DET_TITLE = STRTRIM(DET_NAMES(LDET), 2)
   X_WIN = !X.WINDOW
   Y_WIN = !Y.WINDOW
   IF (PLOT_TYPE EQ 1) OR $
      (PLOT_TYPE EQ 2) OR $
      (PLOT_TYPE EQ 5) AND $
      (NUM_DET GT 1) THEN BEGIN
      PLABEL = PLOT_SYM_V(LDET MOD 7) + ' ' + DET_TITLE
   ENDIF ELSE BEGIN
      PLABEL = DET_TITLE
   ENDELSE

   IF (CV_MULTI_DET_PLOT_MODE EQ 'S') OR $
      ((CV_MULTI_DET_PLOT_MODE EQ 'C') AND (PLOT_TYPE EQ 1)) THEN $
      PLABEL = DET_TITLE

   IF (MULTI_FLAG EQ 0) THEN $
      IF (ANNOTATE_SIZE GT 0.0) THEN BEGIN
         IF (PLOT_TYPE NE 5) THEN BEGIN
            XYOUTS, X_WIN(1) -  0.04, $
                 Y_WIN(1) - 0.04 * (LDET + 1) * (ANNOTATE_SIZE/1.5), $
                 PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
         ENDIF ELSE BEGIN
            ; Left side of plot for nuF_nu
            XYOUTS, X_WIN(0) +  0.2, $
              Y_WIN(1) - 0.04 * (LDET + 1) * (ANNOTATE_SIZE/1.5), $
              PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
         ENDELSE
      ENDIF
   IF (MULTI_FLAG EQ 1) THEN $
      IF (ANNOTATE_SIZE GT 0.0) THEN BEGIN
         IF (PLOT_TYPE NE 5) THEN BEGIN
            XYOUTS, X_WIN(1) -  0.04, Y_WIN(1) - 0.04*(ANNOTATE_SIZE/1.5), $
                 PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
         ENDIF ELSE BEGIN
            ; Left side of plot for nuF_nu
            XYOUTS, X_WIN(0) +  0.2, Y_WIN(1) - 0.04*(ANNOTATE_SIZE/1.5), $
              PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
         ENDELSE
      ENDIF

   ENDFOR ; LDET loop

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PAGE_POS, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF

YLOG = READ_MENU(2) 
!P.MULTI = MULTI_SAVE
!X.TICKS = 0 & !Y.TICKS = 0


END; PRO MULTI_MODEL_PLOT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
PRO PLOT_COUNT_HIST, PAGE_POS, LDET, HC_OPTION, MULTI_FLAG

@wgsp_cb.pro


; Maximum of four detectors for simultaneous fit
;  Vector-drawn fonts corresponding to PSYM 1, 8, 6, 4, 5, 7, 2:
PLOT_SYM_V = ['!13+!X', '!20B!X', '!9B!X', '!9V!X', '!4D!X', '!9X!X', '!4*!X']
PLOT_SYM = [3, 8, 6, 4, 5, 7, 2]
;PLOT_SYM_V = ['!13+!X', '!20B!X', '!9B!X', '!9V!X']
;PLOT_SYM = [3, 8, 6, 4]

XR = [XBEG(LDET, PLOT_TYPE), XEND(LDET, PLOT_TYPE)]
YR = [YBEG(LDET, PLOT_TYPE), YEND(LDET, PLOT_TYPE)]
XLOG = READ_MENU(1) 
YLOG = READ_MENU(2) 
F_TITLE = STRTRIM(TOPLABEL, 0)
X_F_TITLE = XAXIS_LABEL
Y_F_TITLE = YAXIS_LABEL(PLOT_TYPE)

; Scale the plot position according to the chararacter size
X0 = 0.11  &  X0 = X0 + (0.075 * (GLOBAL_CHARSIZE-1))
X1 = 0.96  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
Y0 = 0.11  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
Y1 = 0.96  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
;X0 = PAGE_POS(0)  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
;Y0 = PAGE_POS(1)  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
;X1 = PAGE_POS(2)  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
;Y1 = PAGE_POS(3)  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))

NCHAN = NUM_CHAN(LDET) - 1
OFF_CHAN = CHAN_OFFSET(LDET)

XLO = FIRST_CHAN_FIT(LDET) - OFF_CHAN
XHI = LAST_CHAN_FIT(LDET) - OFF_CHAN
STOP_IND = USED_REBIN(LDET)
QIND = REBIN_CHAN(0: STOP_IND, LDET)
QIND = QIND(WHERE(QIND GE XLO))
QIND = QIND(WHERE(QIND LE XHI))
QIND = [QIND, XHI + 1] - XLO

IF CV_PLOT_MODEL_EXTRAP THEN BEGIN
   TOP = LAST_CHAN_PLOT(LDET) - OFF_CHAN
   BOT = FIRST_CHAN_PLOT(LDET) - OFF_CHAN
ENDIF ELSE BEGIN
   TOP = XHI
   BOT = XLO
ENDELSE

PIND = REBIN_CHAN(0: STOP_IND, LDET)
PIND = PIND(WHERE(PIND GE BOT))
PIND = PIND(WHERE(PIND LE TOP))
PIND = [PIND, TOP + 1] - BOT

DE = CHAN_WIDTH(0: NCHAN, LDET)
CH_EDGES = FLTARR(2, NCHAN + 1)
CH_EDGES(0, *) = CHAN_ENERGY(0: NCHAN, LDET) - DE / 2.
CH_EDGES(1, *) = CHAN_ENERGY(0: NCHAN, LDET) + DE / 2.

NIND = WHERE(NET_CRATE(*, LDET) LT -1.0E14)
IF NIND(0) NE -1 THEN $
   NET_CRATE(NIND, LDET) = 1.0E-14
TOP_CNT = LAST_CHAN_PLOT(LDET) - OFF_CHAN
BOT_CNT = FIRST_CHAN_PLOT(LDET) - OFF_CHAN
CIND = REBIN_CHAN(0: STOP_IND, LDET)
CIND = CIND(WHERE(CIND GE BOT_CNT))
CIND = CIND(WHERE(CIND LE TOP_CNT))
CIND = [CIND, TOP_CNT + 1] - BOT_CNT

COMBINE, NET_CRATE(BOT_CNT:TOP_CNT, LDET) * DE(BOT_CNT:TOP_CNT), $
         CNT_RATE_SIG(BOT_CNT:TOP_CNT, LDET) * DE(BOT_CNT:TOP_CNT), $
         CH_EDGES(*, BOT_CNT:TOP_CNT), CIND, $
         Y_F_DATA, DY_F_DATA, X_F_DATA

IF PLOT_MODEL THEN BEGIN
   T_IND = WHERE(TERM_USED EQ 1)
   NUM_TERMS = N_ELEMENTS(T_IND)
   IF NUM_TERMS EQ 2 THEN NUM_TERMS = 1
   MY_DATA = FLTARR(N_ELEMENTS(PIND) - 1, NUM_TERMS)
   NIND = WHERE(PHOT_OBS_RATE(*, LDET) LT -1.0E14)
   FOR LL = 0, (NUM_TERMS - 1) DO BEGIN
      IF NIND(0) NE -1 THEN $
         MODEL_CNT_RATE(NIND, T_IND(LL), LDET) = 1.0E-14
      COMBINE, MODEL_CNT_RATE(BOT:TOP, T_IND(LL), LDET) * DE(BOT:TOP), $
               0.0 * DE(BOT:TOP), $
               CH_EDGES(*, BOT:TOP), PIND, $
               DUMMY_MY, MDY_DATA, MX_DATA
      MY_DATA(*, LL) = DUMMY_MY
      ENDFOR

   IF (XLO EQ BOT) AND (XHI EQ TOP) THEN BEGIN
      X_TEMP = MX_DATA
      Y_TEMP = MY_DATA(*, 0)
      ENDIF $
   ELSE BEGIN
      COMBINE, MODEL_CNT_RATE(XLO:XHI, 0, LDET) * DE(XLO:XHI), $
               0.0 * DE(XLO:XHI), $
               CH_EDGES(*, XLO:XHI), QIND, $
               Y_TEMP, MDY_DATA, X_TEMP
      ENDELSE
   ENDIF

PLOTTING = 0
IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0    &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 185 / 660.0   &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 439 / 510.0   &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 567 / 660.0   &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
ENDIF 

IF MULTI_FLAG EQ 0 THEN $
   PLOT, XR, YR, $                 
         TITLE = F_TITLE, XTITLE = X_F_TITLE, POSITION = [X0, Y0, X1, Y1],$
         YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
         XSTYLE = 1, YSTYLE = 1, /NODATA
IF MULTI_FLAG EQ 1 THEN $
   PLOT, XR, YR, $                 
         TITLE = F_TITLE, XTITLE = X_F_TITLE, $
         YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
         XSTYLE = 1, YSTYLE = 1, /NODATA

   PLOT_POINTS, X_F_DATA, Y_F_DATA, DY_F_DATA
   IF (PLOT_TYPE EQ 1) OR $
      (PLOT_TYPE EQ 2) OR $
      (PLOT_TYPE EQ 5) THEN BEGIN

      IF (CV_MULTI_DET_PLOT_MODE EQ 'S') OR $
         ((CV_MULTI_DET_PLOT_MODE EQ 'C') AND (PLOT_TYPE EQ 1)) THEN GOTO, SKIP

      ; Get the mid point of data and oplot a different symbol for each det.
      XMID = ( ( X_F_DATA(1, *) - X_F_DATA(0, *) ) / 2.0 ) + X_F_DATA(0, *)
      ; Need upper limits?
      YMID = FLTARR(N_ELEMENTS(Y_F_DATA)) 
      FOR I=0, N_ELEMENTS(Y_F_DATA)-1 DO BEGIN
          IF Y_F_DATA(I) LT DY_F_DATA(I) THEN BEGIN
             YMID(I) = 2 * DY_F_DATA(I)
          ENDIF ELSE BEGIN
             YMID(I) = Y_F_DATA(I)
          ENDELSE
      ENDFOR
      ; Make a plot symbol
      PI = ACOS(-1.0)
      A  = FINDGEN(16)*(PI*2/16.0)
      USERSYM, COS(A)*0.5, SIN(A)*0.5, /FILL
      OPLOT, XMID, YMID, PSYM = PLOT_SYM(LDET MOD 7)
   ENDIF

SKIP:

   IF PLOT_MODEL THEN BEGIN
      IF NOT CV_PLOT_EACH_TERM THEN NUM_TERMS = 1
      FOR LL = 0, (NUM_TERMS - 1) DO BEGIN
         LINE_NUM = MIN([2,2 * LL + 1])
         IF CV_ABS_MODEL THEN BEGIN
            SAVE_STYLE = !P.LINESTYLE
            !P.LINESTYLE = LINE_NUM
            NEW_HIST, MX_DATA, ABS(MY_DATA(*, LL)), !P.COLOR
            !P.LINESTYLE = SAVE_STYLE
            ENDIF $
         ELSE BEGIN
            TEMP_MY = MY_DATA(*, LL)
            NEG_IND = WHERE(TEMP_MY, NEG_NUM)
            IF NEG_NUM NE 0 THEN $
               TEMP_MX = MX_DATA
               SAVE_STYLE = !P.LINESTYLE
               !P.LINESTYLE = LINE_NUM
               NEW_HIST, TEMP_MX(*, NEG_IND), TEMP_MY(NEG_IND), !P.COLOR
               !P.LINESTYLE = SAVE_STYLE
            ENDELSE
         ENDFOR

      Y_IND = WHERE(Y_TEMP)
      IF Y_IND(0) EQ -1 THEN Y_IND = WHERE(X_TEMP)
      SAVE_STYLE = !P.LINESTYLE
      !P.LINESTYLE = 0
      NEW_HIST, X_TEMP(*, Y_IND), Y_TEMP(Y_IND), !P.COLOR
      !P.LINESTYLE = SAVE_STYLE
      ENDIF     ; Plot model.

DET_TITLE = STRTRIM(DET_NAMES(LDET), 2)
X_WIN = !X.WINDOW
Y_WIN = !Y.WINDOW
IF (PLOT_TYPE EQ 1) OR $
   (PLOT_TYPE EQ 2) OR $
   (PLOT_TYPE EQ 5) AND $
   (NUM_DET GT 1) THEN BEGIN
   PLABEL = PLOT_SYM_V(LDET MOD 7) + ' ' + DET_TITLE
ENDIF ELSE BEGIN
   PLABEL = DET_TITLE
ENDELSE

IF (CV_MULTI_DET_PLOT_MODE EQ 'S') OR $
   ((CV_MULTI_DET_PLOT_MODE EQ 'C') AND (PLOT_TYPE EQ 1)) THEN PLABEL=DET_TITLE

IF (ANNOTATE_SIZE GT 0.0) THEN BEGIN
   IF (PLOT_TYPE NE 5) THEN BEGIN
      XYOUTS, X_WIN(1) -  0.04, Y_WIN(1) - 0.04*(ANNOTATE_SIZE/1.5), $
          PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
   ENDIF ELSE BEGIN
      ; Left side of plot for nuF_nu
      XYOUTS, X_WIN(0) +  0.2, Y_WIN(1) - 0.04*(ANNOTATE_SIZE/1.5), $
           PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
   ENDELSE
ENDIF

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PAGE_POS, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF

YLOG = READ_MENU(2) 



END; PRO PLOT_COUNT_HIST
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
PRO SIGMA_PLOT, PAGE_POS, LDET, HC_OPTION, MULTI_FLAG

@wgsp_cb.pro


XLOG = READ_MENU(1) 
YLOG = 'LINEAR'
F_TITLE = STRTRIM(TOPLABEL, 0)
X_F_TITLE = XAXIS_LABEL
Y_F_TITLE = 'Residuals (!7r!X)'

; Scale the plot position according to the chararacter size
X0 = 0.11  &  X0 = X0 + (0.075 * (GLOBAL_CHARSIZE-1))
X1 = 0.96  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
Y0 = 0.11  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
Y1 = 0.96  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
;X0 = PAGE_POS(0)  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
;Y0 = PAGE_POS(1)  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
;X1 = PAGE_POS(2)  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
;Y1 = PAGE_POS(3)  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))

OFF_CHAN = CHAN_OFFSET(LDET)

NCHAN = NUM_CHAN(LDET) - 1
X_F_DATA = CHAN_ENERGY(0: NCHAN, LDET) 
Y_F_DATA = PHOT_RESID(*, LDET)
TEMP = PHOT_OBS_SIG(*, LDET)
NIND = WHERE(TEMP GT 0.0)
IF NIND(0) EQ -1 THEN BEGIN
   MFIT_INFORM, "SIGMA_PLOT ERROR: Negative models have all zero sigmas."
   RETURN
   ENDIF
Y_F_DATA(NIND) = Y_F_DATA(NIND) / TEMP(NIND)
XR = [XBEG(LDET, PLOT_TYPE), XEND(LDET, PLOT_TYPE)]
TOP = LAST_CHAN_PLOT(LDET) - OFF_CHAN
BOT = FIRST_CHAN_PLOT(LDET) - OFF_CHAN

PLOT_INDEX = 6

IF (HAVE_YAXIS_LIMITS(LDET, PLOT_INDEX) NE 0) THEN BEGIN
   YR = [YBEG(LDET, PLOT_INDEX), YEND(LDET, PLOT_INDEX)]
ENDIF ELSE BEGIN
   YR = [MIN(Y_F_DATA(NIND)), MAX(Y_F_DATA(NIND))]
   IF N_ELEMENTS(NIND) EQ 1 THEN YR = [-YR(0), YR(0)]
   HAVE_YAXIS_LIMITS(LDET, PLOT_INDEX) = LONG(1)
ENDELSE

MIND = WHERE(MODEL_ENERGY(*, LDET))
XLO = FIRST_MODEL_PLOT(LDET)
XHI = LAST_MODEL_PLOT(LDET)
MX_DATA = MODEL_ENERGY(*, LDET)
MY_DATA = FLTARR(N_ELEMENTS(MX_DATA))
MY_DATA(*) = 0.0
NUM_TERMS = 1

PLOTTING = 0
IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0    &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 185 / 660.0   &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 439 / 510.0   &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 567 / 660.0   &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
ENDIF 


IF MULTI_FLAG EQ 0 THEN $
   PLOT, XR, YR, $                 
         TITLE = F_TITLE, XTITLE = X_F_TITLE, POSITION = [X0, Y0, X1, Y1],$
         YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
         XSTYLE = 1, YSTYLE = 1, /NODATA
IF MULTI_FLAG EQ 1 THEN $
   PLOT, XR, YR, $                 
         TITLE = F_TITLE, XTITLE = X_F_TITLE,$
         YTITLE = Y_F_TITLE, XTYPE = XLOG EQ 'LOG', YTYPE = YLOG EQ 'LOG', $
         XSTYLE = 1, YSTYLE = 1, /NODATA

USERSYM, [-1, 1, 1, -1], [1, 1, -1, -1], /FILL

DET_IND = LDET

FOR ICHAN = BOT, TOP DO BEGIN
   IF (LIVE_TIME(ICHAN, DET_IND) NE 0.0) AND $
            (PHOT_OBS_SIG(ICHAN, DET_IND) GT 0.0) THEN BEGIN  ; Data is valid.
      FIT_FLAG = 1                                            ;Filled symbol.
      X_VAL = X_F_DATA(ICHAN)
      Y_VAL = Y_F_DATA(ICHAN)
      IF (ICHAN LT FIRST_CHAN_FIT(LDET) - OFF_CHAN) OR $       ; Channel not
         (ICHAN GT LAST_CHAN_FIT(LDET) - OFF_CHAN) OR $        ;chosen for fit:
         (LIVE_TIME(ICHAN, DET_IND) LT 0.0) THEN FIT_FLAG = 0  ;Hollow symbol.
      PLOT_SYM = 6
      IF FIT_FLAG THEN PLOT_SYM = 8
      OPLOT, [X_VAL, X_VAL], [Y_VAL, Y_VAL], PSYM = PLOT_SYM, SYMSIZE = 0.5
      OPLOT, [X_VAL, X_VAL], [0.0, Y_VAL]
      ENDIF
   ENDFOR

OPLOT, MX_DATA(MIND), MY_DATA(MIND), LINESTYLE = 1
X_TEMP = MX_DATA(XLO:XHI)
Y_TEMP = MY_DATA(XLO:XHI)
OPLOT, X_TEMP, Y_TEMP, LINESTYLE = 0

DET_TITLE = STRTRIM(DET_NAMES(LDET), 2)
X_WIN = !X.WINDOW
Y_WIN = !Y.WINDOW
;IF (PLOT_TYPE EQ 1) OR $
;   (PLOT_TYPE EQ 2) OR $
;   (PLOT_TYPE EQ 5) AND $
;   (NUM_DET GT 1) THEN BEGIN
;   PLABEL = PLOT_SYM_V(LDET) + ' ' + DET_TITLE
;ENDIF ELSE BEGIN
   PLABEL = DET_TITLE
;ENDELSE

IF (ANNOTATE_SIZE GT 0.0) THEN BEGIN
   XYOUTS, X_WIN(1) -  0.04, Y_WIN(1) - 0.04*(ANNOTATE_SIZE/1.5), $
        PLABEL, ALIGN = 1, /NORM, CHARSIZE = ANNOTATE_SIZE
ENDIF

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PAGE_POS, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF

YLOG = READ_MENU(2) 


END; PRO SIGMA_PLOT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
PRO CHI_1D_PLOT, PG_POS, HC_OPTION

@wgsp_cb.pro


XLOG = 'LINEAR' 
YLOG = 'LINEAR'

CHI = FLTARR(3)
CHI_LABELS = STRARR(3)

;IF (CV_CONTOUR_CHOICE EQ 'A') THEN $
;   PLOT_CHOICE = WIDMENU(['Choose to display either:', 'Percentiles', 'Sigmas'],$
;                       TITLE = 0) $
;   ELSE IF (CV_CONTOUR_CHOICE EQ 'P') THEN $
;      PLOT_CHOICE = 1 $
;   ELSE PLOT_CHOICE = 2
;CHI_1D_PLOT_CH = PLOT_CHOICE

SOME_NUM = INDGEN(11)
TOP_PAR = MIN([10, NUM_VARY])
SOME_NUM = STRING(SOME_NUM(1: TOP_PAR))

IF HC_OPTION LT 1 THEN BEGIN
   IF (CV_CONTOUR_CHOICE EQ 'A') THEN $
      PLOT_CHOICE = WIDMENU(['Choose to display either:', 'Percentiles', $
                          'Sigmas'], TITLE = 0) $
      ELSE IF (CV_CONTOUR_CHOICE EQ 'P') THEN $
         PLOT_CHOICE = 1 $
      ELSE PLOT_CHOICE = 2
   CHI_1D_PLOT_CH = PLOT_CHOICE

   PARAM_INTEREST = WIDMENU(['Number of Parameters of Interest:', SOME_NUM], $
                       TITLE = 0) - 1
   CHI_1D_PAR_INT = PARAM_INTEREST 
ENDIF ELSE BEGIN
   PLOT_CHOICE = CHI_1D_PLOT_CH  
   PARAM_INTEREST = CHI_1D_PAR_INT 
   ENDELSE

IF PLOT_CHOICE EQ 1 THEN BEGIN
   CHI(0) = MODEL_CHISQ + NINE_LEVELS(PARAM_INTEREST, 0)
   CHI(1) = MODEL_CHISQ + NINE_LEVELS(PARAM_INTEREST, 1)
   CHI(2) = MODEL_CHISQ + NINE_LEVELS(PARAM_INTEREST, 2)
   CHI_LABELS(0) = '  90%'
   CHI_LABELS(1) = '  99%'
   CHI_LABELS(2) = '  99.9%'
   ENDIF $
ELSE BEGIN
   CHI(0) = MODEL_CHISQ + SIG_LEVELS(PARAM_INTEREST, 0)
   CHI(1) = MODEL_CHISQ + SIG_LEVELS(PARAM_INTEREST, 1)
   CHI(2) = MODEL_CHISQ + SIG_LEVELS(PARAM_INTEREST, 2)
   CHI_LABELS(0) = ' 1!7r!X'
   CHI_LABELS(1) = ' 2!7r!X'
   CHI_LABELS(2) = ' 3!7r!X'
   ENDELSE

X_PARAM_TEMP = X_PARAM_VALS(WHERE(X_PARAM_VALS))
CHI_1D_TEMP = CHI_1D_VALS(WHERE(CHI_1D_VALS))
XR = [MIN(X_PARAM_TEMP), MAX(X_PARAM_TEMP)]
YR = [MIN(CHI_1D_TEMP), MAX(CHI_1D_TEMP)]
F_TITLE = STRTRIM(TOPLABEL, 0)
X_F_TITLE = STRTRIM(X_CHI_LABEL, 0)
Y_F_TITLE = '!7v!X!U2!N'  ; chi squared

; Scale the plot position according to the chararacter size
X0 = 0.11  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
X1 = 0.96  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
Y0 = 0.11  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
Y1 = 0.96  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
;X0 = PG_POS(0)  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
;Y0 = PG_POS(1)  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
;X1 = PG_POS(2)  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
;Y1 = PG_POS(3)  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))

PLOTTING = 0
IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0    &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 185 / 660.0   &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 439 / 510.0   &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 567 / 660.0   &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
   ENDIF 

PLOT, X_PARAM_TEMP, CHI_1D_TEMP, YRANGE = YR, TITLE = F_TITLE, XSTYLE = 1, $
      XTITLE = X_F_TITLE, YTITLE = Y_F_TITLE, POSITION = [X0, Y0, X1, Y1]

FOR II = 0, 2 DO BEGIN
   OPLOT, !X.CRANGE, [CHI(II), CHI(II)], LINESTYLE = 1
   IF CHI(II) LT !Y.CRANGE(1) THEN $
      XYOUTS, !X.CRANGE(1), CHI(II), CHI_LABELS(II)
   ENDFOR

OPLOT, [X_BEST_VALUE, X_BEST_VALUE], !Y.CRANGE, LINESTYLE = 1

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PG_POS, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF



END; PRO CHI_1D_PLOT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
PRO CHI_2D_PLOT, PG_POS, HC_OPTION

@wgsp_cb.pro


XLOG = 'LINEAR' 
YLOG = 'LINEAR'

CHI = FLTARR(3)
CHI_LABELS = STRARR(3)
SOME_NUM = INDGEN(11)
TOP_PAR = MIN([10, NUM_VARY])
SOME_NUM = STRING(SOME_NUM(2: TOP_PAR))

IF HC_OPTION LT 1 THEN BEGIN
   PLOT_CHOICE = WIDMENU(['Choose to display either:', 'Percentiles', $
                          'Sigmas'], TITLE = 0)
   CHI_2D_PLOT_CH = PLOT_CHOICE
   PARAM_INTEREST = WIDMENU(['Number of Parameters of Interest:', SOME_NUM], $
                       TITLE = 0)
   CHI_2D_PAR_INT = PARAM_INTEREST 
ENDIF ELSE BEGIN
   PLOT_CHOICE = CHI_2D_PLOT_CH  
   PARAM_INTEREST = CHI_2D_PAR_INT 
   ENDELSE

IF PLOT_CHOICE EQ 1 THEN BEGIN
   CHI(0) = MODEL_CHISQ + NINE_LEVELS(PARAM_INTEREST, 0)
   CHI(1) = MODEL_CHISQ + NINE_LEVELS(PARAM_INTEREST, 1)
   CHI(2) = MODEL_CHISQ + NINE_LEVELS(PARAM_INTEREST, 2)
   CHI_LABELS(0) = '90%'
   CHI_LABELS(1) = '99%'
   CHI_LABELS(2) = '99.9%'
   ENDIF $
ELSE BEGIN
   CHI(0) = MODEL_CHISQ + SIG_LEVELS(PARAM_INTEREST, 0)
   CHI(1) = MODEL_CHISQ + SIG_LEVELS(PARAM_INTEREST, 1)
   CHI(2) = MODEL_CHISQ + SIG_LEVELS(PARAM_INTEREST, 2)
   CHI_LABELS(0) = '1 !7r!X'
   CHI_LABELS(1) = '2 !7r!X'
   CHI_LABELS(2) = '3 !7r!X'
   ENDELSE

XR = [MIN(X_PARAM_VALS(0: num_chi - 1)), MAX(X_PARAM_VALS(0: num_chi - 1))]
YR = [MIN(Y_PARAM_VALS(0: num_chi - 1)), MAX(Y_PARAM_VALS(0: num_chi - 1))]
F_TITLE = STRTRIM(TOPLABEL, 0)
X_F_TITLE = STRTRIM(X_CHI_LABEL, 0)
Y_F_TITLE = STRTRIM(Y_CHI_LABEL, 0)

; Scale the plot position according to the chararacter size
X0 = 0.11  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
X1 = 0.96  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
Y0 = 0.11  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
Y1 = 0.96  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
;X0 = PG_POS(0)  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
;Y0 = PG_POS(1)  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
;X1 = PG_POS(2)  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
;Y1 = PG_POS(3)  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))

PLOTTING = 0
IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0    &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 185 / 660.0   &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 439 / 510.0   &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 567 / 660.0   &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
   ENDIF 

REDUCED_CHI_2D = FLTARR(NUM_CHI, NUM_CHI)
REDUCED_CHI_2D = CHI_2D_VALS(0: NUM_CHI - 1, 0: NUM_CHI - 1)
IF NUM_CHI LE 16 THEN $
CONTOUR, REDUCED_CHI_2D, X_PARAM_VALS(0: NUM_CHI - 1), $
      Y_PARAM_VALS(0: NUM_CHI - 1), XSTYLE = 1, YSTYLE = 1, $
      /FOLLOW, LEVELS = CHI, C_LABELS=[1,1,1], C_ANNOTATION = CHI_LABELS, $
      /SPLINE, XRANGE = XR, YRANGE = YR, TITLE = F_TITLE, $
      XTITLE = X_F_TITLE, YTITLE = Y_F_TITLE, POSITION = [X0, Y0, X1, Y1] $
ELSE $
CONTOUR, REDUCED_CHI_2D, X_PARAM_VALS(0: NUM_CHI - 1), $
      Y_PARAM_VALS(0: NUM_CHI - 1), XSTYLE = 1, YSTYLE = 1, $
      /FOLLOW, LEVELS = CHI, C_LABELS=[1,1,1], C_ANNOTATION = CHI_LABELS, $
      XRANGE = XR, YRANGE = YR, TITLE = F_TITLE, $
      XTITLE = X_F_TITLE, YTITLE = Y_F_TITLE, POSITION = [X0, Y0, X1, Y1]

SX = FINDGEN(16) * 2 * !PI / 16
USERSYM, COS(SX), SIN(SX), /FILL
OPLOT, [X_BEST_VALUE, X_BEST_VALUE], [Y_BEST_VALUE, Y_BEST_VALUE], PSYM = 8

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PG_POS, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF



END; PRO CHI_2D_PLOT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
PRO FIT_GAUSS_PLOT, PG_POS, HC_OPTION

@wgsp_cb.pro


XLOG = READ_MENU(1) 
YLOG = 'LINEAR'

X_PARAM_TEMP = X_PARAM_VALS(0: NUM_CHI - 1)
CHI_1D_TEMP = CHI_1D_VALS(0: NUM_CHI - 1)
XR = [MIN(X_PARAM_TEMP), MAX(X_PARAM_TEMP)]
YR = [MIN([MIN(CHI_1D_TEMP), -1]), MAX(CHI_1D_TEMP)*1.1]
F_TITLE = STRTRIM(TOPLABEL, 0)
X_F_TITLE = 'Gaussian Centroid (keV)'
Y_F_TITLE = 'Gaussian !4Dv!X!E2!N'

; Scale the plot position according to the chararacter size
X0 = 0.11  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
X1 = 0.96  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
Y0 = 0.11  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
Y1 = 0.96  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
;X0 = PG_POS(0)  &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
;Y0 = PG_POS(1)  &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
;X1 = PG_POS(2)  &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
;Y1 = PG_POS(3)  &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))

PLOTTING = 0
IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0    &  X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 185 / 660.0   &  X1 = X1 - (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 439 / 510.0   &  Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 567 / 660.0   &  Y1 = Y1 - (0.05 * (GLOBAL_CHARSIZE-1))
   ENDIF 

PLOT, X_PARAM_TEMP, CHI_1D_TEMP, YRANGE = YR, TITLE = F_TITLE, XSTYLE = 1, $
      YSTYLE = 1, XTITLE = X_F_TITLE, YTITLE = Y_F_TITLE, $
      XTYPE = XLOG EQ 'LOG', POSITION = [X0, Y0, X1, Y1]

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PG_POS, 'FIT'
   CLOSE_PLOT, CURRENT_DEVICE
ENDIF



END; PRO FIT_GAUSS_PLOT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
