; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
; Rounds INVALUE for log and linear scales
; If scale is log, rounds to a multiple of 10

FUNCTION ROUND_VAL, INVALUE, LOG = LOG, UP = UP, DOWN = DOWN

IF KEYWORD_SET(LOG) THEN BEGIN
   IF (INVALUE EQ 0) THEN VALUE = 1.0E-30 ELSE VALUE = INVALUE

   P = FIX(ALOG10(VALUE))
   IF VALUE LT 1.0 THEN P = P - 1
   IF KEYWORD_SET(DOWN) THEN D = FIX(VALUE / 10.0^P)
   IF KEYWORD_SET(UP) THEN D = FIX(VALUE / 10.0^P + 1) 
   RETURN, D * 10.0^P

ENDIF ELSE BEGIN

   IF KEYWORD_SET(DOWN) THEN RETURN, FLOOR(INVALUE)
   IF KEYWORD_SET(UP) THEN RETURN, CEIL(INVALUE) 

ENDELSE


END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
FUNCTION TRACK_ONE, X0, Y0
; Tracks the mouse cursor, and accepts one click


YPOS = !D.Y_SIZE - 15
;XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, CHARSIZE=1.5

; Handle LOG scales
X_LO = !X.CRANGE(0)
X_HI = !X.CRANGE(1)
IF !X.TYPE EQ 1 THEN BEGIN
   X_LO = 10.0^X_LO
   X_HI = 10.0^X_HI
ENDIF
Y_LO = !Y.CRANGE(0)
Y_HI = !Y.CRANGE(1)
IF !Y.TYPE EQ 1 THEN BEGIN
   Y_LO = 10.0^Y_LO 
   Y_HI = 10.0^Y_HI 
ENDIF

CLIPRECT = [X_LO, Y_LO, X_HI, Y_HI]

CURSOR, X0, Y0, /DATA, /CHANGE
BUTTON = !ERR
X1 = X0
Y1 = Y0

PREV_STRING = '(X: ' + STRING(X0) + ', Y: ' + STRING(Y0) + ')'
IF X0 LT X_LO THEN PREV_STRING = 'EXIT'
IF X0 GT X_HI THEN PREV_STRING = 'RESET'
IF NOT KEYWORD_SET(D) THEN $
   IF Y0 LT Y_LO THEN PREV_STRING = 'Numerical Entry'

WHILE (BUTTON AND 1) EQ 0 DO BEGIN
      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT X_LO THEN NEW_STRING = 'EXIT'
      IF X1 GT X_HI THEN NEW_STRING = 'RESET'
      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING

      X0 = X1
      Y0 = Y1
      CURSOR, X1, Y1, /DATA, /NOWAIT
      BUTTON = !ERR

      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT X_LO THEN NEW_STRING = 'EXIT'
      IF X1 GT X_HI THEN NEW_STRING = 'RESET'
      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING

      X0 = X1
      Y0 = Y1
      CURSOR, X1, Y1, /DATA, /CHANGE
      IF (BUTTON AND 1) EQ 0 THEN $
         BUTTON = !ERR            ; Else pass the original 'button down' message
ENDWHILE

XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND

X0 = X1
Y0 = Y1
IF X0 LT X_LO THEN BEGIN
;   XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;              CHARSIZE = 1.5, COLOR = !P.BACKGROUND
   RETURN, 1
ENDIF

IF X0 GT X_HI THEN BEGIN
;   XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;               CHARSIZE = 1.5, COLOR = !P.BACKGROUND
   RETURN, 2
ENDIF

IF Y0 LT Y_LO THEN BEGIN
;   XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;           CHARSIZE = 1.5, COLOR = !P.BACKGROUND
   RETURN, 3
ENDIF


RETURN, 0
END ; FUNCTION TRACK_ONE
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
FUNCTION TRACK_TWO, X0, Y0, X1, Y1, DRAW_BOX = D
; Tracks the mouse cursor, and accepts two clicks

YPOS = !D.Y_SIZE - 15
;XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, CHARSIZE=1.5

; Handle LOG scales
X_LO = !X.CRANGE(0)
X_HI = !X.CRANGE(1)
IF !X.TYPE EQ 1 THEN BEGIN
   X_LO = 10.0^X_LO
   X_HI = 10.0^X_HI
ENDIF
Y_LO = !Y.CRANGE(0)
Y_HI = !Y.CRANGE(1)
IF !Y.TYPE EQ 1 THEN BEGIN
   Y_LO = 10.0^Y_LO 
   Y_HI = 10.0^Y_HI 
ENDIF

CLIPRECT = [X_LO, Y_LO, X_HI, Y_HI]

CURSOR, X0, Y0, /DATA, /CHANGE
BUTTON = !ERR
X1 = X0
Y1 = Y0

PREV_STRING = '(X: ' + STRING(X0) + ', Y: ' + STRING(Y0) + ')'
IF X0 LT X_LO THEN PREV_STRING = 'EXIT'
IF X0 GT X_HI THEN PREV_STRING = 'RESET'
;IF NOT KEYWORD_SET(D) THEN $
   IF Y0 LT Y_LO THEN PREV_STRING = 'Numerical Entry'

WHILE (BUTTON AND 1) EQ 0 DO BEGIN
      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT X_LO THEN NEW_STRING = 'EXIT'
      IF X1 GT X_HI THEN NEW_STRING = 'RESET'
;      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING

      X0 = X1
      Y0 = Y1
      CURSOR, X1, Y1, /DATA, /NOWAIT
      BUTTON = !ERR

      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT X_LO THEN NEW_STRING = 'EXIT'
      IF X1 GT X_HI THEN NEW_STRING = 'RESET'
;      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING

      X0 = X1
      Y0 = Y1
      CURSOR, X1, Y1, /DATA, /CHANGE
      IF (BUTTON AND 1) EQ 0 THEN $
         BUTTON = !ERR            ; Else pass the original 'button down' message

ENDWHILE

XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND

X0 = X1
Y0 = Y1
IF X0 LT X_LO THEN BEGIN
;   XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;              CHARSIZE = 1.5, COLOR = !P.BACKGROUND
   RETURN, 1
ENDIF

IF X0 GT X_HI THEN BEGIN
;   XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;               CHARSIZE = 1.5, COLOR = !P.BACKGROUND
   RETURN, 2
ENDIF

IF NOT KEYWORD_SET(D) THEN $
   IF Y0 LT Y_LO THEN BEGIN
;      XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;               CHARSIZE = 1.5, COLOR = !P.BACKGROUND
      RETURN, 3
   ENDIF

IF NOT KEYWORD_SET(D) THEN $
   OPLOT, [X0, X0], [Y_LO, Y_HI], LINESTYLE = 2

CURSOR, X1, Y1, /DATA, /CHANGE
BUTTON = !ERR
LX1 = X1
LY1 = Y1

WHILE (BUTTON AND 1) EQ 0 DO BEGIN
      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT X_LO THEN NEW_STRING = 'EXIT'
      IF X1 GT X_HI THEN NEW_STRING = 'RESET'
;      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING

      IF KEYWORD_SET(D) THEN BEGIN
         PLOTS, [X0, X0, LX1, LX1, X0], [Y0, LY1, LY1, Y0, Y0], $
                COLOR = !P.BACKGROUND, /DATA, $
                LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
         PLOTS, [X0, X0, X1, X1, X0], [Y0, Y1, Y1, Y0, Y0], /DATA, $
                LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
      ENDIF

      LX1 = X1
      LY1 = Y1
      CURSOR, X1, Y1, /DATA, /NOWAIT
      BUTTON = !ERR

      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT X_LO THEN NEW_STRING = 'EXIT'
      IF X1 GT X_HI THEN NEW_STRING = 'RESET'
;      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING

      IF KEYWORD_SET(D) THEN BEGIN
         PLOTS, [X0, X0, LX1, LX1, X0], [Y0, LY1, LY1, Y0, Y0], $
                COLOR = !P.BACKGROUND, /DATA, $
                LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
         PLOTS, [X0, X0, X1, X1, X0], [Y0, Y1, Y1, Y0, Y0], /DATA, $
                LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
      ENDIF

      LX1 = X1
      LY1 = Y1
      CURSOR, X1, Y1, /DATA, /CHANGE
      IF (BUTTON AND 1) EQ 0 THEN $
         BUTTON = !ERR
ENDWHILE

LX1 = X1
LY1 = Y1

XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
;XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;         CHARSIZE=1.5, COLOR = !P.BACKGROUND
IF LX1 LT X_LO THEN RETURN, 1
IF LX1 GT X_HI THEN RETURN, 2
;IF NOT KEYWORD_SET(D) THEN IF LY1 LT Y_LO THEN RETURN, 3
IF LY1 LT Y_LO THEN RETURN, 3

IF NOT KEYWORD_SET(D) THEN $
   OPLOT, [X0, X0], [Y_LO, Y_HI], LINESTYLE = 2, COLOR = !P.BACKGROUND



RETURN, 0
END ; FUNCTION TRACK_TWO
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
; Uses mouse cursor to zoom in or out on a plot window
;  If BAIL_OUT = 0 then returns the x and y coordinate ranges 
;     BAIL_OUT = 1 then user has EXITed (no zoom)
;     BAIL_OUT = 2 then user has RESET (zoom again)
;  If zooming OUT, zooms in 10% increments
;  If ROUND_VAL is supplied, axis will not be rounded if
;   the range is LE 2.0 * ROUND_VAL 

PRO ZOOM, XRANGE, YRANGE, BAIL_OUT, ROUND_VAL, IN = IN, OUT = OUT

COMMON WGSP_GET_RANGE, WLO_X, WHI_X, NUMERICAL_XRANGE, NUMERICAL_YRANGE


; Handle LOG scales
IF !X.TYPE EQ 1 THEN XRANGE_IN = 10.0^!X.CRANGE ELSE XRANGE_IN = !X.CRANGE
IF !Y.TYPE EQ 1 THEN YRANGE_IN = 10.0^!Y.CRANGE ELSE YRANGE_IN = !Y.CRANGE

XRANGE = FLTARR(2)
YRANGE = FLTARR(2)

; If numerical entry, then don't round the axis ranges
; Assume no numerical entry to start:
NUMERICAL = 0

IF (KEYWORD_SET(IN)) OR $
   (N_ELEMENTS(IN) EQ 0 AND N_ELEMENTS(OUT) EQ 0) THEN ZOOMING = 'IN'
IF KEYWORD_SET(OUT) THEN ZOOMING = 'OUT'

IF ZOOMING EQ 'IN' THEN BEGIN

   BAIL_OUT = TRACK_TWO(LO_X, LO_Y, HI_X, HI_Y, /DRAW_BOX)

   CASE BAIL_OUT OF
        ; EXIT; don't zoom
        1: BEGIN
            XRANGE(0) = !X.CRANGE(0) 
            XRANGE(1) = !X.CRANGE(1) 
            YRANGE(0) = !Y.CRANGE(0) 
            YRANGE(1) = !Y.CRANGE(1) 
            GOTO, DONE           
            END
        ; RESET
        2: BEGIN                
            XRANGE(0) = XRANGE_IN(0) 
            XRANGE(1) = XRANGE_IN(1) 
            YRANGE(0) = YRANGE_IN(0) 
            YRANGE(1) = YRANGE_IN(1) 
            END  
        ; Numerical Entry
        3: BEGIN       
;            GET_RANGE
            SELECT_BOX, !X.CRANGE, !Y.CRANGE
            BAIL_OUT  = -1
            NUMERICAL = 1
            XRANGE(0) = NUMERICAL_XRANGE(0) 
            XRANGE(1) = NUMERICAL_XRANGE(1)
            YRANGE(0) = NUMERICAL_YRANGE(0) 
            YRANGE(1) = NUMERICAL_YRANGE(1) 
            GOTO, DONE           
            END  
        ELSE: BEGIN
            XRANGE(0) = LO_X
            XRANGE(1) = HI_X
            YRANGE(0) = LO_Y
            YRANGE(1) = HI_Y
            END
   ENDCASE

ENDIF 

IF ZOOMING EQ 'OUT' THEN BEGIN

   XSPAN = !X.CRANGE(1) - !X.CRANGE(0)
   YSPAN = !Y.CRANGE(1) - !Y.CRANGE(0)
   DX = XSPAN * 0.1
   DY = YSPAN * 0.1

   XRANGE(0) = !X.CRANGE(0) - DX 
   XRANGE(1) = !X.CRANGE(1) + DX
   YRANGE(0) = !Y.CRANGE(0) - DY
   YRANGE(1) = !Y.CRANGE(1) + DY 

ENDIF

DONE:

; Sort the axis ranges
XRANGE = XRANGE(SORT(XRANGE))
YRANGE = YRANGE(SORT(YRANGE))

; If the axis values are less than ROUND_VAL, do not round 
IF (N_ELEMENTS(ROUND_VAL) EQ 0) THEN ROUND_VAL = 1.0
ROUND_VAL = 2.0 * ROUND_VAL
NO_ROUNDX = 0
NO_ROUNDY = 0
IF (!X.TYPE EQ 1) THEN BEGIN
   IF (ABS(10.0^!X.CRANGE(1) - 10.0^!X.CRANGE(0)) LE ROUND_VAL) THEN $
      NO_ROUNDX = 1
ENDIF ELSE BEGIN
   IF (ABS(!X.CRANGE(1) - !X.CRANGE(0)) LE ROUND_VAL) THEN $
      NO_ROUNDX = 1
ENDELSE
IF (!Y.TYPE EQ 1) THEN BEGIN
   IF (ABS(10.0^!Y.CRANGE(1) - 10.0^!Y.CRANGE(0)) LE ROUND_VAL) THEN $
      NO_ROUNDY = 1
ENDIF ELSE BEGIN
   IF (ABS(!Y.CRANGE(1) - !Y.CRANGE(0)) LE ROUND_VAL) THEN $
         NO_ROUNDY = 1
ENDELSE

; Round the axis ranges to nice values
IF (NUMERICAL NE 1) THEN BEGIN

   IF (NO_ROUNDX EQ 0) THEN BEGIN
      IF (!X.TYPE EQ 1) THEN BEGIN
         XRANGE(0) = ROUND_VAL( XRANGE(0), /DOWN, /LOG )
         XRANGE(1) = ROUND_VAL( XRANGE(1), /UP, /LOG )
      ENDIF ELSE BEGIN
         XRANGE(0) = ROUND_VAL( XRANGE(0), /DOWN )
         XRANGE(1) = ROUND_VAL( XRANGE(1), /UP )
      ENDELSE
   ENDIF
   IF (NO_ROUNDY EQ 0) THEN BEGIN
      IF (!Y.TYPE EQ 1) THEN BEGIN
         YRANGE(0) = ROUND_VAL( YRANGE(0), /DOWN, /LOG )
         YRANGE(1) = ROUND_VAL( YRANGE(1), /UP, /LOG )
      ENDIF ELSE BEGIN
         YRANGE(0) = ROUND_VAL( YRANGE(0), /DOWN )
         YRANGE(1) = ROUND_VAL( YRANGE(1), /UP )
      ENDELSE
   ENDIF

ENDIF


END ; PRO ZOOM
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
; NAME:
;	SELECT_BOX
;
; PURPOSE:
;       Allows interactive numerical selection of a box that is
;       used by PRO ZOOM to zoom in on an IDL plot.
;
; CATEGORY:
;	Plotting
;
; CALLING SEQUENCE:
;	SELECT_BOX, INPUT_XRANGE, INPUT_YRANGE
;
; INPUTS:
;       INPUT_XRANGE is the independent axis range (normally !X.CRANGE)
;       INPUT_YRANGE is the dependent axis range (normally !Y.CRANGE)
; 
; KEYWORD PARAMETERS:
;       NONE.
;
; OUTPUTS:
;       FILLS THE COMMON BLOCK VARIABLES NUMERICAL_XRANGE, NUMERICAL_YRANGE
;       WITH THE ZOOMED VALUES.
;
; COMMON BLOCKS:
;       COMMON SB_DATA, LVAL, RVAL, TVAL, BVAL, VALUE_ID
;
; SIDE EFFECTS:
;	PLOTS TO CURRENT DEVICE.
;
; RESTRICTIONS:
;	NONE.
;
; PROCEDURE:
;       PROCEDURE CALL.
;
; MODIFICATION HISTORY:
;	Written, mallozzi@gibson.msfc.nasa.gov, July 1995.
;
; -
; First the event handler
PRO SELECT_BOX_EVENT, EVENT

@wgsp_cb.pro

COMMON SB_DATA, LVAL, RVAL, TVAL, BVAL, VALUE_ID


TYPE = TAG_NAMES(EVENT, /STRUCTURE)
WIDGET_CONTROL, EVENT.ID, GET_UVALUE = UVALUE

IF (!X.TYPE EQ 1) THEN XR = 10.0^!X.CRANGE ELSE XR = !X.CRANGE
IF (!Y.TYPE EQ 1) THEN YR = 10.0^!Y.CRANGE ELSE YR = !Y.CRANGE

; 100 steps per plot
; Steps should be spaced equally on both linear and logarithmic scales
NUM_STEPS = 100
STEP_XARRAY = ( (FINDGEN(NUM_STEPS) / (NUM_STEPS - 1)) * $
               (!X.CRANGE(1) - !X.CRANGE(0)) ) + !X.CRANGE(0)
STEP_YARRAY = ( (FINDGEN(NUM_STEPS) / (NUM_STEPS - 1)) * $
               (!Y.CRANGE(1) - !Y.CRANGE(0)) ) + !Y.CRANGE(0)

XSTEP = STEP_XARRAY(1) - STEP_XARRAY(0)
YSTEP = STEP_YARRAY(1) - STEP_YARRAY(0)

; The button widget events
CASE TYPE OF
  'WIDGET_BUTTON': BEGIN
    IF (UVALUE NE 'DONE') AND (UVALUE NE 'HELP') THEN BEGIN

       CASE UVALUE OF

            ; Top edge, go up
            'T1U': BEGIN
                   TOLD_VAL = TVAL

                   ; Step through the plot in 1% steps
                   IF (!Y.TYPE EQ 1) THEN BEGIN
                      TVAL = 10.0^(ALOG10(TVAL) + YSTEP)
                   ENDIF ELSE TVAL = TVAL + YSTEP
                   YP     = [TVAL, TVAL]
                   YP_OLD = [TOLD_VAL, TOLD_VAL]

                   ; Past edge?
                   IF (TVAL GT YR(1)) THEN TVAL = YR(1)

                   OPLOT, XR, YP_OLD, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XR, YP, LINESTY = 1
                   IF (TVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(0), $
                          SET_VALUE = STRTRIM(STRING(TVAL, F = FORM), 2)
                   END
            ; Top edge, go down
            'T1D': BEGIN
                   TOLD_VAL = TVAL

                   ; Step through the plot in 1% steps
                   IF (!Y.TYPE EQ 1) THEN BEGIN
                      TVAL = 10.0^(ALOG10(TVAL) - YSTEP)
                   ENDIF ELSE TVAL = TVAL - YSTEP
                   YP     = [TVAL, TVAL]
                   YP_OLD = [TOLD_VAL, TOLD_VAL]

                   ; Past edge?
                   IF (TVAL LT YR(0)) THEN TVAL = YR(0)

                   ; Crossed the other value?
                   IF (TVAL LE BVAL) THEN BEGIN
                      IF (!Y.TYPE EQ 1) THEN BEGIN
                         TVAL = 10.0^(ALOG10(TVAL) + YSTEP)
                      ENDIF ELSE TVAL = TVAL + YSTEP
                   ENDIF

                   OPLOT, XR, YP_OLD, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XR, YP, LINESTY = 1
                   IF (TVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(0), $
                          SET_VALUE = STRTRIM(STRING(TVAL, F = FORM), 2)
                   END

            ; Bottom edge, go up
            'B1U': BEGIN
                   BOLD_VAL = BVAL

                   ; Step through the plot in 1% steps
                   IF (!Y.TYPE EQ 1) THEN BEGIN
                      BVAL = 10.0^(ALOG10(BVAL) + YSTEP)
                   ENDIF ELSE BVAL = BVAL + YSTEP
                   YP     = [BVAL, BVAL]
                   YP_OLD = [BOLD_VAL, BOLD_VAL]

                   ; Past edge?
                   IF (BVAL GT YR(1)) THEN BVAL = YR(1)

                   ; Crossed the other value?
                   IF (BVAL GE TVAL) THEN BEGIN
                      IF (!Y.TYPE EQ 1) THEN BEGIN
                         BVAL = 10.0^(ALOG10(BVAL) - YSTEP)
                      ENDIF ELSE BVAL = BVAL - YSTEP
                   ENDIF

                   OPLOT, XR, YP_OLD, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XR, YP, LINESTY = 1
                   IF (BVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(1), $
                          SET_VALUE = STRTRIM(STRING(BVAL, F = FORM), 2)
                   END
            ; Bottom edge, go down
            'B1D': BEGIN
                   BOLD_VAL = BVAL

                   ; Step through the plot in 1% steps
                   IF (!Y.TYPE EQ 1) THEN BEGIN
                      BVAL = 10.0^(ALOG10(BVAL) - YSTEP)
                   ENDIF ELSE BVAL = BVAL - YSTEP
                   YP     = [BVAL, BVAL]
                   YP_OLD = [BOLD_VAL, BOLD_VAL]

                   ; Past edge?
                   IF (BVAL LT YR(0)) THEN BVAL = YR(0)

                   OPLOT, XR, YP_OLD, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XR, YP, LINESTY = 1
                   IF (BVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(1), $
                          SET_VALUE = STRTRIM(STRING(BVAL, F = FORM), 2)
                   END


            ; Left edge, go left
            'L1L': BEGIN
                   LOLD_VAL = LVAL

                   ; Step through the plot in 1% steps
                   IF (!X.TYPE EQ 1) THEN BEGIN
                      LVAL = 10.0^(ALOG10(LVAL) - XSTEP)
                   ENDIF ELSE LVAL = LVAL - XSTEP
                   XP     = [LVAL, LVAL]
                   XP_OLD = [LOLD_VAL, LOLD_VAL]

                   ; Past edge?
                   IF (LVAL LT XR(0)) THEN LVAL = XR(0)

                   OPLOT, XP_OLD, YR, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XP, YR, LINESTY = 1
                   IF (LVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(2), $
                          SET_VALUE = STRTRIM(STRING(LVAL, F = FORM), 2)
                   END
            ; Left edge, go right
            'L1R': BEGIN
                   LOLD_VAL = LVAL

                   ; Step through the plot in 1% steps
                   IF (!X.TYPE EQ 1) THEN BEGIN
                      LVAL = 10.0^(ALOG10(LVAL) + XSTEP)
                   ENDIF ELSE LVAL = LVAL + XSTEP
                   XP     = [LVAL, LVAL]
                   XP_OLD = [LOLD_VAL, LOLD_VAL]

                   ; Past edge?
                   IF (LVAL GT XR(1)) THEN LVAL = XR(1)

                   ; Crossed the other value?
                   IF (LVAL GE RVAL) THEN BEGIN
                      IF (!X.TYPE EQ 1) THEN BEGIN
                         LVAL = 10.0^(ALOG10(LVAL) - XSTEP)
                      ENDIF ELSE LVAL = LVAL - XSTEP
                   ENDIF

                   OPLOT, XP_OLD, YR, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XP, YR, LINESTY = 1
                   IF (LVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(2), $
                          SET_VALUE = STRTRIM(STRING(LVAL, F = FORM), 2)
                   END


            ; Right edge, go left
            'R1L': BEGIN
                   ROLD_VAL = RVAL

                   ; Step through the plot in 1% steps
                   IF (!X.TYPE EQ 1) THEN BEGIN
                      RVAL = 10.0^(ALOG10(RVAL) - XSTEP)
                   ENDIF ELSE RVAL = RVAL - XSTEP
                   XP     = [RVAL, RVAL]
                   XP_OLD = [ROLD_VAL, ROLD_VAL]

                   ; Past edge?
                   IF (RVAL LT XR(0)) THEN RVAL = XR(0)

                   ; Crossed the other value?
                   IF (RVAL LE LVAL) THEN BEGIN
                      IF (!X.TYPE EQ 1) THEN BEGIN
                         RVAL = 10.0^(ALOG10(RVAL) + XSTEP)
                      ENDIF ELSE RVAL = RVAL + XSTEP
                   ENDIF

                   OPLOT, XP_OLD, YR, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XP, YR, LINESTY = 1
                   IF (RVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(3), $
                          SET_VALUE = STRTRIM(STRING(RVAL, F = FORM), 2)
                   END
            ; Right edge, go right
            'R1R': BEGIN
                   ROLD_VAL = RVAL

                   ; Step through the plot in 1% steps
                   IF (!X.TYPE EQ 1) THEN BEGIN
                      RVAL = 10.0^(ALOG10(RVAL) + XSTEP)
                   ENDIF ELSE RVAL = RVAL + XSTEP
                   XP     = [RVAL, RVAL]
                   XP_OLD = [ROLD_VAL, ROLD_VAL]

                   ; Past edge?
                   IF (RVAL GT XR(1)) THEN RVAL = XR(1)

                   OPLOT, XP_OLD, YR, LINESTY = 1, COLOR = !P.BACKGROUND
                   OPLOT, XP, YR, LINESTY = 1
                   IF (RVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM ='(F11.3)'
                   WIDGET_CONTROL, VALUE_ID(3), $
                          SET_VALUE = STRTRIM(STRING(RVAL, F = FORM), 2)
                   END


       ENDCASE

    ENDIF ELSE BEGIN

       CASE UVALUE OF
        'HELP': BEGIN
          WM_XDISPLAYFILE, $
             WGSP_SOURCE + STRLOWCASE('SELECT_BOX.HLP'), TITLE = UVALUE
          END
        'DONE': BEGIN
          NUMERICAL_XRANGE = [LVAL, RVAL]
          NUMERICAL_YRANGE = [BVAL, TVAL]
          WIDGET_CONTROL, EVENT.TOP, /DESTROY
          END
       ENDCASE
    ENDELSE
    END ; WIDGET_BUTTON

  'WIDGET_TEXT_CH': BEGIN
    WIDGET_CONTROL, EVENT.ID, GET_VALUE = VALUE

    IF (UVALUE EQ 'TEXTT') THEN BEGIN
       TOLD_VAL = TVAL
       TVAL = VALUE(0)
       IF (TVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM = '(F11.3)'
       WIDGET_CONTROL, VALUE_ID(0), $
              SET_VALUE = STRTRIM(STRING(TVAL, F = FORM), 2)
       YP     = [TVAL, TVAL]
       YP_OLD = [TOLD_VAL, TOLD_VAL]
       OPLOT, XR, YP_OLD, LINESTY = 1, COLOR = !P.BACKGROUND
       OPLOT, XR, YP, LINESTY = 1
    ENDIF
    IF (UVALUE EQ 'TEXTB') THEN BEGIN
       BOLD_VAL = BVAL
       BVAL = VALUE(0)
       IF (BVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM = '(F11.3)'
       WIDGET_CONTROL, VALUE_ID(1), $
              SET_VALUE = STRTRIM(STRING(BVAL, F = FORM), 2)
       YP     = [BVAL, BVAL]
       YP_OLD = [BOLD_VAL, BOLD_VAL]
       OPLOT, XR, YP_OLD, LINESTY = 1, COLOR = !P.BACKGROUND
       OPLOT, XR, YP, LINESTY = 1
    ENDIF
    IF (UVALUE EQ 'TEXTL') THEN BEGIN
       LOLD_VAL = LVAL
       LVAL = VALUE(0)
       IF (LVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM = '(F11.3)'
       WIDGET_CONTROL, VALUE_ID(2), $
              SET_VALUE = STRTRIM(STRING(LVAL, F = FORM), 2)
       XP     = [LVAL, LVAL]
       XP_OLD = [LOLD_VAL, LOLD_VAL]
       OPLOT, XP_OLD, YR, LINESTY = 1, COLOR = !P.BACKGROUND
       OPLOT, XP, YR, LINESTY = 1
    ENDIF
    IF (UVALUE EQ 'TEXTR') THEN BEGIN
       ROLD_VAL = RVAL
       RVAL = VALUE(0)
       IF (RVAL LT 0.001) THEN FORM = '(E11.3)' ELSE FORM = '(F11.3)'
       WIDGET_CONTROL, VALUE_ID(3), $
              SET_VALUE = STRTRIM(STRING(RVAL, F = FORM), 2)
       XP     = [RVAL, RVAL]
       XP_OLD = [ROLD_VAL, ROLD_VAL]
       OPLOT, XP_OLD, YR, LINESTY = 1, COLOR = !P.BACKGROUND
       OPLOT, XP, YR, LINESTY = 1
    ENDIF

    END ; WIDGET_TEXT_CH
ENDCASE ; for TYPE


END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
PRO SELECT_BOX, INPUT_XRANGE, INPUT_YRANGE

@wgsp_cb.pro

COMMON SB_DATA, LVAL, RVAL, TVAL, BVAL, VALUE_ID


DEVICE, RETAIN = CV_IDL_RETAIN

; Handle LOG case
IF (!X.TYPE EQ 1) THEN INPUT_XRANGE = 10.0^INPUT_XRANGE
IF (!Y.TYPE EQ 1) THEN INPUT_YRANGE = 10.0^INPUT_YRANGE

;  Adjust the initial selection 
LVAL = INPUT_XRANGE(0)  ; Left
IF (LVAL LT 0.001) THEN FORM_L = '(E11.3)' ELSE FORM_L = '(F11.3)'
RVAL = INPUT_XRANGE(1)  ; Right
IF (RVAL LT 0.001) THEN FORM_R = '(E11.3)' ELSE FORM_R = '(F11.3)'
BVAL = INPUT_YRANGE(0)  ; Bottom
IF (BVAL LT 0.001) THEN FORM_B = '(E11.3)' ELSE FORM_B = '(F11.3)'
TVAL = INPUT_YRANGE(1)  ; Top
IF (TVAL LT 0.001) THEN FORM_T = '(E11.3)' ELSE FORM_T = '(F11.3)'

; Parent
SBOX_BASE = WIDGET_BASE(/COLUMN, TITLE = 'Select Zoom Box')
            
D = WIDGET_BUTTON(SBOX_BASE, VALUE = 'DONE', UVALUE = 'DONE')
H = WIDGET_BUTTON(SBOX_BASE, VALUE = 'HELP', UVALUE = 'HELP')

; -----------------------------------------------------------------------------
SBOX_BASET = WIDGET_BASE(SBOX_BASE, /COLUMN)

; Define some bit map buttons

; Single left arrow
S_ARROW_LEFT = [ $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [000B, 032B, 000B], [000B, 048B, 000B], [000B, 056B, 000B], $
  [000B, 060B, 000B], [000B, 062B, 000B], [000B, 255B, 001B], $
  [128B, 255B, 001B], [192B, 255B, 001B], [224B, 255B, 001B], $
  [240B, 255B, 001B], [248B, 255B, 001B], [252B, 255B, 001B], $
  [252B, 255B, 001B], [248B, 255B, 001B], [240B, 255B, 001B], $
  [224B, 255B, 001B], [192B, 255B, 001B], [128B, 255B, 001B], $
  [000B, 255B, 001B], [000B, 062B, 000B], [000B, 060B, 000B], $
  [000B, 056B, 000B], [000B, 048B, 000B], [000B, 032B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B]  $
  ]
; Single right arrow
S_ARROW_RIGHT = [ $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [032B, 000B, 000B], [096B, 000B, 000B], [224B, 000B, 000B], $
  [224B, 001B, 000B], [224B, 003B, 000B], [252B, 007B, 000B], $
  [252B, 015B, 000B], [252B, 031B, 000B], [252B, 063B, 000B], $
  [252B, 127B, 000B], [252B, 255B, 000B], [252B, 255B, 001B], $
  [252B, 255B, 001B], [252B, 255B, 000B], [252B, 127B, 000B], $
  [252B, 063B, 000B], [252B, 031B, 000B], [252B, 015B, 000B], $
  [252B, 007B, 000B], [224B, 003B, 000B], [224B, 001B, 000B], $
  [224B, 000B, 000B], [096B, 000B, 000B], [032B, 000B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B]  $
  ]

S_ARROW_UP = [ $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $ 
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [000B, 006B, 000B], [000B, 015B, 000B], [128B, 031B, 000B], $
  [192B, 063B, 000B], [224B, 127B, 000B], [240B, 255B, 000B], $
  [248B, 255B, 001B], [252B, 255B, 003B], [254B, 255B, 007B], $
  [224B, 127B, 000B], [224B, 127B, 000B], [224B, 127B, 000B], $
  [224B, 127B, 000B], [224B, 127B, 000B], [224B, 127B, 000B], $
  [224B, 127B, 000B], [000B, 000B, 000B], [000B, 000B, 000B] $
  ]

S_ARROW_DOWN = [ $
  [000B, 000B, 000B], [000B, 000B, 000B], [224B, 127B, 000B], $
  [224B, 127B, 000B], [224B, 127B, 000B], [224B, 127B, 000B], $
  [224B, 127B, 000B], [224B, 127B, 000B], [254B, 255B, 007B], $
  [252B, 255B, 003B], [248B, 255B, 001B], [240B, 255B, 000B], $
  [224B, 127B, 000B], [192B, 063B, 000B], [128B, 031B, 000B], $
  [000B, 015B, 000B], [000B, 006B, 000B], [000B, 000B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B], $
  [000B, 000B, 000B], [000B, 000B, 000B], [000B, 000B, 000B] $
  ]

VALUE_ID    = LONARR(4) ; IDs of the text boxes

SBOX_BASET2 = WIDGET_BASE(SBOX_BASET, /COLUMN, /FRAME)
LABEL       = WIDGET_LABEL(SBOX_BASET2, VALUE = 'Top')
T_BASE      = WIDGET_BASE(SBOX_BASET2, /ROW)
B1          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_DOWN, UVALUE = 'T1D')
VALUE_ID(0) = WIDGET_TEXT(T_BASE, UVALUE = 'TEXTT', $
                     VALUE = STRTRIM(STRING(TVAL, F = FORM_T), 2), /EDIT)
B2          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_UP, UVALUE = 'T1U')

LABEL       = WIDGET_LABEL(SBOX_BASET2, VALUE = 'Bottom')
T_BASE      = WIDGET_BASE(SBOX_BASET2, /ROW)
B1          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_DOWN, UVALUE = 'B1D')
VALUE_ID(1) = WIDGET_TEXT(T_BASE, UVALUE = 'TEXTB', $
                     VALUE = STRTRIM(STRING(BVAL, F = FORM_B), 2), /EDIT)
B2          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_UP, UVALUE = 'B1U')

SBOX_BASET3 = WIDGET_BASE(SBOX_BASET, /COLUMN, /FRAME)
LABEL       = WIDGET_LABEL(SBOX_BASET3, VALUE = 'Left')
T_BASE      = WIDGET_BASE(SBOX_BASET3, /ROW)
B1          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_LEFT, UVALUE = 'L1L')
VALUE_ID(2) = WIDGET_TEXT(T_BASE, UVALUE = 'TEXTL', $
                     VALUE = STRTRIM(STRING(LVAL, F = FORM_L), 2), /EDIT)
B2          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_RIGHT, UVALUE = 'L1R')

LABEL       = WIDGET_LABEL(SBOX_BASET3, VALUE = 'Right')
T_BASE      = WIDGET_BASE(SBOX_BASET3, /ROW)
B1          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_LEFT, UVALUE = 'R1L')
VALUE_ID(3) = WIDGET_TEXT(T_BASE, UVALUE = 'TEXTR', $
                     VALUE = STRTRIM(STRING(RVAL, F = FORM_R), 2), /EDIT)
B2          = WIDGET_BUTTON(T_BASE, VALUE = S_ARROW_RIGHT, UVALUE = 'R1R')
; -----------------------------------------------------------------------------

; Realize the BASE widget and the children
WIDGET_CONTROL, SBOX_BASE, /REALIZE, SHOW = 1 

XMANAGER, 'SELECT_BOX', SBOX_BASE, /MODAL


END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
FUNCTION TRACK, X0, Y0, X1, Y1, XSCALE, YSCALE, DRAW_BOX = D

COMMON WSP_CONTROL_C, $
       CV_DEBUG, CV_TALKY, CV_EXP_USER, CV_CONTOUR_CHOICE, $
       CV_WRITE_CONTOUR_CHI_STEPS, CV_AUTO_COMMENT, $
       CV_FIRST_BIN_CALC, CV_LAST_BIN_CALC, $
       CV_BATCH_FIT_SUMMARY, CV_GAUSS_OFFSET, $
       CV_START_GAUSS_E, CV_END_GAUSS_E, CV_GAUSS_STEP_SIZE, $
       CV_GAUSS_VWIDTH, CV_FIX_UNDETERMINED, CV_AXES_SAME, $
  
       CV_PRINTER_LANG, CV_PLOT_MODEL_EXTRAP, $
       CV_PLOT_EACH_TERM, CV_ABS_MODEL, CV_PLOT_ONLY_DATA, $
       CV_SUPPRESS_2ND_LABELS, CV_MULTI_DET_PLOT_MODE, $
       CV_GRAPH_LIMIT_MODE, CV_HCOPY_FILE_STATUS, $
       CV_ENCAPSULATED_PS, CV_SPEC_STYLE, $

       CV_RATE_MODE, CV_TRACK_MOUSE, CV_PLOT_UNDETERMINED, $
       CV_PLOT_CURSOR, CV_IDL_RETAIN, CV_TITLE_STYLE, $
       CV_SPARE_1, CV_SPARE_2, CV_SPARE_3, $

       CV_KEEP_ASCII_OPEN, CV_ASCII_OUT_FILE, $
       CV_STARTUP_TEMPLATE_FILE, CV_FULL_BATCH_OUT, $
       CV_SUPPRESS_BATCH_OUT, CV_BATCH_OUT_FILE, CV_ALWAYS_WA, $
       CV_ALWAYS_WB, $

       CV_REL_CONVERG, CV_ABS_CONVERG, CV_MAX_TRIES

YPOS = !D.Y_SIZE - 15
;XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, CHARSIZE=1.5

XLOW = !X.CRANGE(0)
IF XSCALE EQ 'LOG' THEN XLOW = 10^XLOW
XHI = !X.CRANGE(1)
IF XSCALE EQ 'LOG' THEN XHI = 10^XHI
Y_LO = !Y.CRANGE(0)
IF YSCALE EQ 'LOG' THEN Y_LO = 10^Y_LO 
Y_HI = !Y.CRANGE(1)
IF YSCALE EQ 'LOG' THEN Y_HI = 10^Y_HI 

CLIPRECT = [XLOW, Y_LO, XHI, Y_HI]

CURSOR, X0, Y0, /DATA, /CHANGE
BUTTON = !ERR
X1 = X0
Y1 = Y0
IF CV_TRACK_MOUSE THEN BEGIN
   PREV_STRING = '(X: ' + STRING(X0) + ', Y: ' + STRING(Y0) + ')'
   IF X0 LT XLOW THEN PREV_STRING = 'EXIT Command'
   IF X0 GT XHI THEN PREV_STRING = 'RESET'
   IF NOT KEYWORD_SET(D) THEN $
      IF Y0 LT Y_LO THEN PREV_STRING = 'Numerical Entry'
   ENDIF

WHILE (BUTTON AND 1) EQ 0 DO BEGIN
   IF CV_TRACK_MOUSE THEN BEGIN
      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT XLOW THEN NEW_STRING = 'EXIT Command'
      IF X1 GT XHI THEN NEW_STRING = 'RESET'
      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING
      ENDIF
   X0 = X1
   Y0 = Y1

   CURSOR, X1, Y1, /DATA, /NOWAIT
   BUTTON = !ERR
   IF CV_TRACK_MOUSE THEN BEGIN
      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT XLOW THEN NEW_STRING = 'EXIT Command'
      IF X1 GT XHI THEN NEW_STRING = 'RESET'
      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING
      ENDIF
   X0 = X1
   Y0 = Y1
   CURSOR, X1, Y1, /DATA, /CHANGE
   IF (BUTTON AND 1) EQ 0 THEN $
      BUTTON = !ERR             ; Else pass the original 'button down' message
   ENDWHILE

IF CV_TRACK_MOUSE THEN $
   XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
X0 = X1
Y0 = Y1
IF X0 LT XLOW THEN BEGIN
;   XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;              CHARSIZE=1.5, COLOR = !P.BACKGROUND
   RETURN, 1
   ENDIF
IF X0 GT XHI THEN BEGIN
;   XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;               CHARSIZE=1.5, COLOR = !P.BACKGROUND
   RETURN, 2
   ENDIF
IF NOT KEYWORD_SET(D) THEN $
   IF Y0 LT Y_LO THEN BEGIN
;      XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;               CHARSIZE=1.5, COLOR = !P.BACKGROUND
      RETURN, 3
      ENDIF

IF NOT KEYWORD_SET(D) THEN $
   OPLOT, [X0, X0], [Y_LO, Y_HI], LINESTYLE = 2

CURSOR, X1, Y1, /DATA, /CHANGE
BUTTON = !ERR
LX1 = X1
LY1 = Y1
WHILE (BUTTON AND 1) EQ 0 DO BEGIN
   IF CV_TRACK_MOUSE THEN BEGIN
      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT XLOW THEN NEW_STRING = 'EXIT Command'
      IF X1 GT XHI THEN NEW_STRING = 'RESET'
      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING
      ENDIF
   IF KEYWORD_SET(D) THEN BEGIN
      PLOTS, [X0, X0, LX1, LX1, X0], [Y0, LY1, LY1, Y0, Y0], $
         COLOR = !P.BACKGROUND, /DATA, $
         LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
      PLOTS, [X0, X0, X1, X1, X0], [Y0, Y1, Y1, Y0, Y0], /DATA, $
         LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
      ENDIF
   LX1 = X1
   LY1 = Y1
   CURSOR, X1, Y1, /DATA, /NOWAIT
   BUTTON = !ERR

   IF CV_TRACK_MOUSE THEN BEGIN
      XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
      NEW_STRING = '(X: ' + STRING(X1) + ', Y: ' + STRING(Y1) + ')'
      IF X1 LT XLOW THEN NEW_STRING = 'EXIT Command'
      IF X1 GT XHI THEN NEW_STRING = 'RESET'
      IF NOT KEYWORD_SET(D) THEN $
         IF Y1 LT Y_LO THEN NEW_STRING = 'Numerical Entry'
      XYOUTS, 10, 10, NEW_STRING, /DEVICE
      PREV_STRING = NEW_STRING
      ENDIF

   IF KEYWORD_SET(D) THEN BEGIN
      PLOTS, [X0, X0, LX1, LX1, X0], [Y0, LY1, LY1, Y0, Y0], $
         COLOR = !P.BACKGROUND, /DATA, $
         LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
      PLOTS, [X0, X0, X1, X1, X0], [Y0, Y1, Y1, Y0, Y0], /DATA, $
         LINESTYLE = 1, CLIP = CLIPRECT, NOCLIP = 0
      ENDIF
   LX1 = X1
   LY1 = Y1
   CURSOR, X1, Y1, /DATA, /CHANGE
   IF (BUTTON AND 1) EQ 0 THEN $
      BUTTON = !ERR
   ENDWHILE

LX1 = X1
LY1 = Y1
IF CV_TRACK_MOUSE THEN $
   XYOUTS, 10, 10, PREV_STRING, /DEVICE, COLOR = !P.BACKGROUND
;XYOUTS, 10, YPOS, 'Click twice to set range', /DEVICE, $
;        CHARSIZE=1.5, COLOR = !P.BACKGROUND
IF LX1 LT XLOW THEN RETURN, 1
IF LX1 GT XHI THEN RETURN, 2
IF NOT KEYWORD_SET(D) THEN $
   IF LY1 LT Y_LO THEN RETURN, 3

IF NOT KEYWORD_SET(D) THEN $
   OPLOT, [X0, X0], [Y_LO, Y_HI], LINESTYLE = 2, COLOR = !P.BACKGROUND



RETURN, 0
END ;TRACK
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
; Widget to get NUMERICAL ENTRY from ZOOM

; This is the event handler
PRO GET_RANGE_EVENT, EVENT

COMMON WGSP_GET_RANGE, WLO_X, WHI_X, NUMERICAL_XRANGE, NUMERICAL_YRANGE
COMMON TBOX, RX1, RX2, RY1, RY2, $
             RX1_OLD, RX2_OLD, RY1_OLD, RY2_OLD


STYPE = TAG_NAMES(EVENT, /STRUCTURE)
WIDGET_CONTROL, EVENT.ID, GET_VALUE = VALUE, GET_UVALUE = UVALUE

CASE STYPE OF

'WIDGET_TEXT_CH': BEGIN
  VALUE = FLOAT(VALUE(0))
  CASE UVALUE OF 
    'RX1': BEGIN
        WIDGET_CONTROL, RX1, SET_VALUE = STRTRIM(VALUE, 2)
        IF (!Y.TYPE EQ 1) THEN BEGIN
           OPLOT, [RX1_OLD, RX1_OLD], 10.0^!Y.CRANGE, $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RX1_OLD = VALUE
           OPLOT, [VALUE, VALUE], 10.0^!Y.CRANGE, LINESTY = 1
        ENDIF ELSE BEGIN
           OPLOT, [RX1_OLD, RX1_OLD], !Y.CRANGE, $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RX1_OLD = VALUE
           OPLOT, [VALUE, VALUE], !Y.CRANGE, LINESTY = 1
        ENDELSE
        NUMERICAL_XRANGE(0) = VALUE
        END
    'RX2': BEGIN
        WIDGET_CONTROL, RX2, SET_VALUE = STRTRIM(VALUE, 2)
        IF (!Y.TYPE EQ 1) THEN BEGIN
           OPLOT, [RX2_OLD, RX2_OLD], 10.0^!Y.CRANGE, $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RX2_OLD = VALUE
           OPLOT, [VALUE, VALUE], 10.0^!Y.CRANGE, LINESTY = 1
        ENDIF ELSE BEGIN
           OPLOT, [RX2_OLD, RX2_OLD], !Y.CRANGE, $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RX2_OLD = VALUE
           OPLOT, [VALUE, VALUE], !Y.CRANGE, LINESTY = 1
        ENDELSE
        NUMERICAL_XRANGE(1) = VALUE
        END
    'RY1': BEGIN
        WIDGET_CONTROL, RY1, SET_VALUE = STRTRIM(VALUE, 2)
        IF (!X.TYPE EQ 1) THEN BEGIN
           OPLOT, 10.0^!X.CRANGE, [RY1_OLD, RY1_OLD], $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RY1_OLD = VALUE
           OPLOT, 10.0^!X.CRANGE, [VALUE, VALUE], LINESTY = 1
        ENDIF ELSE BEGIN
           OPLOT, !X.CRANGE, [RY1_OLD, RY1_OLD], $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RY1_OLD = VALUE
           OPLOT, !X.CRANGE, [VALUE, VALUE], LINESTY = 1
        ENDELSE
        NUMERICAL_YRANGE(0) = VALUE
        END
    'RY2': BEGIN
        WIDGET_CONTROL, RY2, SET_VALUE = STRTRIM(VALUE, 2)
        IF (!X.TYPE EQ 1) THEN BEGIN
           OPLOT, 10.0^!X.CRANGE, [RY2_OLD, RY2_OLD], $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RY2_OLD = VALUE
           OPLOT, 10.0^!X.CRANGE, [VALUE, VALUE], LINESTY = 1
        ENDIF ELSE BEGIN
           OPLOT, !X.CRANGE, [RY2_OLD, RY2_OLD], $
                  LINESTY = 1, COLOR = !P.BACKGROUND
           RY2_OLD = VALUE
           OPLOT, !X.CRANGE, [VALUE, VALUE], LINESTY = 1
        ENDELSE
        NUMERICAL_YRANGE(1) = VALUE
        END
  ENDCASE
  END

'WIDGET_BUTTON': BEGIN
  CASE UVALUE OF 
    'DONE': WIDGET_CONTROL, EVENT.TOP, /DESTROY
  ENDCASE
  END

ENDCASE ; FOR STYPE


END
; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
PRO GET_RANGE

COMMON WGSP_GET_RANGE, WLO_X, WHI_X, NUMERICAL_XRANGE, NUMERICAL_YRANGE
COMMON TBOX, RX1, RX2, RY1, RY2, $
             RX1_OLD, RX2_OLD, RY1_OLD, RY2_OLD


IF (!X.TYPE EQ 1) THEN RX1_OLD = 10.0^!X.CRANGE(0) ELSE RX1_OLD = !X.CRANGE(0)
IF (!X.TYPE EQ 1) THEN RX2_OLD = 10.0^!X.CRANGE(1) ELSE RX2_OLD = !X.CRANGE(1)
IF (!Y.TYPE EQ 1) THEN RY1_OLD = 10.0^!Y.CRANGE(0) ELSE RY1_OLD = !Y.CRANGE(0)
IF (!Y.TYPE EQ 1) THEN RY2_OLD = 10.0^!Y.CRANGE(1) ELSE RY2_OLD = !Y.CRANGE(1)
NUMERICAL_XRANGE = [RX1_OLD, RX2_OLD]
NUMERICAL_YRANGE = [RY1_OLD, RY2_OLD]


T_BASE = WIDGET_BASE(/COLUMN)

SDONE = WIDGET_BUTTON(T_BASE, VALUE = 'Done', UVALUE = 'DONE')

SUB_BASE = WIDGET_BASE(T_BASE, /ROW)

SX_BASE  = WIDGET_BASE(SUB_BASE, /COLUMN)
SX_TEXT = WIDGET_LABEL(SX_BASE, VALUE = 'Enter x-axis data range')
RX1 = WIDGET_TEXT(SX_BASE, /EDIT, UVALUE = 'RX1', VALUE = STRTRIM(RX1_OLD, 2))
RX2 = WIDGET_TEXT(SX_BASE, /EDIT, UVALUE = 'RX2', VALUE = STRTRIM(RX2_OLD, 2))

SY_BASE  = WIDGET_BASE(SUB_BASE, /COLUMN)
SY_TEXT = WIDGET_LABEL(SY_BASE, VALUE = 'Enter y-axis data range')
RY1 = WIDGET_TEXT(SY_BASE, /EDIT, UVALUE = 'RY1', VALUE = STRTRIM(RY1_OLD, 2))
RY2 = WIDGET_TEXT(SY_BASE, /EDIT, UVALUE = 'RY2', VALUE = STRTRIM(RY2_OLD, 2))


WIDGET_CONTROL, T_BASE, /REALIZE

XMANAGER, 'GET_RANGE', T_BASE, /MODAL



END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
