; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO REINTEGRATE, T_RANGE, I_SPECTRUM, I_SPEC_ERR, I_TOT_TIME

COMMON RATE_C, SPECTRA, R_SPECTRA, SPECTRA_E, SPECTRA_T, $
               SPECTRUM, HISTORY, RATE_RANGE, HIST_RANGE

COMMON ERROR_C, SPECTRA_ERRORS, R_SPECTRA_ERR, SPECTRA_E_ERR, SPECTRA_T_ERR, $
                SPECTRUM_ERR, HISTORY_ERR

COMMON TIME_C, TIMES, TIME_LOOKUP, COMBINED_TIMES, TIME_RANGE, TIME_SPAN, $
               DEFAULT_TL, TRIGGER

; Integrate the spectral history over time.
; 9/2/93: Now add spectra via the livetime, which is R / R_E^2.
;Livetime (averaged over non-zero energy bins) is returned.
NN = SIZE(SPECTRA)
I_SPECTRUM = FLTARR(NN(1))
I_SPEC_ERR = FLTARR(NN(1))
TOTAL_TIME = 0

RANGE_SIZE = SIZE(T_RANGE)
IF RANGE_SIZE(0) EQ 1 THEN $
   NUM_T = 1 $
ELSE $
   NUM_T = RANGE_SIZE(2) 

FOR K = 0, NUM_T - 1 DO BEGIN
   FOR I = T_RANGE(0, K), T_RANGE(1, K) DO BEGIN
      NIND = WHERE(SPECTRA(*, I))             
;Don't divide by zeros!
      LIVE_T = SPECTRA(NIND, I) / (SPECTRA_ERRORS(NIND, I) * $
                                   SPECTRA_ERRORS(NIND, I))
      DT = TOTAL(LIVE_T) / N_ELEMENTS(NIND)   ;Make the livetime the average.
      TOTAL_TIME = TOTAL_TIME + DT
      I_SPECTRUM = I_SPECTRUM + SPECTRA(*, I)*DT
      ERR = SPECTRA_ERRORS(*, I)*DT
      I_SPEC_ERR = I_SPEC_ERR + ERR*ERR
      ENDFOR ; I
   ENDFOR ; K

I_SPEC_ERR = SQRT(I_SPEC_ERR)/TOTAL_TIME
I_SPECTRUM = I_SPECTRUM/TOTAL_TIME
I_TOT_TIME = TOTAL_TIME

END ; PRO REINTEGRATE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO COUNT_SPAN, EDGES, A_SPAN, AN_IND, COMB

   N = SIZE(EDGES)
   AR = INTARR(2)
   ACOMB = AR
   AN_ARR = INTARR(N(2))
   AN_ARR(INDGEN(N(2))) = 0
   AN_IND = INDGEN(N(2))

   THE_REGIONS = SIZE(A_SPAN)
   IF (THE_REGIONS(1) - 1) GT 0 THEN BEGIN
      LOWER = 1
      UPPER = THE_REGIONS(1) - 1
   ENDIF ELSE BEGIN
      LOWER = 0
      UPPER = 0
      ENDELSE
   FOR HH = LOWER, UPPER DO BEGIN
      ER = NEAREST_EDGE(EDGES, A_SPAN(HH, *), AR)
      IF KEYWORD_SET(COMB) THEN BEGIN                 ; Handle binned thresholds
         EB = NEAREST_EDGE(COMB, A_SPAN(HH, *), ACOMB)
         IF EB(0) LT ER(0) THEN BEGIN
            WHILE EB(0) LT ER(0) DO BEGIN
               AR(0) = AR(0) - 1
               ER(0) = EDGES(0, AR(0))
               ENDWHILE
            ENDIF
         IF EB(1) GT ER(1) THEN BEGIN
            WHILE EB(1) GT ER(1) DO BEGIN
               AR(1) = AR(1) + 1
               ER(1) = EDGES(1, AR(1))
               ENDWHILE
            ENDIF
         ENDIF
      I0 = AR(0)
      I1 = AR(1)
      FOR KK = I0, I1 DO AN_ARR(KK) = 1
      ENDFOR

   ; 8/16/96 RP: Set up for test of no content selection (so it won't blow up!)
   SELECT_IND = WHERE(AN_ARR, SEL_COUNT)
   IF SEL_COUNT GT 0 THEN $
      AN_IND = AN_IND(SELECT_IND) $
   ELSE $
      AN_IND = -1

END; PRO COUNT_SPAN
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO STACK_PLOTS, N_PLOTS, PAGE_POSITION, PLOT_POSITIONS, SPAN, $
                 Y_CURVES, DY_CURVES, COMBINED_X, COMBINED_Y, $
                 X_IND, Y_IND, X_SCALE, Y_SCALE, X_TITLE, Y_TITLE, $
                 Y_TICKS, PLACE_STR, TYPE, SPEC_TITLE

@wgsp_cb.pro

PLOT_SIZE = (PAGE_POSITION(3) - PAGE_POSITION(1))/N_PLOTS
Y_MINOR = !Y.MINOR
SAVE_YSTYLE = !Y.STYLE

Y_LO_RANGE = FLTARR(N_PLOTS)
Y_HI_RANGE = FLTARR(N_PLOTS)
IF Y_SCALE THEN BEGIN
   !Y.STYLE = 1
   FOR I = 0, N_PLOTS - 1 DO BEGIN
       Y = Y_CURVES(*, I)
       DY = DY_CURVES(*, I)
       WY = WHERE(Y GT 0, WY_COUNT)
       IF WY_COUNT EQ 0 THEN BEGIN
          HC_INFORM, 'Spectrum ' + STRTRIM(I, 2) + ' all negative.'
          POSITIVE_Y = [0, 1]
       ENDIF ELSE BEGIN
          POSITIVE_Y = Y(WY)                                 ; + DY(WY)
       ENDELSE
       Y_LO_RANGE(I) = MIN(POSITIVE_Y)
       Y_HI_RANGE(I) = MAX(POSITIVE_Y)
   ENDFOR

; RSM 24 May, 1995: Error in axis rounding procedure; changed to incorporate
;     the rounding functions M_ROUND_BEG, M_ROUND_END 

   Y_RANGE = [MIN(Y_LO_RANGE), MAX(Y_HI_RANGE)]
   TEMP0 = LONG(ALOG10(Y_RANGE(0)))
;   Y_RANGE(0) = 10.0^FLOAT(TEMP0)
   MODE = 'P' ; Round to a Power of 10
   Y_RANGE(0) = M_ROUND_BEG(Y_RANGE(0), !Y.TYPE, MODE)
   TEMP1 = LONG(ALOG10(Y_RANGE(1))) + 1
;   Y_RANGE(1) = 10.0^FLOAT(TEMP1)
   Y_RANGE(1) = M_ROUND_END(Y_RANGE(1), !Y.TYPE, MODE)
   !Y.MINOR = TEMP1 - TEMP0 

   ENDIF $
ELSE BEGIN
   Y_RANGE = [MIN(Y_CURVES - DY_CURVES), MAX(Y_CURVES + DY_CURVES)]
   IF Y_TICKS EQ 1 THEN BEGIN
      !Y.STYLE = 1
      DYR = Y_RANGE(1) - Y_RANGE(0)
      DYR10 = ALOG10(ABS(DYR))
      IF DYR10 NE LONG(DYR10) THEN BEGIN
         IF (DYR10 GE 0) THEN BEGIN
            DYR = 10^FLOAT(LONG(DYR10) + 1)
            ENDIF $
         ELSE BEGIN
            DYR = 10^FLOAT(LONG(DYR10))
            ENDELSE
         ENDIF
      YRES = DYR/10
      Y_RANGE(0) = LONG(Y_RANGE(0)/YRES)*YRES
      Y_RANGE(1) = LONG(Y_RANGE(1)/YRES + 1)*YRES
      !Y.MINOR = LONG((Y_RANGE(1) - Y_RANGE(0))/YRES + 0.5)
      ENDIF

   ENDELSE

X_RANGE = FLTARR(2)
IF X_SCALE AND (SPAN(0,0) LE 0) THEN $
   X_RANGE(0) = SPAN(0,1)/100 $
   ELSE X_RANGE(0) = SPAN(0,0)
X_RANGE(1) = SPAN(0,1)

FOR I = 0, N_PLOTS - 1 DO BEGIN
   Y = Y_CURVES(*, I)
   DY = DY_CURVES(*, I)

   IF NOT Y_SCALE THEN BEGIN
      YIND = WHERE(Y)
      Y_RANGE = [MIN(Y(YIND) - DY(YIND)), MAX(Y(YIND) + DY(YIND))]

      MODE = 'M' ; Round to a Minor tick mark
      Y_RANGE(0) = M_ROUND_BEG(Y_RANGE(0), !Y.TYPE, MODE)
      Y_RANGE(1) = M_ROUND_END(Y_RANGE(1), !Y.TYPE, MODE)
      ENDIF

   PP = PAGE_POSITION
   PP(1) = PP(1) + (I)*PLOT_SIZE + 0.05*PLOT_SIZE
   PP(3) = PP(1) + PLOT_SIZE*0.9
   PLOT_POSITIONS(I) = PP(1)

   IF I EQ 0 THEN BEGIN
      SAVE_STYLE = !X.STYLE
      !X.STYLE = 8
      PLOT, X_RANGE, Y_RANGE, XTYPE = X_SCALE, XTITLE = '!5' + X_TITLE, $
            YTITLE = '!5', $
            /NODATA, POSITION = PP, YTYPE = Y_SCALE, /NOERASE, YTICKS = Y_TICKS
      !X.STYLE = SAVE_STYLE
      ENDIF $
   ELSE IF I EQ N_PLOTS - 1 THEN BEGIN
      SAVE_STYLE = !X.STYLE
      !X.STYLE = 4
      PLOT, X_RANGE, Y_RANGE, YTITLE = '!5', /NODATA, $
            POSITION = PP, YTYPE = Y_SCALE, XTYPE = X_SCALE, $
            /NOERASE, YTICKS = Y_TICKS
      !X.STYLE = SAVE_STYLE
      AXIS, XAXIS = 1, XRANGE = X_RANGE, XTITLE = '!5Spectral History'
      ENDIF $
   ELSE BEGIN
      SAVE_STYLE = !X.STYLE
      !X.STYLE = 4
      PLOT, X_RANGE, Y_RANGE, YTITLE = '!5', /NODATA, $
            POSITION = PP, YTYPE = Y_SCALE, XTYPE = X_SCALE, $
            /NOERASE, YTICKS = Y_TICKS
      !X.STYLE = SAVE_STYLE
      ENDELSE

   IF TYPE EQ 'STACKED SPECTRA' THEN $
      PLOT_POINTS, COMBINED_X(*, X_IND), Y, DY $
   ELSE $
      NEW_HIST, COMBINED_X(*, X_IND), Y, !P.COLOR, DY
   ENUM0 = COMBINED_Y(0, Y_IND(I))
   IF LONG(ABS(ENUM0)) GT 100 THEN $
     E0 = STRTRIM(STRING(FORMAT='(D15.2)',ENUM0), 2) $
   ELSE $
     E0 = STRTRIM(STRING(FORMAT='(D15.3)',ENUM0), 2)

   ENUM1 = COMBINED_Y(1, Y_IND(I))
   IF LONG(ABS(ENUM1)) GT 100 THEN $
     E1 = STRTRIM(STRING(FORMAT='(D15.2)',ENUM1), 2) $
   ELSE $
     E1 = STRTRIM(STRING(FORMAT='(D15.3)',ENUM1), 2)

   SPEC_TITLE(I) = E0 + ': ' + E1 + PLACE_STR
   XYOUTS, PP(2) -  0.01, PP(3) - 0.02, SPEC_TITLE(I), ALIGN = 1, /NORM
   ENDFOR

!Y.STYLE = SAVE_YSTYLE
!Y.MINOR = Y_MINOR
X = PAGE_POSITION(0) - 0.075*(PAGE_POSITION(2) - PAGE_POSITION(0)) * $
                       GLOBAL_CHARSIZE
Y = PAGE_POSITION(1) + 0.5*(PAGE_POSITION(3) - PAGE_POSITION(1))
XYOUTS, X, Y, Y_TITLE, ORIENTATION = 90, ALIGN = 0.5, /NORMAL, $
              CHARSIZE = GLOBAL_CHARSIZE, CHARTHICK = GLOBAL_CHARTHICK
IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PAGE_POSITION, TYPE



END;  PRO STACK_PLOTS
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO STACK_PLOTS_new, N_PLOTS, PAGE_POSITION, PLOT_POSITIONS, SPAN, $
                 Y_CURVES, DY_CURVES, COMBINED_X, COMBINED_Y, $
                 X_IND, Y_IND, X_SCALE, Y_SCALE, X_TITLE, Y_TITLE, $
                 Y_TICKS, PLACE_STR, TYPE, SPEC_TITLE

@wgsp_cb.pro



; Set up for MULTIPLOT
MULTIPLOT, [1, N_PLOTS]

PLOT_SIZE = (PAGE_POSITION(3) - PAGE_POSITION(1))/N_PLOTS
Y_MINOR = !Y.MINOR
SAVE_YSTYLE = !Y.STYLE

Y_LO_RANGE = FLTARR(N_PLOTS)
Y_HI_RANGE = FLTARR(N_PLOTS)
IF Y_SCALE THEN BEGIN
   !Y.STYLE = 1
   FOR I = 0, N_PLOTS - 1 DO BEGIN
       Y = Y_CURVES(*, I)
       DY = DY_CURVES(*, I)
       WY = WHERE(Y GT 0, WY_COUNT)
       IF WY_COUNT EQ 0 THEN BEGIN
          HC_INFORM, 'Spectrum ' + STRTRIM(I, 2) + ' all negative.'
          POSITIVE_Y = [0, 1]
       ENDIF ELSE BEGIN
          POSITIVE_Y = Y(WY)                                 ; + DY(WY)
       ENDELSE
       Y_LO_RANGE(I) = MIN(POSITIVE_Y)
       Y_HI_RANGE(I) = MAX(POSITIVE_Y)
   ENDFOR

; RSM 24 May, 1995: Error in axis rounding procedure; changed to incorporate
;     the rounding functions M_ROUND_BEG, M_ROUND_END 

   Y_RANGE = [MIN(Y_LO_RANGE), MAX(Y_HI_RANGE)]
   TEMP0 = LONG(ALOG10(Y_RANGE(0)))
;   Y_RANGE(0) = 10.0^FLOAT(TEMP0)
   MODE = 'P' ; Round to a Power of 10
   Y_RANGE(0) = M_ROUND_BEG(Y_RANGE(0), !Y.TYPE, MODE)
   TEMP1 = LONG(ALOG10(Y_RANGE(1))) + 1
;   Y_RANGE(1) = 10.0^FLOAT(TEMP1)
   Y_RANGE(1) = M_ROUND_END(Y_RANGE(1), !Y.TYPE, MODE)
   !Y.MINOR = TEMP1 - TEMP0 

   ENDIF $
ELSE BEGIN
   Y_RANGE = [MIN(Y_CURVES - DY_CURVES), MAX(Y_CURVES + DY_CURVES)]
   IF Y_TICKS EQ 1 THEN BEGIN
      !Y.STYLE = 1
      DYR = Y_RANGE(1) - Y_RANGE(0)
      DYR10 = ALOG10(ABS(DYR))

;      ; RSM:  ?? How is this loop *ever* executed?
;      IF DYR10 NE LONG(DYR10) THEN BEGIN
;         IF (DYR10 GE 0) THEN BEGIN
;            DYR = 10^FLOAT(LONG(DYR10) + 1)
;         ENDIF $
;         ELSE BEGIN
;            DYR = 10^FLOAT(LONG(DYR10))
;         ENDELSE
;      ENDIF

      YRES = DYR/10
      Y_RANGE(0) = LONG(Y_RANGE(0)/YRES)*YRES
      Y_RANGE(1) = LONG(Y_RANGE(1)/YRES + 1)*YRES
      !Y.MINOR = LONG((Y_RANGE(1) - Y_RANGE(0))/YRES + 0.5)
   ENDIF

ENDELSE

X_RANGE = FLTARR(2)
IF X_SCALE AND (SPAN(0,0) LE 0) THEN $
   X_RANGE(0) = SPAN(0,1)/100 $
ELSE X_RANGE(0) = SPAN(0,0)
X_RANGE(1) = SPAN(0,1)

FOR I = 0, N_PLOTS - 1 DO BEGIN
   Y = Y_CURVES(*, I)
   DY = DY_CURVES(*, I)

   IF NOT Y_SCALE THEN BEGIN
      YIND = WHERE(Y)
      Y_RANGE = [MIN(Y(YIND) - DY(YIND)), MAX(Y(YIND) + DY(YIND))]

      MODE = 'M' ; Round to a Minor tick mark
      Y_RANGE(0) = M_ROUND_BEG(Y_RANGE(0), !Y.TYPE, MODE)
      Y_RANGE(1) = M_ROUND_END(Y_RANGE(1), !Y.TYPE, MODE)
   ENDIF

   IF (I EQ N_PLOTS - 1) THEN BEGIN
      PLOT, /NODATA, /NOERASE, X_RANGE, Y_RANGE, $
            YTITLE = '!5', YTYPE = Y_SCALE, $
            XTYPE = X_SCALE, XTITLE = '!5' + X_TITLE, $
            XTICK_GET = THE_XTICKS, YTICK_GET = THE_YTICKS

      MULTIPLOT, /RESET
   ENDIF $
   ELSE BEGIN
      PLOT, /NODATA, /NOERASE, X_RANGE, Y_RANGE, $
            YTITLE = '!5', YTYPE = Y_SCALE, $
            XTITLE = '!5', XTYPE = X_SCALE, $
            XTICK_GET = THE_XTICKS, YTICK_GET = THE_YTICKS
      MULTIPLOT
   ENDELSE

   IF (TYPE EQ 'STACKED SPECTRA') THEN $
      PLOT_POINTS, COMBINED_X(*, X_IND), Y, DY $
   ELSE $
      NEW_HIST, COMBINED_X(*, X_IND), Y, !P.COLOR, DY

   ENUM0 = COMBINED_Y(0, Y_IND(I))
   IF (ABS(ENUM0) GT 100) THEN $
     E0 = STRTRIM(STRING(FORMAT='(D15.2)',ENUM0), 2) $
   ELSE $
     E0 = STRTRIM(STRING(FORMAT='(D15.3)',ENUM0), 2)

   ENUM1 = COMBINED_Y(1, Y_IND(I))
   IF (ABS(ENUM1) GT 100) THEN $
     E1 = STRTRIM(STRING(FORMAT='(D15.2)',ENUM1), 2) $
   ELSE $
     E1 = STRTRIM(STRING(FORMAT='(D15.3)',ENUM1), 2)

   SPEC_TITLE(I) = E0 + ': ' + E1 + PLACE_STR
 
   XYOUTS, THE_XTICKS(N_ELEMENTS(THE_XTICKS)-1), $
           THE_YTICKS(N_ELEMENTS(THE_YTICKS)-2), $
           SPEC_TITLE(I), ALIGN = 1.5, /DATA

ENDFOR

!Y.STYLE = SAVE_YSTYLE
!Y.MINOR = Y_MINOR
X = PAGE_POSITION(0) - 0.075*(PAGE_POSITION(2) - PAGE_POSITION(0)) * $
                       GLOBAL_CHARSIZE
Y = PAGE_POSITION(1) + 0.5*(PAGE_POSITION(3) - PAGE_POSITION(1))
XYOUTS, X, Y, Y_TITLE, ORIENTATION = 90, ALIGN = 0.5, /NORMAL, $
              CHARSIZE = GLOBAL_CHARSIZE, CHARTHICK = GLOBAL_CHARTHICK
IF (NOT CV_SUPPRESS_2ND_LABELS) AND (STRUPCASE(!D.NAME) NE 'X') THEN $
   PLOT_NOTES, PAGE_POSITION, TYPE



END;  PRO STACK_PLOTS
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO ZOOM_BAR, X_SCALE, Y_SCALE, $
              IN = IN, OUT = OUT, HIST = HIST, SPEC = SPEC

COMMON RATE_C, SPECTRA, R_SPECTRA, SPECTRA_E, SPECTRA_T, $
               SPECTRUM, HISTORY, RATE_RANGE, HIST_RANGE

COMMON ENERGY_C, THRESHOLDS, ENERGY_LOOKUP, COMBINED_ENERGIES, ENERGY_RANGE, $
                 ENERGY_SPAN, DEFAULT_EL, ENERGIES

COMMON WINDOWS_C, SPECTRUM_WINDOW, HISTORY_WINDOW, PLOT_WINDOW, $
                  PROCESSED_HISTORY, PROCESSED_SPECTRUM, LAYOUT_WINDOW

COMMON PROCESSED_C, X_PH_DATA, Y_PH_DATA, DY_PH_DATA, $
                    X_PH_TITLE, Y_PH_TITLE, PH_TITLE, $
                    X_PS_DATA, Y_PS_DATA, X_PS_TITLE, Y_PS_TITLE, PS_TITLE, $
                    DY_PS_DATA, FLAT_INDEX

IF KEYWORD_SET(SPEC) THEN BEGIN
   WSHOW, PROCESSED_SPECTRUM
   WSET, PROCESSED_SPECTRUM
ENDIF
IF KEYWORD_SET(HIST) THEN BEGIN
   WSHOW, PROCESSED_HISTORY
   WSET, PROCESSED_HISTORY
ENDIF

X_RANGE = FLTARR(2)
Y_RANGE = FLTARR(2)

IF X_SCALE EQ 1 THEN XSCALE = 'LOG' ELSE XSCALE = 'LINEAR'
IF Y_SCALE EQ 1 THEN YSCALE = 'LOG' ELSE YSCALE = 'LINEAR'

IF KEYWORD_SET(IN) THEN ZOOMING = 0
IF KEYWORD_SET(OUT) THEN ZOOMING = 1

IF ZOOMING EQ 0 THEN BEGIN
   BAIL_OUT = TRACK(LO_X, LO_Y, HI_X, HI_Y, XSCALE, YSCALE, /DRAW_BOX)
   IF BAIL_OUT EQ 1 THEN ZOOMING = 2 $       ; EXITed: don't zoom
   ELSE IF BAIL_OUT EQ 2 THEN ZOOMING = 1 $  ; RESET: Zoom out
   ELSE BEGIN
      X_RANGE(0) = LO_X
      X_RANGE(1) = HI_X
      Y_RANGE(0) = LO_Y
      Y_RANGE(1) = HI_Y
      ENERGY_RANGE = X_RANGE(SORT(X_RANGE))
      IF PH_TITLE THEN $
         HIST_RANGE = Y_RANGE(SORT(Y_RANGE)) $
      ELSE $
         RATE_RANGE = Y_RANGE(SORT(Y_RANGE))
      ENDELSE
   ENDIF 
IF ZOOMING EQ 1 THEN BEGIN
   IF X_SCALE THEN BEGIN
      XW = WHERE(X_PS_DATA GT 0)
      ENERGY_RANGE = [MIN(X_PS_DATA(XW)), MAX(X_PS_DATA)]
      ENDIF $
   ELSE BEGIN
      ENERGY_RANGE = [MIN(X_PS_DATA), MAX(X_PS_DATA)]
      ENDELSE

   IF Y_SCALE THEN BEGIN
      IF PH_TITLE THEN BEGIN
         YW = WHERE(Y_PH_DATA GT 0)
         HIST_RANGE = [MIN(Y_PH_DATA(YW)), MAX(Y_PH_DATA + DY_PH_DATA)] 
         ENDIF $
      ELSE BEGIN
         YW = WHERE(Y_PS_DATA GT 0)
         RATE_RANGE = [MIN(Y_PS_DATA(YW)), MAX(Y_PS_DATA + DY_PS_DATA)]
         ENDELSE
      ENDIF $
   ELSE BEGIN
      IF PH_TITLE THEN $
         HIST_RANGE = [MIN(Y_PH_DATA - DY_PH_DATA), MAX(Y_PH_DATA+DY_PH_DATA)] $
      ELSE $
         RATE_RANGE = [MIN(Y_PS_DATA - DY_PS_DATA), MAX(Y_PS_DATA + DY_PS_DATA)]
      ENDELSE
   ENDIF

PLOT_PS_PH, X_SCALE, Y_SCALE



END;  PRO ZOOM_BAR



; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; * Plot PS and PH array data in a standard format                            *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO PLOT_PS_PH, X_SCALE, Y_SCALE, PAGE_POSITION 

@wgsp_cb.pro


POS_SAVE = !P.POSITION
IF N_ELEMENTS(PAGE_POSITION) NE 0 THEN !P.POSITION = PAGE_POSITION

IF PH_TITLE THEN BEGIN
   PLOT, ENERGY_RANGE, RATE_RANGE, XTITLE = X_PS_TITLE, $
                     XTYPE = X_SCALE, YTYPE = Y_SCALE, $
                     YTITLE = Y_PS_TITLE, TITLE = PS_TITLE, $
                    /NODATA, YSTYLE = 16 + 8

   PLOT_POINTS, X_PS_DATA, Y_PS_DATA, DY_PS_DATA

   PLOT, ENERGY_RANGE, HIST_RANGE, XTYPE = X_SCALE, $
                  XTITLE = X_PS_TITLE, $
                  /NODATA, YSTYLE = 16 + 4, /NOERASE
   AXIS, YAXIS = 1, YRANGE = HIST_RANGE, /YNOZERO, YTITLE = Y_PH_TITLE
   P_LINESAVE = !P.LINESTYLE
   !P.LINESTYLE = 1
   BTH_FLAG = STRPOS(Y_PH_TITLE, 'Burst Time History')
   IF BTH_FLAG EQ -1 THEN $
      PLOT_POINTS, X_PH_DATA, Y_PH_DATA, DY_PH_DATA $
   ELSE $
      NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA 
   !P.LINESTYLE = P_LINESAVE
   ENDIF $
ELSE BEGIN
   PLOT, ENERGY_RANGE, RATE_RANGE, XTITLE = X_PS_TITLE, $
                     XTYPE = X_SCALE, YTYPE = Y_SCALE, $
                     YTITLE = Y_PS_TITLE, TITLE = PS_TITLE, $
                     /NODATA, YSTYLE = 16

   JOIN_POINTS = STRPOS(Y_PS_TITLE, 'Number of Occurances')
   IF JOIN_POINTS EQ -1 THEN $
      PLOT_POINTS, X_PS_DATA, Y_PS_DATA, DY_PS_DATA $
   ELSE $
      NEW_HIST, X_PS_DATA, Y_PS_DATA, !P.COLOR 
   ENDELSE


!P.POSITION = POS_SAVE 



END; PRO PLOT_PS_PH

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO PLOT_SPECTRA, PAGE_POSITION

@wgsp_cb.pro

 
TYPE = READ_MENU(0)

IF (N_ELEMENTS(PAGE_POSITION) EQ 0) THEN PAGE_POSITION = [0, 0, 1, 1]

IF (TYPE EQ 'HIDDEN LINE') OR (TYPE EQ 'CONTOUR') OR $
   (TYPE EQ 'SURFACE') THEN BEGIN

   E = AVERAGE(ENERGIES, SPECTRA_T, ENERGY_LOOKUP)
   T = AVERAGE((TIMES(0, *) + TIMES(1, *))/2, SPECTRA_E, TIME_LOOKUP)
   X_TITLE = READ_MENU(3)
   Y_TITLE = READ_MENU(4)
   Z_TITLE = READ_MENU(5)

   N = N_ELEMENTS(E)
   IE0 = SEARCH(E, ENERGY_SPAN(0, 0))
   IF IE0 EQ (N - 1) THEN BEGIN
      ; Error TBD
      STOP
      ENDIF
   INTERPOLATE0 = IE0 NE -1

   IE1 = SEARCH(E, ENERGY_SPAN(0, 1))
   IF IE1 EQ -1 THEN BEGIN
      ; Error TBD
      STOP
      ENDIF
   INTERPOLATE1 = IE1 NE (N - 1)

   IF INTERPOLATE0 AND INTERPOLATE1 THEN BEGIN
      DE0 = ENERGY_SPAN(0, 0) - E(IE0)
      DE1 = ENERGY_SPAN(0, 1) - E(IE1)
      DR_DE0 = (R_SPECTRA(IE0 + 1, *) - R_SPECTRA(IE0, *))/(E(IE0 + 1) - E(IE0))
      DR_DE1 = (R_SPECTRA(IE1 + 1, *) - R_SPECTRA(IE1, *))/(E(IE1 + 1) - E(IE1))
      RS = [R_SPECTRA(IE0, *) + DR_DE0*DE0, R_SPECTRA(IE0 + 1:IE1, *), $
            R_SPECTRA(IE1, *) + DR_DE1*DE1]
      E = [ENERGY_SPAN(0, 0), E(IE0 + 1:IE1), ENERGY_SPAN(0, 1)]
      ENDIF $
   ELSE IF INTERPOLATE0 THEN BEGIN
      DE = ENERGY_SPAN(0, 0) - E(IE0)
      DR_DE = (R_SPECTRA(IE0 + 1, *) - R_SPECTRA(IE0, *))/(E(IE0 + 1) - E(IE0))
      RS = [R_SPECTRA(IE0, *) + DR_DE*DE, R_SPECTRA(IE0 + 1:*, *)]
      E = [ENERGY_SPAN(0, 0), E(IE0 + 1:*)]
      ENDIF $
   ELSE IF INTERPOLATE1 THEN BEGIN
      DE = ENERGY_SPAN(0, 1) - E(IE1)
      DR_DE = (R_SPECTRA(IE1 + 1, *) - R_SPECTRA(IE1, *))/(E(IE1 + 1) - E(IE1))
      RS = [R_SPECTRA(0:IE1, *), R_SPECTRA(IE1, *) + DR_DE*DE]
      E = [E(0:IE1), ENERGY_SPAN(0, 1)]
      ENDIF $
   ELSE RS = R_SPECTRA

   N = N_ELEMENTS(T)
   IT0 = SEARCH(T, TIME_SPAN(0, 0))
   IF IT0 EQ (N - 1) THEN BEGIN
      ; Error
      STOP
      ENDIF
   INTERPOLATE0 = IT0 NE -1

   IT1 = SEARCH(T, TIME_SPAN(0, 1))
   IF IT1 EQ -1 THEN BEGIN
      ; Error
      STOP
      ENDIF
   INTERPOLATE1 = IT1 NE (N - 1)

   IF INTERPOLATE0 AND INTERPOLATE1 THEN BEGIN
      DT0 = TIME_SPAN(0, 0) - T(IT0)
      DT1 = TIME_SPAN(0, 1) - T(IT1)
      DR_DT0 = (RS(*, IT0 + 1) - RS(*, IT0))/(T(IT0 + 1) - T(IT0))
      DR_DT1 = (RS(*, IT1 + 1) - RS(*, IT1))/(T(IT1 + 1) - T(IT1))
      RS = [TRANSPOSE(RS(*, IT0) + DR_DT0*DT0), TRANSPOSE(RS(*, IT0 + 1:IT1)), $
            TRANSPOSE(RS(*, IT1) + DR_DT1*DT1)]
      T = [TIME_SPAN(0, 0), T(IT0 + 1:IT1), TIME_SPAN(0, 1)]
      ENDIF $
   ELSE IF INTERPOLATE0 THEN BEGIN
      DT0 = TIME_SPAN(0, 0) - T(IT0)
      DR_DT0 = (RS(*, IT0 + 1) - RS(*, IT0))/(T(IT0 + 1) - T(IT0))
      RS = [TRANSPOSE(RS(*, IT0) + DR_DT0*DT0), TRANSPOSE(RS(*, IT0 + 1:*))]
      T = [TIME_SPAN(0, 0), T(IT0 + 1:*)]
      ENDIF $
   ELSE IF INTERPOLATE1 THEN BEGIN
      DT1 = TIME_SPAN(0, 1) - T(IT1)
      DR_DT1 = (RS(*, IT1 + 1) - RS(*, IT1))/(T(IT1 + 1) - T(IT1))
      RS = [TRANSPOSE(RS(*, 0:IT1)), TRANSPOSE(RS(*, IT1) + DR_DT1*DT1)]
      T = [T(IT0 + 1:IT1), TIME_SPAN(0, 1)]
      ENDIF $
   ELSE RS = TRANSPOSE(RS)

   PLOT_TITLE = READ_MENU(8)

   YR = [ENERGY_SPAN(0, 1), ENERGY_SPAN(0, 0)]
   YTY = READ_MENU(1) EQ 'LOG'
   E_AXIS = [MIN(E), MAX(E)]
   IF YTY THEN BEGIN
      E = ALOG10(E)
      YR = ALOG10(YR)
      ENDIF

   ZMAX = MAX(RS, MIN = ZMIN)
   ZR = [ZMIN, ZMAX]
   ZTY = READ_MENU(2) EQ 'LOG'
   IF ZTY THEN BEGIN
      Z_INDEX = WHERE(RS LE 0.0, Z_COUNT)
      IF Z_COUNT NE 0 THEN RS(Z_INDEX) = 1.0
      ZMAX = MAX(RS, MIN = ZMIN)
      ZR = [ZMIN, ZMAX]

      RS = ALOG10(RS)
      ZR = ALOG10(ZR)
      IF (ZR(1) - ZR(0)) GT 3. THEN BEGIN
         ZR(0) = ZR(1) - 3.
         ENDIF
      Z_TITLE = 'Log( ' + Z_TITLE + ' )'
      ENDIF
   IF (TYPE EQ 'HIDDEN LINE') OR (TYPE EQ 'SURFACE') THEN BEGIN
      ; These options have hardcopy choices built in to other menus
      W_HARDCOPY, 'Burst Spectral History', '     ', /BIG, /NOINQUIRE, /NODONE

      ROTATION = W_SLIDER( [0, 360], LABEL = 'Rotation Angle')
      ROT_OPT = STRTRIM(ROTATION,2)
      PLOTTING = 0
      WHILE (ROT_OPT NE 'EXIT') DO BEGIN
MAKEHC:
         IF PLOTTING THEN BEGIN
            OPEN_PLOT, CURRENT_DEVICE
            ROTATION = ROT_LAST
         ENDIF $
         ELSE ROT_LAST = ROTATION
         R = ROTATION
         Z_AXIS = ((R/90 + 2) MOD 4) + 1
         Y_AXIS = R GE 180
         IF R GT 180 THEN R = R - 360
         X_AXIS = ABS(R) GT 90
         IF (TYPE EQ 'HIDDEN LINE') THEN $
         SURFACE, RS, T, E, ZTITLE = Z_TITLE, SKIRT = 0, YRANGE = YR, $
                  TITLE = 'Hidden Line Plot of ' + PLOT_TITLE, $
                  POSITION = PAGE_POSITION, AZ = ROTATION, AX = 45, $
                  XSTYLE = 4, YSTYLE = 4, ZRANGE = ZR, ZAXIS = Z_AXIS, /SAVE
         IF (TYPE EQ 'SURFACE') THEN $
         SHADE_SURF, RS, T, E, ZTITLE = Z_TITLE, SKIRT = 0, YRANGE = YR, $
                  TITLE = 'Surface Plot of ' + PLOT_TITLE, $
                  POSITION = PAGE_POSITION, AZ = ROTATION, AX = 45, $
                  XSTYLE = 4, YSTYLE = 4, ZRANGE = ZR, ZAXIS = Z_AXIS, /SAVE

         HC_INFORM, 'Rotation angle = ' + $
            STRTRIM(ROTATION, 2) + ' degrees.', /NO_STATUS

         AXIS, XAXIS = X_AXIS, XTITLE = X_TITLE, /T3D, /NOERASE
         AXIS, YAXIS = Y_AXIS, YTITLE = Y_TITLE, YTYPE = YTY, /T3D, /NOERASE
         IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PAGE_POSITION, TYPE

         IF PLOTTING THEN BEGIN
            CLOSE_PLOT, CURRENT_DEVICE
            HC_INFORM, 'Rotation angle = ' + $
               STRTRIM(ROTATION, 2) + ' degrees.', /NO_STATUS
         ENDIF
         PLOTTING = 0

         IF NOT PLOTTING THEN BEGIN
            ADD_ROT = WIDMENU(['EXIT', 'Another Rotation', 'Create Hardcopy'])
            IF ADD_ROT EQ 0 THEN BEGIN
               ROT_OPT = 'EXIT'  
               WIDGET_CONTROL, WIDS.HC_BASE, /DESTROY
            ENDIF ELSE BEGIN
               IF ADD_ROT EQ 1 THEN $
                  ROTATION = W_SLIDER( [0, 360], LABEL = 'Rotation Angle') $
               ELSE BEGIN
                  HC_INFORM, 'Creating hardcopy: ' + TYPE
                  PLOTTING = 1
                  GOTO, MAKEHC
               ENDELSE
            ENDELSE   
         ENDIF

      ENDWHILE

      ENDIF $
   ELSE IF TYPE EQ 'CONTOUR' THEN BEGIN 
      W_HARDCOPY, 'Burst Spectral History', /BIG

      PLOTTING = 0
DO_PLOT:
      IF PLOTTING THEN OPEN_PLOT, CURRENT_DEVICE
      CONTOUR, RS, T, E, XTITLE = X_TITLE, $
            YTITLE = 'Log ' + Y_TITLE, YRANGE = YR, $
            NLEVELS = 18, C_LINESTYLE = [1, 0], $
            POSITION = PAGE_POSITION
      IF NOT CV_SUPPRESS_2ND_LABELS THEN PLOT_NOTES, PAGE_POSITION, TYPE
      GET_HC_EVENT, HC_OPTION
      IF NOT PLOTTING THEN BEGIN
         IF HC_OPTION EQ 1 THEN BEGIN
            PLOTTING = 1
            GOTO, DO_PLOT
         ENDIF 
      ENDIF $
      ELSE CLOSE_PLOT, CURRENT_DEVICE
   ENDIF
ENDIF $
ELSE IF TYPE EQ 'STACKED HISTORIES' THEN BEGIN
   ; This option has hardcopy choices built in to other menus
   W_HARDCOPY, 'Burst Spectral History', '     ', /BIG, /NOINQUIRE, /NODONE

   X_TITLE = READ_MENU(3)
   Y_TITLE = READ_MENU(5)
   RATE_SCALE = READ_MENU(2) EQ 'LOG'
   SAVE_SYM = !P.PSYM
   !P.PSYM = 0

   E = AVERAGE(ENERGIES, SPECTRA_T, ENERGY_LOOKUP)
   N = SIZE(THRESHOLDS)
   E_MIN = THRESHOLDS(0, 0)
   E_MAX = THRESHOLDS(1, N(2) - 1)
   COLORS = FIX(63*E/(E_MAX - E_MIN))*3 + 1

   TIME_IND = INTARR(10)
   COUNT_SPAN, COMBINED_TIMES, TIME_SPAN, TIME_IND

   ENRG_IND = INTARR(10)
   COUNT_SPAN, COMBINED_ENERGIES, ENERGY_SPAN, ENRG_IND

   N_PLOTS = N_ELEMENTS(ENRG_IND)

   Y_CURVES = R_SPECTRA(*, TIME_IND)
   Y_CURVES = TRANSPOSE(Y_CURVES(ENRG_IND, *))
   DY_CURVES = R_SPECTRA_ERR(*, TIME_IND)
   DY_CURVES = TRANSPOSE(DY_CURVES(ENRG_IND, *))

   IF HAVE_BACK THEN $
      BACK_SUB = 1 $
   ELSE $
      BACK_SUB = 2

   IF HAVE_BACK THEN BEGIN
      BACK_SUB = WIDMENU(['Subtract Background?', 'Yes', 'No'], TITLE = 0)
   ENDIF

   D_TIME = FLTARR(N_ELEMENTS(TIME_IND))
   D_TIME = TRANSPOSE(COMBINED_TIMES(1, TIME_IND) - $
                      COMBINED_TIMES(0, TIME_IND))
   D_ENRG = FLTARR(N_PLOTS)
   D_ENRG = TRANSPOSE(COMBINED_ENERGIES(1, ENRG_IND) - $
                      COMBINED_ENERGIES(0,ENRG_IND))

   IF BACK_SUB EQ 1 THEN BEGIN       ; Create background-subtracted histories.
      T_BEG = TRANSPOSE(COMBINED_TIMES(0, TIME_IND))     
      T_END = TRANSPOSE(COMBINED_TIMES(1, TIME_IND))
      NUM_TIMES = LONG(N_ELEMENTS(TIME_IND))
      IF WGSP_NO_MFIT THEN BEGIN
         BACK_SPECS = TRANSPOSE(BACK_EVAL_MODEL(T_BEG, T_END))
      ENDIF ELSE BEGIN
         BACK_SPECS = FLTARR(NUM_TIMES, MAX_CHAN)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MODEL', NUM_TIMES, $
               T_BEG, T_END, BACK_SPECS)
         BACK_SPECS = TRANSPOSE(BACK_SPECS)
      ENDELSE

      IF WGSP_NO_MFIT THEN BEGIN
         BACK_ERR_SPECS = TRANSPOSE(BACK_EVAL_MSIG(T_BEG, T_END))
      ENDIF ELSE BEGIN
         BACK_ERR_SPECS = FLTARR(NUM_TIMES, MAX_CHAN)
         AFUNC = FLTARR(5, NUM_TIMES)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MSIG', NUM_TIMES, $
               T_BEG, T_END, AFUNC, BACK_ERR_SPECS)
         BACK_ERR_SPECS = TRANSPOSE(BACK_ERR_SPECS)
      ENDELSE

      FOR JJ = 0, NUM_TIMES - 1 DO BEGIN                 ; Loop over time.
         COMBINE, BACK_SPECS(*, JJ), $                   ; Combine over energy.
                  BACK_ERR_SPECS(*, JJ), THRESHOLDS, $
                  ENERGY_LOOKUP, B_SPEC, B_ERR, B_THRES
         ERR_TEMP = B_ERR(ENRG_IND) * D_ENRG
         ; RMS the errors: Spectra are weighted by 'livetimes'.
         ; Background errors are already weighted, just square them.
         DY_CURVES(JJ, *) = SQRT(Y_CURVES(JJ, *) / D_TIME(JJ) * D_ENRG + $
                            ERR_TEMP * ERR_TEMP) / D_ENRG
         Y_CURVES(JJ, *) = Y_CURVES(JJ, *) - B_SPEC(ENRG_IND)  ; Subtract.
         ENDFOR
      ENDIF

   PLOT_POSITIONS = FLTARR(N_PLOTS)
   HISTORY_TITLE = STRARR(N_PLOTS)

   STACK_PLOTS, N_PLOTS, PAGE_POSITION, PLOT_POSITIONS, TIME_SPAN, $
                 Y_CURVES, DY_CURVES, COMBINED_TIMES, COMBINED_ENERGIES, $
                 TIME_IND, ENRG_IND, 0, RATE_SCALE, X_TITLE, Y_TITLE, $
                 1, ' keV', TYPE, HISTORY_TITLE

      OPTIONS_MENU = ['Stacked Histories', $
                      'EXIT', $
                      'Create Hardcopy: Stacked Histories', $
                      'Ratio', $
                      'Display History', $
                      'Create Hardcopy: Processed History', $
                      'Zoom In Processed History', $
                      'Zoom Out Processed History: Full Range']

      OPTION = WIDMENU(OPTIONS_MENU(0:N_ELEMENTS(OPTIONS_MENU)-4), TITLE = 0)
      RATIO_SELECTED = 0
      PLOTTING = 0
      X_RANGE = TIME_SPAN(0, *)
      WHILE OPTIONS_MENU(OPTION) NE 'EXIT' DO BEGIN
         IF OPTIONS_MENU(OPTION) EQ $
            'Create Hardcopy: Stacked Histories' THEN BEGIN
            HC_INFORM, 'Creating hardcopy: Stacked Histories.'
            OPEN_PLOT, CURRENT_DEVICE
            STACK_PLOTS, N_PLOTS, PAGE_POSITION, PLOT_POSITIONS, TIME_SPAN, $
                 Y_CURVES, DY_CURVES, COMBINED_TIMES, COMBINED_ENERGIES, $
                 TIME_IND, ENRG_IND, 0, RATE_SCALE, X_TITLE, Y_TITLE, $
                 1, ' keV', TYPE, HISTORY_TITLE
            CLOSE_PLOT, CURRENT_DEVICE
            HC_INFORM, ''
         ENDIF
         IF OPTIONS_MENU(OPTION) EQ 'Ratio' THEN BEGIN
            RATIO_SELECTED = 1
            WIDGET_CONTROL, WIDS.HC_DRAW, SHOW = 1
            WIDGET_CONTROL, WIDS.HC_DRAW, GET_VALUE = PLOT_WINDOW
            WSET, PLOT_WINDOW
            HC_INFORM, 'Click on a history.'
PICKED_SAME_HIST:
            CURSOR, X, Y, /DOWN, /NORM
            HC_INFORM, ''
            PLOT1 = SEARCH(PLOT_POSITIONS, Y)
            IF PLOT1 EQ -1 THEN GOTO, DONE

            HC_INFORM, 'Click on a second history.'
            CURSOR, X, Y, /DOWN, /NORM
            HC_INFORM, ''
            PLOT2 = SEARCH(PLOT_POSITIONS, Y)
            IF PLOT2 EQ -1 THEN GOTO, DONE

            Y1 = Y_CURVES(*, PLOT1) * D_ENRG(PLOT1)
            Y2 = Y_CURVES(*, PLOT2) * D_ENRG(PLOT2)
            DY1 = DY_CURVES(*, PLOT1) * D_ENRG(PLOT1)
            DY2 = DY_CURVES(*, PLOT2) * D_ENRG(PLOT2)

            X_PH_DATA = COMBINED_TIMES(*, TIME_IND)
            Y_PH_DATA = Y1/Y2
            DY_PH_DATA = Y_PH_DATA * SQRT((DY1 * DY1) / (Y1 * Y1) + $
                                          (DY2 * DY2) / (Y2 * Y2))
            IF TOTAL(Y_PH_DATA) / N_ELEMENTS(Y_PH_DATA) EQ 1.0 THEN BEGIN
               HC_INFORM, 'Ratio is one for same history.  Click on a history.'
               GOTO, PICKED_SAME_HIST
            ENDIF

            IF N_ELEMENTS(PROCESSED_HISTORY) EQ 0 THEN BEGIN
               PROCESSED_HISTORY = 4
               WINDOW, PROCESSED_HISTORY, TITLE = 'Processed History', $
                       YSIZE = CURRENT_SCREEN(1)*0.4, RETAIN = CV_IDL_RETAIN
            ENDIF $
            ELSE BEGIN
               IF PROCESSED_HISTORY EQ 0 THEN BEGIN
                  PROCESSED_HISTORY = 4
                  WINDOW, PROCESSED_HISTORY, TITLE = 'Processed History', $
                          YSIZE = CURRENT_SCREEN(1)*0.4, RETAIN = CV_IDL_RETAIN
               ENDIF
               WSET, PROCESSED_HISTORY
               WSHOW, PROCESSED_HISTORY
            ENDELSE

            X_PH_TITLE = X_TITLE
            Y_PH_TITLE = 'Ratio of Time Histories'
            PH_TITLE = 'Ratio ' + HISTORY_TITLE(PLOT1) + ' / ' + $
                       HISTORY_TITLE(PLOT2)

            Y_RANGE = [MIN(Y_PH_DATA), MAX(Y_PH_DATA)]
            X_RANGE = TIME_SPAN(0, *)
            PLOT, X_RANGE, Y_RANGE, XTITLE = X_PH_TITLE, $
              YTITLE = Y_PH_TITLE, TITLE = PH_TITLE, /NODATA, YTYPE = RATE_SCALE

            NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA
            SAVE_POS = !P.POSITION
         ENDIF
         IF (OPTIONS_MENU(OPTION) EQ 'Create Hardcopy: Processed History') AND $
            RATIO_SELECTED THEN BEGIN
            HC_INFORM, 'Creating hardcopy: Processed History.'
            PLOTTING = 1
            IF PLOTTING THEN BEGIN
               SAVE_POS = !P.POSITION
               !P.POSITION = PAGE_POSITION
               OPEN_PLOT, CURRENT_DEVICE
            ENDIF
            PLOT, X_RANGE, Y_RANGE, XTITLE = X_PH_TITLE, $
              YTITLE = Y_PH_TITLE, TITLE = PH_TITLE, /NODATA, YTYPE = RATE_SCALE

            NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA
            IF PLOTTING THEN BEGIN
               IF NOT CV_SUPPRESS_2ND_LABELS THEN $
                      PLOT_NOTES, PAGE_POSITION, TYPE
               CLOSE_PLOT, CURRENT_DEVICE
               !P.POSITION = SAVE_POS
            ENDIF
            PLOTTING = 0
         ENDIF
         IF (OPTIONS_MENU(OPTION) EQ 'Zoom In Processed History') THEN BEGIN
            HC_INFORM, 'Click on Processed History to Zoom In.'
            WSHOW, PROCESSED_HISTORY
            WSET, PROCESSED_HISTORY
            X_SCALE = 'LINEAR'
            Y_SCALE = READ_MENU(2)
            ZOOMING = 0                               ; Assume we don't zoom out
            BAIL_OUT = TRACK(LO_X, LO_Y, HI_X, HI_Y, X_SCALE, Y_SCALE,/DRAW_BOX)
            IF BAIL_OUT EQ 1 THEN ZOOMING = 2 $       ; EXITed: don't zoom
            ELSE IF BAIL_OUT EQ 2 THEN ZOOMING = 1 $  ; RESET: Zoom out
            ELSE BEGIN
               X_RANGE(0) = LO_X
               X_RANGE(1) = HI_X
               Y_RANGE(0) = LO_Y
               Y_RANGE(1) = HI_Y
               X_RANGE = X_RANGE(SORT(X_RANGE))
               Y_RANGE = Y_RANGE(SORT(Y_RANGE))
               ENDELSE
            IF ZOOMING EQ 1 THEN BEGIN
               X_RANGE = [MIN(X_PH_DATA), MAX(X_PH_DATA)]

               IF RATE_SCALE THEN BEGIN
                  YW = WHERE(Y_PH_DATA GT 0)
                  Y_RANGE = [MIN(Y_PH_DATA(YW)), MAX(Y_PH_DATA + DY_PH_DATA)]
                  ENDIF $
               ELSE BEGIN
                  Y_RANGE = [MIN(Y_PH_DATA - DY_PH_DATA), $
                             MAX(Y_PH_DATA + DY_PH_DATA)]
                  ENDELSE
               ENDIF
            PLOT, X_RANGE, Y_RANGE, XTITLE = X_PH_TITLE, $
                  YTYPE = RATE_SCALE, $
                  YTITLE = Y_PH_TITLE, TITLE = PH_TITLE, $
                  /NODATA, YSTYLE = 16

            NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA
            HC_INFORM, ''
            ENDIF
         IF (OPTIONS_MENU(OPTION) EQ 'Zoom Out Processed History: Full Range') $
            THEN BEGIN
            WSHOW, PROCESSED_HISTORY
            WSET, PROCESSED_HISTORY
            X_RANGE = [MIN(X_PH_DATA), MAX(X_PH_DATA)]
           
            IF RATE_SCALE THEN BEGIN
               YW = WHERE(Y_PH_DATA GT 0)
               Y_RANGE = [MIN(Y_PH_DATA(YW)), MAX(Y_PH_DATA + DY_PH_DATA)]
               ENDIF $
            ELSE BEGIN
               Y_RANGE = [MIN(Y_PH_DATA - DY_PH_DATA), $
                          MAX(Y_PH_DATA + DY_PH_DATA)]
               ENDELSE
            PLOT, X_RANGE, Y_RANGE, XTITLE = X_PH_TITLE, $
                  YTYPE = RATE_SCALE, $
                  YTITLE = Y_PH_TITLE, TITLE = PH_TITLE, $
                  /NODATA, YSTYLE = 16

            NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA
         ENDIF 
         IF (OPTIONS_MENU(OPTION) EQ 'Display History') THEN BEGIN
            WIDGET_CONTROL, WIDS.HC_DRAW, SHOW=1
            WIDGET_CONTROL, WIDS.HC_DRAW, GET_VALUE=PLOT_WINDOW
            WSET, PLOT_WINDOW
            HC_INFORM, 'Click on History.'
            CURSOR, X, Y, /DOWN, /NORM
            HC_INFORM, ''
            PLOT1 = SEARCH(PLOT_POSITIONS, Y)
            IF PLOT1 EQ -1 THEN GOTO, DONE

            Y1 = Y_CURVES(*, PLOT1) ;* D_ENRG(PLOT1)
            DY1 = DY_CURVES(*, PLOT1) ;* D_ENRG(PLOT1)

            X_PH_DATA = COMBINED_TIMES(*, TIME_IND)
            Y_PH_DATA = Y1
            DY_PH_DATA = DY1

            IF N_ELEMENTS(PROCESSED_HISTORY) EQ 0 THEN BEGIN
               PROCESSED_HISTORY = 4
               WINDOW, PROCESSED_HISTORY, TITLE = 'Processed History', $
                       YSIZE = CURRENT_SCREEN(1)*0.4, RETAIN = CV_IDL_RETAIN
            ENDIF $
            ELSE BEGIN
               IF PROCESSED_HISTORY EQ 0 THEN BEGIN
                  PROCESSED_HISTORY = 4
                  WINDOW, PROCESSED_HISTORY, TITLE = 'Processed History', $
                          YSIZE = CURRENT_SCREEN(1)*0.4, RETAIN = CV_IDL_RETAIN
               ENDIF
               WSET, PROCESSED_HISTORY
               WSHOW, PROCESSED_HISTORY
            ENDELSE

            X_PH_TITLE = X_TITLE
            Y_PH_TITLE = 'Counts s!U-1!N keV!U-1!N'
            PH_TITLE = HISTORY_TITLE(PLOT1)

            X_RANGE = TIME_SPAN(0, *)
            Y_RANGE = [MIN(Y_PH_DATA), MAX(Y_PH_DATA)]
            PLOT, X_RANGE, Y_RANGE, XTITLE = X_PH_TITLE, $
              YTITLE = Y_PH_TITLE, TITLE = PH_TITLE, /NODATA, YTYPE = RATE_SCALE

            NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA
            SAVE_POS = !P.POSITION
            RATIO_SELECTED = 1
         ENDIF 

         HC_INFORM, ''
DONE:
         IF NOT CV_SUPPRESS_2ND_LABELS AND PLOTTING THEN $
            PLOT_NOTES, PAGE_POSITION, TYPE
         IF PLOTTING THEN BEGIN
            CLOSE_PLOT, CURRENT_DEVICE
            !P.POSITION = SAVE_POS
         ENDIF

         IF RATIO_SELECTED EQ 1 THEN $
            OPTION = WIDMENU(OPTIONS_MENU, TITLE = 0) $
         ELSE $
            OPTION = WIDMENU(OPTIONS_MENU(0:N_ELEMENTS(OPTIONS_MENU)-4), $
                             TITLE = 0)
         ENDWHILE
   !P.PSYM = SAVE_SYM
   WIDGET_CONTROL, WIDS.HC_BASE, /DESTROY

   ; Reset to the entry (HISTORY) window 
   WIDGET_CONTROL, WIDS.DRAW1, GET_VALUE=HISTORY_WINDOW
   WSET, HISTORY_WINDOW

   IF (N_ELEMENTS(PROCESSED_HISTORY) NE 0) THEN BEGIN
;      WSHOW, PROCESSED_HISTORY, 0
      WDELETE, PROCESSED_HISTORY
      PROCESSED_HISTORY = 0
      ENDIF

   ENDIF $
ELSE IF TYPE EQ 'STACKED SPECTRA' THEN BEGIN
   W_HARDCOPY, 'Burst Spectral History', '     ', /BIG, /NOINQUIRE, /NODONE
   ; This option has hardcopy choices built in to other menus
   STACKED_SPECTRA, PAGE_POSITION, TYPE
   WIDGET_CONTROL, WIDS.HC_BASE, /DESTROY

   ; Reset to the entry (HISTORY) window 
   WIDGET_CONTROL, WIDS.DRAW1, GET_VALUE = HISTORY_WINDOW
   WSET, HISTORY_WINDOW
   ENDIF



END; PRO PLOT_SPECTRA
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO ADJUST_SCALES, E_SCALE, R_SCALE, E_RANGE, R_RANGE, E_SPAN

COMMON MENUS_C, PLOT_FIELDS, PLOT_MENU, PLOT_OPTIONS, PLOT_TYPES, ROTATION

COMMON PROCESSED_C, X_PH_DATA, Y_PH_DATA, DY_PH_DATA, X_PH_TITLE, Y_PH_TITLE, PH_TITLE, $
                    X_PS_DATA, Y_PS_DATA, X_PS_TITLE, Y_PS_TITLE, PS_TITLE, $
                    DY_PS_DATA, FLAT_INDEX

R_SCALE = READ_MENU(2) EQ 'LOG'
E_SCALE = READ_MENU(1) EQ 'LOG'

YW = WHERE(Y_PS_DATA GT 0)
Y_RANGE = [MIN(Y_PS_DATA(YW) + DY_PS_DATA(YW)), $
           MAX(Y_PS_DATA + DY_PS_DATA)]
IF R_SCALE THEN $
   IF R_RANGE(0) LE 0 THEN R_RANGE = Y_RANGE
IF E_SCALE THEN BEGIN
   XW = WHERE(X_PS_DATA GT 0)
   X_RANGE = [MIN(X_PS_DATA(XW)), MAX(X_PS_DATA)]
   IF E_RANGE(0) LE 0 THEN E_RANGE = X_RANGE
   ENDIF $
ELSE $
   X_RANGE = [MIN(X_PS_DATA), MAX(X_PS_DATA)]

IF YW(0) EQ -1 THEN BEGIN
   R_SCALE = 0
   Y_RANGE = [MIN(Y_PS_DATA - DY_PS_DATA), $
              MAX(Y_PS_DATA + DY_PS_DATA)]
   ENDIF

XR = !X.CRANGE
IF E_SCALE THEN XR = 10^XR
IF (X_RANGE(0) GE XR(1)) OR (X_RANGE(1) LE XR(0)) THEN BEGIN
   E_RANGE = X_RANGE
   ENDIF

YR = !Y.CRANGE
IF R_SCALE THEN YR = 10^YR
IF (Y_RANGE(0) GE YR(1)) OR (Y_RANGE(1) LE YR(0)) THEN BEGIN
   R_RANGE = Y_RANGE
   IF E_SCALE AND (E_SPAN(0,0) LE 0) THEN $
       E_RANGE(0) = E_SPAN(0,1)/100 
   ENDIF



END; PRO ADJUST_SCALES
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO STACKED_SPECTRA, THE_PP, TH_TYPE

@wgsp_cb.pro


PH_TITLE = 0                     ; Set 'flag' to indicate overplot mode.
; First time through, initialize variables in MFIT_SUPER.
IF N_ELEMENTS(HAVE_INITTED) EQ 0 THEN BEGIN
   HAVE_INITTED = LONG(0)
   HAVE_DRM = LONG(0)
ENDIF

X_TITLE = READ_MENU(4)
Y_TITLE = READ_MENU(5)
RATE_SCALE   = READ_MENU(2) EQ 'LOG'
ENERGY_SCALE = READ_MENU(1) EQ 'LOG'

; Save variables we are passing in from COMMON:
RATE_SAVE = RATE_RANGE
HIST_SAVE = HIST_RANGE
ENRG_SAVE = ENERGY_RANGE
SAVE_SYM = !P.PSYM
!P.PSYM = 0

TIME_IND = INTARR(10)
COUNT_SPAN, COMBINED_TIMES, TIME_SPAN, TIME_IND

ENRG_IND = INTARR(10)
COUNT_SPAN, COMBINED_ENERGIES, ENERGY_SPAN, ENRG_IND

E_AVG = AVERAGE(ENERGIES, SPECTRA_T, ENERGY_LOOKUP)
E_AVG = E_AVG(ENRG_IND)

N_PLOTS = N_ELEMENTS(TIME_IND)

Y_CURVES = R_SPECTRA(ENRG_IND, *)
Y_CURVES = Y_CURVES(*, TIME_IND)
DY_CURVES = R_SPECTRA_ERR(ENRG_IND, *)
DY_CURVES = DY_CURVES(*, TIME_IND)

; We need to skip all of the menu-driven stuff when STACKED_SPECTRA is called
;  for the purpose of producing a hardcopy of the 'SPECTRAL HISTORY' window.
IF HAVE_BACK THEN $
   FLAT_INDEX = WIDMENU(['Rate', 'Rate x Power law', $
                         'Background Subtracted Rate']) $
ELSE $
   FLAT_INDEX = WIDMENU(['Rate', 'Rate x Power law']) 

IF FLAT_INDEX EQ 2 THEN BEGIN
   IF HAVE_BACK THEN BEGIN
      N_EBINS = N_ELEMENTS(ENRG_IND) - 1

      ; Beginning and end times of stacked plots.
      T_BEG = TRANSPOSE(COMBINED_TIMES(0, TIME_IND))
      T_END = TRANSPOSE(COMBINED_TIMES(1, TIME_IND))

      ; Calculate the background model for each plot.
      NUM_TIMES = LONG(N_ELEMENTS(TIME_IND))
      IF WGSP_NO_MFIT THEN BEGIN
         BACK_SPECS = TRANSPOSE(BACK_EVAL_MODEL(T_BEG, T_END))
      ENDIF ELSE BEGIN
         BACK_SPECS = FLTARR(NUM_TIMES, MAX_CHAN)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MODEL', NUM_TIMES, $
                             T_BEG, T_END, BACK_SPECS)
         BACK_SPECS = TRANSPOSE(BACK_SPECS)
      ENDELSE

      IF WGSP_NO_MFIT THEN BEGIN
         BACK_SPEC_ERRS = TRANSPOSE(BACK_EVAL_MSIG(T_BEG, T_END))
      ENDIF ELSE BEGIN
         BACK_ERR_SPECS = FLTARR(NUM_TIMES, MAX_CHAN)
         AFUNC = FLTARR(5, NUM_TIMES)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MSIG', NUM_TIMES, $
                             T_BEG, T_END, AFUNC, BACK_ERR_SPECS)
         BACK_SPEC_ERRS = TRANSPOSE(BACK_ERR_SPECS)
      ENDELSE

      ; 'Livetime' for each spectrum.
      D_TIME = TRANSPOSE(COMBINED_TIMES(1, TIME_IND) - $
                         COMBINED_TIMES(0, TIME_IND))

      ; Width of each energy bin.
      D_ENRG = TRANSPOSE(COMBINED_ENERGIES(1, ENRG_IND) - $
                         COMBINED_ENERGIES(0,ENRG_IND))

      BAD_IND = WHERE(D_ENRG LE 0.0)
      IF BAD_IND NE -1 THEN D_ENRG(BAD_IND) = 0.1        ; Handle bad thresholds

      FOR JJ = 0, N_PLOTS - 1 DO BEGIN   ; Loop over selected times

          ; First we combine spec & errs over energy binning.
          COMBINE, BACK_SPECS(*, JJ), $ 
                   BACK_SPEC_ERRS(*, JJ), THRESHOLDS, $
                   ENERGY_LOOKUP, B_SPEC, B_ERR, B_THRES
          NEG_IND = WHERE(B_SPEC LE 0.0)  
          IF NEG_IND(0) NE -1 THEN BEGIN
             B_SPEC(NEG_IND) = 0.0        ; For negative background model in
             B_ERR(NEG_IND) = 0.0         ; channels below the LLD.
          ENDIF

          ; RMS the errors: Spectra are weighted by 'livetimes'.
          ; Background errors are already weighted, just square them.
          ERR_TEMP = B_ERR(ENRG_IND) 
          DY_CURVES(*, JJ) = SQRT(Y_CURVES(*, JJ) / (D_TIME(JJ) * D_ENRG) + $
                                  ERR_TEMP * ERR_TEMP) 
          Y_CURVES(*, JJ) = Y_CURVES(*, JJ) - B_SPEC(ENRG_IND)

          IF BAD_IND(0) NE -1 THEN BEGIN     ; Here we handle problems in C->E
             Y_CURVES(BAD_IND, JJ) = 0.0     ;conversion: zero or neg. width
             DY_CURVES(BAD_IND, JJ) = 0.0    ;energy bins.
          ENDIF
      ENDFOR
   ENDIF 
ENDIF

INDICES = STRMID(STRTRIM(STRING(FINDGEN(39)/10 + 1.1), 2), 0, 3)
IF (FLAT_INDEX EQ 1) THEN BEGIN
   INDEX = WIDMENU(['Spectral index', INDICES, 'EXIT'], TITLE = 0, /SCROLL)
   IF INDEX EQ 40 THEN GOTO, DRAW_SH
   SPECTRAL_INDEX = (INDEX - 1)*0.1 + 1.1
   E_MAX = FIX(!X.CRANGE(1) + !X.CRANGE(0)) / 2
   IF ENERGY_SCALE THEN E_MAX = 10 ^ E_MAX
   FLAT = (E_AVG/E_MAX)^SPECTRAL_INDEX
   FOR I = 0, N_PLOTS - 1 DO BEGIN
       Y_CURVES(*, I) = Y_CURVES(*, I)*FLAT
       DY_CURVES(*, I) = DY_CURVES(*, I)*FLAT
   ENDFOR
   E_MAX = STRING(E_MAX + 0.5)
   E_MAX = STRTRIM(STRMID(E_MAX, 0, STRPOS(E_MAX, '.')), 2)
   Y_TITLE = 'Rate !9X!X (E/' + E_MAX + ')!U' + INDICES(INDEX-1) + '!N'
   Y_TITLE = Y_TITLE + ' (Counts sec!U-1!N keV!U-1!N)'
ENDIF

DRAW_SH:
   
PLOT_POSITIONS = FLTARR(N_PLOTS)
SPEC_TITLE = STRARR(N_PLOTS)

STACK_PLOTS, N_PLOTS, THE_PP, PLOT_POSITIONS, ENERGY_SPAN, $
             Y_CURVES, DY_CURVES, COMBINED_ENERGIES, COMBINED_TIMES, $
             ENRG_IND, TIME_IND, ENERGY_SCALE, RATE_SCALE, X_TITLE, Y_TITLE, $
             1, ' s', TH_TYPE, SPEC_TITLE

; We need to skip all of the menu-driven stuff when STACKED_SPECTRA is called
;  for the purpose of producing a hardcopy of the 'SPECTRAL HISTORY' window.
N_ANNOTES = 0
HAVE_APLOT = 0
IF FLAT_INDEX EQ 2 THEN $
   OPTIONS_MENU = ['Stacked Spectra:', 'EXIT', $
                   'Create Hardcopy: Stacked Spectra', $
                   'Difference', 'Flatten', 'Display Spectrum', $
                   'Display Background'] $
ELSE $
   OPTIONS_MENU = ['Stacked Spectra:', 'EXIT', $
                   'Create Hardcopy: Stacked Spectra', $
                   'Difference', 'Flatten', 'Display Spectrum']

OPTIONAL_MENU = [OPTIONS_MENU, $
                 'Create Hardcopy: Spectral Results', $
                 'Zoom In Spectral Results', $
                 'Zoom Out Spectral Results: Full Range'] 

OPTION = WIDMENU(OPTIONS_MENU, TITLE = 0)
WHILE OPTIONS_MENU(OPTION) NE 'EXIT' DO BEGIN
      IF (OPTIONS_MENU(OPTION) EQ 'Create Hardcopy: Stacked Spectra') THEN BEGIN
         HC_INFORM, 'Creating hardcopy: Stacked Spectra.'
         OPEN_PLOT, CURRENT_DEVICE
              STACK_PLOTS, N_PLOTS, THE_PP, PLOT_POSITIONS, ENERGY_SPAN, $
                   Y_CURVES, DY_CURVES, COMBINED_ENERGIES, COMBINED_TIMES, $
                   ENRG_IND, TIME_IND, ENERGY_SCALE, RATE_SCALE, $
                   X_TITLE, Y_TITLE, 1, ' s', TH_TYPE, SPEC_TITLE
         CLOSE_PLOT, CURRENT_DEVICE
         HC_INFORM, ''
      ENDIF $
      ELSE IF (OPTIONS_MENU(OPTION) EQ $
              'Create Hardcopy: Spectral Results') THEN BEGIN
              HC_INFORM, 'Creating hardcopy: Spectral Results.'
              IF N_ELEMENTS(PROCESSED_SPECTRUM) NE 0 THEN BEGIN
                 HARD_COPY, ENERGY_RANGE, RATE_RANGE, ENERGY_SCALE, $
                            RATE_SCALE, THE_PP, 'STACKED SPECTRA'
              ENDIF
              HC_INFORM, ''
           ENDIF $
      ELSE IF (OPTIONS_MENU(OPTION) EQ 'Zoom In Spectral Results') THEN BEGIN
              HC_INFORM, 'Click on Spectral Results to Zoom In.'
              IF N_ELEMENTS(PROCESSED_SPECTRUM) NE 0 THEN BEGIN
                 ZOOM_BAR, ENERGY_SCALE, RATE_SCALE, /IN, /SPEC
              ENDIF
              HC_INFORM, ''
           ENDIF $
      ELSE IF (OPTIONS_MENU(OPTION) EQ 'Zoom Out Spectral Results: Full Range')$
              THEN BEGIN
              IF N_ELEMENTS(PROCESSED_SPECTRUM) NE 0 THEN BEGIN
                 ZOOM_BAR, ENERGY_SCALE, RATE_SCALE, /OUT, /SPEC
              ENDIF
           ENDIF $
      ELSE BEGIN
           WIDGET_CONTROL, WIDS.HC_DRAW, GET_VALUE = PLOT_WINDOW
           WIDGET_CONTROL, WIDS.HC_BASE, SHOW = 1
           WSET, PLOT_WINDOW
           IF N_PLOTS GT 1 THEN BEGIN    ; Pick which spectrum to work with:
              HC_INFORM, 'Click on a spectrum.'
PICKED_SAME_SPEC:
              CURSOR, X, Y, /DOWN, /NORM
              HC_INFORM, ''
              PLOT1 = SEARCH(PLOT_POSITIONS, Y)
           ENDIF $
           ELSE BEGIN                    ; Only one spectrum, no need to click
              PLOT1 = 0
           ENDELSE

           IF PLOT1 EQ -1 THEN GOTO, DONE_S
           Y1 = Y_CURVES(*, PLOT1) 
           DY1 = DY_CURVES(*, PLOT1) 

           IF (OPTIONS_MENU(OPTION) EQ 'Flatten') THEN BEGIN
              HC_INFORM, 'Select an index.'
              E_MAX = FIX(!X.CRANGE(1) + !X.CRANGE(0)) / 2
              IF ENERGY_SCALE THEN E_MAX = 10 ^ E_MAX
              INDEX = WIDMENU(['Spectral index', INDICES, 'EXIT'], $
                               TITLE = 0, /SCROLL)
              HC_INFORM, ''
              IF INDEX EQ 40 THEN GOTO, DONE_S
              SPECTRAL_INDEX = (INDEX - 1)*0.1 + 1.1
         
              FLAT = (E_AVG/E_MAX)^SPECTRAL_INDEX
              X_PS_DATA = COMBINED_ENERGIES(*, ENRG_IND)
              Y_PS_DATA = Y1*FLAT
              DY_PS_DATA = DY1*FLAT
           
              E_MAX = STRING(E_MAX + 0.5)
              E_MAX = STRTRIM(STRMID(E_MAX, 0, STRPOS(E_MAX, '.')), 2)
              X_PS_TITLE = X_TITLE
              Y_PS_TITLE = 'Rate !9X!X (E/' + E_MAX + ')!U' + $
                            INDICES(INDEX-1) + $
                            '!N' + ' (Counts sec!U-1!N keV!U-1!N)'
              PS_TITLE = 'Flattened spectrum (' + SPEC_TITLE(PLOT1) + ')'
              ADJUST_SCALES, ENERGY_SCALE, RATE_SCALE, ENERGY_RANGE, $
                             RATE_RANGE, ENERGY_SPAN
           ENDIF $
           ELSE IF (OPTIONS_MENU(OPTION) EQ 'Display Spectrum') THEN BEGIN
                   X_PS_DATA = COMBINED_ENERGIES(*, ENRG_IND)
                   Y_PS_DATA = Y1
                   DY_PS_DATA = DY1
                   X_PS_TITLE = READ_MENU(4)
                   Y_PS_TITLE = READ_MENU(5)
                   PS_TITLE = 'Spectrum (' + SPEC_TITLE(PLOT1) + ')'
                   ADJUST_SCALES, ENERGY_SCALE, RATE_SCALE, ENERGY_RANGE, $
                                  RATE_RANGE, ENERGY_SPAN
                ENDIF $
           ELSE IF (OPTIONS_MENU(OPTION) EQ 'Display Background') THEN BEGIN
                   COMBINE, BACK_SPECS(*, PLOT1), $ 
                            BACK_SPEC_ERRS(*, PLOT1), THRESHOLDS, $
                            ENERGY_LOOKUP, B_SPEC, B_ERR, B_THRES
                   NEG_IND = WHERE(B_SPEC LE 0.0)  
                   IF NEG_IND(0) NE -1 THEN BEGIN
                      B_SPEC(NEG_IND) = 0.0   ; For negative background model in
                      B_ERR(NEG_IND) = 0.0    ; channels below the LLD.
                   ENDIF

                   ;*_PS_DATA arrays store info for later plotting and hardcopy.
                   X_PS_DATA = COMBINED_ENERGIES(*, ENRG_IND)
                   Y_PS_DATA = B_SPEC(ENRG_IND)
                   DY_PS_DATA = B_ERR(ENRG_IND)
                   X_PS_TITLE = READ_MENU(4)
                   Y_PS_TITLE = READ_MENU(5)
                   PS_TITLE = 'Background (' + SPEC_TITLE(PLOT1) + ')'

                   ; Reset the plot window in case the data are out of view.
                   ADJUST_SCALES, ENERGY_SCALE, RATE_SCALE, ENERGY_RANGE, $
                                  RATE_RANGE, ENERGY_SPAN
                ENDIF $              
           ELSE IF (OPTIONS_MENU(OPTION) EQ 'Difference') THEN BEGIN
                    HC_INFORM, 'Click on a second spectrum.'
                    CURSOR, X, Y, /DOWN, /NORM
                    HC_INFORM, ''
                    PLOT2 = SEARCH(PLOT_POSITIONS, Y)
                    IF PLOT2 EQ -1 THEN GOTO, DONE_S
                    Y2 = Y_CURVES(*, PLOT2) 
                    DY2 = DY_CURVES(*, PLOT2) 
         
                    X_PS_DATA = COMBINED_ENERGIES(*, ENRG_IND)
                    Y_PS_DATA = Y1 - Y2
                    IF TOTAL(WHERE(Y_PS_DATA GT 0.0)) EQ -1 THEN BEGIN
                       Y_PS_DATA = Y2 - Y1
                       IF TOTAL(WHERE(Y_PS_DATA GT 0.0)) EQ -1 THEN BEGIN
                          HC_INFORM, 'Difference less than zero.  Invalid selection.'  
                          GOTO, DONE_S
                       ENDIF
                    ENDIF
                    IF TOTAL(Y_PS_DATA) EQ 0.0 THEN BEGIN
                       HC_INFORM, 'Difference for same spectrum is zero. Click on a spectrum.'
                       GOTO, PICKED_SAME_SPEC
                    ENDIF
                    DY_PS_DATA = SQRT(DY1*DY1 + DY2*DY2)
                    X_PS_TITLE = READ_MENU(4)
                    Y_PS_TITLE = READ_MENU(5)
                    PS_TITLE = 'Difference (' + SPEC_TITLE(PLOT1) + ') - (' + $
                               SPEC_TITLE(PLOT2) + ')'
                    ADJUST_SCALES, ENERGY_SCALE, RATE_SCALE, ENERGY_RANGE, $
                                   RATE_RANGE, ENERGY_SPAN
                 ENDIF

                 IF N_ELEMENTS(PROCESSED_SPECTRUM) EQ 0 THEN BEGIN
                    PROCESSED_SPECTRUM = 5
                    WINDOW, PROCESSED_SPECTRUM, TITLE = 'Spectral Results', $
                            YSIZE = CURRENT_SCREEN(1)*0.4, RETAIN=CV_IDL_RETAIN
                 ENDIF $
                 ELSE BEGIN
                   IF PROCESSED_SPECTRUM NE 5 THEN BEGIN
                     PROCESSED_SPECTRUM = 5
                     WINDOW, PROCESSED_SPECTRUM, TITLE = 'Spectral Results', $
                             YSIZE = CURRENT_SCREEN(1)*0.4, RETAIN=CV_IDL_RETAIN
                   ENDIF
                   WSET, PROCESSED_SPECTRUM
                   WSHOW, PROCESSED_SPECTRUM
                 ENDELSE
         
                 PLOT, ENERGY_RANGE, RATE_RANGE, XTITLE = X_PS_TITLE, $
                       XTYPE = ENERGY_SCALE, YTYPE = RATE_SCALE, $
                       YTITLE = Y_PS_TITLE, TITLE = PS_TITLE, $
                       CHARSIZE = 1.25, /NODATA
                 PLOT_POINTS, X_PS_DATA, Y_PS_DATA, DY_PS_DATA
       
                 OPTIONS_MENU = OPTIONAL_MENU

      ENDELSE  ; Skip cursor down opts

DONE_S:  
      OPTION = WIDMENU(OPTIONS_MENU, TITLE = 0)
ENDWHILE                                        ;OPTIONS_MENU(OPTION)

RATE_RANGE = RATE_SAVE
HIST_RANGE = HIST_SAVE
ENERGY_RANGE = ENRG_SAVE

IF N_ELEMENTS(PROCESSED_SPECTRUM) NE 0 THEN BEGIN
;   WSHOW, PROCESSED_SPECTRUM, 0
   WDELETE, PROCESSED_SPECTRUM
   PROCESSED_SPECTRUM = 0
   ENDIF

!P.PSYM = SAVE_SYM



END; PRO STACKED_SPECTRA
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO WRITE_SPEC, T_INDEX, DATA_TITLE, DATA_COMMENT, PA_POS, IO_E, $
                BUTTON_COMMAND, STUFF = ST

@wgsp_cb.pro


DATA_FILENAME = READ_MENU(6)
BREAK_FILE, DATA_FILENAME, DATA_FDEV, DATA_FDIR, DATA_FNAME, DATA_FEXT, $
            DATA_FVER
STRING_FILE_NAME = STRING(REPLICATE(32B, 70))
DATA_FILENAME = DATA_FNAME + DATA_FEXT
STRPUT, STRING_FILE_NAME, DATA_FILENAME
LOOKUP_FILE   = READ_MENU(7)

IF HAVE_INITTED THEN BEGIN            ; Initted, so check if DRMs are valid
   TEMP_DATA_NAME = DATA_FILE_NAME(CDET)
   IF (DATA_FILENAME EQ STRTRIM(TEMP_DATA_NAME, 2)) THEN BEGIN
      HAVE_DRM = LONG(1)              ; Data file name has not changed
      NEW_DRM = LONG(0)               ; So we don't need a new DRM
   ENDIF $
   ELSE BEGIN
      HAVE_DRM = LONG(0)              ; DRM has changed, get a new one
      NEW_DATA = LONG(1)              ; Just in case....  
   ENDELSE
ENDIF $
ELSE BEGIN                            ; Must initialize MFIT variables
   INIT_VARS
   HAVE_INITTED = LONG(1)             ; MFIT vars intitialized
   HAVE_DRM = LONG(0)                 ; DRM not valid, get a new one
ENDELSE

IO_E = 0
IF (NOT HAVE_DRM) THEN BEGIN          ; Get a new DRM file

   ; Get the FITS data file name and use it to construct the DRM filename
   BREAK_FILE, CURRENT_VALUES(6), FDEV, FDIR, FNAME, FEXT, FVER

   ; Check to see if the user has supplied a path in WGSP_DRM
   BREAK_FILE, WGSP_DRM, DDEV, DDIR, DNAME, DEXT, DVER
   IF DDIR NE '' THEN BEGIN
      UPATH   = DDEV + DDIR
      UFILTER = DNAME + DEXT + DVER
   ENDIF ELSE BEGIN
      STAR = STRPOS(WGSP_DRM, '*')
      IF STAR NE -1 THEN BEGIN
         UPATH = FDEV + FDIR 
         UFILTER = STRMID(WGSP_DRM, STAR + 1, 999)
      ENDIF ELSE BEGIN
         UPATH = FDEV + FDIR 
         UFILTER = WGSP_DRM
      ENDELSE
   ENDELSE

   ; Try to find the file automatically based on FITS data file path
   ;  and WGSP_DRM
   DRM_SPEC = UPATH + FNAME + UFILTER
   DRM_TRY = DRM_SPEC
   FILENAME = FINDFILE(DRM_TRY, COUNT = COUNT1)
   FILENAME = FILENAME(0) 

   IF COUNT1 EQ 0 THEN BEGIN
      ; Try to find the file automatically based on WGSP_SCRATCH
      DRM_SPEC = WGSP_SCRATCH + FNAME + UFILTER 
      DRM_TRY = DRM_SPEC 
      FILENAME = FINDFILE(DRM_TRY, COUNT = COUNT2)
      FILENAME = FILENAME(0) 

      IF COUNT2 EQ 0 THEN BEGIN
         DEFAULT_FILE = WGSP_SOURCE + $
                        STRLOWCASE('HER_HERB_143_6_SUMMAT.FITS')
         FILENAME = PICKFILE(FILTER = WGSP_DRM, PATH = UPATH, $
                             TITLE = 'Select a DRM File to Read.', $
                             FILE = DEFAULT_FILE, /NOCONFIRM)
         IF FILENAME EQ '' THEN BEGIN
            MFIT_INFORM, 'File not found.  Ready.'
            RETURN
         ENDIF
      ENDIF      ; COUNT2
   ENDIF         ; COUNT1

   BREAK_FILE, FILENAME, DRM_DEV, DRM_DIR, DRM_NAME, DRM_EXT, DRM_VERSION
   READ_DRM, FILENAME, IO_E, /FITS      ; DRM is a FITS file

   IF (IO_E NE 0) THEN BEGIN
      PRINT, !ERR_STRING
      HAVE_DRM = LONG(0)
      HAVE_INITTED = LONG(0)
      RETURN
   ENDIF
   HAVE_DRM = LONG(1)
   NEW_DRM  = LONG(1)                  ; We have a new DRM
ENDIF

NUM_TIMES = LONG(N_ELEMENTS(T_INDEX))
PLOT_RANGE = FLTARR(2, NUM_TIMES)
PLOT_RANGE(0, *) = TIME_LOOKUP(T_INDEX)
PLOT_RANGE(1, *) = TIME_LOOKUP(T_INDEX + 1) - 1

; The 'SPECTRAL HISTORY' plots show the data binned in time and energy. MFIT
;  doesn't accept data binned in energy, so recreate the integration over
;  time. PLOT_RANGE has the selected plots, REINTEGRATE returns P_SPECTRUM and
;  P_ERRORS and  the total livetime, DP_TIME.
REINTEGRATE, PLOT_RANGE, P_SPECTRUM, P_ERRORS, DP_TIME

LAST_DATA = N_ELEMENTS(P_SPECTRUM)
THE_WIDTH = TRANSPOSE(THRESHOLDS(1, *) - THRESHOLDS(0, *))

; Handle cases where we have unphysical energy thresholds: negative widths.
W_IND = WHERE(THE_WIDTH LE 0.0)
IF W_IND(0) NE -1 THEN $
   THE_WIDTH(WHERE(THE_WIDTH LE 0.0)) = 0.1

FIRST_CHAN_DATA = LONG(0)                       
LAST_CHAN_DATA = LONG(LAST_DATA) - 1            

NCHAN = NUM_CHAN(CDET)

IF LAST_CHAN_DATA GT NCHAN THEN BEGIN
   PRINT, 'Wrong offset found in the energy array!'
   IO_E = -1
   RETURN
   ENDIF 

OBS_CRATE(FIRST_CHAN_DATA: LAST_CHAN_DATA, CDET) = P_SPECTRUM / THE_WIDTH

YN = 1
; Calculate the background model for each plot.
IF HAVE_BACK THEN BEGIN

   TOT_BACK_TIME = 0.0
   T_BACK_SIG = FLTARR(LAST_CHAN_DATA - FIRST_CHAN_DATA + 1)
   T_BACK_RATE = FLTARR(LAST_CHAN_DATA - FIRST_CHAN_DATA + 1)

   FOR I = 0, NUM_TIMES - 1 DO BEGIN

      TEMP_SPAN = FLTARR(1, 2)
      ; Beginning and end times of stacked plots.
      TEMP_SPAN(0, 0) = TIMES(0, PLOT_RANGE(0, I)) + 1.0E-4
      TEMP_SPAN(0, 1) = TIMES(1, PLOT_RANGE(1, I)) - 1.0E-4
      COUNT_SPAN, TIMES, TEMP_SPAN, TEMP_IND

      NUM_IND = N_ELEMENTS(TEMP_IND)

      T_BEG = TIMES(0, TEMP_IND)
      T_END = TIMES(1, TEMP_IND)

      IF WGSP_NO_MFIT THEN BEGIN
         BACK_SPECS = BACK_EVAL_MODEL(T_BEG, T_END)
      ENDIF ELSE BEGIN
         BACK_SPECS = FLTARR(NUM_IND, MAX_CHAN)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MODEL', NUM_IND, $
                  T_BEG, T_END, BACK_SPECS)
      ENDELSE

      IF WGSP_NO_MFIT THEN BEGIN
         BACK_ERR_SPECS = BACK_EVAL_MSIG(T_BEG, T_END)
      ENDIF ELSE BEGIN
         BACK_ERR_SPECS = FLTARR(NUM_IND, MAX_CHAN)
         AFUNC = FLTARR(5, NUM_IND)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MSIG', NUM_IND, $
                  T_BEG, T_END, AFUNC, BACK_ERR_SPECS)
      ENDELSE

      FOR J = 0, NUM_IND - 1 DO BEGIN
         TEMP_BCRATE = TRANSPOSE(BACK_SPECS(J, FIRST_CHAN_DATA: LAST_CHAN_DATA)) 
;         TEMP_BSIG = TRANSPOSE(BACK_ERR_SPECS(J, FIRST_CHAN_DATA: LAST_CHAN_DATA)) 

         ; Calculate observed livetime
         TEMP_ONESP = SPECTRA(*, TEMP_IND(J))
         TEMP_ONESP = TEMP_ONESP(FIRST_CHAN_DATA: LAST_CHAN_DATA)
         TEMP_ONEBS = SPECTRA_ERRORS(*, TEMP_IND(J))
         TEMP_ONEBS = TEMP_ONEBS(FIRST_CHAN_DATA: LAST_CHAN_DATA)
         NBIND = WHERE(TEMP_ONEBS)
         BLIVE_T = TEMP_ONESP(NBIND) / (TEMP_ONEBS(NBIND) * TEMP_ONEBS(NBIND))
         DBT = TOTAL(BLIVE_T) / N_ELEMENTS(NBIND)

         ; Weight by observed Livetime
         T_BACK_RATE = T_BACK_RATE + TEMP_BCRATE * DBT
         TOT_BACK_TIME = TOT_BACK_TIME + DBT
         ENDFOR
      ENDFOR

   BACK_CRATE(FIRST_CHAN_DATA: LAST_CHAN_DATA, CDET) = T_BACK_RATE / THE_WIDTH $
                                                       / TOT_BACK_TIME 

   IF WGSP_NO_MFIT THEN BEGIN
         BACK_ERR_SPECS = BACK_EVAL_MSIG(TIMES(0, PLOT_RANGE(0, 0)), $
                                         TIMES(1, PLOT_RANGE(1, NUM_TIMES - 1)))
   ENDIF ELSE BEGIN
         TN_TIMES = 1
         MAX_BG_ORDER = 5
         BACK_ERR_SPECS = FLTARR(TN_TIMES, MAX_CHAN)
         AFUNC = REFORM(FLTARR(MAX_BG_ORDER, TN_TIMES), MAX_BG_ORDER, TN_TIMES)
 
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MSIG', $
                  LONG(TN_TIMES), $
                  TIMES(0, PLOT_RANGE(0, 0)), $
                  TIMES(1, PLOT_RANGE(1, NUM_TIMES - 1)), $
                  AFUNC, BACK_ERR_SPECS)
   ENDELSE

   TEMP_BSIG = TRANSPOSE(BACK_ERR_SPECS(0, FIRST_CHAN_DATA: LAST_CHAN_DATA)) 

   BACK_CSIG(FIRST_CHAN_DATA: LAST_CHAN_DATA, CDET) = TEMP_BSIG / THE_WIDTH 

   ENDIF $
ELSE BEGIN
   YN = 1
   IF RUN_MODE NE 'B' THEN BEGIN
      YN = WIDMENU( $
           ['Are you sure you want to fit without background subtraction?', $
                      'Yes', 'No'], TITLE = 0)
   ENDIF
   IF YN THEN BEGIN
      BACK_CRATE(*, CDET) = FLTARR(MAX_CHAN)
      BACK_CSIG(*, CDET) = FLTARR(MAX_CHAN)
   ENDIF $
   ELSE BEGIN
      IO_E = -1
      HAVE_INITTED = LONG(0)             ; MFIT vars NOT intitialized!
      RETURN
   ENDELSE
ENDELSE


; COUNT the number of energy bins in THRESHOLDS SPANned by 
;the selection in ENERGY_SPAN: Returns index array ENERGY_I.
COUNT_SPAN, THRESHOLDS, ENERGY_SPAN, ENERGY_I, COMBINED_ENERGIES

; Mask out deselected bins for MFIT by zeroing livetime:
PICKED = FLTARR(N_ELEMENTS(P_SPECTRUM))
PICKED(*) = 0.0    
PICKED(ENERGY_I) = DP_TIME
LIVE_TIME(FIRST_CHAN_DATA: LAST_CHAN_DATA, CDET) = PICKED

TOPLABEL = STRING(REPLICATE(32B, 70))
STRPUT, TOPLABEL, DATA_TITLE

DATA_FILE_NAME(CDET) = STRING_FILE_NAME            

COMMENT_DATA = STRING(REPLICATE(32B, 80))
STRPUT, COMMENT_DATA, DATA_COMMENT


; Store the lookup table so that MODEL_PLOTTER can combine data for each det.:
STOP_IND = WHERE(ENERGY_LOOKUP EQ NCHAN)
USED_REBIN(CDET) = LONG(STOP_IND(0))
REBIN_CHAN(0: STOP_IND(0), CDET) = ENERGY_LOOKUP

IF KEYWORD_SET(ST) THEN YN = 0     ; Don't call INIT_MFIT when STuffing data.

IF YN EQ 1 THEN BEGIN
   INIT_MFIT, PA_POS, BUTTON_COMMAND
ENDIF




END; PRO WRITE_SPEC
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO SUM_SPEC, T_INDEX, DATA_TITLE, DATA_COMMENT, PA_POS, IO_E, SUM_DET

@wgsp_cb.pro


DATA_FILENAME = READ_MENU(6)
BREAK_FILE, DATA_FILENAME, DATA_FDEV, DATA_FDIR, DATA_FNAME, DATA_FEXT, $
            DATA_FVER
STRING_FILE_NAME = STRING(REPLICATE(32B, 70))
DATA_FILENAME = DATA_FNAME + DATA_FEXT
STRPUT, STRING_FILE_NAME, DATA_FILENAME
LOOKUP_FILE   = READ_MENU(7)

NUM_TIMES = LONG(N_ELEMENTS(T_INDEX))
PLOT_RANGE = FLTARR(2, NUM_TIMES)
PLOT_RANGE(0, *) = TIME_LOOKUP(T_INDEX)
PLOT_RANGE(1, *) = TIME_LOOKUP(T_INDEX + 1) - 1

; The 'SPECTRAL HISTORY' plots show the data binned in time and energy. MFIT
;  doesn't accept data binned in energy, so recreate the integration over
;  time. PLOT_RANGE has the selected plots, REINTEGRATE returns P_SPECTRUM and
;  P_ERRORS and  the total livetime, DP_TIME.
REINTEGRATE, PLOT_RANGE, P_SPECTRUM, P_ERRORS, DP_TIME

LAST_DATA = N_ELEMENTS(P_SPECTRUM)
THE_WIDTH = TRANSPOSE(THRESHOLDS(1, *) - THRESHOLDS(0, *))

; Handle cases where we have unphysical energy thresholds: negative widths.
W_IND = WHERE(THE_WIDTH LE 0.0)
IF W_IND(0) NE -1 THEN $
   THE_WIDTH(WHERE(THE_WIDTH LE 0.0)) = 0.1

FIRST_CHAN_DATA = LONG(0)                       
LAST_CHAN_DATA = LONG(LAST_DATA) - 1            

NCHAN = NUM_CHAN(SUM_DET)

PREV_LIVE = MAX(LIVE_TIME(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET))

IF HAVE_INITTED THEN BEGIN            ; Initted, so check if DRMs are valid
   TEMP_DATA_NAME = DATA_FILE_NAME(SUM_DET)
   IF (DATA_FILENAME EQ STRTRIM(TEMP_DATA_NAME, 2)) THEN BEGIN
      HAVE_DRM = LONG(1)              ; Data file name has not changed
      NEW_DRM = LONG(0)               ; So we don't need a new DRM
   ENDIF $
   ELSE BEGIN
      HAVE_DRM = LONG(0)              ; DRM has changed, get a new one
      NEW_DATA = LONG(1)              ; Just in case....  
   ENDELSE
ENDIF $
ELSE BEGIN                            ; Must initialize MFIT variables
   INIT_VARS
   HAVE_INITTED = LONG(1)             ; MFIT vars intitialized
   HAVE_DRM = LONG(0)                 ; DRM not valid, get a new one
ENDELSE

IO_E = 0
IF (NOT HAVE_DRM) THEN BEGIN          ; Get a new DRM file

   ; Get the FITS data file name and use it to construct the DRM filename
   BREAK_FILE, CURRENT_VALUES(6), FDEV, FDIR, FNAME, FEXT, FVER

   ; Check to see if the user has supplied a path in WGSP_DRM
   BREAK_FILE, WGSP_DRM, DDEV, DDIR, DNAME, DEXT, DVER
   IF DDIR NE '' THEN BEGIN
      UPATH   = DDEV + DDIR
      UFILTER = DNAME + DEXT + DVER
   ENDIF ELSE BEGIN
      STAR = STRPOS(WGSP_DRM, '*')
      IF STAR NE -1 THEN BEGIN
         UPATH = FDEV + FDIR 
         UFILTER = STRMID(WGSP_DRM, STAR + 1, 999)
      ENDIF ELSE BEGIN
         UPATH = FDEV + FDIR 
         UFILTER = WGSP_DRM
      ENDELSE
   ENDELSE

   ; Try to find the file automatically based on FITS data file path
   ;  and WGSP_DRM
   DRM_SPEC = UPATH + FNAME + UFILTER
   DRM_TRY = DRM_SPEC
   FILENAME = FINDFILE(DRM_TRY, COUNT = COUNT1)
   FILENAME = FILENAME(0) 

   IF COUNT1 EQ 0 THEN BEGIN
      ; Try to find the file automatically based on WGSP_SCRATCH
      DRM_SPEC = WGSP_SCRATCH + FNAME + UFILTER 
      DRM_TRY = DRM_SPEC
      FILENAME = FINDFILE(DRM_TRY, COUNT = COUNT2)
      FILENAME = FILENAME(0) 

      IF COUNT2 EQ 0 THEN BEGIN
         DEFAULT_FILE = WGSP_SOURCE + $
                        STRLOWCASE('HER_HERB_143_6_SUMMAT.FITS')
         FILENAME = PICKFILE(FILTER = WGSP_DRM, PATH = UPATH, $
                             TITLE = 'Select a DRM File to Read.', $
                             FILE = DEFAULT_FILE, /NOCONFIRM)
         IF FILENAME EQ '' THEN BEGIN
            MFIT_INFORM, 'File not found.  Ready.'
            RETURN
         ENDIF
      ENDIF      ; COUNT2
   ENDIF         ; COUNT1

   BREAK_FILE, FILENAME, DRM_DEV, DRM_DIR, DRM_NAME, DRM_EXT, DRM_VERSION
   SUM_DRM, FILENAME, PREV_LIVE, DP_TIME, SUM_DET, IO_E ; Sum DRM by livetimes.

   IF (IO_E NE 0) THEN BEGIN
      PRINT, !ERR_STRING
      HAVE_DRM = LONG(0)
      HAVE_INITTED = LONG(0)
      RETURN
   ENDIF
   HAVE_DRM = LONG(1)
   NEW_DRM  = LONG(1)                  ; We have a new DRM
ENDIF

IF LAST_CHAN_DATA GT NCHAN THEN BEGIN
   PRINT, 'Wrong offset found in the energy array!'
   IO_E = -1
   RETURN
   ENDIF 

; Livetime-weight the observed rates:
OBS_CRATE(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) = $
   (OBS_CRATE(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) * PREV_LIVE + $
    P_SPECTRUM / THE_WIDTH * DP_TIME) / (PREV_LIVE + DP_TIME)

YN = 1
; Calculate the background model for each plot.
IF HAVE_BACK THEN BEGIN

   TOT_BACK_TIME = 0.0
   T_BACK_SIG = FLTARR(LAST_CHAN_DATA - FIRST_CHAN_DATA + 1)
   T_BACK_RATE = FLTARR(LAST_CHAN_DATA - FIRST_CHAN_DATA + 1)

   FOR I = 0, NUM_TIMES - 1 DO BEGIN

      TEMP_SPAN = FLTARR(1, 2)
      ; Beginning and end times of stacked plots.
      TEMP_SPAN(0, 0) = TIMES(0, PLOT_RANGE(0, I)) + 1.0E-4
      TEMP_SPAN(0, 1) = TIMES(1, PLOT_RANGE(1, I)) - 1.0E-4
      COUNT_SPAN, TIMES, TEMP_SPAN, TEMP_IND

      NUM_IND = N_ELEMENTS(TEMP_IND)

      T_BEG = TIMES(0, TEMP_IND)
      T_END = TIMES(1, TEMP_IND)

      IF WGSP_NO_MFIT THEN BEGIN
         BACK_SPECS = BACK_EVAL_MODEL(T_BEG, T_END)
      ENDIF ELSE BEGIN
         BACK_SPECS = FLTARR(NUM_IND, MAX_CHAN)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MODEL', NUM_IND, $
                  T_BEG, T_END, BACK_SPECS)
      ENDELSE

      IF WGSP_NO_MFIT THEN BEGIN
         BACK_ERR_SPECS = BACK_EVAL_MSIG(T_BEG, T_END)
      ENDIF ELSE BEGIN
         BACK_ERR_SPECS = FLTARR(NUM_IND, MAX_CHAN)
         AFUNC = FLTARR(5, NUM_IND)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MSIG', NUM_IND, $
                  T_BEG, T_END, AFUNC, BACK_ERR_SPECS)
      ENDELSE

      FOR J = 0, NUM_IND - 1 DO BEGIN
         TEMP_BCRATE = TRANSPOSE(BACK_SPECS(J, FIRST_CHAN_DATA: $
                       LAST_CHAN_DATA)) 

         ; Calculate observed livetime
         TEMP_ONESP = SPECTRA(*, TEMP_IND(J))
         TEMP_ONESP = TEMP_ONESP(FIRST_CHAN_DATA: LAST_CHAN_DATA)
         TEMP_ONEBS = SPECTRA_ERRORS(*, TEMP_IND(J))
         TEMP_ONEBS = TEMP_ONEBS(FIRST_CHAN_DATA: LAST_CHAN_DATA)
         NBIND = WHERE(TEMP_ONEBS)
         BLIVE_T = TEMP_ONESP(NBIND) / (TEMP_ONEBS(NBIND) * TEMP_ONEBS(NBIND))
         DBT = TOTAL(BLIVE_T) / N_ELEMENTS(NBIND)

         ; Weight by observed Livetime
         T_BACK_RATE = T_BACK_RATE + TEMP_BCRATE * DBT
         TOT_BACK_TIME = TOT_BACK_TIME + DBT
         ENDFOR
      ENDFOR

   NONB_ZERO = WHERE(BACK_CSIG(*, SUM_DET) NE 0.0)
   OLD_B_LIVETIME = MAX(BACK_CRATE(NONB_ZERO, SUM_DET) / $
                    BACK_CSIG(NONB_ZERO, SUM_DET)^2)

   ; Livetime-weight the background rates:
   BACK_CRATE(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) = $
      (BACK_CRATE(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) * OLD_B_LIVETIME + $
      T_BACK_RATE / THE_WIDTH) / (TOT_BACK_TIME + OLD_B_LIVETIME)

   IF WGSP_NO_MFIT THEN BEGIN
         BACK_ERR_SPECS = BACK_EVAL_MSIG(TIMES(0, PLOT_RANGE(0, 0)), $
                                         TIMES(1, PLOT_RANGE(1, NUM_TIMES - 1)))
   ENDIF ELSE BEGIN
         BACK_ERR_SPECS = FLTARR(1, MAX_CHAN)
         AFUNC = FLTARR(5, 1)
         STATUS = CALL_EXTERNAL('MFIT_SHARE', 'BACK_EVAL_MSIG', 1, $
                  TIMES(0, PLOT_RANGE(0, 0)), $
                  TIMES(1, PLOT_RANGE(1, NUM_TIMES - 1)), $
                  AFUNC, BACK_ERR_SPECS)
   ENDELSE

   TEMP_BSIG = TRANSPOSE(BACK_ERR_SPECS(0, FIRST_CHAN_DATA: LAST_CHAN_DATA)) 

   ; Livetime-weight the background errors:
   BACK_CSIG(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) = $
       (BACK_CSIG(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) * OLD_B_LIVETIME + $
       TEMP_BSIG / THE_WIDTH * TOT_BACK_TIME) / $
       (OLD_B_LIVETIME + TOT_BACK_TIME)

   ENDIF $
ELSE BEGIN
   YN = 1
   IF RUN_MODE NE 'B' THEN BEGIN
      YN = WIDMENU( $
           ['Are you sure you want to fit without background subtraction?', $
                      'Yes', 'No'], TITLE = 0)
      ENDIF
   IF YN THEN BEGIN
      BACK_CRATE(*, SUM_DET) = FLTARR(MAX_CHAN)
      BACK_CSIG(*, SUM_DET) = FLTARR(MAX_CHAN)
      ENDIF $
   ELSE BEGIN
      IO_E = -1
      HAVE_INITTED = LONG(0)             ; MFIT vars NOT intitialized!
      RETURN
      ENDELSE
   ENDELSE

; COUNT the number of energy bins in THRESHOLDS SPANned by 
;the selection in ENERGY_SPAN: Returns index array ENERGY_I.
COUNT_SPAN, THRESHOLDS, ENERGY_SPAN, ENERGY_I, COMBINED_ENERGIES

; Mask out deselected bins for MFIT by zeroing livetime:
PICKED = FLTARR(N_ELEMENTS(P_SPECTRUM))
PICKED(*) = 0.0    
PICKED(ENERGY_I) = DP_TIME
; Add livetimes:
LIVE_TIME(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) = $
         LIVE_TIME(FIRST_CHAN_DATA: LAST_CHAN_DATA, SUM_DET) + PICKED

TOPLABEL = STRING(REPLICATE(32B, 70))
STRPUT, TOPLABEL, DATA_TITLE

DATA_FILE_NAME(SUM_DET) = STRING_FILE_NAME            

COMMENT_DATA = STRING(REPLICATE(32B, 80))
STRPUT, COMMENT_DATA, DATA_COMMENT

; Store the lookup table so that MODEL_PLOTTER can combine data for each det.:
STOP_IND = WHERE(ENERGY_LOOKUP EQ NCHAN)
USED_REBIN(SUM_DET) = LONG(STOP_IND(0))
REBIN_CHAN(0: STOP_IND(0), SUM_DET) = ENERGY_LOOKUP

END; PRO SUM_SPEC
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO PLOT_PARAMS, TIME_ARR, PARAM_ARR, PARAM_UNCER_ARR, PLOT_NAME, $
                 X_SCALE, Y_SCALE, X_RANGE, Y_RANGE, RESID_CONTOURS, $
                 NUFNU_CONTOURS, HAVE_PLOT1, OPT, MAKE_HC = MAKE_HC
; If OPT is supplied, we skip the main pop-up menu and immediately execute 
;  the selection specified by OPT

@wgsp_cb.pro


POS_SAVE = !P.POSITION
IF N_ELEMENTS(MAKE_HC) EQ 0 THEN BEGIN
   X0 = 0.13 & X0 = X0 + (0.05 * (GLOBAL_CHARSIZE-1))
   X1 = 0.87 & X1 = X1 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y0 = 0.10 & Y0 = Y0 + (0.05 * (GLOBAL_CHARSIZE-1))
   Y1 = 0.90 & Y1 = Y1 + (0.05 * (GLOBAL_CHARSIZE-1))
   !P.POSITION = [X0, Y0, X1, Y1]
ENDIF

; VEK: add 4 variables to param_l_list
PARAM_L_LIST = STRARR(NUM_LIST + 6)
TEMP = STRING(PARAM_LABEL_LIST)
PARAM_L_LIST(0: NUM_LIST - 1) = TEMP(0: NUM_LIST - 1)
colon_pos = strpos (param_l_list(0), ':')
model_name = strmid(param_l_list(0),0, colon_pos+1)
PARAM_L_LIST(NUM_LIST) = model_name + ' Photon Flux (ph/s-cm^2)'
PARAM_L_LIST(NUM_LIST+1) = model_name + ' Photon Fluence (ph/cm^2)'
PARAM_L_LIST(NUM_LIST+2) = model_name + ' Energy Flux (erg/s-cm^2)'
PARAM_L_LIST(NUM_LIST+3) = model_name + ' Energy Fluence (erg/cm^2)'
PARAM_L_LIST(NUM_LIST+4) = model_name + ' Reduced Chi-squares'

PARAM_UNCER_TEMP = PARAM_UNCER_ARR          ; Make changes in the copy only!
PARAM_UNCER_TEMP(NUM_LIST + 4, *) = 0.0     ; No errors on Chi-squares
PARAM_L_LIST(NUM_LIST + 5) = 'Burst Time History (counts/s-keV)'
IF (CV_RATE_MODE EQ 'R') THEN BEGIN         ; Don't divide by bin width 
   PARAM_L_LIST(NUM_LIST + 5) = 'Burst Time History (counts/s)'
ENDIF
PARAM_MENU = ['Choose a Parameter:', STRTRIM(PARAM_L_LIST, 2)]
IF (N_ELEMENTS(OPT) EQ 0) THEN BEGIN
   OPT = WIDMENU(['Choose to plot:', 'Parameter Time History', $
                  'One Parameter vs. another', $
                  'Parameter Histogram', 'Sigma Residuals Map', $
                  'Model Nu-F-Nu Contours'], TITLE = 0)
ENDIF

; Change to nice units for hardcopy
PARAM_L_LIST(NUM_LIST)   = MODEL_NAME + ' Photon Flux (ph s!U-1!N cm!U-2!N)'
PARAM_L_LIST(NUM_LIST+1) = MODEL_NAME + ' Photon Fluence (ph cm!U-2!N)'
PARAM_L_LIST(NUM_LIST+2) = MODEL_NAME + ' Energy Flux (erg s!U-1!N cm!U-2!N)'
PARAM_L_LIST(NUM_LIST+3) = MODEL_NAME + ' Energy Fluence (erg Cm!U-2!N)'
PARAM_L_LIST(NUM_LIST+4) = MODEL_NAME + ' Reduced Chi-squares'
PARAM_L_LIST(NUM_LIST+5) = 'Burst Time History (counts s!U-1!N keV!U-1!N)'
IF (CV_RATE_MODE EQ 'R') THEN BEGIN       ; Don't divide by bin width 
   PARAM_L_LIST(NUM_LIST + 5) = 'Burst Time History (counts s!U-1!N)'
ENDIF

JOIN_POINTS = 0
PLOT_MODE = 0
IF (OPT EQ 1) THEN BEGIN
   IF (HAVE_PLOT1) THEN BEGIN        ; Ask if we should overplot
      PLOT_MODE = WIDMENU(['Overplot parameter?', 'Yes', 'No'], TITLE = 0)
      IF (PLOT_MODE) THEN BEGIN
         INDEX1 = WIDMENU(PARAM_MENU, TITLE = 0) - 1
         TEMP_STR = PARAM_L_LIST(INDEX1)
         X_PH_TITLE = 'Seconds since burst trigger'
         X_PH_DATA = TIME_ARR
         Y_PH_TITLE = STRTRIM(TEMP_STR, 2)
         Y_PH_DATA = TRANSPOSE(PARAM_ARR(INDEX1, *))
         DY_PH_DATA = TRANSPOSE(PARAM_UNCER_TEMP(INDEX1, *))
         PH_TITLE = 1              ; Set 'flag'
         HAVE_PLOT1 = 0            ; Next time, don't ask
         ENDIF $
      ELSE BEGIN
         PH_TITLE = 0              ; Reset 'flag'
         HAVE_PLOT1 = 1            ; Have one plot's data
         ENDELSE
      ENDIF

   IF (NOT PLOT_MODE) THEN BEGIN
      INDEX1 = TIME_HIST_WIDMENU(PARAM_MENU, TITLE = 0) - 1
      ; OPLOT_TIME_HIST is set here on TIME_HIST_WIDMENU widget (0 or 1)

      ; RSM: 1 Sept, 1995
      ; Calculations of flux, fluence, etc are inaccurate for the discrete data
      ;  bins when using the artifical upper limit of 100000.0 keV for the 
      ;  overflow energy bin

      ; RDP: 20 Feb. 1996
      ; Need to use the selected range!
      IF (STRPOS(STRUPCASE(PARAM_MENU(INDEX1)), 'FLUENCE') NE -1 OR $
         STRPOS(STRUPCASE(PARAM_MENU(INDEX1)), 'FLUX') NE -1) THEN BEGIN
         COUNT_SPAN, THRESHOLDS, ENERGY_SPAN, TIND
         IF (MAX(THRESHOLDS(*, TIND)) GE 100000.0) THEN BEGIN
           WARN = WIDMENU(['WARNING: Max threshold is an overflow bin.', $
                          'OK'], TITLE = 0)
         ENDIF
      ENDIF

      TEMP_STR   = PARAM_L_LIST(INDEX1)
      PS_TITLE   = 'Parameter Time History: ' + PLOT_NAME
      X_PS_TITLE = 'Seconds since burst trigger'
      X_PS_DATA  = TIME_ARR
      Y_PS_TITLE = STRTRIM(TEMP_STR, 2)
      Y_PS_DATA  = TRANSPOSE(PARAM_ARR(INDEX1, *))
      DY_PS_DATA = TRANSPOSE(PARAM_UNCER_TEMP(INDEX1, *))
      PH_TITLE   = 0                         ; Set 'flag'
      HAVE_PLOT1 = 1                         ; Have one plot's data
      IF (OPLOT_TIME_HIST) THEN BEGIN        ; User asked for overplot:
         INDEX2 = NUM_LIST + 5               ; Burst Time History
         TEMP_STR = PARAM_L_LIST(INDEX2)
         X_PH_TITLE = 'Seconds since burst trigger'
         X_PH_DATA = TIME_ARR
         Y_PH_TITLE = STRTRIM(TEMP_STR, 2)
         Y_PH_DATA = TRANSPOSE(PARAM_ARR(INDEX2, *))
         DY_PH_DATA = TRANSPOSE(PARAM_UNCER_TEMP(INDEX2, *))
         PH_TITLE = 1              ; Set 'flag': we're overplotting
         HAVE_PLOT1 = 0            ; Next time, don't ask
         ENDIF
      ENDIF

   ENDIF $
ELSE IF OPT EQ 2 THEN BEGIN
   INDEX1 = WIDMENU(PARAM_MENU(0:NUM_LIST+4), TITLE = 0) - 1
   TEMP_STR = PARAM_L_LIST(INDEX1)
   PS_TITLE = "Parameter Dependency: " + PLOT_NAME
   X_PS_TITLE = STRTRIM(TEMP_STR, 2)
   N_TIMES = SIZE(PARAM_ARR)
   X_PS_DATA = FLTARR(2, N_TIMES(2))
   X_PS_DATA(0, *) = TRANSPOSE(PARAM_ARR(INDEX1, *) - $
                     PARAM_UNCER_TEMP(INDEX1, *))
   X_PS_DATA(1, *) = TRANSPOSE(PARAM_ARR(INDEX1, *) + $
                     PARAM_UNCER_TEMP(INDEX1, *))
   INDEX2 = INDEX1
   WHILE INDEX2 EQ INDEX1 DO BEGIN
      INDEX2 = WIDMENU(PARAM_MENU(0:NUM_LIST+4), TITLE = 0) - 1
      ENDWHILE
   TEMP_STR = PARAM_L_LIST(INDEX2)
   Y_PS_TITLE = STRTRIM(TEMP_STR, 2)
   Y_PS_DATA = TRANSPOSE(PARAM_ARR(INDEX2, *))
   DY_PS_DATA = TRANSPOSE(PARAM_UNCER_TEMP(INDEX2, *))
   PH_TITLE = 0              ; Set 'flag' to false: no overplotting
   HAVE_PLOT1 = 0            ; Doing param vs. param, don't ask to overplot
   ENDIF $
ELSE IF OPT EQ 3 THEN BEGIN
   INDEX1 = WIDMENU(PARAM_MENU(0:NUM_LIST + 5), TITLE = 0) - 1
   TEMP_STR = PARAM_L_LIST(INDEX1)
   PS_TITLE = "Parameter Histogram: " + PLOT_NAME
   X_PS_TITLE = STRTRIM(TEMP_STR, 2)
   Y_PS_TITLE = 'Number of Occurances'
   TEMP_ARR = TRANSPOSE(PARAM_ARR(INDEX1, *))
   UNCER_TEMP = TRANSPOSE(PARAM_UNCER_TEMP(INDEX1, *))
   IF INDEX1 EQ NUM_LIST+4 THEN BEGIN        ; Have chosen Red. Chi Squares
      ZIND = WHERE(TEMP_ARR GT 0.0)        ; Blank out poss. outliers
      HBIN = (MAX(TEMP_ARR(ZIND)) - MIN(TEMP_ARR(ZIND))) / 10.0
      ENDIF $
   ELSE BEGIN                              ; Use 1 sigma errors...
      ZIND = WHERE(UNCER_TEMP GT 0.0, ZCNT)
      IF ZCNT EQ 0 THEN BEGIN
         MFIT_INFORM, 'Selected Parameter has no uncertanties (possibly Fixed).  Ready.'
         !P.POSITION = POS_SAVE
         RETURN
         ENDIF
      HBIN = MIN(UNCER_TEMP(ZIND)) / 3.0 
      ENDELSE
   TEMP_ARR = FIX(TEMP_ARR / HBIN)
   Y_TEMP = HISTOGRAM(TEMP_ARR)    ; BINSIZE = HBIN
   N_HIST = N_ELEMENTS(Y_TEMP)
   Y_PS_DATA = INTARR(N_HIST + 2)
   Y_PS_DATA(1:N_HIST) = Y_TEMP
   X_PS_DATA = FLTARR(2, N_HIST + 2)
   X_PS_DATA(0, *) = LINDGEN(N_HIST + 2) * HBIN + MIN(TEMP_ARR * HBIN) - HBIN 
   X_PS_DATA(1, *) = LINDGEN(N_HIST + 2) * HBIN + MIN(TEMP_ARR * HBIN)
   DY_PS_DATA = FLTARR(N_HIST)
   JOIN_POINTS = 1
   PH_TITLE = 0              ; Set 'flag' to false: no overplotting
   HAVE_PLOT1 = 0            ; Doing param vs. param, don't ask to overplot
   ENDIF $
ELSE IF OPT EQ 4 THEN BEGIN
   WGSP_LAST_PLOT = 'SIGMA RESIDUALS MAP'
   THE_TITLE = "Sigma Residuals Map: " + PLOT_NAME
   IF KEYWORD_SET(MAKE_HC) THEN BEGIN
      PLOT_CONTOURS, RESID_CONTOURS, TIME_ARR, THE_TITLE, 1
   ENDIF ELSE BEGIN
      PLOT_CONTOURS, RESID_CONTOURS, TIME_ARR, THE_TITLE, 0
   ENDELSE
   !P.POSITION = POS_SAVE
   RETURN
   ENDIF $
ELSE IF OPT EQ 5 THEN BEGIN
   WGSP_LAST_PLOT = 'MODEL NU-F-NU CONTOURS'
   THE_TITLE = "Model NuFNu Contours: " + PLOT_NAME
   CONTOUR_MODE = WIDMENU(['Vertical Axis?', 'Time', 'Fluence'], TITLE = 0)
   IF CONTOUR_MODE EQ 1 THEN BEGIN
      CONTV_ARR = TRANSPOSE((TIME_ARR(1, *) + TIME_ARR(0, *)) / 2.)   ;TIME_ARR
      VTITLE = "Seconds since burst trigger"
   ENDIF ELSE BEGIN
      CONTV_ARR = TRANSPOSE(PARAM_ARR(NUM_LIST + 1, *))
      VTITLE = PARAM_L_LIST(NUM_LIST+1) ;"Seconds since burst trigger"
      ENDELSE
   IF KEYWORD_SET(MAKE_HC) THEN BEGIN
      PLOT_NUFNU_CONT, NUFNU_CONTOURS, CONTV_ARR, THE_TITLE, VTITLE, 1
   ENDIF ELSE BEGIN
      PLOT_NUFNU_CONT, NUFNU_CONTOURS, CONTV_ARR, THE_TITLE, VTITLE, 0
   ENDELSE
   !P.POSITION = POS_SAVE
   RETURN
   ENDIF

IF PH_TITLE THEN BEGIN
   IF OPLOT_TIME_HIST THEN BEGIN        ; User asked for overplot; set ranges:
      HAVE_ZOOMED_PARAM = 1             ; Implicitly zoomed HISTORY
      X_SCALE = 0
      X_RANGE = [MIN(X_PS_DATA(0, *)), MAX(X_PS_DATA(1, *))]
      Y_SCALE = 0
      Y_RANGE = [MIN(Y_PS_DATA - DY_PS_DATA), MAX(Y_PS_DATA + DY_PS_DATA)] 
      ENDIF
   PLOT, X_RANGE, Y_RANGE, XTITLE = X_PS_TITLE, $
                  XTYPE = X_SCALE, YTYPE = Y_SCALE, $
                  YTITLE = Y_PS_TITLE, TITLE = PS_TITLE, $
                  /NODATA, YSTYLE = 16 + 8

   PLOT_POINTS, X_PS_DATA, Y_PS_DATA, DY_PS_DATA
   RATE_RANGE = Y_RANGE        ; Store this parameter for use by ZOOM_BAR

   YH_RANGE = [MIN(Y_PH_DATA - DY_PH_DATA), MAX(Y_PH_DATA + DY_PH_DATA)]
   HIST_RANGE = YH_RANGE
   PLOT, X_RANGE, YH_RANGE, XTYPE = X_SCALE, $
                  XTITLE = X_PS_TITLE, $
                  /NODATA, YSTYLE = 16 + 4, /NOERASE
   AXIS, YAXIS = 1, YRANGE = YH_RANGE, /YNOZERO, YTITLE = Y_PH_TITLE
   P_LINESAVE = !P.LINESTYLE
   !P.LINESTYLE = 1
   BTH_FLAG = STRPOS(Y_PH_TITLE, 'Burst Time History')
   IF BTH_FLAG EQ -1 THEN $
      PLOT_POINTS, X_PH_DATA, Y_PH_DATA, DY_PH_DATA $
   ELSE $
      NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA 
   !P.LINESTYLE = P_LINESAVE
   ENDIF $
ELSE BEGIN
   X_SCALE = 0
   X_RANGE = [MIN(X_PS_DATA(0, *)), MAX(X_PS_DATA(1, *))]
   Y_SCALE = 0
   IF OPT NE 3 THEN $
      Y_RANGE = [MIN(Y_PS_DATA - DY_PS_DATA), MAX(Y_PS_DATA + DY_PS_DATA)] $
   ELSE $
      Y_RANGE = [MIN(Y_PS_DATA - DY_PS_DATA), MAX(Y_PS_DATA + DY_PS_DATA)* 1.1]

   PLOT, X_RANGE, Y_RANGE, XTITLE = X_PS_TITLE, $
                  XTYPE = X_SCALE, YTYPE = Y_SCALE, $
                  YTITLE = Y_PS_TITLE, TITLE = PS_TITLE, $
                  /NODATA, YSTYLE = 16

   IF JOIN_POINTS THEN $
      NEW_HIST, X_PS_DATA, Y_PS_DATA, !P.COLOR $
   ELSE $
      PLOT_POINTS, X_PS_DATA, Y_PS_DATA, DY_PS_DATA 
   ENDELSE

!P.POSITION = POS_SAVE



END; PRO PLOT_PARAMS
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO PLOT_POINTS, X_DATA, Y_DATA, DY_DATA

N = SIZE(X_DATA)
INDEX = N(2) - 1
IF N(0) NE 2 THEN BEGIN
   N = SIZE(Y_DATA)
   INDEX = N(1) - 1
   ENDIF
X_RANGE = 0.005*(!X.CRANGE(1) - !X.CRANGE(0))
DX = X_DATA(1, *) - X_DATA(0, *)
IF !Y.TYPE THEN BEGIN               ; Axis is log., so we do fancy stuff
   Y_RANGE = 10 ^ !Y.CRANGE
   USERSYM, [-0.5, 0.5, 0.5, -0.5], [0.5, 0.5, -0.5, -0.5], /FILL
   FOR I = 0, INDEX DO BEGIN
      YY = Y_DATA(I) 
      YY = [YY, YY]
      XX = [X_DATA(0, I), X_DATA(1, I)]
      XX2 = 0.5*(X_DATA(0, I) + X_DATA(1, I))
      XX2 = [XX2, XX2]
      IF (KEYWORD_SET(DY_DATA)) AND (DX(I) GT X_RANGE) THEN BEGIN
         IF Y_DATA(I) LT DY_DATA(I) THEN BEGIN ; Create upper limit mark
            YY = 2 * DY_DATA(I) 
            YY = [YY, YY]
            YY2 = [Y_RANGE(0), 2 * DY_DATA(I)]
            ENDIF $
         ELSE BEGIN                            ; Create error bar
            YY2 = Y_DATA(I) + [- DY_DATA(I), DY_DATA(I)]
            ENDELSE
         ENDIF $
      ELSE BEGIN                 ; No DY_DATA, just plot a point
         YY2 = Y_DATA(I) 
         YY2 = [YY2, YY2]
         ENDELSE
      IF (YY2(0) GT Y_RANGE(1)) OR (YY2(1) LT Y_RANGE(0)) THEN BEGIN
         YY = Y_DATA(I) 
         YY = [YY, YY]
         XX = 0.5*(X_DATA(0, I) + X_DATA(1, I))
         XX = [XX, XX]
         OPLOT, XX, YY, PSYM=8   ; Make a square if the point is off-axis 
         ENDIF $
      ELSE BEGIN                 ; Plot the data point w. error bar
         OPLOT, XX, YY
         OPLOT, XX2, YY2
         ENDELSE
      ENDFOR
   ENDIF $
ELSE BEGIN                          ; Axis is linear - don't do tricks.
   A = FINDGEN(16) * (!PI * 2 / 16.0)
   USERSYM, COS(A), SIN(A), /FILL   ; Define a circle symbol for dy = 0
   FOR I = 0, INDEX DO BEGIN
      XX = [X_DATA(0, I), X_DATA(1, I)]
      YY = Y_DATA(I) 
      YY = [YY, YY]
      IF XX(0) EQ XX(1) THEN $
         OPLOT, XX, YY, PSYM = 8 $
      ELSE $
         OPLOT, XX, YY
      ENDFOR
   IF KEYWORD_SET(DY_DATA) THEN BEGIN
      FOR I = 0, INDEX DO IF (DX(I) GT X_RANGE) OR (DX(I) EQ 0.0) THEN BEGIN
         XX = 0.5*(X_DATA(0, I) + X_DATA(1, I))
         XX = [XX, XX]
         IF DY_DATA(I) NE 0.0 THEN BEGIN
            YY = Y_DATA(I) + [- DY_DATA(I), DY_DATA(I)]
            OPLOT, XX, YY
            ENDIF $
         ELSE BEGIN
            YY = Y_DATA(I)
            YY = [YY, YY]
            OPLOT, XX, YY, PSYM = 8
            ENDELSE
         ENDIF
      ENDIF
   ENDELSE



END; PRO PLOT_POINTS
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO PLOT_NOTES, PAGE_POSITION, TYPE

@wgsp_cb.pro


; No notes if this selection is made in Plot Labels / Options
IF (WGSP_SUPPRESS_NOTES EQ 1) THEN RETURN

DX = PAGE_POSITION(2) - PAGE_POSITION(0)
DY = PAGE_POSITION(3) - PAGE_POSITION(1)
X0 = PAGE_POSITION(0)
Y0 = PAGE_POSITION(1)

NOTE_IND = N_ANNOTES

IF TYPE EQ 'BATCH' THEN BEGIN
   NOTE_IND = 7
   TEMP = STRING(PARAM_LABEL_LIST)
   colon_pos = strpos (TEMP(0), ':')
   model_name = strmid(TEMP(0),0, colon_pos)
   ANNOTES(0) = 'Batch fit: ' + MODEL_NAME
ENDIF

IF (TYPE EQ 'FIT') OR (TYPE EQ 'BATCH') THEN BEGIN
    IF N_ANNOTES NE 0 THEN BEGIN
      BREAK = 8                       ;At the 'break' we switch to left align:
      FOR I = 0, BREAK - 1 DO $
         XYOUTS, ANN_X(I), ANN_Y(I), ANNOTES(I), ALIGN = 1.0, /NORMAL
      FOR I = BREAK, NOTE_IND - 1 DO $
         XYOUTS, ANN_X(I), ANN_Y(I), ANNOTES(I), /NORMAL
    ENDIF
ENDIF

FOR I = 0, N_NOTES - 1 DO BEGIN
   X = X0 
   Y = Y0 - (I + 3)*0.03*DY 
   XYOUTS, X, Y, NOTES(I), /NORMAL
ENDFOR


END ; PRO PLOT_NOTES
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO HARD_COPY, X_RANGE, Y_RANGE, X_SCALE, Y_SCALE, PAGE_POSITION, THE_TYPE

@wgsp_cb.pro


XRSAVE = !X.CRANGE 
YRSAVE = !Y.CRANGE 

X_P_DATA = FLTARR(2, N_ELEMENTS(X_PS_DATA(0, *)))
X_P_DATA = X_PS_DATA
Y_P_DATA = FLTARR(N_ELEMENTS(Y_PS_DATA))
Y_P_DATA = Y_PS_DATA
DY_P_DATA = FLTARR(N_ELEMENTS(DY_PS_DATA))
DY_P_DATA = DY_PS_DATA
P_TITLE = PS_TITLE
X_P_TITLE = X_PS_TITLE
Y_P_TITLE = Y_PS_TITLE
X_STYLE = 0
Y_STYLE = 16
HIST_FLAG = 0

POS_SAVE = !P.POSITION
OPEN_PLOT, CURRENT_DEVICE
X0 = 55 / 510.0  & X0 = X0 + (0.07 * (GLOBAL_CHARSIZE-1))
Y0 = 185 / 660.0 & Y0 = Y0 + (0.07 * (GLOBAL_CHARSIZE-1))
X1 = 439 / 510.0 & X1 = X1 + (0.07 * (GLOBAL_CHARSIZE-1))
Y1 = 567 / 660.0 & Y1 = Y1 + (0.07 * (GLOBAL_CHARSIZE-1))

IF PH_TITLE THEN BEGIN
   PLOT, X_RANGE, Y_RANGE, XTITLE = X_P_TITLE, POSITION = [X0, Y0, X1, Y1], $
                  XTYPE = X_SCALE, YTYPE = Y_SCALE, $
                  YTITLE = Y_P_TITLE, TITLE = '!5' + P_TITLE, $
                  /NODATA, YSTYLE = 16 + 8

   PLOT_POINTS, X_P_DATA, Y_P_DATA, DY_P_DATA

   PLOT, X_RANGE, HIST_RANGE, XTYPE = X_SCALE, POSITION = [X0, Y0, X1, Y1], $
                  XTITLE = X_P_TITLE, $
                  /NODATA, YSTYLE = 16 + 4, /NOERASE
   AXIS, YAXIS = 1, YRANGE = HIST_RANGE, /YNOZERO, YTITLE = Y_PH_TITLE
   P_LINESAVE = !P.LINESTYLE
   !P.LINESTYLE = 1
   BTH_FLAG = STRPOS(Y_PH_TITLE, 'Burst Time History')
   IF BTH_FLAG EQ -1 THEN $
      PLOT_POINTS, X_PH_DATA, Y_PH_DATA, DY_PH_DATA $
   ELSE $
      NEW_HIST, X_PH_DATA, Y_PH_DATA, !P.COLOR, DY_PH_DATA 
   !P.LINESTYLE = P_LINESAVE
   ENDIF $
ELSE BEGIN
   PLOT, X_RANGE, Y_RANGE, XTITLE = X_P_TITLE, POSITION = [X0, Y0, X1, Y1], $
                  XTYPE = X_SCALE, YTYPE = Y_SCALE, $
                  YTITLE = Y_P_TITLE, TITLE = P_TITLE, $
                  /NODATA, YSTYLE = 16

   JOIN_POINTS = STRPOS(Y_P_TITLE, 'Number of Occurances')
   IF JOIN_POINTS EQ -1 THEN $
      PLOT_POINTS, X_P_DATA, Y_P_DATA, DY_P_DATA $
   ELSE $
      NEW_HIST, X_P_DATA, Y_P_DATA, !P.COLOR 
   ENDELSE

IF NOT CV_SUPPRESS_2ND_LABELS THEN $
   PLOT_NOTES, PAGE_POSITION, THE_TYPE

CLOSE_PLOT, CURRENT_DEVICE
!P.POSITION = POS_SAVE 

!X.CRANGE = XRSAVE  
!Y.CRANGE = YRSAVE 



END; PRO HARD_COPY
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO PLOT_CONTOURS, RESID_CONTOURS, TIME_ARR, PLOT_NAME, HC_OPTION

@wgsp_cb.pro


XRSAVE = !X.CRANGE 
YRSAVE = !Y.CRANGE 

RESID_SIZE = SIZE(RESID_CONTOURS)
N_RESID_E = RESID_SIZE(1)
N_RESID_T = RESID_SIZE(2)
; Enlarge the array before smoothing, to offset edge effects, then reduce:
TEMP_RESID = FLTARR(N_RESID_E, N_RESID_T + 2)
TEMP_RESID(*, 1: N_RESID_T) = RESID_CONTOURS
TEMP_RESID = SMOOTH(TEMP_RESID, 3)
TEMP_RESID = TEMP_RESID(*, 1: N_RESID_T) 

NCHAN = NUM_CHAN(CDET) - 2
OFF_CHAN = CHAN_OFFSET(CDET)
TOP = LAST_CHAN_PLOT(CDET) - OFF_CHAN
BOT = FIRST_CHAN_PLOT(CDET) - OFF_CHAN
TEMP_RESID = TEMP_RESID(BOT: TOP, *)
EN_ARR = CHAN_ENERGY(BOT: TOP, CDET)
EN_ARR = ALOG10(EN_ARR)
EN_RANGE = [CHAN_ENERGY(BOT, CDET), CHAN_ENERGY(TOP, CDET)]
TM_ARR = TRANSPOSE((TIME_ARR(1, *) + TIME_ARR(0, *)) / 2.)

LEV = INDGEN(7) - 3
STY = [0,2,0,1,3,1,3]
X_LABEL = "Energy (keV)"
Y_LABEL = "Seconds since burst trigger"

X0 = 55 / 510.0
Y0 = 70 / 660.0
X1 = 439 / 510.0
Y1 = 600 / 660.0

PLOTTING = 0
DO_PLOT:
IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0
   Y0 = 185 / 660.0
   X1 = 439 / 510.0
   Y1 = 567 / 660.0
   ENDIF 

THE_POS = [X0, Y0, X1, Y1]
CONTOUR, TEMP_RESID, EN_ARR, TM_ARR, LEVELS = LEV, C_LINESTYLE = STY, $
         YTITLE = Y_LABEL, XSTYLE = 5, YSTYLE = 1, $
         TITLE = PLOT_NAME, POSITION = THE_POS

PLOT, EN_RANGE, [0,1], XTYPE = 1, YSTYLE = 4, /NOERASE, /NODATA, $
         XTITLE = X_LABEL, XSTYLE = 1, POSITION = THE_POS

IF NOT PLOTTING THEN BEGIN
   IF HC_OPTION EQ 1 THEN BEGIN
      PLOTTING = 1
      GOTO, DO_PLOT
      ENDIF
   ENDIF $
ELSE BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN BEGIN
      PAGE_POS = [0.1, 0.28, 0.86, 0.86]
      PLOT_NOTES, PAGE_POS, 'BATCH'
      ENDIF
   CLOSE_PLOT, CURRENT_DEVICE
   ENDELSE

!X.CRANGE = XRSAVE 
!Y.CRANGE = YRSAVE 



END; PRO PLOT_CONTOURS
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PRO PLOT_NUFNU_CONT, NUFNU_CONTOURS, TIME_ARR, PLOT_NAME, VTITLE, HC_OPTION

@wgsp_cb.pro


XRSAVE = !X.CRANGE 
YRSAVE = !Y.CRANGE 

NCHAN = NUM_CHAN(CDET) - 2
OFF_CHAN = CHAN_OFFSET(CDET)
PLOT_TYPE = LONG(5)                       ; Nu-f-nu plot

TOP = LAST_MODEL_PLOT(CDET) 
BOT = FIRST_MODEL_PLOT(CDET)
TEMP_NUFNU = NUFNU_CONTOURS(BOT: TOP, *)
EN_ARR = MODEL_ENERGY(BOT: TOP, CDET)
EN_ARR = ALOG10(EN_ARR)
EN_RANGE = [MODEL_ENERGY(BOT, CDET), MODEL_ENERGY(TOP, CDET)]
TM_ARR = TIME_ARR       ;TRANSPOSE((TIME_ARR(1, *) + TIME_ARR(0, *)) / 2.)
NTIM = N_ELEMENTS(TM_ARR)
TM_RANGE = [TM_ARR(0), TM_ARR(NTIM - 1)]
MAX_NUFNU = FLTARR(NTIM)
FOR I = 0, NTIM - 1 DO BEGIN
    TEMP_ARR = TEMP_NUFNU(*, I)
    MAXNU = MAX(TEMP_ARR, MAX_SUB)
    MAX_NUFNU(I) = 10 ^ EN_ARR(MAX_SUB)
    ENDFOR

IF NTIM GT 29 THEN NTIM = 29   ; No more allowed in CONTOUR function.

X_LABEL = "Energy (keV)"
Y_LABEL = VTITLE  ;"Seconds since burst trigger"

X0 = 55 / 510.0
Y0 = 70 / 660.0
X1 = 439 / 510.0
Y1 = 600 / 660.0

PLOTTING = 0
IF HC_OPTION EQ 1 THEN BEGIN
   PLOTTING = 1
   ENDIF

IF PLOTTING THEN BEGIN
   OPEN_PLOT, CURRENT_DEVICE
   X0 = 55 / 510.0
   Y0 = 185 / 660.0
   X1 = 439 / 510.0
   Y1 = 567 / 660.0
   ENDIF 

THE_POS = [X0, Y0, X1, Y1]
CONTOUR, TEMP_NUFNU, EN_ARR, TM_ARR, NLEVELS = NTIM, $
         YTITLE = Y_LABEL, XSTYLE = 5, YSTYLE = 1, $
         TITLE = PLOT_NAME, POSITION = THE_POS, /FOLLOW

TM_RANGE = !Y.CRANGE
PLOT, EN_RANGE, TM_RANGE, XTYPE = 1, YSTYLE = 5, /NOERASE, /NODATA, $
         XTITLE = X_LABEL, XSTYLE = 1, POSITION = THE_POS

OPLOT, MAX_NUFNU, TM_ARR, LINESTYLE = 2

IF PLOTTING THEN BEGIN
   IF NOT CV_SUPPRESS_2ND_LABELS THEN BEGIN
      PAGE_POS = [0.1, 0.28, 0.86, 0.86]
      PLOT_NOTES, PAGE_POS, 'BATCH'
      ENDIF
   CLOSE_PLOT, CURRENT_DEVICE
   ENDIF


!X.CRANGE = XRSAVE 
!Y.CRANGE = YRSAVE 



END; PRO PLOT_NUFNU_CONT
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
