; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
FUNCTION NAMELIST_QUOTE, STRING_VARIABLE

   RETURN, "'" + STRTRIM(STRING_VARIABLE, 2) + "'"

END

FUNCTION NAMELIST_CONVERT, IDL_LOGICAL


IF (IDL_LOGICAL) THEN BEGIN
   RETURN, '.TRUE.'
ENDIF ELSE BEGIN
   RETURN, '.FALSE.'
ENDELSE

END

; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; Writes the file MFIT_CONTROL.DAT to OUTFILE

PRO WRITE_CONTROL, OUTFILE


COMMON WSP_CONTROL_C, $
       CV_DEBUG, CV_TALKY, CV_EXP_USER, CV_CONTOUR_CHOICE, $
       CV_WRITE_CONTOUR_CHI_STEPS, CV_AUTO_COMMENT, $
       CV_FIRST_BIN_CALC, CV_LAST_BIN_CALC, $
       CV_BATCH_FIT_SUMMARY, CV_GAUSS_OFFSET, $
       CV_START_GAUSS_E, CV_END_GAUSS_E, CV_GAUSS_STEP_SIZE, $
       CV_GAUSS_VWIDTH, CV_FIX_UNDETERMINED, CV_AXES_SAME, $
  
       CV_PRINTER_LANG, CV_PLOT_MODEL_EXTRAP, $
       CV_PLOT_EACH_TERM, CV_ABS_MODEL, CV_PLOT_ONLY_DATA, $
       CV_SUPPRESS_2ND_LABELS, CV_MULTI_DET_PLOT_MODE, $
       CV_GRAPH_LIMIT_MODE, CV_HCOPY_FILE_STATUS, $
       CV_ENCAPSULATED_PS, CV_SPEC_STYLE, $

       CV_RATE_MODE, CV_TRACK_MOUSE, CV_PLOT_UNDETERMINED, $
       CV_PLOT_CURSOR, CV_IDL_RETAIN, CV_TITLE_STYLE, $
       CV_SPARE_1, CV_SPARE_2, CV_SPARE_3, $

       CV_KEEP_ASCII_OPEN, CV_ASCII_OUT_FILE, $
       CV_STARTUP_TEMPLATE_FILE, CV_FULL_BATCH_OUT, $
       CV_SUPPRESS_BATCH_OUT, CV_BATCH_OUT_FILE, CV_ALWAYS_WA, $
       CV_ALWAYS_WB, $

       CV_REL_CONVERG, CV_ABS_CONVERG, CV_MAX_TRIES

; WINGSPAN IDL source code location and other parameters:
COMMON SOURCE_LOC, WGSP_SOURCE, WGSP_PRINTER, WGSP_SCRATCH, $
       WGSP_FITS, WGSP_LOOKUP, WGSP_DRM, WGSP_NO_MFIT, $
       WGSP_SCALE, WGSP_PRINT_COMMAND, WGSP_CONFIRM, WGSP_HELP, $
       WGSP_WORK



OPENW, FL, OUTFILE, /GET_LUN

OPENR, FL_IN, WGSP_SOURCE + STRLOWCASE('MFIT_CONTROL.DAT'), /GET_LUN
       STR = '' & STR_ARR = ''
       WHILE NOT EOF(FL_IN) DO BEGIN
             READF, FL_IN, STR
             IF (STRTRIM(STR, 2) EQ '&MFIT_CONTROL') THEN GOTO, DONE
             PRINTF, FL, STR
       ENDWHILE

DONE:
FREE_LUN, FL_IN


PRINTF, FL, ' &MFIT_CONTROL'

 PRINTF, FL, ' MCV_DEBUG = ',             NAMELIST_CONVERT(CV_DEBUG)
 PRINTF, FL, ' MCV_TALKY = ',             CV_TALKY
 PRINTF, FL, ' MCV_EXP_USER = ',          NAMELIST_CONVERT(CV_EXP_USER)
 PRINTF, FL, ' MCV_CONTOUR_CHOICE = ',    NAMELIST_QUOTE(CV_CONTOUR_CHOICE)
 PRINTF, FL, ' MCV_WRITE_CONTOUR_CHI_STEPS = ', $
               NAMELIST_CONVERT(CV_WRITE_CONTOUR_CHI_STEPS)
 PRINTF, FL, ' MCV_AUTO_COMMENT = ',      NAMELIST_CONVERT(CV_AUTO_COMMENT)
 PRINTF, FL, ' MCV_FIRST_BIN_CALC = ',    CV_FIRST_BIN_CALC
 PRINTF, FL, ' MCV_LAST_BIN_CALC = ',     CV_LAST_BIN_CALC
 PRINTF, FL, ' MCV_BATCH_FIT_SUMMARY = ', CV_BATCH_FIT_SUMMARY
 PRINTF, FL, ' MCV_GAUSS_OFFSET = ',      CV_GAUSS_OFFSET
 PRINTF, FL, ' MCV_START_GAUSS_E = ',     CV_START_GAUSS_E
 PRINTF, FL, ' MCV_END_GAUSS_E = ',       CV_END_GAUSS_E
 PRINTF, FL, ' MCV_GAUSS_STEP_SIZE = ',   CV_GAUSS_STEP_SIZE
 PRINTF, FL, ' MCV_GAUSS_VWIDTH = ',      NAMELIST_CONVERT(CV_GAUSS_VWIDTH)
 PRINTF, FL, ' MCV_FIX_UNDETERMINED = ',  NAMELIST_CONVERT(CV_FIX_UNDETERMINED)
 PRINTF, FL, ' MCV_AXES_SAME = ',         NAMELIST_CONVERT(CV_AXES_SAME)
     
 PRINTF, FL, ' MCV_PRINTER_LANG = ',      NAMELIST_QUOTE(CV_PRINTER_LANG)
 PRINTF, FL, ' MCV_PLOT_MODEL_EXTRAP = ', NAMELIST_CONVERT(CV_PLOT_MODEL_EXTRAP)
 PRINTF, FL, ' MCV_PLOT_EACH_TERM = ',    NAMELIST_CONVERT(CV_PLOT_EACH_TERM)
 PRINTF, FL, ' MCV_ABS_MODEL = ',         NAMELIST_CONVERT(CV_ABS_MODEL)
 PRINTF, FL, ' MCV_PLOT_ONLY_DATA = ',    NAMELIST_CONVERT(CV_PLOT_ONLY_DATA)
 PRINTF, FL, ' MCV_SUPPRESS_2ND_LABELS = ', $
              NAMELIST_CONVERT(CV_SUPPRESS_2ND_LABELS)
 PRINTF, FL, ' MCV_MULTI_DET_PLOT_MODE = ', $
               NAMELIST_QUOTE(CV_MULTI_DET_PLOT_MODE)
 PRINTF, FL, ' MCV_GRAPH_LIMIT_MODE = ',  NAMELIST_QUOTE(CV_GRAPH_LIMIT_MODE)
 PRINTF, FL, ' MCV_HCOPY_FILE_STATUS = ', NAMELIST_QUOTE(CV_HCOPY_FILE_STATUS)
 PRINTF, FL, ' MCV_ENCAPSULATED_PS = ',   NAMELIST_CONVERT(CV_ENCAPSULATED_PS)
 PRINTF, FL, ' MCV_SPEC_STYLE = ',        CV_SPEC_STYLE

 PRINTF, FL, ' MCV_RATE_MODE = ',         NAMELIST_QUOTE(CV_RATE_MODE)
 PRINTF, FL, ' MCV_TRACK_MOUSE = ',       NAMELIST_CONVERT(CV_TRACK_MOUSE)
 PRINTF, FL, ' MCV_PLOT_UNDETERMINED = ', NAMELIST_CONVERT(CV_PLOT_UNDETERMINED)
 PRINTF, FL, ' MCV_PLOT_CURSOR = ',       NAMELIST_CONVERT(CV_PLOT_CURSOR)
 PRINTF, FL, ' MCV_IDL_RETAIN = ',        CV_IDL_RETAIN
 PRINTF, FL, ' MCV_TITLE_STYLE = ',       NAMELIST_QUOTE(CV_TITLE_STYLE)
     
 PRINTF, FL, ' MCV_KEEP_ASCII_OPEN = ',   NAMELIST_CONVERT(CV_KEEP_ASCII_OPEN)
 PRINTF, FL, ' MCV_ASCII_OUT_FILE = ',    NAMELIST_QUOTE(CV_ASCII_OUT_FILE)
 PRINTF, FL, ' MCV_STARTUP_TEMPLATE_FILE = ', $
               NAMELIST_QUOTE(CV_STARTUP_TEMPLATE_FILE)
 PRINTF, FL, ' MCV_FULL_BATCH_OUT = ',    NAMELIST_CONVERT(CV_FULL_BATCH_OUT)
 PRINTF, FL, ' MCV_SUPPRESS_BATCH_OUT = ', $
               NAMELIST_CONVERT(CV_SUPPRESS_BATCH_OUT)
 PRINTF, FL, ' MCV_BATCH_OUT_FILE = ',    NAMELIST_QUOTE(CV_BATCH_OUT_FILE)
 PRINTF, FL, ' MCV_ALWAYS_WA = ',         NAMELIST_CONVERT(CV_ALWAYS_WA)
 PRINTF, FL, ' MCV_ALWAYS_WB = ',         NAMELIST_CONVERT(CV_ALWAYS_WB)
     
 PRINTF, FL, ' MCV_REL_CONVERG = ',       CV_REL_CONVERG
 PRINTF, FL, ' MCV_ABS_CONVERG = ',       CV_ABS_CONVERG
 PRINTF, FL, ' MCV_MAX_TRIES = ',         CV_MAX_TRIES

PRINTF, FL, ' &END'


FREE_LUN, FL

        

END ; PRO WRITE_CONTROL
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
